/*This part is used in internationalization process.*/
%global webout_options;
%let webout_options=%str(encoding='utf-8');
/*I18N-20080425-1932*/
%global NLDATE_FMT;
%let NLDATE_FMT=nldateym8.;
libname smd_ds "Data/bisdata/internationalization/en";
/* All Library specifications for BIS solutions */
libname custpara BASE "Data/bisdata/param" ;
libname dds "Data/bisdata/dds";
libname dim BASE "Data/bisdata/dim" ;
libname abtscr BASE "Data/bisdata/scratch/abt" ;
libname martscr BASE "Data/bisdata/scratch/mart" ;
libname format "Data/bisdata/format";
libname abtagg "Data/bisdata/abt_agg_table" ;

libname fact BASE "Data/bisdata/fact" ;
libname agg BASE "Data/bisdata/agg" ;
libname bridge BASE "Data/bisdata/bridge" ;
libname detail BASE "Data/bisdata/detail" ;
libname error BASE "Data/bisdata/error" ;
libname martscr "Data/bisdata/scratch/mart";

libname log BASE "Data/bisdata/log";
libname analytic BASE "Data/bisdata/analytics";
libname abt BASE "Data/bisdata/abt";

libname control BASE "Data/bisdata/control";


/*Path to the job deployment folder on the server */
 filename jobs 'Data/bisdata/jobs';

/*Filerefs for the temporary .sas files. These files are created by create_abt.sas file
 during dynamic ABT creating */
filename cust_fl "Data/bisdata/scratch/abt/cust_fl.sas";
filename acct_fl "Data/bisdata/scratch/abt/acct_fl.sas";
filename jh1_fl "Data/bisdata/scratch/abt/jh1_fl.sas";
filename jh2_fl "Data/bisdata/scratch/abt/jh2_fl.sas";
filename semi_col "Data/bisdata/scratch/abt/semi_col.sas";
filename acc_abt "Data/bisdata/scratch/abt/acc_abt.sas";
filename jh1_abt "Data/bisdata/scratch/abt/jh1_abt.sas";

filename appl_fl 'Data/bisdata/scratch/abt/appl_fl.sas';
filename pa_fl 'Data/bisdata/scratch/abt/pa_fl.sas';
filename ja1_fl 'Data/bisdata/scratch/abt/ja1_fl.sas';
filename pg_fl 'Data/bisdata/scratch/abt/pg_fl.sas';
filename pn_fl 'Data/bisdata/scratch/abt/pn_fl.sas';
filename appl_abt 'Data/bisdata/scratch/abt/appl_abt.sas';
filename pa_abt 'Data/bisdata/scratch/abt/pa_abt.sas';

/* Assigning folders for format searching and compilation of macros */
options fmtsearch=(format work) MAUTOSOURCE 
SASAUTOS=("Data/bisdata/macro" | 
		"Data/bisdata/macro/analytics" | 
		"Data/bisdata/macro/debug" |
		"Data/bisdata/macro/display" |
		"Data/bisdata/macro/account_basic" | 
		"Data/bisdata/macro/account_inquiry" | 
		"Data/bisdata/macro/account_outbound_comm" |		
		"Data/bisdata/macro/account_transaction" |	
		"Data/bisdata/macro/customer_contacts" |
		"Data/bisdata/macro/account_chng" |
		"Data/bisdata/macro/account_snapshot"|
		"Data/bisdata/macro/account_bank_card"|
		"Data/bisdata/macro/application"|
		"Data/bisdata/macro/account_default_recovery" |
		"Data/bisdata/macro/computations/common" |
		"Data/bisdata/macro/outcome_variables/account_snapshot" |
		"Data/bisdata/macro/outcome_variables/account_transaction" |
		"Data/bisdata/macro/internationalization"|
		"Data/bisdata/macro/common" 
		,SASAUTOS);

/*%include "Data/bisdata/param/run_control.sas";*/

/*This macro reads the parameter list table in custpara library and sets values 
  of all global parameters.*/
/*I18N-20080429-1127*/ 
/*Del where clause. Because locaized strings will be different. The where clause will fail to match. */
/*%load_global_parameters(where= where parent_category_cd in ('Foundation Mart','ABT', 'Reporting') );*/
%load_global_parameters(where=);
/*I18N-20080429-1127*/
/* Assignment of global parameters as per user input values in Parameter dataset */

%include "Data/bisdata/param/bis_customize_para.sas";