%macro check_seg_job_depnd_table;
proc sql noprint;
%if %sysfunc(exist(CONTROL.PARAMETER_LIST_CREDIT_SCORING)) eq 0 %then %do;
	create table CONTROL.PARAMETER_LIST_CREDIT_SCORING(
		JOB_NM char(40),
		LEVEL_NO num,
		RETURN_CD num
		);
	create unique index XPI_JOB_NM_LVL_NO on CONTROL.PARAMETER_LIST_CREDIT_SCORING(JOB_NM,LEVEL_NO);
%end;

insert into CONTROL.PARAMETER_LIST_CREDIT_SCORING (JOB_NM ,LEVEL_NO ,RETURN_CD)
VALUES("ACCT_SNPSHT_TIME.sas",1,.)
VALUES("CS_BUILT_ABT_SCORING.sas",1,.)
VALUES("POOL_DIM_EXT.sas",1,.)
VALUES("AM_CAS_LGD.sas",2,.)
VALUES("AM_POOL_SCHEME.sas",2,.)
VALUES("APS_AM.sas",2,.)
VALUES("APS_AM_PD.sas",2,.)
VALUES("CAS_AM_CCF.sas",2,.)
VALUES("CAS_AM_PD.sas",2,.)
VALUES("CS_MONITORING_MODEL.sas",2,.)
VALUES("CS_SCORING_INPUT.sas",2,.)
VALUES("SCORE_APPLICATION.sas",2,.)
VALUES("ACCT_MODEL_LKP.sas",3,.)
VALUES("ACCT_SCR_RANGE.sas",3,.)
VALUES("ACT_LGD_IO_RK.sas",3,.)
VALUES("AM_POOL_SCHEME_APS.sas",3,.)
VALUES("AM_POOL_SCHEME_CAS.sas",3,.)
VALUES("APP_ACT_FA_L.sas",4,.)
VALUES("APPL_MODEL_LKP.sas",3,.)
VALUES("APS_AM_LKP.sas",3,.)
VALUES("CAS_AM_CCF_FA.sas",3,.)
VALUES("CAS_AM_FA.sas",3,.)
VALUES("FIN_APPL_PRD_RK.sas",3,.)
VALUES("FPA_ACCT_SCR.sas",3,.)
VALUES("SCORE_APPL_ACCOUNT.sas",3,.)
VALUES("VARIABLE_EXT.sas",3,.)
VALUES("ACCT_MODEL_POOL_SCH.sas",5,.)
VALUES("ACT_LGD_COUNTRY_CD.sas",5,.)
VALUES("AM_POOL_SCHEME_APS_TRANSPOSED.sas",5,.)
VALUES("AM_POOLSCHEME_CAS_TRANSPOSED.sas",5,.)
VALUES("APPL_MODEL_SCH_SPLIT.sas",5,.)
VALUES("CCF_CUSTOMER_RK.sas",5,.)
VALUES("FIN_ACT_APP.sas",5,.)
VALUES("FIN_APPLICANT_RK.sas",5,.)
VALUES("PD_CUSTOMER_RK.sas",5,.)
VALUES("SCORE_CARD_VARIABLE_DIM.sas",5,.)
VALUES("ACCT_MOD_VAR_SCR.sas",6,.)
VALUES("ACCT_MODEL_POOL_SCH_SPLIT.sas",6,.)
VALUES("AM_CAS_FA_CUXFA.sas",6,.)
VALUES("APP_PD_IO_RK.sas",6,.)
VALUES("APPL_POOL_PD.sas",6,.)
VALUES("APPL_POOL_SCR.sas",6,.)
VALUES("CCF_PRODUCT_RK.sas",6,.)
VALUES("FIN_APP_FU.sas",6,.)
VALUES("MOD_VAR_GRP.sas",6,.)
VALUES("PD_PRODUCT_RK.sas",6,.)
VALUES("SCORE_CARD_PRE_FACT.sas",6,.)
VALUES("SCORE_RANGE_PRE_FACT.sas",6,.)
VALUES("SPLIT_ACCOUNT_POOLSCHEME_TYPES.sas",6,.)
VALUES("SPLIT_APPLICATION_POOLSCHEME_TYPES.sas",6,.)
VALUES("ACCT_POOL_CCF.sas",7,.)
VALUES("ACCT_POOL_LGD.sas",7,.)
VALUES("ACCT_POOL_PD.sas",7,.)
VALUES("ACCT_POOL_SCR.sas",7,.)
VALUES("APPL_MODEL_SCR_SCH.sas",7,.)
VALUES("CCF_POOL_SCHEME_SK.sas",7,.)
VALUES("DISBRS_APRVD_AMT.sas",7,.)
VALUES("LGD_PRODUCT_RK.sas",7,.)
VALUES("MOD_VAR_SCR.sas",7,.)
VALUES("PD_APP_POOL.sas",7,.)
VALUES("PD_POOL.sas",7,.)
VALUES("PDLGD_POOL.sas",7,.)
VALUES("PDLGDCCF_POOL.sas",7,.)
VALUES("POOL_SCHEME_MODEL_SK.sas",7,.)
VALUES("POOL_SCHEME_SK.sas",7,.)
VALUES("SCORE_APP_POOL.sas",7,.)
VALUES("SCORE_POOL.sas",7,.)
VALUES("ACCOUNT_CCF_PRE_FACT.sas",8,.)
VALUES("ACCOUNT_LGD_APP.sas",8,.)
VALUES("ACCOUNT_PD_APP.sas",8,.)
VALUES("ACCT_POOL.sas",8,.)
VALUES("APPL_MODEL_SCR_EST_PD.sas",8,.)
VALUES("APPLICATION_PD_APP.sas",8,.)
VALUES("EXPOSR_AT_DEFAULT.sas",8,.)
VALUES("FIN_APP_SCR_AMT.sas",8,.)
VALUES("MOD_VAR_GRP_SCR.sas",8,.)
VALUES("ACCOUNT_CCF_FACT.sas",9,.)
VALUES("ACCOUNT_PD_APP_POOL_SCHEME_SK.sas",9,.)
VALUES("ACCT_MODEL_POOL.sas",9,.)
VALUES("ANALYTICAL_POOL_RK.sas",9,.)
VALUES("APPL_MODEL_SCR_ACCT.sas",9,.)
VALUES("APPLICATION_ANALYSIS_LOOK_UP.sas",9,.)
VALUES("APPLPDAPP_POOL_SCHEME_MODEL_SK.sas",9,.)
VALUES("SCORE_CARD_DIM.sas",9,.)
VALUES("ACCOUNT_CCF_FACT_EXT.sas",10,.)
VALUES("ACCPDAPP_POOLSCHSK_SCR.sas",10,.)
VALUES("ACCT_MODEL_SCR.sas",10,.)
VALUES("ACT_LGD_POOL_RK.sas",10,.)
VALUES("APP_LOW_HIGH_SIDE.sas",10,.)
VALUES("APPL_MODEL_SCR_ACCT_SNPSHT.sas",10,.)
VALUES("APPLPDAPP_POOLSCHMODSK_SCR.sas",10,.)
VALUES("REC_AMT_AGG.sas",10,.)
VALUES("SCORE_CARD_FACT.sas",10,.)
VALUES("SCORE_CARD_VARIABLE_FACT_PDO_DEVY.sas",10,.)
VALUES("SCORE_RANGE_FACT.sas",10,.)
VALUES("ACCOUNT_RK_CURNT_PRD.sas",11,.)
VALUES("ACCPDAPP_POOLSCHSK_SCR_ACCPOOL.sas",11,.)
VALUES("ACCT_MODEL_SCR_EST_PD.sas",11,.)
VALUES("ACT_DEF_REC_SK.sas",11,.)
VALUES("APPL_MODEL_SCR_ACCT_SNPSHT_RT.sas",11,.)
VALUES("APPLICATION_ANALYSIS_FACT.sas",11,.)
VALUES("APPLPDAPP_PLSCHMODSKSCR_APPPOOL.sas",11,.)
VALUES("SCORE_CARD_VARIABLE_FACT_PDO_DEVN.sas",11,.)
VALUES("ACCOUNT_LGD_PRE_FACT.sas",12,.)
VALUES("ACCPDAPP_POOLSCHSK_SCR_ACCPOOLRT.sas",12,.)
VALUES("ACCT_SNPSHT_TIME_MODEL.sas",12,.)
VALUES("ACT_CURNT_LMT_AMT.sas",12,.)
VALUES("APPL_MODEL_POOL_SCR_ALL.sas",12,.)
VALUES("APPLPD_PLMODSCHSKSCR_APL_RT.sas",12,.)
VALUES("ACCOUNT_LGD_FACT.sas",13,.)
VALUES("ACCOUNT_PD_PRE_FACT.sas",13,.)
VALUES("ACCT_SNPSHT_TIME_MODEL_RT.sas",13,.)
VALUES("APPLICATION_PD_PRE_FACT.sas",13,.)
VALUES("DEFAULT_DATE_AND_EAD.sas",13,.)
VALUES("MODEL_DEV_APPL_FACT.sas",13,.)
VALUES("ACCOUNT_LGD_FACT_EXT_UPD1.sas",14,.)
VALUES("ACCOUNT_PD_FACT.sas",14,.)
VALUES("APPLICATION_PD_FACT.sas",14,.)
VALUES("MODEL_DEV_FACT.sas",14,.)
VALUES("PR_CURRENT_ACCOUNT_RK.sas",14,.)
VALUES("ACCOUNT_PD_FACT_EXT.sas",15,.)
VALUES("ACT_DIM_ACT_LGD_EXT_UPD1.sas",15,.)
VALUES("APPLICATION_PD_FACT_EXT.sas",15,.)
VALUES("CCF_PRIOR_ACT_SK.sas",15,.)
VALUES("MODEL_MEASURE_FACT_PDO_DEVY.sas",21,.)
VALUES("APPLICATION_PD_RK.sas",16,.)
VALUES("CCF_PRIOR_AVG_BAL_AMT.sas",16,.)
VALUES("DEF_ACT_LGD_LD_FIN.sas",16,.)
VALUES("MODEL_MEASURE_FACT_PDO_DEVN.sas",22,.)
VALUES("TRG_SCR_TIME_ACT_DIM.sas",16,.)
VALUES("ACT_APPL_PD_RK.sas",17,.)
VALUES("CCF_UPDATE_TABLE.sas",17,.)
VALUES("DEF_DIM_ACT_RK_LKP.sas",17,.)
VALUES("MODEL_MEASURE_FACT_LGD_DEVY.sas",25,.)
VALUES("TRG_SCR_TIME_ACT_KEY.sas",17,.)
VALUES("ACTUL_GD_BAD_CAL.sas",18,.)
VALUES("APPL_PD_ACTUAL_GOOD_BAD.sas",18,.)
VALUES("MODEL_MEASURE_FACT_LGD_DEVN.sas",26,.)
VALUES("UPD_ACCOUNT_CCF_FACT.sas",18,.)
VALUES("UPD_ACT_LGD_FACT_PRE.sas",18,.)
VALUES("ACCOUNT_LGD_FACT_EXT_UPD2.sas",19,.)
VALUES("MODEL_MEASURE_FACT_CCF_DEVY.sas",19,.)
VALUES("UPD_ACCOUNT_PD_FACT.sas",19,.)
VALUES("UPD_APPLICATION_PD_FACT.sas",19,.)
VALUES("ACT_DIM_ACT_LGD_EXT_UPD2.sas",20,.)
VALUES("MODEL_MEASURE_FACT_CCF_DEVN.sas",20,.)
VALUES("ACT_LGD_ALL_SK_UPD.sas",21,.)
VALUES("MODEL_MEASURE_FACT_PDA_DEVY.sas",23,.)
VALUES("ACT_LGD_ALL_REC_SUMM.sas",22,.)
VALUES("MODEL_MEASURE_FACT_PDA_DEVN.sas",24,.)
VALUES("ACTUL_LGD_LOSS_CAL.sas",23,.)
VALUES("UPD_ACT_LGD_FACT.sas",24,.)
VALUES("VW_ACCTSNPSHT_CCF.sas",1,.)
VALUES("VW_DELINQ_TMP.sas",1,.)
VALUES("VW_DELINQUENCY.sas",2,.)
VALUES("VW_VINTAGE_ANALYSIS.sas",1,.)
VALUES("VW_POOL_LGD_TMP.sas",14,.)
VALUES("VW_POOL_LGD.sas",15,.)
VALUES("VW_POOL_PD_TMP.sas",15,.)
VALUES("VW_POOL_PD.sas",16,.)
;
quit;
%mend check_seg_job_depnd_table;
%check_seg_job_depnd_table;