proc sql;

/* Insert and update in ABT metadata */
/* Please review the script before you run the script */

/* 
Update in var_master dataset
*/

update analytic.var_master 
set agg_var_nm = 'ACC_DSB_CURR_MTH_AMT',
agg_table_nm = 'ACC_BASIC_LTD_X_CURR_ABT'
where strip(agg_var_nm)='ACC_DSBR_CURR_MTH_AMT';
	
update analytic.var_master 
set var_desc = "The total closing cost amount include application underwriting and loan-origination fees, mortgage points, title search and insurance fees for related legal services and costs to fund an escrow account"
where strip(var_nm)='ACC_CLS_FEE_AMT_12';

/* create table for ABT Model information capture feature */

create table CONTROL.PARAMETER_LIST_MODEL_JOBS( bufsize=8192 )
  (
   JOB_NM char(40),
   LEVEL_NO num,
   RETURN_CD num
  );
create unique index XPI_JOB_NM_LVL_NO on CONTROL.PARAMETER_LIST_MODEL_JOBS(JOB_NM,LEVEL_NO);

insert into CONTROL.PARAMETER_LIST_CREDIT_SCORING (JOB_NM ,LEVEL_NO ,RETURN_CD)
VALUES("AM_EXT_ABT_FW.sas",1,.)
VALUES("ANALYTICAL_MODEL_PRE_DIM.sas",2,.)
VALUES("ANALYTICAL_MODEL_DIM.sas",3,.);
	
quit;

%include "Data/bisdata/code/frame_work_script/abt_purpose_crs.sas";
%include "Data/bisdata/code/frame_work_script/abt_purpose_x_level_crs.sas";
%include "Data/bisdata/code/frame_work_script/abt_purpose_x_product_crs.sas";
%include "Data/bisdata/code/frame_work_script/outcome_master.sas";
%include "Data/bisdata/code/frame_work_script/outcome_master_sub.sas";
