proc sql;

/* Insert and update parameter values */
/* Please review the script and check your parameter values before you run the script */

update custpara.parameter
set PARAMETER_VALUE = "&PD_APP_MODEL"
where strip(PARAMETER_NM) = "PDA_ACC_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&PD_APP_MODEL"
where strip(PARAMETER_NM) = "PDA_CUS_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&PD_ONG_MODEL"
where strip(PARAMETER_NM) = "PDO_ACC_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&PD_ONG_MODEL"
where strip(PARAMETER_NM) = "PDO_CUS_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&LGD_MODEL"
where strip(PARAMETER_NM) = "LGD_ACC_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&LGD_MODEL"
where strip(PARAMETER_NM) = "LGD_CUS_MDL";

update custpara.parameter
set PARAMETER_VALUE = "&CCF_MODEL"
where strip(PARAMETER_NM) = "CCF_ACC_MDL";

/* description updates in parameter tables */

update custpara.parameter
set PARAMETER_DESC = "Parameter to set the script path for BIS configuration. This path will be available as a virtual path in the web layer to access the scripts and images."
where strip(PARAMETER_NM) = "CONF_REPORT_PATH";

update custpara.parameter
set PARAMETER_DESC = 
"Parameter to set the traffic lighting rule for the Model Level Dashboard for stability level in LGD Models. If 'Y' then the traffic lighting is calculated based on the measure given by CS_STAB_MSR_NAME_LGD, else by number of tests for LGD Models."
where strip(PARAMETER_NM) = "CS_STAB_MDL_DB_SEL_MSR_LGD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to set the measure name according the which the traffic lighting for model level dashboard for stability level in LGD Models will be done if CS_STAB_MDL_DB_SEL_MSR_LGD is set to 'Y'."
where strip(PARAMETER_NM) = "CS_STAB_MSR_NAME_LGD";

update custpara.parameter
set PARAMETER_DESC = 
"Parameter to set the traffic lighting rule for the Model Level Dashboard for calibration level in LGD Models. If 'Y' then the traffic lighting is done based on the measure given by CS_CLIB_MDL_DB_SEL_MSR_LGD, else by number of tests for LGD Models."
where strip(PARAMETER_NM) = "CS_CLIB_MDL_DB_SEL_MSR_LGD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the count above which the term is considered to be long term."
where strip(PARAMETER_NM) = "LONG_TERM_DEP_MTH_CNT";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for account profit.For e.g if the value of profit is more than this value then it indicates high profit."
where strip(PARAMETER_NM) = "ACCT_PROFIT_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for account revenue.For e.g if the value of revenue is more than this value then it indicates high revenue."
where strip(PARAMETER_NM) = "ACCT_REVENUE_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for account tenure.For e.g if the value of tenure is more than this value then it indicates high tenure."
where strip(PARAMETER_NM) = "ACCT_TENURE_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for cusotmer relationship size. For e.g. if the value of total cost is more than this value then the relationship_size indicator is set to high."
where strip(PARAMETER_NM) = "CUS_RLTN_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for product account density.For e.g if account density is more than this value then it indicates high account density."
where strip(PARAMETER_NM) = "PR_ACCT_DNS_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for product profit.For e.g if the value of profit more than this value then it indicates high profit."
where strip(PARAMETER_NM) = "PR_PROFIT_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for product revenue.For e.g if the value of revenue is more than this value then it indicates high revenue."
where strip(PARAMETER_NM) = "PR_REVENUE_THRESHOLD";


update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the customer profit. For e.g if the value of profit is more than this value then it indicates high profit."
where strip(PARAMETER_NM) = "CUS_PROFIT_THRESHOLD";


update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the customer revenue. For e.g. if the value of revenue is more than this value then it indicates high revenue."
where strip(PARAMETER_NM) = "CUS_REVENUE_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the internal organization account density. For e.g. if account density is more than this value then it indicates high account density."
where strip(PARAMETER_NM) = "IO_ACCT_DNS_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the internal organization customer density. For e.g. if customer density is more than this value then it indicates high customer density."
where strip(PARAMETER_NM) = "IO_CUST_DNS_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the internal organization profit. For e.g. if the value of profit is more than this value then it indicates high profit."
where strip(PARAMETER_NM) = "IO_PROFIT_THRESHOLD";

update custpara.parameter
set PARAMETER_DESC = "Parameter to specify the threshold for the internal organization revenue. For e.g. if the value of revenue is more than this value then it indicates high revenue."
where strip(PARAMETER_NM) = "IO_REVENUE_THRESHOLD";

/* Insertion of new parameters */

insert into custpara.PARAMETER 
(PARAMETER_NO ,PARAMETER_NM ,PARAMETER_VALUE ,PARAMETER_DESC)
VALUES(443,"COL_TYPE_PRP","'PRP'","Parameter to specify collateral type to property");
	
insert into custpara.parameter_x_category (PARAMETER_NO, CATEGORY_CD) 
VALUES(443, "Property Collateral");

insert into custpara.parameter_category (CATEGORY_CD, PARENT_CATEGORY_CD) 
VALUES("Property Collateral", "Foundation Mart");

quit;
