%macro check_pool_menu_table;
proc sql;
%if %sysfunc(exist(POOL.POOL_MENU_ITEMS)) eq 0 %then %do;
	CREATE TABLE POOL.POOL_MENU_ITEMS( bufsize=16384 )
	  (
	   MENU_NO num label='Unique key representing the menu item',
	   MENU_NM char(100) label='Name of the menu item',
	   PROGRAM_NM char(100) label='Name of the stored process to be called linked to the menu item'
	  );
	create unique index MENU_NO on pool.POOL_MENU_ITEMS(MENU_NO);
%end;

insert into POOL.POOL_MENU_ITEMS (
MENU_NO ,MENU_NM ,PROGRAM_NM 
)
VALUES(2,"Define Pool Scheme","SBIP://Foundation/BIS/pool/build_scheme_data")
VALUES(3,"Define pools based on Score Ranges","SBIP://Foundation/BIS/pool/build_scheme_score_pool")
VALUES(4,"Define pools based on PD Ranges","SBIP://Foundation/BIS/pool/build_scheme_pd_pool")
VALUES(5,"Define pools based on PD and LGD Ranges","SBIP://Foundation/BIS/pool/build_scheme_pd_lgd_pool")
VALUES(6,"Define pools based on PD, LGD and CCF Ranges","SBIP://Foundation/BIS/pool/build_scheme_pd_lgd_ccf_pool")
VALUES(7,"Create Master Scale","SBIP://Foundation/BIS/pool/create_master_scale")
VALUES(8,"Map PD to Master Scale","SBIP://Foundation/BIS/pool/build_scheme_rating_pool")
VALUES(9,"Deploy Scheme","SBIP://Foundation/BIS/pool/deploy_pool_scheme")
;
quit;
%mend check_pool_menu_table;
%check_pool_menu_table;
