/****************************************************************************** 
 * Job:           ACCOUNT_SNAPSHOT                          A52B3KFO.BP00005X * 
 * Description:   This job builds the ACCOUNT_SNAPSHOT fact from              * 
 *                 ACCOUNT_SNAPSHOT_PRE_FACT.                                 * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SNAPSHOT_PRE_FACT -               A52B3KFO.BH0000XK * 
 *                 martscr.ACCOUNT_SNAPSHOT_PRE_FACT                          * 
 *                BEHV_CS_BRIDGE_SEGMENT_EXT -              A52B3KFO.BH0000S2 * 
 *                 martscr.BEHV_CS_BRIDGE_SEGMENT_EXT                         * 
 *                TIME_DIM_EXT - martscr.TIME_DIM_EXT       A52B3KFO.BH0000X2 * 
 *                ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A52B3KFO.BH0000WC * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A52B3KFO.BH0000WN * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 *                EMPLOYEE_DIM_EXT -                        A52B3KFO.BH0000WL * 
 *                 martscr.EMPLOYEE_DIM_EXT                                   * 
 *                CHANNEL_DIM_EXT - martscr.CHANNEL_DIM_EXT A52B3KFO.BH0000WG * 
 *                INTERNAL_ORG_DIM_EXT -                    A52B3KFO.BH0000WS * 
 *                 martscr.INTERNAL_ORG_DIM_EXT                               * 
 * Target Tables: ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A52B3KFO.BH0000XY * 
 *                ACCOUNT_SNAPSHOT_EXP -                    A52B3KFO.BH0000Y7 * 
 *                 facterr.ACCOUNT_SNAPSHOT_EXP                               * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 9:30:06 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * ACCOUNT_SNAPSHOT                                                           * 
 * Job Name: ACCOUNT_SNAPSHOTJob Desc Pre Process: NoneMain: a) Data is       * 
 * picked up from ACCOUNT_SNAPSHOT_PRE_FACT and EMPLOYEE_DIM_EXT,             * 
 * CHANNEL_DIM_EXT, FINANCIAL_PRODUCT_DIM_EXT, INTERNAL_ORG_DIM_EXT,          * 
 * TIME_DIM_EXT, ACCOUNT_DIM_EXT and BEHV_CS_BRIDGE_SEGMENT are used for      * 
 * lookup.b) The lookup returnsEMPLOYEE_SK from EMPLOYEE_DIM_EXT,CHANNEL_SK   * 
 * from CHANNEL_DIM_EXT,PRODUCT_SK from                                       * 
 * FINANCIAL_PRODUCT_DIM_EXT,INTERNAL_ORG_SK from                             * 
 * INTERNAL_ORG_DIM_EXT,TIME_SK from TIME_DIM_EXT,CURRENT_LIMIT_AMT and       * 
 * ACCOUNT_SK from ACCOUNT_DIM_EXT andSEGMENT_SK from                         * 
 * BEHV_CS_BRIDGE_SEGMENT.For Age_Range, Tenure_Range and Employee SKs, if    * 
 * the underlying columns have null values available, the DUMMY_SKs will be   * 
 * populated in the ETL logic in job ACCOUNT_SNAPSHOT_PRE_FACT.c) The         * 
 * exception table ACCOUNT_SNAPSHOT_EXP is loaded if any exception is         * 
 * thrown during the lookup.d) The data is appended in to the fact table      * 
 * for the current month.Post Process: NoneParameters: NoneDeveloped by:      * 
 *  singupReviewed by:Tested by:                                              * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00005X);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACCOUNT_SNAPSHOT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          ACCOUNT_SNAPSHOT Lookup                   A52B3KFO.BQ0000D3 * 
 * Transform:     Lookup                                                      * 
 * Description:   ACCOUNT_SNAPSHOT Lookup to obtain SEGMENT_SK,               * 
 *                SALES_CHANNEL_SK, OWNED_BY_INTERNAL_ORG_SK, TIME_SK,        * 
 *                EMPLOYEE_SK, PRODUCT_SK, ACCOUNT_SK and                     * 
 *                 CURRENT_LIMIT_AMT.                                         * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SNAPSHOT_PRE_FACT -               A52B3KFO.BH0000XK * 
 *                 martscr.ACCOUNT_SNAPSHOT_PRE_FACT                          * 
 *                BEHV_CS_BRIDGE_SEGMENT_EXT -              A52B3KFO.BH0000S2 * 
 *                 martscr.BEHV_CS_BRIDGE_SEGMENT_EXT                         * 
 *                TIME_DIM_EXT - martscr.TIME_DIM_EXT       A52B3KFO.BH0000X2 * 
 *                ACCOUNT_DIM_EXT - martscr.ACCOUNT_DIM_EXT A52B3KFO.BH0000WC * 
 *                FINANCIAL_PRODUCT_DIM_EXT -               A52B3KFO.BH0000WN * 
 *                 martscr.FINANCIAL_PRODUCT_DIM_EXT                          * 
 *                EMPLOYEE_DIM_EXT -                        A52B3KFO.BH0000WL * 
 *                 martscr.EMPLOYEE_DIM_EXT                                   * 
 *                CHANNEL_DIM_EXT - martscr.CHANNEL_DIM_EXT A52B3KFO.BH0000WG * 
 *                INTERNAL_ORG_DIM_EXT -                    A52B3KFO.BH0000WS * 
 *                 martscr.INTERNAL_ORG_DIM_EXT                               * 
 * Target Tables: Lookup Target -                           A52B3KFO.BR00006H * 
 *                 martscr.ACCOUNT_SNAPSHOT_LKP                               * 
 *                Exception WorkTable - work.W5CC572R       A52B3KFO.BR00006I * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0000D3); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete ACCOUNT_SNAPSHOT_LKP;
quit;

proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5CC572R;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.ACCOUNT_SNAPSHOT_LKP
         (keep = CUSTOMER_SK ACCOUNT_SK PRODUCT_SK TIME_SK 
                 OWNED_BY_INTERNAL_ORG_SK SALES_CHANNEL_SK SEGMENT_SK 
                 EMPLOYEE_SK CUSTOMER_TENURE_RANGE_SK AGE_RANGE_SK 
                 DELINQUENCY_RANGE_SK BALANCE_AMT INTEREST_EXPECTED_AMT 
                 PRINCIPAL_BALANCE_AMT PAST_DUE_AMT DAYS_PAYMENT_PAST_DUE_CNT 
                 AVERAGE_DAILY_BALANCE_AMT MAX_ACCOUNT_VALUE_AMT 
                 MIN_ACCOUNT_VALUE_AMT BILLED_AMT CURRENT_BILL_AMT 
                 MIN_BILLING_AMT LAST_STATEMENT_DT ACTIVE_ACCOUNT_CNT 
                 INACTIVE_ACCOUNT_CNT CLOSED_ACCOUNT_CNT OPEN_ACCOUNT_CNT 
                 DELINQUENCY_CNT LATE_PAYMENT_CNT DIFFER_PAYMENT_CNT DEFAULT_CNT 
                 NEW_ACCOUNT_CNT CROSS_SELL_ACCOUNT_CNT CROSS_SELL_CAMPAIGN_IND 
                 UP_SELL_ACCOUNT_CNT CCD_TOT_POINTS_EARNED 
                 CCD_TOT_POINTS_REDEEMED CCD_POINTS_BALANCE 
                 LAST_PAYMENT_STATUS_CD CURRENT_LIMIT_AMT FEES_AMT 
                 CURTAILMENT_AMT ESCROW_AMT CLEARED_BALANCE_AMT 
                 NEXT_INTEREST_PAYMENT_DT TOTAL_BALANCE_AMT 
                 TOTAL_SUSPENSIONS_CNT OVERDRAFT_CURRENT_AMT)
      work.W5CC572R 
         (keep = etls_source_row etls_lookup_table etls_exception_cond 
                 etls_exception_action CAL_MONTH_LAST_DT CUSTOMER_SK EMPLOYEE_RK 
                 ACCOUNT_RK PRODUCT_RK OWNED_BY_INTERNAL_ORG_RK 
                 CUSTOMER_TENURE_RANGE_SK AGE_RANGE_SK DELINQUENCY_RANGE_SK 
                 BILLED_AMT CURRENT_BILL_AMT BALANCE_AMT INTEREST_EXPECTED_AMT 
                 PRINCIPAL_BALANCE_AMT PAST_DUE_AMT DAYS_PAYMENT_PAST_DUE_CNT 
                 AVERAGE_DAILY_BALANCE_AMT MAX_ACCOUNT_VALUE_AMT 
                 MIN_ACCOUNT_VALUE_AMT MIN_BILLING_AMT FEES_AMT CURTAILMENT_AMT 
                 LAST_STATEMENT_DT LATE_PAYMENT_CNT CCD_TOT_POINTS_EARNED 
                 CCD_TOT_POINTS_REDEEMED CCD_POINTS_BALANCE LAST_PAYMENT_STATUS_CD 
                 OPENING_CHANNEL_CD ACTIVE_ACCOUNT_CNT INACTIVE_ACCOUNT_CNT 
                 CLOSED_ACCOUNT_CNT OPEN_ACCOUNT_CNT DELINQUENCY_CNT 
                 DIFFER_PAYMENT_CNT DEFAULT_CNT NEW_ACCOUNT_CNT 
                 CROSS_SELL_ACCOUNT_CNT CROSS_SELL_CAMPAIGN_IND ESCROW_AMT 
                 UP_SELL_ACCOUNT_CNT CLEARED_BALANCE_AMT NEXT_INTEREST_PAYMENT_DT 
                 TOTAL_SUSPENSIONS_CNT OVERDRAFT_CURRENT_AMT TOTAL_BALANCE_AMT 
                 LOAD_END_DTTM)
      ; 
   
   attrib CUSTOMER_SK length=8 format=12.
          ACCOUNT_SK length=8 format=12.
          PRODUCT_SK length=8 format=12.
          TIME_SK length=8 format=12. label="TIME_SK"
          OWNED_BY_INTERNAL_ORG_SK length=8 format=12.
          SALES_CHANNEL_SK length=8 format=12.
          SEGMENT_SK length=8 format=12.
          EMPLOYEE_SK length=8 format=12. label="Employee Key"
          CUSTOMER_TENURE_RANGE_SK length=8
          AGE_RANGE_SK length=8 format=12.
          DELINQUENCY_RANGE_SK length=8 format=12.
          BALANCE_AMT length=8 format=NLNUM18.5 label="Balance Amount"
          INTEREST_EXPECTED_AMT length=8 format=NLNUM18.5 label="Interest Balance Amount"
          PRINCIPAL_BALANCE_AMT length=8 format=NLNUM18.5 label="Principal Balance Amount"
          PAST_DUE_AMT length=8 format=NLNUM18.5 label="Past Due Amount"
          DAYS_PAYMENT_PAST_DUE_CNT length=8 label="No of Days Payment Past Due"
          AVERAGE_DAILY_BALANCE_AMT length=8 format=NLNUM18.5 label="Average Daily Balance Amount"
          MAX_ACCOUNT_VALUE_AMT length=8 format=NLNUM18.5 label="Maximum Account Value Amount"
          MIN_ACCOUNT_VALUE_AMT length=8 format=NLNUM18.5 label="Minimum Account Value Amount"
          BILLED_AMT length=8 format=NLNUM18.5 label="Billed Amount"
          CURRENT_BILL_AMT length=8 format=NLNUM18.5 label="Current Bill Amount"
          MIN_BILLING_AMT length=8 format=NLNUM18.5 label="Minimum Due Amount"
          LAST_STATEMENT_DT length=8 label="Statement Date"
          ACTIVE_ACCOUNT_CNT length=8
          INACTIVE_ACCOUNT_CNT length=8
          CLOSED_ACCOUNT_CNT length=8
          OPEN_ACCOUNT_CNT length=8
          DELINQUENCY_CNT length=8
          LATE_PAYMENT_CNT length=8 label=
          "Number of late payment transactions, performed by all the Sk''s."
          DIFFER_PAYMENT_CNT length=8
          DEFAULT_CNT length=8
          NEW_ACCOUNT_CNT length=8
          CROSS_SELL_ACCOUNT_CNT length=8
          CROSS_SELL_CAMPAIGN_IND length=8
          UP_SELL_ACCOUNT_CNT length=8
          CCD_TOT_POINTS_EARNED length=8 format=NLNUM6.2 label="Total No Points Earned"
          CCD_TOT_POINTS_REDEEMED length=8 format=NLNUM6.2 label="Total No Points Redeemed"
          CCD_POINTS_BALANCE length=8 format=NLNUM18.5 label="Credit Card Points Balance"
          LAST_PAYMENT_STATUS_CD length=$3
          CURRENT_LIMIT_AMT length=8
          FEES_AMT length=8 format=NLNUM18.5 label="Fees Amount"
          CURTAILMENT_AMT length=8 format=NLNUM18.5 label="Curtailment Amount"
          ESCROW_AMT length=8 format=NLNUM18.5 label="Escrow Amount"
          CLEARED_BALANCE_AMT length=8 format=NLNUM18.5 label="Cleared Balance Amount"
          NEXT_INTEREST_PAYMENT_DT length=8 format=NLDATE10. label="Next Interest Payment Date"
          TOTAL_BALANCE_AMT length=8 format=NLNUM18.5 label="Total Balance Amount"
          TOTAL_SUSPENSIONS_CNT length=8
          OVERDRAFT_CURRENT_AMT length=8 format=NLNUM18.5
          ; 
   
   length etls_lookup_table $41 etls_exception_cond etls_exception_action $32 
   BEHV_SEGMENT_SK 8 LOAD_END_DTTM 8 CAL_MONTH_LAST_DT 8 ACCOUNT_RK 8 PRODUCT_RK 8 EMPLOYEE_RK 8 CHANNEL_SK 8 CHANNEL_CD $3 INTERNAL_ORG_SK 8 INTERNAL_ORG_RK 8 ; 
   
   retain missing0 0 missing1 0 missing2 0 missing3 0 missing4 0 missing5 0 missing6 0 ; 
   
   /* Assign variables used for error/exception handling  */ 
   etls_source_row      = _n_;
   request_write_target = 0; 
   request_write_error  = 0; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.BEHV_CS_BRIDGE_SEGMENT_EXT */ 
      nlobs = .; 
      dsid = open("martscr.BEHV_CS_BRIDGE_SEGMENT_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.BEHV_CS_BRIDGE_SEGMENT_EXT", hashexp: exponent);
            h0.defineKey( "CUSTOMER_SK",
                           "LOAD_END_DTTM");
            h0.defineData( "BEHV_SEGMENT_SK");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.BEHV_CS_BRIDGE_SEGMENT_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table martscr.TIME_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.TIME_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "martscr.TIME_DIM_EXT", hashexp: exponent);
            h1.defineKey( "LOAD_END_DTTM",
                           "CAL_MONTH_LAST_DT");
            h1.defineData( "TIME_SK");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.TIME_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.TIME_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.TIME_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.TIME_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.TIME_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.TIME_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table martscr.ACCOUNT_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.ACCOUNT_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "martscr.ACCOUNT_DIM_EXT", hashexp: exponent);
            h2.defineKey( "LOAD_END_DTTM",
                           "ACCOUNT_RK");
            h2.defineData( "ACCOUNT_SK",
                           "CURRENT_LIMIT_AMT");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.ACCOUNT_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.ACCOUNT_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.ACCOUNT_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.ACCOUNT_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.ACCOUNT_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.ACCOUNT_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h3 from lookup table martscr.FINANCIAL_PRODUCT_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.FINANCIAL_PRODUCT_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h3(dataset: "martscr.FINANCIAL_PRODUCT_DIM_EXT", hashexp: exponent);
            h3.defineKey( "PRODUCT_RK",
                           "LOAD_END_DTTM");
            h3.defineData( "PRODUCT_SK");
            h3.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h3.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.FINANCIAL_PRODUCT_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.FINANCIAL_PRODUCT_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.FINANCIAL_PRODUCT_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.FINANCIAL_PRODUCT_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h4 from lookup table martscr.EMPLOYEE_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.EMPLOYEE_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h4(dataset: "martscr.EMPLOYEE_DIM_EXT", hashexp: exponent);
            h4.defineKey( "LOAD_END_DTTM",
                           "EMPLOYEE_RK");
            h4.defineData( "EMPLOYEE_SK");
            h4.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h4.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.EMPLOYEE_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.EMPLOYEE_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.EMPLOYEE_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.EMPLOYEE_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.EMPLOYEE_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.EMPLOYEE_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h5 from lookup table martscr.CHANNEL_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.CHANNEL_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h5(dataset: "martscr.CHANNEL_DIM_EXT", hashexp: exponent);
            h5.defineKey( "LOAD_END_DTTM",
                           "CHANNEL_CD");
            h5.defineData( "CHANNEL_SK");
            h5.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h5.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.CHANNEL_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.CHANNEL_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.CHANNEL_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.CHANNEL_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.CHANNEL_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.CHANNEL_DIM_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h6 from lookup table martscr.INTERNAL_ORG_DIM_EXT */ 
      nlobs = .; 
      dsid = open("martscr.INTERNAL_ORG_DIM_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h6(dataset: "martscr.INTERNAL_ORG_DIM_EXT", hashexp: exponent);
            h6.defineKey( "LOAD_END_DTTM",
                           "INTERNAL_ORG_RK");
            h6.defineData( "INTERNAL_ORG_SK");
            h6.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h6.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.INTERNAL_ORG_DIM_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.INTERNAL_ORG_DIM_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.INTERNAL_ORG_DIM_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.INTERNAL_ORG_DIM_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.INTERNAL_ORG_DIM_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.INTERNAL_ORG_DIM_EXT";
         
         abort 3; 
      end; 
      
      call missing (CUSTOMER_SK, LOAD_END_DTTM, BEHV_SEGMENT_SK, 
                    CAL_MONTH_LAST_DT, TIME_SK, ACCOUNT_RK, ACCOUNT_SK, 
                    CURRENT_LIMIT_AMT, PRODUCT_RK, PRODUCT_SK, EMPLOYEE_RK, 
                    EMPLOYEE_SK, CHANNEL_CD, CHANNEL_SK, INTERNAL_ORG_RK, 
                    INTERNAL_ORG_SK); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.ACCOUNT_SNAPSHOT_PRE_FACT end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   SEGMENT_SK = BEHV_SEGMENT_SK;
   
   /* Is the current key value stored in hash h1?  */ 
   rc1 = h1.find();
   
   /* Is the current key value stored in hash h2?  */ 
   rc2 = h2.find();
   
   /* Is the current key value stored in hash h3?  */ 
   rc3 = h3.find();
   
   /* Is the current key value stored in hash h4?  */ 
   rc4 = h4.find();
   
   /* Is the current key value stored in hash h5?  */ 
   CHANNEL_CD = OPENING_CHANNEL_CD;
   rc5 = h5.find();
   SALES_CHANNEL_SK = CHANNEL_SK;
   
   /* Is the current key value stored in hash h6?  */ 
   INTERNAL_ORG_RK = OWNED_BY_INTERNAL_ORG_RK;
   rc6 = h6.find();
   OWNED_BY_INTERNAL_ORG_SK = INTERNAL_ORG_SK;
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0and rc2=0and rc3=0and rc4=0and rc5=0and rc6=0) then 
   do; 
      /* Write row to target  */ 
      output martscr.ACCOUNT_SNAPSHOT_LKP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.BEHV_CS_BRIDGE_SEGMENT_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.TIME_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.ACCOUNT_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc3 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.FINANCIAL_PRODUCT_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc4 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.EMPLOYEE_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc5 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.CHANNEL_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
      
      if (rc6 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Write exception row  */ 
         etls_lookup_table = "martscr.INTERNAL_ORG_DIM_EXT"; 
         etls_exception_cond = "Lookup Value Not Found"; 
         etls_exception_action = "Add Row to Exception Table"; 
         /* Write row to exception table  */ 
         output work.W5CC572R; 
         /* Check: Lookup value not found-Skip the record  */ 
         return; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Loader                                    A52B3KFO.BQ0000D2 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Exception WorkTable - work.W5CC572R       A52B3KFO.BR00006I * 
 * Target Table:  ACCOUNT_SNAPSHOT_EXP -                    A52B3KFO.BH0000Y7 * 
 *                 facterr.ACCOUNT_SNAPSHOT_EXP                               * 
 *============================================================================*/ 

/* Access the data for Lookup Error Tables  */ 
LIBNAME facterr BASE "Data/bisdata/error" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(work.W5CC572R); 

%let transformID = %quote(A52B3KFO.BQ0000D2); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, DATA)) or 
         %sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, VIEW))); 
   
   %if (&etls_tableExist gt 0) %then 
   %do;  /* if table exists  */ 
   
      /*---- Drop a table  ----*/ 
      %put %str(NOTE: Dropping table ...);
      proc datasets lib = facterr nolist nodetails;
           delete ACCOUNT_SNAPSHOT_EXP;
      quit;
      
      %rcSet(&syserr); 
      
      %let etls_tableExist = 0;
      
   %end;  /* if table exists  */ 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data facterr.ACCOUNT_SNAPSHOT_EXP
              (label = 'ACCOUNT_SNAPSHOT_EXP');
         attrib etls_exception_action length = $32
                   label = 'The name of the action to take for this exception'; 
         attrib etls_lookup_table length = $41
                   label = 'The name of the lookup table'; 
         attrib etls_source_row length = 8
                   label = 'The row number in the source table'; 
         attrib etls_exception_cond length = $32
                   label = 'The name of the condition that caused this exception'; 
         attrib OWNED_BY_INTERNAL_ORG_RK length = 8 format = 12. informat = 12.
                   label = 'Internal Organization Retained Key'; 
         attrib PAST_DUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Past Due Amount'; 
         attrib CCD_POINTS_BALANCE length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Credit Card Points Balance'; 
         attrib UP_SELL_ACCOUNT_CNT length = 8; 
         attrib DEFAULT_CNT length = 8; 
         attrib CUSTOMER_TENURE_RANGE_SK length = 8; 
         attrib PRINCIPAL_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Principal Balance Amount'; 
         attrib CCD_TOT_POINTS_REDEEMED length = 8 format = NLNUM6.2 informat = NLNUM6.2
                   label = 'Total No Points Redeemed'; 
         attrib CLEARED_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Cleared Balance Amount'; 
         attrib DIFFER_PAYMENT_CNT length = 8; 
         attrib TOTAL_SUSPENSIONS_CNT length = 8; 
         attrib FEES_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Fees Amount'; 
         attrib INTEREST_EXPECTED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Interest Balance Amount'; 
         attrib NEXT_INTEREST_PAYMENT_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = 'Next Interest Payment Date'; 
         attrib AGE_RANGE_SK length = 8 format = 12. informat = 12.; 
         attrib OPENING_CHANNEL_CD length = $3; 
         attrib DELINQUENCY_CNT length = 8; 
         attrib OVERDRAFT_CURRENT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Overdraft Current Amount'; 
         attrib BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Balance Amount'; 
         attrib MIN_ACCOUNT_VALUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Minimum Account Value Amount'; 
         attrib LAST_PAYMENT_STATUS_CD length = $3; 
         attrib DELINQUENCY_RANGE_SK length = 8 format = 12. informat = 12.; 
         attrib CAL_MONTH_LAST_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = 'MONTH_END_DT'; 
         attrib CURRENT_BILL_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Current Bill Amount'; 
         attrib OPEN_ACCOUNT_CNT length = 8; 
         attrib TOTAL_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Total Balance Amount'; 
         attrib MIN_BILLING_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Minimum Due Amount'; 
         attrib CLOSED_ACCOUNT_CNT length = 8; 
         attrib LAST_STATEMENT_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = 'Statement Date'; 
         attrib LOAD_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = 'Load End Datetime'; 
         attrib CUSTOMER_SK length = 8; 
         attrib ESCROW_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Escrow Amount'; 
         attrib BILLED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Billed Amount'; 
         attrib MAX_ACCOUNT_VALUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Maximum Account Value Amount'; 
         attrib ACTIVE_ACCOUNT_CNT length = 8; 
         attrib CURTAILMENT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Curtailment Amount'; 
         attrib EMPLOYEE_RK length = 8 format = 12. informat = 12.
                   label = 'Employee Key'; 
         attrib INACTIVE_ACCOUNT_CNT length = 8; 
         attrib CROSS_SELL_CAMPAIGN_IND length = 8; 
         attrib AVERAGE_DAILY_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = 'Average Daily Balance Amount'; 
         attrib ACCOUNT_RK length = 8 format = 12. informat = 12.
                   label = 'Account Key'; 
         attrib CROSS_SELL_ACCOUNT_CNT length = 8; 
         attrib CCD_TOT_POINTS_EARNED length = 8 format = NLNUM6.2 informat = NLNUM6.2
                   label = 'Total No Points Earned'; 
         attrib DAYS_PAYMENT_PAST_DUE_CNT length = 8
                   label = 'No of Days Payment Past Due'; 
         attrib LATE_PAYMENT_CNT length = 8
                   label = 'Number of late payment transactions, performed by all the Sk''s.'; 
         attrib PRODUCT_RK length = 8 format = 12. informat = 12.
                   label = 'Product Key'; 
         attrib NEW_ACCOUNT_CNT length = 8; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, DATA)) or 
            %sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.ACCOUNT_SNAPSHOT_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(ACCOUNT_SNAPSHOT_EXP);
   %let etls_lib   = %nrquote(Lookup Error Tables);
   
   proc append base = facterr.ACCOUNT_SNAPSHOT_EXP 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, DATA)) or 
            %sysfunc(exist(facterr.ACCOUNT_SNAPSHOT_EXP, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = facterr.ACCOUNT_SNAPSHOT_EXP out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
%mend etls_loader;
%etls_loader;

/*============================================================================* 
 * Step:          Incremental Loader                        A52B3KFO.BQ0000D1 * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A52B3KFO.BR00006H * 
 *                 martscr.ACCOUNT_SNAPSHOT_LKP                               * 
 * Target Table:  ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A52B3KFO.BH0000XY * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.ACCOUNT_SNAPSHOT_LKP); 

%let transformID = %quote(A52B3KFO.BQ0000D1); 

%let trans_rc = 0; 

%global etls_tableExist;
%global etls_numIndex;
%global etls_lastTable;
%let etls_tableExist = -1; 
%let etls_numIndex = -1; 
%let etls_lastTable = &SYSLAST; 

/*---- Define load data macro  ----*/ 
%macro etls_loader;

   %let SYSOPT = ;
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(fact.ACCOUNT_SNAPSHOT, DATA)) or 
         %sysfunc(exist(fact.ACCOUNT_SNAPSHOT, VIEW))); 
   
   %if (&etls_tableExist gt 0) %then 
   %do;  /* if table exists  */ 
   
      /*---- Drop indexes from a table  ----*/ 
      %put %str(NOTE: Dropping indexes ...);
      proc datasets lib = work nolist nowarn memtype = (data view);
         delete etls_CIList;
      quit;
      
      proc sql; 
      
         reset noprint; 
         
         create table etls_CIList as 
            select tabname length=100, 
                   idxname length=200 
            from 
            ( 
               select distinct indxname as idxname, 
                      "fact.ACCOUNT_SNAPSHOT" as tabname 
                  from dictionary.indexes 
                     where upcase(libname) eq "FACT" and upcase(memname) eq "ACCOUNT_SNAPSHOT" 
            ); 
         %let etls_numIndex = &sqlObs; 
         
         %let etls_deleteList= etls_CIList; 
         
         %put %str(NOTE: Number of Indexes to be dropped: &etls_numIndex);
         
         %do etls_indexCount = 1 %to &etls_numIndex; 
         
            select idxname, tabname into :etls_indexName , :etls_indexTable 
               from &etls_deleteList 
                       (firstobs = &etls_indexCount 
                        obs = &etls_indexCount); 
               
            %put NOTE: Dropping Index &etls_indexCount: %bquote(&etls_indexName) ...;
            
            drop index &etls_indexName on &etls_indexTable 
            ; 
            
         %end;  /* do loop through indexes  */ 
         
      quit; 
      
      %rcSet(&sqlrc); 
      
      proc datasets lib = work nolist nowarn memtype = (data view);
         delete etls_CIList etls_CIList2;
      quit;
      
   %end;  /* if table exists  */ 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data fact.ACCOUNT_SNAPSHOT
              (label = 'ACCOUNT_SNAPSHOT');
         attrib CUSTOMER_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib ACCOUNT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib PRODUCT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib TIME_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib INTEREST_EXPECTED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib PAST_DUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib DAYS_PAYMENT_PAST_DUE_CNT length = 8; 
         attrib AVERAGE_DAILY_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib MIN_ACCOUNT_VALUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib MAX_ACCOUNT_VALUE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib LAST_STATEMENT_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = '_DT'; 
         attrib OWNED_BY_INTERNAL_ORG_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib BILLED_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib CURRENT_BILL_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib DELINQUENCY_CNT length = 8; 
         attrib ACTIVE_ACCOUNT_CNT length = 8; 
         attrib INACTIVE_ACCOUNT_CNT length = 8; 
         attrib CLOSED_ACCOUNT_CNT length = 8; 
         attrib OPEN_ACCOUNT_CNT length = 8; 
         attrib LATE_PAYMENT_CNT length = 8; 
         attrib DEFAULT_CNT length = 8; 
         attrib NEW_ACCOUNT_CNT length = 8; 
         attrib CROSS_SELL_ACCOUNT_CNT length = 8; 
         attrib CROSS_SELL_CAMPAIGN_IND length = 8; 
         attrib DIFFER_PAYMENT_CNT length = 8; 
         attrib UP_SELL_ACCOUNT_CNT length = 8; 
         attrib SALES_CHANNEL_SK length = 8 format = 12. informat = 12.
                   label = 'Surrogate key for the channel dimension.'; 
         attrib SEGMENT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib EMPLOYEE_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib AGE_RANGE_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib DELINQUENCY_RANGE_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib MIN_BILLING_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib CUSTOMER_TENURE_RANGE_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib TOTAL_SUSPENSIONS_CNT length = 8; 
         attrib CCD_TOT_POINTS_EARNED length = 8; 
         attrib CCD_TOT_POINTS_REDEEMED length = 8; 
         attrib CCD_POINTS_BALANCE length = 8; 
         attrib FEES_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib CURTAILMENT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib ESCROW_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib NEXT_INTEREST_PAYMENT_DT length = 8 format = NLDATE10. informat = NLDATE10.
                   label = '_DT'; 
         attrib CLEARED_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib CURRENT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib PRINCIPAL_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib OVERDRAFT_CURRENT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
                   label = '_AMT'; 
         attrib LAST_PAYMENT_STATUS_CD length = $3 format = $3. informat = $3.
                   label = '_CD'; 
         attrib TOTAL_BALANCE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   /*---- Append new data  ----*/ 
   %put %str(NOTE: Appending data ...);
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(fact.ACCOUNT_SNAPSHOT, DATA)) or 
            %sysfunc(exist(fact.ACCOUNT_SNAPSHOT, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = fact.ACCOUNT_SNAPSHOT out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(ACCOUNT_SNAPSHOT);
   %let etls_lib   = %nrquote(Facts);
   
   proc append base = fact.ACCOUNT_SNAPSHOT 
               data = &etls_lastTable (&SYSOPT) force; 
   run; 
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsAfter = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(fact.ACCOUNT_SNAPSHOT, DATA)) or 
            %sysfunc(exist(fact.ACCOUNT_SNAPSHOT, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = fact.ACCOUNT_SNAPSHOT out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsAfter", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   
   /*---- Create the indexes for a table  ----*/ 
   %if ((&etls_tableExist eq 0) or 
        (&etls_numIndex ne -1)) %then 
   %do;  /* if table did not exist or there are indexes to create  */ 
   
      /*---- Create the indexes for a table  ----*/ 
      %put %str(NOTE: Creating indexes ...);
      proc datasets lib = fact nolist; 
         modify ACCOUNT_SNAPSHOT; 
            index create XPKACCOUNT_SNAPSHOT = (TIME_SK ACCOUNT_SK SALES_CHANNEL_SK CUSTOMER_SK 
                            CUSTOMER_TENURE_RANGE_SK AGE_RANGE_SK SEGMENT_SK 
                            PRODUCT_SK EMPLOYEE_SK OWNED_BY_INTERNAL_ORG_SK)
               / unique;
      quit; 
      
      %rcSet(&syserr); 
      
   %end;  /* if table did not exist or there are indexes to create  */ 
   
%mend etls_loader;
%etls_loader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
