/****************************************************************************** 
 * Job:           ACCOUNT_TRANS_FACT_EXT_CURR               A52B3KFO.BP00022Z * 
 * Description:   This job extracts data for current month from               * 
 *                ACCOUNT_TRANSACTION_FACT and builds the                     * 
 *                 ACCOUNT_TRANS_FACT_EXT_CURR table.                         * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_TRANSACTION_FACT -                A52B3KFO.BH0000Y0 * 
 *                 fact.ACCOUNT_TRANSACTION_FACT                              * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  ACCOUNT_TRANS_FACT_EXT_CURR -             A52B3KFO.BH00015G * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_CURR                         * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 4:23:46 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00022Z);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACCOUNT_TRANS_FACT_EXT_CURR;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0004Q9 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: ACCOUNT_TRANSACTION_FACT -                A52B3KFO.BH0000Y0 * 
 *                 fact.ACCOUNT_TRANSACTION_FACT                              * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002DY * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_CURR                         * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004Q9); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACCOUNT_TRANS_FACT_EXT_CURR;
quit;

proc sql;
   create table abtscr.ACCOUNT_TRANS_FACT_EXT_CURR as
      select
         ACCOUNT_TRANSACTION_FACT.TRANSACTION_TYPE_SK length = 8
                                                      format = 12.
                                                      informat = 12.
                                                      label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.TRANSACTION_STATUS_SK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.TRANSACTION_STATUS_REASON_SK length = 8
                                                               format = 12.
                                                               informat = 12.
                                                               label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.TRANSACTION_CNT length = 8,
         ACCOUNT_TRANSACTION_FACT.TRANSACTION_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "_AMT",
         ACCOUNT_TRANSACTION_FACT.TIME_SK length = 8
                                          format = 12.
                                          informat = 12.
                                          label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.SEGMENT_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.PRODUCT_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.OVER_LIMIT_CNT length = 8,
         ACCOUNT_TRANSACTION_FACT.MIN_TRANSACTION_AMT length = 8
                                                      format = NLNUM18.5
                                                      informat = NLNUM18.5
                                                      label = "_AMT",
         ACCOUNT_TRANSACTION_FACT.MERCHANT_CATEGORY_SK length = 8
                                                       format = 12.
                                                       informat = 12.
                                                       label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.MEDIUM_SK length = 8
                                            format = 12.
                                            informat = 12.
                                            label = "_RKorSK",
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_3M_BCK_DTTM as MAX_TRANSACTION_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5
                                                                             label = "_AMT",
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                          format = NLDATM21.
                                                          informat = NLDATM21.,
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DATE length = 8
                                                          format = NLDATE10.
                                                          informat = NLDATE10.,
         ACCOUNT_TRANSACTION_FACT.LATE_PAYMENT_CNT length = 8,
         ACCOUNT_TRANSACTION_FACT.INTERNAL_ORG_SK length = 8
                                                  format = 12.
                                                  informat = 12.
                                                  label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.FEE_REASON_TYPE_SK length = 8
                                                     format = 12.
                                                     informat = 12.
                                                     label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.CUSTOMER_SK length = 8
                                              format = 12.
                                              informat = 12.
                                              label = "_RKorSK",
         ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK length = 8,
         ACCOUNT_TRANSACTION_FACT.COUNTRY_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "_RKorSK",
         ACCOUNT_TRANSACTION_FACT.CHANNEL_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "Surrogate key for the channel dimension.",
         ACC_DEF_EVENT_X_ACC_DIM.BACK_6M_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.BACK_3M_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.OTE_CURR_TIME_SK as BACK_24M_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.OTE_BACK_1M_TIME_SK as BACK_12M_TIME_SK length = 8,
         ACCOUNT_TRANSACTION_FACT.ACCOUNT_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "_RKorSK"
      from
         fact.ACCOUNT_TRANSACTION_FACT, 
         abtscr.ACC_DEF_EVENT_X_ACC_DIM, 
         dim.account_dim
      where
         account_dim.ACCOUNT_RK = ACC_DEF_EVENT_X_ACC_DIM.ACCOUNT_RK
         and ACCOUNT_TRANSACTION_FACT.ACCOUNT_SK = account_dim.ACCOUNT_SK
         and ACCOUNT_TRANSACTION_FACT.TIME_SK = ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004QA * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002DY * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_CURR                         * 
 * Target Table:  ACCOUNT_TRANS_FACT_EXT_CURR -             A52B3KFO.BH00015G * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_CURR                         * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

