/****************************************************************************** 
 * Job:           ACC_DEF_EVENT_CURR_EXT                    A52B3KFO.BP00008B * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Table:  DEFAULT_EVENT_DIM - dim.DEFAULT_EVENT_DIM A52B3KFO.BH0000VM * 
 * Target Table:  ACC_DEF_EVENT_CURR_EXT -                  A52B3KFO.BH00010S * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:12:19 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_DEF_EVENT_CURR_EXT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Extract: Capture the accounts that        A52B3KFO.BQ0000IR * 
 *                 defaulted.                                                 * 
 * Transform:     Extract                                                     * 
 * Description:   Extract: Capture the accounts that have defaulted in the    * 
 *                period (&LOAD_ABT_USER_INPUT_DTTM and                       * 
 *                 &LOAD_ABT_USER_INPUT_DTTM - &DEFAULT_CAPTURE_PERIOD)       * 
 *                                                                            * 
 * Source Table:  DEFAULT_EVENT_DIM - dim.DEFAULT_EVENT_DIM A52B3KFO.BH0000VM * 
 * Target Table:  Extract Target -                          A52B3KFO.BR00009V * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(dim.DEFAULT_EVENT_DIM); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_DEF_EVENT_CURR_EXT;
quit;

proc sql; 
   create table abtscr.ACC_DEF_EVENT_CURR_EXT as 
      select ACCOUNT_RK length = 8 label = '_RKorSK',
             DEFAULT_DT length = 8 label = '_DT',
             EXPOSURE_AT_DEFAULT_AMT length = 8 label = '_AMT',
             (DHMS(INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT,0,'END') , 23, 59, 59)) as LOAD_ABT_USER_INPUT_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT,0,'END')) as LOAD_ABT_USER_INPUT_DATE length = 8,
             (INTNX('DTMONTH',DHMS(DEFAULT_EVENT_DIM.DEFAULT_DT , 00, 00, 00) ,-12,'END')) as LOAD_ABT_12M_BCK_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT ,-12,'END')) as LOAD_ABT_12M_BCK_DATE length = 8,
             (INTNX('DTMONTH',DHMS(DEFAULT_EVENT_DIM.DEFAULT_DT , 00, 00, 00) ,-24,'END')) as LOAD_ABT_24M_BCK_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT ,-24,'END')) as LOAD_ABT_24M_BCK_DATE length = 8,
             (INTNX('DTMONTH',DHMS(DEFAULT_EVENT_DIM.DEFAULT_DT , 00, 00, 00) ,-3,'END')) as LOAD_ABT_3M_BCK_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT ,-3,'END')) as LOAD_ABT_3M_BCK_DATE length = 8,
             (INTNX('DTMONTH',DHMS(DEFAULT_EVENT_DIM.DEFAULT_DT , 00, 00, 00) ,-6,'END')) as LOAD_ABT_6M_BCK_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT ,-6,'END')) as LOAD_ABT_6M_BCK_DATE length = 8,
             (DHMS(INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT,0,'END') , 23, 59, 59)) as OUTCOME_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('DTMONTH',DHMS(DEFAULT_EVENT_DIM.DEFAULT_DT , 00, 00, 00),&OUTCOME_PERIOD,'END')) as OUTCOME_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT,0,'END')) as OUTCOME_START_DATE length = 8,
             (INTNX('MONTH',DEFAULT_EVENT_DIM.DEFAULT_DT,&OUTCOME_PERIOD,'END')) as OUTCOME_END_DATE length = 8
         from &SYSLAST
            where (&LOAD_ABT_USER_INPUT_DTTM. >= VALID_START_DTTM AND &LOAD_ABT_USER_INPUT_DTTM. <=
                   VALID_END_DTTM ) AND (DEFAULT_DT > INTNX('MONTH',&LOAD_ABT_USER_INPUT_DATE., -&DEFAULT_CAPTURE_PERIOD. ,'END')   
                  AND DEFAULT_DT <= &LOAD_ABT_USER_INPUT_DATE.) AND (DEFAULT_STATUS_CD IN (&DEFAULT_STATUS_CD.) ); 
quit;

%let SYSLAST = abtscr.ACC_DEF_EVENT_CURR_EXT; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0000IQ * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target -                          A52B3KFO.BR00009V * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 * Target Table:  ACC_DEF_EVENT_CURR_EXT -                  A52B3KFO.BH00010S * 
 *                 abtscr.ACC_DEF_EVENT_CURR_EXT                              * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

