/****************************************************************************** 
 * Job:           ACC_OTBND_COM_FACT_EXT_CURR               A52B3KFO.BP000222 * 
 * Description:   This job picks up the data from OUTBOUND_COMM_FACT.         * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: OUTBOUND_COMM_FACT -                      A52B3KFO.BH0000YQ * 
 *                 fact.OUTBOUND_COMM_FACT                                    * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  ACC_OTBND_COM_FACT_EXT_CURR -             A52B3KFO.BH00013Q * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_CURR                         * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 6:42:39 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP000222);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_OTBND_COM_FACT_EXT_CURR;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0004OA * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: OUTBOUND_COMM_FACT -                      A52B3KFO.BH0000YQ * 
 *                 fact.OUTBOUND_COMM_FACT                                    * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002CM * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_CURR                         * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004OA); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_OTBND_COM_FACT_EXT_CURR;
quit;

proc sql;
   create table abtscr.ACC_OTBND_COM_FACT_EXT_CURR as
      select
         OUTBOUND_COMM_FACT.ACCOUNT_SK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "_RKorSK",
         OUTBOUND_COMM_FACT.TRANSACTION_TYPE_SK length = 8
                                                format = 12.
                                                informat = 12.
                                                label = "_RKorSK",
         OUTBOUND_COMM_FACT.PRODUCT_SK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "_RKorSK",
         OUTBOUND_COMM_FACT.CUSTOMER_SK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "_RKorSK",
         OUTBOUND_COMM_FACT.TIME_SK length = 8
                                    format = 12.
                                    informat = 12.
                                    label = "_RKorSK",
         OUTBOUND_COMM_FACT.OUTBOUND_COMM_CNT length = 8,
         OUTBOUND_COMM_FACT.CHANNEL_SK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "Surrogate key for the channel dimension.",
         OUTBOUND_COMM_FACT.INTERNAL_ORG_SK length = 8
                                            format = 12.
                                            informat = 12.
                                            label = "_RKorSK",
         OUTBOUND_COMM_FACT.SEGMENT_SK length = 8
                                       format = 12.
                                       informat = 12.
                                       label = "_RKorSK",
         ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK length = 8
      from
         fact.OUTBOUND_COMM_FACT, 
         abtscr.ACC_DEF_EVENT_X_ACC_DIM, 
         dim.account_dim
      where
         account_dim.ACCOUNT_RK = ACC_DEF_EVENT_X_ACC_DIM.ACCOUNT_RK
         and OUTBOUND_COMM_FACT.ACCOUNT_SK = account_dim.ACCOUNT_SK
         and OUTBOUND_COMM_FACT.TIME_SK = ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004OB * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002CM * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_CURR                         * 
 * Target Table:  ACC_OTBND_COM_FACT_EXT_CURR -             A52B3KFO.BH00013Q * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_CURR                         * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
