/****************************************************************************** 
 * Job:           ACC_OTBND_LST_6M_LKP                      A52B3KFO.BP00022A * 
 * Description:   This job picks up the data                                  * 
 *                TRANSACTION_TYPE_DIM,ACCOUNT_DIM  and                       * 
 *                 ACC_OTBND_COM_FACT_EXT_LST_6M.                             * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACC_OTBND_COM_FACT_EXT_LST_6M -           A52B3KFO.BH00013T * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_LST_6M                       * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 6:42:46 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00022A);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_OTBND_LST_6M_LKP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Finding the account key                   A52B3KFO.BQ0004OV * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: ACC_OTBND_COM_FACT_EXT_LST_6M -           A52B3KFO.BH00013T * 
 *                 abtscr.ACC_OTBND_COM_FACT_EXT_LST_6M                       * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target - abtscr.ACC_OTBND_LST_6M      A52B3KFO.BR0002D4 * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004OV); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_OTBND_LST_6M;
quit;

proc sql;
   create table abtscr.ACC_OTBND_LST_6M as
      select
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         ACC_OTBND_COM_FACT_EXT_LST_6M.TRANSACTION_TYPE_SK length = 8
                                                           format = 12.
                                                           informat = 12.
                                                           label = "_RKorSK",
         ACC_OTBND_COM_FACT_EXT_LST_6M.OUTBOUND_COMM_CNT length = 8,
         ACC_OTBND_COM_FACT_EXT_LST_6M.TIME_SK length = 8
                                               format = 12.
                                               informat = 12.
                                               label = "_RKorSK",
         account_dim.PRIMARY_CUSTOMER_RK length = 8,
         account_dim.ACCOUNT_TYPE_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.ACCOUNT_SUB_TYPE_CD length = 3
                                         format = $3.
                                         informat = $3.
                                         label = "_CD",
         account_dim.COLLATERAL_CD length = 3
                                   format = $3.
                                   informat = $3.
                                   label = "_CD",
         account_dim.ALLOW_OVERDRAFT_FLG length = 1
                                         format = $1.
                                         informat = $1.
                                         label = "Flags",
         account_dim.ACCOUNT_STATUS_CD length = 3
                                       format = $3.
                                       informat = $3.
                                       label = "_CD",
         ACC_OTBND_COM_FACT_EXT_LST_6M.BACK_12M_TIME_SK length = 8,
         ACC_OTBND_COM_FACT_EXT_LST_6M.CURR_TIME_SK length = 8
      from
         abtscr.ACC_OTBND_COM_FACT_EXT_LST_6M, 
         dim.account_dim
      where
         ACC_OTBND_COM_FACT_EXT_LST_6M.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          TRANSACTION_TYPE_CD Lookup                A52B3KFO.BQ0004OW * 
 * Transform:     Lookup                                                      * 
 * Description:   Picking up the TRANSACTION_TYPE_CD from                     * 
 *                TRANSACTION_TYPE_DIM respective SK is taken from the        * 
 *                 source table.                                              * 
 *                                                                            * 
 * Source Tables: SQL Target - abtscr.ACC_OTBND_LST_6M      A52B3KFO.BR0002D4 * 
 *                TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 * Target Table:  Lookup Target -                           A52B3KFO.BR0002D2 * 
 *                 abtscr.ACC_OTBND_LST_6M_LKP                                * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0004OW); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_OTBND_LST_6M_LKP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  abtscr.ACC_OTBND_LST_6M_LKP
         (keep = TRANSACTION_TYPE_CD TIME_SK PRIMARY_CUSTOMER_RK ACCOUNT_TYPE_CD 
                 ACCOUNT_SUB_TYPE_CD COLLATERAL_CD ALLOW_OVERDRAFT_FLG 
                 ACCOUNT_STATUS_CD ACCOUNT_RK OUTBOUND_COMM_CNT BACK_12M_TIME_SK 
                 CURR_TIME_SK)
      ; 
   
   attrib TRANSACTION_TYPE_CD length=$3 format=$3. label="_CD"
          TIME_SK length=8 format=12. label="_RKorSK"
          PRIMARY_CUSTOMER_RK length=8
          ACCOUNT_TYPE_CD length=$3 format=$3. label="_CD"
          ACCOUNT_SUB_TYPE_CD length=$3 format=$3. label="_CD"
          COLLATERAL_CD length=$3 format=$3. label="_CD"
          ALLOW_OVERDRAFT_FLG length=$1 format=$1. label="Flags"
          ACCOUNT_STATUS_CD length=$3 format=$3. label="_CD"
          ACCOUNT_RK length=8 format=12. label="_RKorSK"
          OUTBOUND_COMM_CNT length=8
          BACK_12M_TIME_SK length=8
          CURR_TIME_SK length=8
          ; 
   
   length TRANSACTION_TYPE_SK 8 ; 
   
   retain missing0 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table dim.TRANSACTION_TYPE_DIM */ 
      nlobs = .; 
      dsid = open("dim.TRANSACTION_TYPE_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "dim.TRANSACTION_TYPE_DIM", hashexp: exponent);
            h0.defineKey( "TRANSACTION_TYPE_SK");
            h0.defineData( "TRANSACTION_TYPE_CD");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.TRANSACTION_TYPE_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TRANSACTION_TYPE_DIM";
         
         abort 3; 
      end; 
      
      call missing (TRANSACTION_TYPE_SK, TRANSACTION_TYPE_CD); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set abtscr.ACC_OTBND_LST_6M end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   
   /* Examine success of lookups  */ 
   if (rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output abtscr.ACC_OTBND_LST_6M_LKP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Macro call: acc_ot_bnd_abt                A52B3KFO.BQ0004OU * 
 * Transform:     User Written Code                                           * 
 * Description:   Macro call  to populate the table                           * 
 *                ACC_OTBND_CURR_ABTACC_OTBND_LST_3M_ABT,ACC_OTBND_LST_6M_    * 
 *                ABT .                                                       * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A52B3KFO.BR0002D2 * 
 *                 abtscr.ACC_OTBND_LST_6M_LKP                                * 
 * Target Table:  ACC_OTBND_CURR/3M/6M_ABT - work.          A52B3KFO.BR0002D3 * 
 *                                                                            * 
 * User Written:  Macro call: acc_ot_bnd_abt                A52B3KFO.AF000OWG * 
 *                Macro call  to populate the table                           * 
 *                ACC_OTBND_CURR_ABTACC_OTBND_LST_3M_ABT,ACC_OTBND_LST_6M_    * 
 *                ABT.                                                        * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(abtscr.ACC_OTBND_LST_6M_LKP); 

%let transformID = %quote(A52B3KFO.BQ0004OU); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A52B3KFO_BR0002D3); 

/*---- Start of User Written Code  ----*/ 

/*Macro Name :acc_ot_bnd_abt
Parameters: 
a) PERIOD: Period for which the historical calculation/summarization is
 to be done .
b) INPUT_TABLE: This is the input table to the macro which will be used for 
  historical calculation/summarization. 

Output: 
Table-1: ACC_OTBND_CURR_ABT
Table-2: ACC_OTBND_LST_3M_ABT
Table-2: ACC_OTBND_LST_6M_ABT
 */

%acc_otbnd_lst_abt(PERIOD=6, INPUT_TABLE=ACC_OTBND_LST_6M_LKP);
PROC SQL;
/*Creating simple index on table for current months*/
CREATE INDEX ACCOUNT_TYPE_CD ON ABTAGG.ACC_OTBND_CURR_ABT(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON ABTAGG.ACC_OTBND_CURR_ABT(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON ABTAGG.ACC_OTBND_CURR_ABT(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON ABTAGG.ACC_OTBND_CURR_ABT(ALLOW_OVERDRAFT_FLG); 
/*Creating simple index on table for last 3 months months*/
CREATE INDEX ACCOUNT_TYPE_CD ON ABTAGG.ACC_OTBND_LST_3M_ABT(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON ABTAGG.ACC_OTBND_LST_3M_ABT(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON ABTAGG.ACC_OTBND_LST_3M_ABT(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON ABTAGG.ACC_OTBND_LST_3M_ABT(ALLOW_OVERDRAFT_FLG); 
/*Creating simple index on table for  last 6 months*/
CREATE INDEX ACCOUNT_TYPE_CD ON ABTAGG.ACC_OTBND_LST_6M_ABT(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON ABTAGG.ACC_OTBND_LST_6M_ABT(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON ABTAGG.ACC_OTBND_LST_6M_ABT(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON ABTAGG.ACC_OTBND_LST_6M_ABT(ALLOW_OVERDRAFT_FLG); 
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
