/****************************************************************************** 
 * Job:           ACC_SNAP_6M_BCK_ABT                       A52B3KFO.BP00022P * 
 * Description:   This job picks up data from ACC_SNAP_EXT_6M_BCK and         * 
 *                 ACCOUNT_DIM.                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                ACC_SNAP_EXT_6M_BCK -                     A52B3KFO.BH00014B * 
 *                 abtscr.ACC_SNAP_EXT_6M_BCK                                 * 
 * Target Table:  ACC_SNAP_6M_BCK_ABT -                     A52B3KFO.BH000157 * 
 *                 abtagg.ACC_SNAP_6M_BCK_ABT                                 * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:21:14 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00022P);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_SNAP_6M_BCK_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk and compute the      A52B3KFO.BQ0004PP * 
 *                 required variables                                         * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk and compute the required variables by  * 
 *                joining ACCOUNT_DIM and ACC_SNAP_EXT_6M_BCK on              * 
 *                 ACCOUNT_SK.                                                * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                ACC_SNAP_EXT_6M_BCK -                     A52B3KFO.BH00014B * 
 *                 abtscr.ACC_SNAP_EXT_6M_BCK                                 * 
 * Target Table:  SQL Target - abtagg.ACC_SNAP_6M_BCK_ABT   A52B3KFO.BR0002DJ * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004PP); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete ACC_SNAP_6M_BCK_ABT;
quit;

proc sql;
   create table abtagg.ACC_SNAP_6M_BCK_ABT as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         ACC_SNAP_EXT_6M_BCK.FEES_AMT as ACC_OUT_FEE_6M_BCK_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.TOTAL_BALANCE_AMT as ACC_OUT_BAL_6M_BCK_AMT length = 8
                                                                         format = NLNUM18.5
                                                                         informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.PRINCIPAL_BALANCE_AMT as ACC_OUT_PPL_6M_BCK_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.INTEREST_EXPECTED_AMT as ACC_OUT_INT_6M_BCK_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  >= 1  & ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  <= 30 THEN ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT END as ACC_1_30DLQ_6M_BCK_AMT length = 8
                                                                                                                                                                                                    format = NLNUM18.5
                                                                                                                                                                                                    informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  >= 31  & ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  <= 60 THEN ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT END as ACC_31_60DLQ_6M_BCK_AMT length = 8
                                                                                                                                                                                                      format = NLNUM18.5
                                                                                                                                                                                                      informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  >= 61  & ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  <= 90 THEN ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT END as ACC_61_90DLQ_6M_BCK_AMT length = 8
                                                                                                                                                                                                      format = NLNUM18.5
                                                                                                                                                                                                      informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  >= 91  & ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  <= 120 THEN ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT END as ACC_91_120DLQ_6M_BCK_AMT length = 8
                                                                                                                                                                                                        format = NLNUM18.5
                                                                                                                                                                                                        informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT  > 120  THEN ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT END as ACC_120PDLQ_6M_BCK_AMT length = 8
                                                                                                                                              format = NLNUM18.5
                                                                                                                                              informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.CCD_POINTS_BALANCE as ACC_BAL_REW_6M_BCK_AMT length = 8
                                                                          format = NLNUM18.5
                                                                          informat = NLNUM18.5,
         CASE  WHEN ACC_SNAP_EXT_6M_BCK.OVERDRAFT_CURRENT_AMT > 0 THEN 1 ELSE 0 END as ACC_OVN_6M_BCK_CNT length = 8,
         ACC_SNAP_EXT_6M_BCK.OVERDRAFT_CURRENT_AMT as ACC_OUT_OVN_6M_BCK_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         SUM(ACC_SNAP_EXT_6M_BCK.OVERDRAFT_CURRENT_AMT, ACC_SNAP_EXT_6M_BCK.INTEREST_EXPECTED_AMT) as ACC_OUT_OVD_6M_BCK_AMT length = 8
                                                                                                                             format = NLNUM18.5
                                                                                                                             informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.AVERAGE_DAILY_BALANCE_AMT as ACC_AVG_DLY_BAL_6M_BCK_AMT length = 8
                                                                                     format = NLNUM18.5
                                                                                     informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.CLEARED_BALANCE_AMT as ACC_CLR_BAL_6M_BCK_AMT length = 8
                                                                           format = NLNUM18.5
                                                                           informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.PAST_DUE_AMT as ACC_DUE_6M_BCK_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.CCD_TOT_POINTS_EARNED length = 8,
         ACC_SNAP_EXT_6M_BCK.CCD_TOT_POINTS_REDEEMED length = 8,
         account_dim.ACCOUNT_TYPE_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.COLLATERAL_CD length = 3
                                   format = $3.
                                   informat = $3.
                                   label = "_CD",
         account_dim.ACCOUNT_STATUS_CD length = 3
                                       format = $3.
                                       informat = $3.
                                       label = "_CD",
         account_dim.ACCOUNT_SUB_TYPE_CD length = 3
                                         format = $3.
                                         informat = $3.
                                         label = "_CD",
         ACC_SNAP_EXT_6M_BCK.DAYS_PAYMENT_PAST_DUE_CNT length = 8,
         ACC_SNAP_EXT_6M_BCK.DELINQUENCY_CNT length = 8,
         account_dim.ALLOW_OVERDRAFT_FLG length = 1
                                         format = $1.
                                         informat = $1.
                                         label = "Flags",
         account_dim.CURRENT_LIMIT_AMT as ACC_LMT_6M_BCK_AMT length = 8
                                                             format = NLNUM18.5
                                                             informat = NLNUM18.5,
         ACC_SNAP_EXT_6M_BCK.DEFAULT_CNT length = 8
      from
         dim.account_dim, 
         abtscr.ACC_SNAP_EXT_6M_BCK
      where
         account_dim.ACCOUNT_SK = ACC_SNAP_EXT_6M_BCK.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004PQ * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - abtagg.ACC_SNAP_6M_BCK_ABT   A52B3KFO.BR0002DJ * 
 * Target Table:  ACC_SNAP_6M_BCK_ABT -                     A52B3KFO.BH000157 * 
 *                 abtagg.ACC_SNAP_6M_BCK_ABT                                 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

