/****************************************************************************** 
 * Job:           ACC_SNAP_CURR_ABT                         A52B3KFO.BP00022Q * 
 * Description:   This job picks up data from ACC_SNAP_EXT_CURR and           * 
 *                 ACCOUNT_DIM.                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                ACC_SNAP_EXT_CURR -                       A52B3KFO.BH00014C * 
 *                 abtscr.ACC_SNAP_EXT_CURR                                   * 
 * Target Table:  ACC_SNAP_CURR_ABT -                       A52B3KFO.BH000158 * 
 *                 abtagg.ACC_SNAP_CURR_ABT                                   * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:21:15 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00022Q);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_SNAP_CURR_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk and compute the      A52B3KFO.BQ0004PS * 
 *                 required variables                                         * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk and compute the required variables by  * 
 *                 joining ACCOUNT_DIM and ACC_SNAP_EXT_CURR on ACCOUNT_SK.   * 
 *                                                                            * 
 * Source Tables: ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                ACC_SNAP_EXT_CURR -                       A52B3KFO.BH00014C * 
 *                 abtscr.ACC_SNAP_EXT_CURR                                   * 
 * Target Table:  SQL Target - abtagg.ACC_SNAP_CURR_ABT     A52B3KFO.BR0002DK * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004PS); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete ACC_SNAP_CURR_ABT;
quit;

proc sql;
   create table abtagg.ACC_SNAP_CURR_ABT as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         INTCK('MONTH' ,ACC_SNAP_EXT_CURR.LAST_STATEMENT_DT, ACC_SNAP_EXT_CURR.LOAD_ABT_USER_INPUT_DATE) as ACC_MTH_SNC_LST_STMT_CNT length = 8,
         
         CASE WHEN ACC_SNAP_EXT_CURR.LOAD_ABT_USER_INPUT_DATE <= 
         INTNX('DAY',ACC_SNAP_EXT_CURR.LAST_STATEMENT_DT,   INPUT(account_dim.STATEMENT_FREQUENCY_CD, SFCFMT.)) 
         THEN INTCK('MONTH', ACC_SNAP_EXT_CURR.LOAD_ABT_USER_INPUT_DATE,  
         INTNX('DAY',  ACC_SNAP_EXT_CURR.LAST_STATEMENT_DT,   INPUT(account_dim.STATEMENT_FREQUENCY_CD, SFCFMT.))) END
          as ACC_MTH_TO_NXT_STMT_CNT length = 8,
         ACC_SNAP_EXT_CURR.FEES_AMT as ACC_OUT_FEE_CURR_MTH_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.TOTAL_BALANCE_AMT as ACC_OUT_BAL_CURR_MTH_AMT length = 8
                                                                         format = NLNUM18.5
                                                                         informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.PRINCIPAL_BALANCE_AMT as ACC_OUT_PPL_CURR_MTH_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.INTEREST_EXPECTED_AMT as ACC_OUT_INT_CURR_MTH_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         (ACC_SNAP_EXT_CURR.PRINCIPAL_BALANCE_AMT / account_dim.COLLATERAL_AMT)  * 100 as ACC_OUT_PPL2PCL_PCT length = 8
                                                                                                              format = NLNUM9.4
                                                                                                              informat = NLNUM9.4,
         ACC_SNAP_EXT_CURR.CURTAILMENT_AMT as ACC_CURT_AMT length = 8
                                                           format = NLNUM18.5
                                                           informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.MIN_BILLING_AMT as ACC_MIN_BILL_CURR_MTH_AMT length = 8
                                                                        format = NLNUM18.5
                                                                        informat = NLNUM18.5,
         (ACC_SNAP_EXT_CURR.BALANCE_AMT / account_dim.CURRENT_LIMIT_AMT )  *  100 as ACC_AVG_LMT_USE_CURR_MTH_PCT length = 8
                                                                                                                  format = NLNUM9.4
                                                                                                                  informat = NLNUM9.4,
         CASE WHEN ACC_SNAP_EXT_CURR.BALANCE_AMT  >= account_dim.CURRENT_LIMIT_AMT THEN 1 ELSE 0 END as ACC_LMT_EXH_CURR_MTH_CNT length = 8,
         CASE  WHEN ACC_SNAP_EXT_CURR.BALANCE_AMT  >= account_dim.CURRENT_LIMIT_AMT THEN ( (ACC_SNAP_EXT_CURR.BALANCE_AMT  - account_dim.CURRENT_LIMIT_AMT ) / account_dim.CURRENT_LIMIT_AMT ) * 100 END as ACC_AVGOTL_2LMT_CURR_MTH_PCT length = 8
                                                                                                                                                                                                                                         format = NLNUM9.4
                                                                                                                                                                                                                                         informat = NLNUM9.4,
         CASE  WHEN ACC_SNAP_EXT_CURR.BALANCE_AMT  >= account_dim.CURRENT_LIMIT_AMT  THEN (ACC_SNAP_EXT_CURR.BALANCE_AMT  - account_dim.CURRENT_LIMIT_AMT) END as ACC_OTL_CURR_MTH_AMT length = 8
                                                                                                                                                                                       format = NLNUM18.5
                                                                                                                                                                                       informat = NLNUM18.5,
         (ACC_SNAP_EXT_CURR.INTEREST_EXPECTED_AMT  / ACC_SNAP_EXT_CURR.BALANCE_AMT ) * 100 as ACC_OINT_2BAL_CURR_MTH_PCT length = 8
                                                                                                                         format = NLNUM9.4
                                                                                                                         informat = NLNUM9.4,
         CASE  WHEN account_dim.CURRENT_LIMIT_AMT  >= ACC_SNAP_EXT_CURR.BALANCE_AMT  THEN (account_dim.CURRENT_LIMIT_AMT  - ACC_SNAP_EXT_CURR.BALANCE_AMT)  END as ACC_OTB_CURR_MTH_AMT length = 8
                                                                                                                                                                                        format = NLNUM18.5
                                                                                                                                                                                        informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.CCD_POINTS_BALANCE as ACC_BAL_REW_CURR_MTH_AMT length = 8
                                                                          format = NLNUM18.5
                                                                          informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.DIFFER_PAYMENT_CNT as ACC_MIN_BLL_PAY_CURR_MTH_CNT length = 8,
         CASE  WHEN ACC_SNAP_EXT_CURR.OVERDRAFT_CURRENT_AMT  > 0 THEN 1 ELSE 0 END as ACC_OVN_CURR_MTH_CNT length = 8,
         ACC_SNAP_EXT_CURR.OVERDRAFT_CURRENT_AMT as ACC_OUT_OVN_CURR_MTH_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         SUM(ACC_SNAP_EXT_CURR.OVERDRAFT_CURRENT_AMT, ACC_SNAP_EXT_CURR.INTEREST_EXPECTED_AMT) as ACC_OUT_OVD_CURR_MTH_AMT length = 8
                                                                                                                           format = NLNUM18.5
                                                                                                                           informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.AVERAGE_DAILY_BALANCE_AMT as ACC_AVG_DLY_BAL_CURR_MTH_AMT length = 8
                                                                                     format = NLNUM18.5
                                                                                     informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.CLEARED_BALANCE_AMT as ACC_CLR_BAL_CURR_MTH_AMT length = 8
                                                                           format = NLNUM18.5
                                                                           informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.LATE_PAYMENT_CNT as ACC_DLD_INST_CURR_MTH_CNT length = 8,
         ACC_SNAP_EXT_CURR.PAST_DUE_AMT as ACC_DUE_CURR_MTH_AMT length = 8
                                                                format = NLNUM18.5
                                                                informat = NLNUM18.5,
         ACC_SNAP_EXT_CURR.CCD_TOT_POINTS_EARNED length = 8,
         ACC_SNAP_EXT_CURR.CCD_TOT_POINTS_REDEEMED length = 8,
         account_dim.ACCOUNT_TYPE_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.COLLATERAL_CD length = 3
                                   format = $3.
                                   informat = $3.
                                   label = "_CD",
         account_dim.ACCOUNT_STATUS_CD length = 3
                                       format = $3.
                                       informat = $3.
                                       label = "_CD",
         account_dim.ACCOUNT_SUB_TYPE_CD length = 3
                                         format = $3.
                                         informat = $3.,
         ACC_SNAP_EXT_CURR.DAYS_PAYMENT_PAST_DUE_CNT length = 8,
         ACC_SNAP_EXT_CURR.DELINQUENCY_CNT length = 8,
         account_dim.ALLOW_OVERDRAFT_FLG length = 1
                                         format = $1.
                                         informat = $1.
                                         label = "Flags",
         
         CASE WHEN ACC_SNAP_EXT_CURR.OVERDRAFT_CURRENT_AMT  >= account_dim.OVERDRAFT_LIMIT_AMT THEN ( (ACC_SNAP_EXT_CURR.OVERDRAFT_CURRENT_AMT  - account_dim.OVERDRAFT_LIMIT_AMT) / account_dim.OVERDRAFT_LIMIT_AMT ) * 100 END
          as ACC_AVOTL_2AVODLMT_CMTH_PCT length = 8
                                         format = NLNUM9.4
                                         informat = NLNUM9.4,
         ACC_SNAP_EXT_CURR.DEFAULT_CNT length = 8,
         CASE WHEN ACC_SNAP_EXT_CURR.BALANCE_AMT  < account_dim.REQUIRED_MIN_BALANCE_AMT THEN 1 ELSE 0 END as ACC_BBLO_CURR_MTH_CNT length = 8,
         account_dim.OPEN_DT as ACC_OPEN_DT length = 8
                                            format = NLDATE10.
                                            informat = NLDATE10.
                                            label = "_DT",
         account_dim.CURRENT_LIMIT_AMT as ACC_LMT_CURR_MTH_AMT length = 8
                                                               format = NLNUM18.5
                                                               informat = NLNUM18.5
      from
         dim.account_dim, 
         abtscr.ACC_SNAP_EXT_CURR
      where
         account_dim.ACCOUNT_SK = ACC_SNAP_EXT_CURR.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004PR * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - abtagg.ACC_SNAP_CURR_ABT     A52B3KFO.BR0002DK * 
 * Target Table:  ACC_SNAP_CURR_ABT -                       A52B3KFO.BH000158 * 
 *                 abtagg.ACC_SNAP_CURR_ABT                                   * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
