/****************************************************************************** 
 * Job:           ACC_SNAP_EXT_LST_3M                       A52B3KFO.BP00022I * 
 * Description:   This job picks up data from ACCOUNT_SNAPSHOT for the last   * 
 *                 three months.                                              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A52B3KFO.BH0000XY * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  ACC_SNAP_EXT_LST_3M -                     A52B3KFO.BH00014E * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M                                 * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:21:24 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_SNAP_EXT_LST_3M;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0004PB * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: ACCOUNT_SNAPSHOT - fact.ACCOUNT_SNAPSHOT  A52B3KFO.BH0000XY * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target - abtscr.ACC_SNAP_EXT_LST_3M   A52B3KFO.BR0002DC * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_SNAP_EXT_LST_3M;
quit;

proc sql;
   create table abtscr.ACC_SNAP_EXT_LST_3M as
      select
         ACCOUNT_SNAPSHOT.ACCOUNT_SK length = 8
                                     format = 12.
                                     informat = 12.
                                     label = "_RKorSK",
         ACCOUNT_SNAPSHOT.TIME_SK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "_RKorSK",
         ACCOUNT_SNAPSHOT.BALANCE_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "_AMT",
         ACCOUNT_SNAPSHOT.INTEREST_EXPECTED_AMT length = 8
                                                format = NLNUM18.5
                                                informat = NLNUM18.5
                                                label = "_AMT",
         ACCOUNT_SNAPSHOT.DAYS_PAYMENT_PAST_DUE_CNT length = 8,
         ACCOUNT_SNAPSHOT.AVERAGE_DAILY_BALANCE_AMT length = 8
                                                    format = NLNUM18.5
                                                    informat = NLNUM18.5
                                                    label = "_AMT",
         ACCOUNT_SNAPSHOT.MIN_ACCOUNT_VALUE_AMT length = 8
                                                format = NLNUM18.5
                                                informat = NLNUM18.5
                                                label = "_AMT",
         ACCOUNT_SNAPSHOT.MAX_ACCOUNT_VALUE_AMT length = 8
                                                format = NLNUM18.5
                                                informat = NLNUM18.5
                                                label = "_AMT",
         ACCOUNT_SNAPSHOT.DELINQUENCY_CNT length = 8,
         ACCOUNT_SNAPSHOT.LATE_PAYMENT_CNT length = 8,
         ACCOUNT_SNAPSHOT.DIFFER_PAYMENT_CNT length = 8,
         ACCOUNT_SNAPSHOT.TOTAL_BALANCE_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5,
         ACCOUNT_SNAPSHOT.DEFAULT_CNT length = 8,
         ACCOUNT_SNAPSHOT.OVERDRAFT_CURRENT_AMT length = 8
                                                format = NLNUM18.5
                                                informat = NLNUM18.5
                                                label = "_AMT",
         ACCOUNT_SNAPSHOT.FEES_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "_AMT",
         ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK length = 8
      from
         fact.ACCOUNT_SNAPSHOT, 
         abtscr.ACC_DEF_EVENT_X_ACC_DIM, 
         dim.account_dim
      where
         account_dim.ACCOUNT_RK = ACC_DEF_EVENT_X_ACC_DIM.ACCOUNT_RK
         and ACCOUNT_SNAPSHOT.ACCOUNT_SK = account_dim.ACCOUNT_SK
         and ACCOUNT_SNAPSHOT.TIME_SK > ACC_DEF_EVENT_X_ACC_DIM.BACK_3M_TIME_SK
         and ACCOUNT_SNAPSHOT.TIME_SK <= ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004PC * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - abtscr.ACC_SNAP_EXT_LST_3M   A52B3KFO.BR0002DC * 
 * Target Table:  ACC_SNAP_EXT_LST_3M -                     A52B3KFO.BH00014E * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M                                 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

