/****************************************************************************** 
 * Job:           ACC_SNAP_EXT_LST_3M_LKP                   A52B3KFO.BP00022T * 
 * Description:   This job picks up data from ACC_SNAP_EXT_LST_3M and         * 
 *                 ACCOUNT_DIM.                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACC_SNAP_EXT_LST_3M -                     A52B3KFO.BH00014E * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M                                 * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:21:25 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_SNAP_EXT_LST_3M_LKP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk                      A52B3KFO.BQ0004PY * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk by joining ACCOUNT_DIM and             * 
 *                 ACC_SNAP_EXT_LST_3M on ACCOUNT_SK.                         * 
 *                                                                            * 
 * Source Tables: ACC_SNAP_EXT_LST_3M -                     A52B3KFO.BH00014E * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M                                 * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002DP * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M_LKP                             * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_SNAP_EXT_LST_3M_LKP;
quit;

proc sql;
   create table abtscr.ACC_SNAP_EXT_LST_3M_LKP as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         ACC_SNAP_EXT_LST_3M.ACCOUNT_SK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "_RKorSK",
         ACC_SNAP_EXT_LST_3M.TIME_SK length = 8
                                     format = 12.
                                     informat = 12.
                                     label = "_RKorSK",
         ACC_SNAP_EXT_LST_3M.BALANCE_AMT length = 8
                                         format = NLNUM18.5
                                         informat = NLNUM18.5
                                         label = "_AMT",
         ACC_SNAP_EXT_LST_3M.INTEREST_EXPECTED_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "_AMT",
         ACC_SNAP_EXT_LST_3M.DAYS_PAYMENT_PAST_DUE_CNT length = 8,
         ACC_SNAP_EXT_LST_3M.AVERAGE_DAILY_BALANCE_AMT length = 8
                                                       format = NLNUM18.5
                                                       informat = NLNUM18.5
                                                       label = "_AMT",
         ACC_SNAP_EXT_LST_3M.MIN_ACCOUNT_VALUE_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "_AMT",
         ACC_SNAP_EXT_LST_3M.MAX_ACCOUNT_VALUE_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "_AMT",
         ACC_SNAP_EXT_LST_3M.DELINQUENCY_CNT length = 8,
         ACC_SNAP_EXT_LST_3M.LATE_PAYMENT_CNT length = 8,
         ACC_SNAP_EXT_LST_3M.DIFFER_PAYMENT_CNT length = 8,
         ACC_SNAP_EXT_LST_3M.TOTAL_BALANCE_AMT length = 8
                                               format = NLNUM18.5
                                               informat = NLNUM18.5,
         ACC_SNAP_EXT_LST_3M.DEFAULT_CNT length = 8,
         account_dim.CURRENT_LIMIT_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "_AMT",
         ACC_SNAP_EXT_LST_3M.OVERDRAFT_CURRENT_AMT length = 8
                                                   format = NLNUM18.5
                                                   informat = NLNUM18.5
                                                   label = "_AMT",
         account_dim.ACCOUNT_TYPE_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.ACCOUNT_SUB_TYPE_CD length = 3
                                         format = $3.
                                         informat = $3.
                                         label = "_CD",
         account_dim.COLLATERAL_CD length = 3
                                   format = $3.
                                   informat = $3.
                                   label = "_CD",
         account_dim.REQUIRED_MIN_BALANCE_AMT length = 8
                                              format = NLNUM18.5
                                              informat = NLNUM18.5
                                              label = "_AMT",
         account_dim.ALLOW_OVERDRAFT_FLG length = 1
                                         format = $1.
                                         informat = $1.
                                         label = "Flags",
         account_dim.ACCOUNT_STATUS_CD length = 3
                                       format = $3.
                                       informat = $3.
                                       label = "_CD",
         account_dim.OVERDRAFT_LIMIT_AMT length = 8
                                         format = NLNUM18.5
                                         informat = NLNUM18.5
                                         label = "_AMT",
         ACC_SNAP_EXT_LST_3M.FEES_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "_AMT",
         ACC_SNAP_EXT_LST_3M.BACK_12M_TIME_SK length = 8,
         ACC_SNAP_EXT_LST_3M.CURR_TIME_SK length = 8
      from
         abtscr.ACC_SNAP_EXT_LST_3M, 
         dim.account_dim
      where
         ACC_SNAP_EXT_LST_3M.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Macro ACC_SNAP_LST_ABT called to populate A52B3KFO.BQ0004PX * 
 *                 data                                                       * 
 * Transform:     User Written Code                                           * 
 * Description:   Macro ACC_SNAP_LST_ABT called to populate the table         * 
 *                 ACC_SNAP_LST_3M_ABT                                        * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002DP * 
 *                 abtscr.ACC_SNAP_EXT_LST_3M_LKP                             * 
 * Target Table:  ACC_SNAP_LST_3M_ABT - work.               A52B3KFO.BR0002DQ * 
 *                                                                            * 
 * User Written:  Macro ACC_SNAP_LST_ABT called to populate A52B3KFO.AF000P1K * 
 *                 data                                                       * 
 *                Macro ACC_SNAP_LST_ABT called to populate the table         * 
 *                 ACC_SNAP_LST_3M_ABT                                        * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(abtscr.ACC_SNAP_EXT_LST_3M_LKP); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A52B3KFO_BR0002DQ); 

/*---- Start of User Written Code  ----*/ 

/* The input to this macro is the 
 1) PERIOD: (3, 6, 12, 24) for which the variables have
 to be aggregated.
 If PERIOD=3, then aggregation for last 3 months will be calculated and stored in,
 ACC_SNAP_LST_3M_ABT.
 If PERIOD=6, then aggregation for last 3 & 6 months will be calculated and stored in,
 ACC_SNAP_LST_3M_ABT, ACC_SNAP_LST_6M_ABT. 
 If PERIOD=12, then aggregation for last 3, 6 & 12 months will be calculated and stored in,
 ACC_SNAP_LST_3M_ABT, ACC_SNAP_LST_6M_ABT, ACC_SNAP_LST_12M_ABT. 
 If PERIOD=24, then aggregation for last 13-24 months will be calculated and stored in,
 ACC_SNAP_LST_13_24M_ABT. 
 If PERIOD=100, then aggregation for last 3, 6, 12 months and life to date data will be
 calculated and stored in, ACC_SNAP_LST_3M_ABT, ACC_SNAP_LST_6M_ABT, ACC_SNAP_LST_12M_ABT
 and ACC_SNAP_LTD_ABT.
 2) TABLE: The input table which is already filtered for the PERIOD (3, 6, 12, 13-24). 

Output: 
 Table1: ACC_SNAP_LST_3M_ABT
*/

%acc_snap_lst_abt(PERIOD=3, INPUT_TABLE=ACC_SNAP_EXT_LST_3M_LKP);

proc sql noprint;

 create index ACCOUNT_RK on abtagg.ACC_SNAP_LST_3M_ABT(ACCOUNT_RK);
 create index ACCOUNT_TYPE_CD on abtagg.ACC_SNAP_LST_3M_ABT(ACCOUNT_TYPE_CD);
 create index ACCOUNT_SUB_TYPE_CD on abtagg.ACC_SNAP_LST_3M_ABT(ACCOUNT_SUB_TYPE_CD);
 create index ACCOUNT_STATUS_CD on abtagg.ACC_SNAP_LST_3M_ABT(ACCOUNT_STATUS_CD);
 create index COLLATERAL_CD on abtagg.ACC_SNAP_LST_3M_ABT(COLLATERAL_CD);
 create index ALLOW_OVERDRAFT_FLG on abtagg.ACC_SNAP_LST_3M_ABT(ALLOW_OVERDRAFT_FLG);

quit;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

