/****************************************************************************** 
 * Job:           ACC_SNAP_PRV_ABT                          A52B3KFO.BP00022W * 
 * Description:   This job picks up data from ACC_SNAP_EXT_PRV and            * 
 *                 ACCOUNT_DIM.                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACC_SNAP_EXT_PRV -                        A52B3KFO.BH00014H * 
 *                 abtscr.ACC_SNAP_EXT_PRV                                    * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  ACC_SNAP_PRV_ABT -                        A52B3KFO.BH00015D * 
 *                 abtagg.ACC_SNAP_PRV_ABT                                    * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:21:30 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00022W);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_SNAP_PRV_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk                      A52B3KFO.BQ0004Q4 * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk by joining ACCOUNT_DIM and             * 
 *                 ACC_SNAP_EXT_PRV on ACCOUNT_SK.                            * 
 *                                                                            * 
 * Source Tables: ACC_SNAP_EXT_PRV -                        A52B3KFO.BH00014H * 
 *                 abtscr.ACC_SNAP_EXT_PRV                                    * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target - abtagg.ACC_SNAP_PRV_ABT      A52B3KFO.BR0002DV * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004Q4); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete ACC_SNAP_PRV_ABT;
quit;

proc sql;
   create table abtagg.ACC_SNAP_PRV_ABT as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         ACC_SNAP_EXT_PRV.TIME_SK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "_RKorSK",
         ACC_SNAP_EXT_PRV.CCD_TOT_POINTS_EARNED length = 8,
         ACC_SNAP_EXT_PRV.CCD_TOT_POINTS_REDEEMED length = 8
      from
         abtscr.ACC_SNAP_EXT_PRV, 
         dim.account_dim
      where
         ACC_SNAP_EXT_PRV.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004Q3 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target - abtagg.ACC_SNAP_PRV_ABT      A52B3KFO.BR0002DV * 
 * Target Table:  ACC_SNAP_PRV_ABT -                        A52B3KFO.BH00015D * 
 *                 abtagg.ACC_SNAP_PRV_ABT                                    * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

