/****************************************************************************** 
 * Job:           ACC_TRANS_EXT_LST_12M_LKP                 A52B3KFO.BP000236 * 
 * Description:   This job creates the ACC_TRANS_EXT_LST_12M_LKP to be used   * 
 *                 as an input for the 'macro_acc_trans_lst_abt' macro.       * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: ACCOUNT_TRANS_FACT_EXT_LST_12M -          A52B3KFO.BH00015H * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_LST_12M                      * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 *                FEE_REASON_DIM - dim.FEE_REASON_DIM       A52B3KFO.BH0000VS * 
 *                MERCHANT_CATEGORY_DIM -                   A52B3KFO.BH0000W0 * 
 *                 dim.MERCHANT_CATEGORY_DIM                                  * 
 *                MEDIUM_DIM - dim.MEDIUM_DIM               A52B3KFO.BH0000VZ * 
 *                CHANNEL_DIM - dim.CHANNEL_DIM             A52B3KFO.BH0000VI * 
 *                TRANSACTION_STATUS_REASON_DIM -           A52B3KFO.BH0000WA * 
 *                 dim.TRANSACTION_STATUS_REASON_DIM                          * 
 *                INTERNAL_ORG_DIM - dim.INTERNAL_ORG_DIM   A52B3KFO.BH0000VY * 
 *                COUNTRY_DIM - dim.COUNTRY_DIM             A52B3KFO.BH0000VJ * 
 *                TIME_DIM - dim.TIME_DIM                   A52B3KFO.BH0000VQ * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 4:23:54 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP000236);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = ACC_TRANS_EXT_LST_12M_LKP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Get the Account related fields required   A52B3KFO.BQ0004QP * 
 *                 for derivations.                                           * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   Get the Account related fields required for derivations.    * 
 *                                                                            * 
 * Source Tables: ACCOUNT_TRANS_FACT_EXT_LST_12M -          A52B3KFO.BH00015H * 
 *                 abtscr.ACCOUNT_TRANS_FACT_EXT_LST_12M                      * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target - work.ACCTRANS_ACC            A52B3KFO.BR0002E9 * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004QP); 

%let trans_rc = 0; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete ACCTRANS_ACC;
quit;

proc sql;
   create table work.ACCTRANS_ACC as
      select
         ACCOUNT_TRANS_FACT_EXT_LST_12M.ACCOUNT_SK length = 8
                                                   format = 12.
                                                   informat = 12.
                                                   label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.INTERNAL_ORG_SK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.CUSTOMER_SK length = 8
                                                    format = 12.
                                                    informat = 12.
                                                    label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.PRODUCT_SK length = 8
                                                   format = 12.
                                                   informat = 12.
                                                   label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TIME_SK length = 8
                                                format = 12.
                                                informat = 12.
                                                label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TRANSACTION_TYPE_SK length = 8
                                                            format = 12.
                                                            informat = 12.
                                                            label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.CHANNEL_SK length = 8
                                                   format = 12.
                                                   informat = 12.
                                                   label = "Surrogate key for the channel dimension.",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.MEDIUM_SK length = 8
                                                  format = 12.
                                                  informat = 12.
                                                  label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.MERCHANT_CATEGORY_SK length = 8
                                                             format = 12.
                                                             informat = 12.
                                                             label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.COUNTRY_SK length = 8
                                                   format = 12.
                                                   informat = 12.
                                                   label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TRANSACTION_CNT length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TRANSACTION_AMT length = 8
                                                        format = NLNUM18.5
                                                        informat = NLNUM18.5
                                                        label = "_AMT",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.LATE_PAYMENT_CNT length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.OVER_LIMIT_CNT length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.FEE_REASON_TYPE_SK length = 8
                                                           format = 12.
                                                           informat = 12.
                                                           label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.MAX_TRANSACTION_AMT length = 8
                                                            format = NLNUM18.5
                                                            informat = NLNUM18.5
                                                            label = "_AMT",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.MIN_TRANSACTION_AMT length = 8
                                                            format = NLNUM18.5
                                                            informat = NLNUM18.5
                                                            label = "_AMT",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TRANSACTION_STATUS_SK length = 8
                                                              format = 12.
                                                              informat = 12.
                                                              label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.TRANSACTION_STATUS_REASON_SK length = 8
                                                                     format = 12.
                                                                     informat = 12.
                                                                     label = "_RKorSK",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.SEGMENT_SK length = 8
                                                   format = 12.
                                                   informat = 12.
                                                   label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         account_dim.REGULAR_PERIODIC_PAYMENT_AMT length = 8
                                                  format = NLNUM18.5
                                                  informat = NLNUM18.5
                                                  label = "_AMT",
         account_dim.CLOSE_DT length = 8
                              format = NLDATE10.
                              informat = NLDATE10.
                              label = "_DT",
         account_dim.ACCOUNT_TYPE_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.CLOSE_REASON_CD length = 3
                                     format = $3.
                                     informat = $3.
                                     label = "_CD",
         account_dim.PRIMARY_CUSTOMER_RK length = 8,
         account_dim.ACCOUNT_SUB_TYPE_CD length = 3
                                         format = $3.
                                         informat = $3.
                                         label = "_CD",
         account_dim.ACCOUNT_STATUS_CD length = 3
                                       format = $3.
                                       informat = $3.
                                       label = "_CD",
         account_dim.COLLATERAL_CD length = 3
                                   format = $3.
                                   informat = $3.
                                   label = "_CD",
         account_dim.ALLOW_OVERDRAFT_FLG length = 1
                                         format = $1.
                                         informat = $1.
                                         label = "Flags",
         ACCOUNT_TRANS_FACT_EXT_LST_12M.BACK_3M_TIME_SK length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.BACK_6M_TIME_SK length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.BACK_12M_TIME_SK length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.BACK_24M_TIME_SK length = 8,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                                 format = NLDATM21.
                                                                 informat = NLDATM21.,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.LOAD_ABT_USER_INPUT_DATE length = 8
                                                                 format = NLDATE10.
                                                                 informat = NLDATE10.,
         ACCOUNT_TRANS_FACT_EXT_LST_12M.CURR_TIME_SK length = 8
      from
         abtscr.ACCOUNT_TRANS_FACT_EXT_LST_12M, 
         dim.account_dim
      where
         ACCOUNT_TRANS_FACT_EXT_LST_12M.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Lookup on Dimensions                      A52B3KFO.BQ0004QQ * 
 * Transform:     Lookup                                                      * 
 * Description:   Lookup on dimensions to obtain the necessary variables by   * 
 *                 looking up the SKs.                                        * 
 *                                                                            * 
 * Source Tables: TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 *                FEE_REASON_DIM - dim.FEE_REASON_DIM       A52B3KFO.BH0000VS * 
 *                MERCHANT_CATEGORY_DIM -                   A52B3KFO.BH0000W0 * 
 *                 dim.MERCHANT_CATEGORY_DIM                                  * 
 *                MEDIUM_DIM - dim.MEDIUM_DIM               A52B3KFO.BH0000VZ * 
 *                CHANNEL_DIM - dim.CHANNEL_DIM             A52B3KFO.BH0000VI * 
 *                TRANSACTION_STATUS_REASON_DIM -           A52B3KFO.BH0000WA * 
 *                 dim.TRANSACTION_STATUS_REASON_DIM                          * 
 *                INTERNAL_ORG_DIM - dim.INTERNAL_ORG_DIM   A52B3KFO.BH0000VY * 
 *                COUNTRY_DIM - dim.COUNTRY_DIM             A52B3KFO.BH0000VJ * 
 *                TIME_DIM - dim.TIME_DIM                   A52B3KFO.BH0000VQ * 
 *                SQL Target - work.ACCTRANS_ACC            A52B3KFO.BR0002E9 * 
 * Target Table:  Lookup Target -                           A52B3KFO.BR0002EA * 
 *                 abtscr.ACC_TRANS_EXT_LST_12M_LKP                           * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0004QQ); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete ACC_TRANS_EXT_LST_12M_LKP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  abtscr.ACC_TRANS_EXT_LST_12M_LKP
         (keep = TRANSACTION_TYPE_CD CREDIT_DEBIT_FLG FEE_REASON_TYPE_CD TIME_SK 
                 TRANSACTION_CNT TRANSACTION_AMT LATE_PAYMENT_CNT OVER_LIMIT_CNT 
                 MAX_TRANSACTION_AMT MIN_TRANSACTION_AMT ACCOUNT_RK 
                 REGULAR_PERIODIC_PAYMENT_AMT MERCHANT_CATEGORY_CD MEDIUM_CD 
                 CHANNEL_CD TRANSACTION_STATUS_REASON_CD INTERNAL_ORG_COUNTRY_CD 
                 COUNTRY_CD CLOSE_DT ACCOUNT_TYPE_CD CAL_MONTH_FIRST_DT 
                 CLOSE_REASON_CD PRIMARY_CUSTOMER_RK ACCOUNT_SUB_TYPE_CD 
                 ACCOUNT_STATUS_CD COLLATERAL_CD ALLOW_OVERDRAFT_FLG 
                 BACK_3M_TIME_SK BACK_6M_TIME_SK BACK_12M_TIME_SK 
                 BACK_24M_TIME_SK LOAD_ABT_USER_INPUT_DTTM 
                 LOAD_ABT_USER_INPUT_DATE CURR_TIME_SK)
      ; 
   
   attrib TRANSACTION_TYPE_CD length=$3 format=$3. label="_CD"
          CREDIT_DEBIT_FLG length=$1 format=$1. label="Flags"
          FEE_REASON_TYPE_CD length=$3 format=$3. label="_CD"
          TIME_SK length=8 format=12. label="_RKorSK"
          TRANSACTION_CNT length=8
          TRANSACTION_AMT length=8 format=NLNUM18.5 label="_AMT"
          LATE_PAYMENT_CNT length=8
          OVER_LIMIT_CNT length=8
          MAX_TRANSACTION_AMT length=8 format=NLNUM18.5 label="_AMT"
          MIN_TRANSACTION_AMT length=8 format=NLNUM18.5 label="_AMT"
          ACCOUNT_RK length=8 format=12. label="_RKorSK"
          REGULAR_PERIODIC_PAYMENT_AMT length=8 format=NLNUM18.5 label="_AMT"
          MERCHANT_CATEGORY_CD length=$3 format=$3. label="_CD"
          MEDIUM_CD length=$3 format=$3. label="_CD"
          CHANNEL_CD length=$3 format=$3. label=
          "Channel type code. Example values are: ATM for automated teller machine, BRN for Branch, CCN for Call Center."
          TRANSACTION_STATUS_REASON_CD length=$3 format=$3. label="_CD"
          INTERNAL_ORG_COUNTRY_CD length=$3 format=$3. label="_CD"
          COUNTRY_CD length=$3 format=$3. label="_CD"
          CLOSE_DT length=8
          ACCOUNT_TYPE_CD length=$3 format=$3. label="_CD"
          CAL_MONTH_FIRST_DT length=8 format=NLDATE10. label="_DT"
          CLOSE_REASON_CD length=$3 format=$3. label="_CD"
          PRIMARY_CUSTOMER_RK length=8
          ACCOUNT_SUB_TYPE_CD length=$3 format=$3. label="_CD"
          ACCOUNT_STATUS_CD length=$3 format=$3. label="_CD"
          COLLATERAL_CD length=$3 format=$3. label="_CD"
          ALLOW_OVERDRAFT_FLG length=$1 format=$1. label="Flags"
          BACK_3M_TIME_SK length=8
          BACK_6M_TIME_SK length=8
          BACK_12M_TIME_SK length=8
          BACK_24M_TIME_SK length=8
          LOAD_ABT_USER_INPUT_DTTM length=8 format=NLDATM21.
          LOAD_ABT_USER_INPUT_DATE length=8 format=NLDATE10.
          CURR_TIME_SK length=8
          ; 
   
   length TRANSACTION_TYPE_SK 8 FEE_REASON_TYPE_SK 8 MERCHANT_CATEGORY_SK 8 MEDIUM_SK 8 CHANNEL_SK 8 TRANSACTION_STATUS_REASON_SK 8 INTERNAL_ORG_SK 8 COUNTRY_SK 8 ; 
   
   retain missing0 0 missing1 0 missing2 0 missing3 0 missing4 0 missing5 0 missing6 0 missing7 0 missing8 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table dim.TRANSACTION_TYPE_DIM */ 
      nlobs = .; 
      dsid = open("dim.TRANSACTION_TYPE_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "dim.TRANSACTION_TYPE_DIM", hashexp: exponent);
            h0.defineKey( "TRANSACTION_TYPE_SK");
            h0.defineData( "TRANSACTION_TYPE_CD",
                           "CREDIT_DEBIT_FLG");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.TRANSACTION_TYPE_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TRANSACTION_TYPE_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table dim.FEE_REASON_DIM */ 
      nlobs = .; 
      dsid = open("dim.FEE_REASON_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "dim.FEE_REASON_DIM", hashexp: exponent);
            h1.defineKey( "FEE_REASON_TYPE_SK");
            h1.defineData( "FEE_REASON_TYPE_CD");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.FEE_REASON_DIM";
                  missing1 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.FEE_REASON_DIM";
            missing1 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.FEE_REASON_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.FEE_REASON_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h2 from lookup table dim.MERCHANT_CATEGORY_DIM */ 
      nlobs = .; 
      dsid = open("dim.MERCHANT_CATEGORY_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h2(dataset: "dim.MERCHANT_CATEGORY_DIM", hashexp: exponent);
            h2.defineKey( "MERCHANT_CATEGORY_SK");
            h2.defineData( "MERCHANT_CATEGORY_CD");
            h2.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h2.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.MERCHANT_CATEGORY_DIM";
                  missing2 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.MERCHANT_CATEGORY_DIM";
            missing2 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.MERCHANT_CATEGORY_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.MERCHANT_CATEGORY_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h3 from lookup table dim.MEDIUM_DIM */ 
      nlobs = .; 
      dsid = open("dim.MEDIUM_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h3(dataset: "dim.MEDIUM_DIM", hashexp: exponent);
            h3.defineKey( "MEDIUM_SK");
            h3.defineData( "MEDIUM_CD");
            h3.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h3.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.MEDIUM_DIM";
                  missing3 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.MEDIUM_DIM";
            missing3 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: dim.MEDIUM_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.MEDIUM_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h4 from lookup table dim.CHANNEL_DIM */ 
      nlobs = .; 
      dsid = open("dim.CHANNEL_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h4(dataset: "dim.CHANNEL_DIM", hashexp: exponent);
            h4.defineKey( "CHANNEL_SK");
            h4.defineData( "CHANNEL_CD");
            h4.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h4.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.CHANNEL_DIM";
                  missing4 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.CHANNEL_DIM";
            missing4 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: dim.CHANNEL_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.CHANNEL_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h5 from lookup table dim.TRANSACTION_STATUS_REASON_DIM */ 
      nlobs = .; 
      dsid = open("dim.TRANSACTION_STATUS_REASON_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h5(dataset: "dim.TRANSACTION_STATUS_REASON_DIM", hashexp: exponent);
            h5.defineKey( "TRANSACTION_STATUS_REASON_SK");
            h5.defineData( "TRANSACTION_STATUS_REASON_CD");
            h5.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h5.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TRANSACTION_STATUS_REASON_DIM";
                  missing5 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TRANSACTION_STATUS_REASON_DIM";
            missing5 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.TRANSACTION_STATUS_REASON_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TRANSACTION_STATUS_REASON_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h6 from lookup table dim.INTERNAL_ORG_DIM */ 
      nlobs = .; 
      dsid = open("dim.INTERNAL_ORG_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h6(dataset: "dim.INTERNAL_ORG_DIM", hashexp: exponent);
            h6.defineKey( "INTERNAL_ORG_SK");
            h6.defineData( "INTERNAL_ORG_COUNTRY_CD");
            h6.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h6.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.INTERNAL_ORG_DIM";
                  missing6 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.INTERNAL_ORG_DIM";
            missing6 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.INTERNAL_ORG_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.INTERNAL_ORG_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h7 from lookup table dim.COUNTRY_DIM */ 
      nlobs = .; 
      dsid = open("dim.COUNTRY_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h7(dataset: "dim.COUNTRY_DIM", hashexp: exponent);
            h7.defineKey( "COUNTRY_SK");
            h7.defineData( "COUNTRY_CD");
            h7.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h7.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.COUNTRY_DIM";
                  missing7 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.COUNTRY_DIM";
            missing7 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: dim.COUNTRY_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.COUNTRY_DIM";
         
         abort 3; 
      end; 
      
      /* Build hash h8 from lookup table dim.TIME_DIM */ 
      nlobs = .; 
      dsid = open("dim.TIME_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h8(dataset: "dim.TIME_DIM", hashexp: exponent);
            h8.defineKey( "TIME_SK");
            h8.defineData( "CAL_MONTH_FIRST_DT");
            h8.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h8.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TIME_DIM";
                  missing8 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TIME_DIM";
            missing8 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: dim.TIME_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TIME_DIM";
         
         abort 3; 
      end; 
      
      call missing (TRANSACTION_TYPE_SK, TRANSACTION_TYPE_CD, CREDIT_DEBIT_FLG, 
                    FEE_REASON_TYPE_SK, FEE_REASON_TYPE_CD, MERCHANT_CATEGORY_SK, 
                    MERCHANT_CATEGORY_CD, MEDIUM_SK, MEDIUM_CD, CHANNEL_SK, 
                    CHANNEL_CD, TRANSACTION_STATUS_REASON_SK, 
                    TRANSACTION_STATUS_REASON_CD, INTERNAL_ORG_SK, 
                    INTERNAL_ORG_COUNTRY_CD, COUNTRY_SK, COUNTRY_CD, TIME_SK, 
                    CAL_MONTH_FIRST_DT); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.ACCTRANS_ACC end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   
   /* Is the current key value stored in hash h1?  */ 
   if (missing1 < 1) then 
   do; 
      rc1 = h1.find();
   end; 
   else 
      rc1 = missing1; 
      
   
   /* Is the current key value stored in hash h2?  */ 
   if (missing2 < 1) then 
   do; 
      rc2 = h2.find();
   end; 
   else 
      rc2 = missing2; 
      
   
   /* Is the current key value stored in hash h3?  */ 
   if (missing3 < 1) then 
   do; 
      rc3 = h3.find();
   end; 
   else 
      rc3 = missing3; 
      
   
   /* Is the current key value stored in hash h4?  */ 
   if (missing4 < 1) then 
   do; 
      rc4 = h4.find();
   end; 
   else 
      rc4 = missing4; 
      
   
   /* Is the current key value stored in hash h5?  */ 
   if (missing5 < 1) then 
   do; 
      rc5 = h5.find();
   end; 
   else 
      rc5 = missing5; 
      
   
   /* Is the current key value stored in hash h6?  */ 
   if (missing6 < 1) then 
   do; 
      rc6 = h6.find();
   end; 
   else 
      rc6 = missing6; 
      
   
   /* Is the current key value stored in hash h7?  */ 
   if (missing7 < 1) then 
   do; 
      rc7 = h7.find();
   end; 
   else 
      rc7 = missing7; 
      
   
   /* Is the current key value stored in hash h8?  */ 
   if (missing8 < 1) then 
   do; 
      rc8 = h8.find();
   end; 
   else 
      rc8 = missing8; 
      
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0and rc2=0and rc3=0and rc4=0and rc5=0and rc6=0and rc7=0and rc8=0) then 
   do; 
      /* Write row to target  */ 
      output abtscr.ACC_TRANS_EXT_LST_12M_LKP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc1 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc2 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc2 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc3 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc3 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc4 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc4 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc5 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc5 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc6 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc6 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc7 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc7 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
      
      if (rc8 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc8 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Macro macro_acc_trans_lst_abt called and  A52B3KFO.BQ0004QR * 
 *                 indexing.                                                  * 
 * Transform:     User Written Code                                           * 
 * Description:   Macro 'macro_acc_trans_lst_abt' called to upload data to    * 
 *                the various account transaction abts and creation of        * 
 *                 simple indices.                                            * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A52B3KFO.BR0002EA * 
 *                 abtscr.ACC_TRANS_EXT_LST_12M_LKP                           * 
 * Target Table:  ACC_TRANS_EXT_LST_12M_LKP - work.         A52B3KFO.BR0002EB * 
 *                                                                            * 
 * User Written:  Macro macro_acc_trans_lst_abt called and  A52B3KFO.AF000P4C * 
 *                 indexing.                                                  * 
 *                Macro 'macro_acc_trans_lst_abt' called to upload data to    * 
 *                the various account transaction abts and creation of        * 
 *                 simple indices.                                            * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(abtscr.ACC_TRANS_EXT_LST_12M_LKP); 

%let transformID = %quote(A52B3KFO.BQ0004QR); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A52B3KFO_BR0002EB); 

/*---- Start of User Written Code  ----*/ 

/* The input to this macro is the 
1) PERIOD=12, so aggregation for current month and last 3, 6 & 12 months will be calculated and stored in,
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH,
TRANS_CASHBACK_REFUND_LST_3M, TRANS_CCD_MERCHANT_CAT_LST_3M, TRANS_CHANNEL_USAGE_LST_3M,
TRANS_CHECK_ISSUE_LST_3M, TRANS_DDR_SORD_LST_3M, TRANS_DEP_WDR_LST_3M,
TRANS_DR_CR_LST_3M, TRANS_FEES_LST_3M, TRANS_FEES_WAIVED_LST_3M,
TRANS_INST_PAYMENTS_LST_3M, TRANS_PAYMENTS_LST_3M, TRANS_PUR_CADV_OVL_LST_3M, 
TRANS_SUMMARY_LST_3M and TRANS_TRANSFER_LST_3M,
TRANS_CASHBACK_REFUND_LST_6M, TRANS_CCD_MERCHANT_CAT_LST_6M, TRANS_CHANNEL_USAGE_LST_6M,
TRANS_CHECK_ISSUE_LST_6M, TRANS_DDR_SORD_LST_6M, TRANS_DEP_WDR_LST_6M,
TRANS_DR_CR_LST_6M, TRANS_FEES_LST_6M, TRANS_FEES_WAIVED_LST_6M,
TRANS_INST_PAYMENTS_LST_6M, TRANS_PAYMENTS_LST_6M, TRANS_PUR_CADV_OVL_LST_6M, 
TRANS_SUMMARY_LST_6M and TRANS_TRANSFER_LST_6M,
TRANS_CASHBACK_REFUND_LST_12M, TRANS_CCD_MERCHANT_CAT_LST_12M, TRANS_CHANNEL_USAGE_LST_12M,
TRANS_CHECK_ISSUE_LST_12M, TRANS_DDR_SORD_LST_12M, TRANS_DEP_WDR_LST_12M,
TRANS_DR_CR_LST_12M, TRANS_FEES_LST_12M, TRANS_FEES_WAIVED_LST_12M,
TRANS_INST_PAYMENTS_LST_12M, TRANS_PAYMENTS_LST_12M, TRANS_PUR_CADV_OVL_LST_12M, 
TRANS_SUMMARY_LST_12M and TRANS_TRANSFER_LST_12M
tables. 
2) TABLE: The input table which is already filtered for the PERIOD 12. 
*/

%macro_acc_trans_lst_abt(PERIOD=12, INPUT_TABLE=ACC_TRANS_EXT_LST_12M_LKP);

/* Creating simple indices */
PROC SQL NOPRINT;
CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_CASHBACK_REFUND_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_CASHBACK_REFUND_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_CCD_MERCHANTCAT_LST_12M(ACCOUNT_TYPE_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_CHANNEL_USAGE_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_CHANNEL_USAGE_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_CHECK_ISSUE_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_CHECK_ISSUE_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_DDR_SORD_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_DDR_SORD_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_DEP_WDR_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_DEP_WDR_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ACCOUNT_RK ON abtagg.TRANS_DEP_WDR_LST_12M(ACCOUNT_RK);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_DR_CR_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_DR_CR_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_DR_CR_LST_12M(COLLATERAL_CD);

CREATE INDEX ACCOUNT_RK ON abtagg.TRANS_FEES_LST_12M(ACCOUNT_RK);
CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_FEES_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_FEES_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_FEES_LST_12M(COLLATERAL_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON abtagg.TRANS_FEES_LST_12M(ALLOW_OVERDRAFT_FLG);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_FEES_WAIVED_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_FEES_WAIVED_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_FEES_WAIVED_LST_12M(COLLATERAL_CD);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_INST_PAYMENTS_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_INST_PAYMENTS_LST_12M(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_INST_PAYMENTS_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON abtagg.TRANS_INST_PAYMENTS_LST_12M(ALLOW_OVERDRAFT_FLG);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_PAYMENTS_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_PAYMENTS_LST_12M(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_PAYMENTS_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_RK ON abtagg.TRANS_PUR_CADV_OVL_LST_12M(ACCOUNT_RK);
CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_PUR_CADV_OVL_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_PUR_CADV_OVL_LST_12M(ACCOUNT_SUB_TYPE_CD);
CREATE INDEX ALLOW_OVERDRAFT_FLG ON abtagg.TRANS_PUR_CADV_OVL_LST_12M(ALLOW_OVERDRAFT_FLG);

CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_SUMMARY_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX COLLATERAL_CD ON abtagg.TRANS_SUMMARY_LST_12M(COLLATERAL_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_SUMMARY_LST_12M(ACCOUNT_SUB_TYPE_CD);

CREATE INDEX ACCOUNT_RK ON abtagg.TRANS_TRANSFER_LST_12M(ACCOUNT_RK);
CREATE INDEX ACCOUNT_TYPE_CD ON abtagg.TRANS_TRANSFER_LST_12M(ACCOUNT_TYPE_CD);
CREATE INDEX ACCOUNT_SUB_TYPE_CD ON abtagg.TRANS_TRANSFER_LST_12M(ACCOUNT_SUB_TYPE_CD);

QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

