/****************************************************************************** 
 * Job:           AM_POOL_SCHEME_APS_TRANSPOSED             A52B3KFO.BP0001Z7 * 
 * Description:   This job picks up data from AM_POOL_SCHEME_APS and          * 
 *                 transposes it.                                             * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Table:  AM_POOL_SCHEME_APS -                      A52B3KFO.BH0002U7 * 
 *                 martscr.AM_POOL_SCHEME_APS                                 * 
 * Target Table:  AM_POOL_SCHEME_APS_TRANSPOSED -           A52B3KFO.BH0002U8 * 
 *                 martscr.AM_POOLSCHEME_APS_TRANSPOSED                       * 
 *                                                                            * 
 * Generated on:  Tuesday, June 10, 2008 2:52:06 PM IST                       * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = AM_POOL_SCHEME_APS_TRANSPOSED;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          User Written Code to transpose            A52B3KFO.BQ000428 * 
 *                 AM_POOL_SCHEME_APS                                         * 
 * Transform:     User Written Code                                           * 
 * Description:   User Written Code to transpose AM_POOL_SCHEME_APS using     * 
 *                 data step.                                                 * 
 *                                                                            * 
 * Source Table:  AM_POOL_SCHEME_APS -                      A52B3KFO.BH0002U7 * 
 *                 martscr.AM_POOL_SCHEME_APS                                 * 
 * Target Table:  User Written Code Target -                A52B3KFO.BR000241 * 
 *                 martscr.AM_POOLSCHEME_APS_TRANSPOSED                       * 
 *                                                                            * 
 * User Written:  Code to transpose AM_POOL_SCHEME_APS      A52B3KFO.AF000M64 * 
 *                Code to transpose AM_POOL_SCHEME_APS                        * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.AM_POOL_SCHEME_APS); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.AM_POOLSCHEME_APS_TRANSPOSED); 

/*---- Start of User Written Code  ----*/ 


/* Sort the input dataset by the variables used for by-group
in the subsequent code */
proc sort data=martscr.AM_POOL_SCHEME_APS;
by FINANCIAL_APPLICATION_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD;
run;

data martscr.AM_POOLSCHEME_APS_TRANSPOSED;
set martscr.AM_POOL_SCHEME_APS;
by FINANCIAL_APPLICATION_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD;

if POOL_SCHEME_TYPE_CD = &SCORE_RANGE_TYPE. then
 ESTIMATED_SCORE=SCORE_POINTS_NO;
else do;
 if MODEL_TYPE_CD = &PD_APP_MODEL. then 
  ESTIMATED_PD=ESTIMATED_RT;
end;

if last.POOL_SCHEME_TYPE_CD then
 output;

keep FINANCIAL_APPLICATION_RK POOL_SCHEME_SK POOL_SCHEME_TYPE_CD ESTIMATED_SCORE ESTIMATED_PD;
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ000427 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A52B3KFO.BR000241 * 
 *                 martscr.AM_POOLSCHEME_APS_TRANSPOSED                       * 
 * Target Table:  AM_POOL_SCHEME_APS_TRANSPOSED -           A52B3KFO.BH0002U8 * 
 *                 martscr.AM_POOLSCHEME_APS_TRANSPOSED                       * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
