/****************************************************************************** 
 * Job:           APPEND_ACCOUNTS                           A52B3KFO.BP00000C * 
 * Description:   This job picks up data from LA_EXT, MA_EXT joined with      * 
 *                PRP_EXT, CRA_EXT and CBA_EXT and appends them to form       * 
 *                 APPEND_ACCOUNTS table                                      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: PRP_EXT - martscr.PRP_EXT                 A52B3KFO.BH0003UX * 
 *                MA_EXT - martscr.MA_EXT                   A52B3KFO.BH0000U8 * 
 *                CBA_EXT - martscr.CBA_EXT                 A52B3KFO.BH0000SJ * 
 *                CRA_EXT - martscr.CRA_EXT                 A52B3KFO.BH0000T0 * 
 *                LA_EXT - martscr.LA_EXT                   A52B3KFO.BH0000U3 * 
 * Target Table:  APPEND_ACCOUNTS - martscr.APPEND_ACCOUNTS A52B3KFO.BH0000S6 * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 10:48:14 AM IST                    * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * APPEND_ACCOUNTS                                                            * 
 * Job Name: APPEND_ACCOUNTSJob Desc Pre Process: NoneMain:a) Appends data    * 
 * from LA_EXT, MA_EXT, CRA_EXT and CBA_EXT account tables, using the         * 
 * append transform.b) The resultant data is loaded into the                  * 
 * APPEND_ACCOUNTS table.Post Process: Create index on ACCOUNT_RK and         * 
 *  LOAD_END_DTTMParameters: NoneDeveloped by: singupReviewed by:Tested by:   * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00000C);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPEND_ACCOUNTS;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0005EJ * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: PRP_EXT - martscr.PRP_EXT                 A52B3KFO.BH0003UX * 
 *                MA_EXT - martscr.MA_EXT                   A52B3KFO.BH0000U8 * 
 * Target Table:  SQL Target - martscr.MA_PRP               A52B3KFO.BR000336 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0005EJ); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete MA_PRP;
quit;

proc sql;
   create table martscr.MA_PRP as
      select
         MA_EXT.ACCOUNT_RK length = 8
                           format = 12.
                           informat = 12.
                           label = "Account Key",
         PRP_EXT.LOAD_END_DTTM length = 8
                               format = NLDATM21.
                               informat = NLDATM21.
                               label = "Load End Datetime",
         PRP_EXT.APPRAISED_VALUE_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Appraised Value Amount",
         MA_EXT.APR_RT_CHANGE_REASON_CD length = 3,
         &COL_TYPE_PRP as COLLATERAL_CD length = 3
                                        label = "Collateral Code",
         MA_EXT.MATURITY_CHANGE_REASON_CD length = 3,
         MA_EXT.SPECIAL_INTEREST_RT length = 8,
         MA_EXT.DISBURSEMENT_TYPE_CD length = 3,
         MA_EXT.HONEYMOON_START_DT length = 8,
         MA_EXT.REPAYMENT_HOLIDAY_END_DT length = 8,
         MA_EXT.REPAYMENT_HOLIDAY_FLG length = 1,
         MA_EXT.REPAYMENT_HOLIDAY_START_DT length = 8,
         MA_EXT.SPECIAL_RATE_END_DT length = 8,
         MA_EXT.SPECIAL_RATE_TYPE_CD length = 3,
         MA_EXT.SPECIAL_RATE_START_DT length = 8,
         MA_EXT.BUILDING_INS_EXTERNAL_ORG_RK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "Building Insurance External Organization Key",
         MA_EXT.MORTGAGE_TYPE_CD length = 3
                                 label = "Mortgage Type Code",
         MA_EXT.MORTGAGE_CYCLE_DAY_NO length = 8
                                      label = "Mortgage Cycle No Date",
         MA_EXT.ACTUAL_ADVANCE_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Actual Advance Amount",
         MA_EXT.ADVANCE_REQ_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Advance Required Amount",
         MA_EXT.ADVANCE_PCT length = 8
                            format = NLNUM9.4
                            informat = NLNUM9.4
                            label = "Advance Percent",
         MA_EXT.REVIEW_DT length = 8
                          format = NLDATE10.
                          informat = NLDATE10.
                          label = "Review Date",
         MA_EXT.CURRENT_LIMIT_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "Current Limit Amount",
         MA_EXT.CURRENT_LIMIT_DT length = 8
                                 format = NLDATE10.
                                 informat = NLDATE10.
                                 label = "Current Limit Date",
         MA_EXT.INTEREST_PAYABLE_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Interest Payable Amount",
         MA_EXT.TAX_YEAR_INTEREST_AMT length = 8
                                      format = NLNUM18.5
                                      informat = NLNUM18.5
                                      label = "Tax Year Interest Amount",
         MA_EXT.SET_UP_FEES_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Set Up Fees Amount",
         MA_EXT.CHARGE_OFF_DT length = 8
                              format = NLDATE10.
                              informat = NLDATE10.
                              label = "Charge Off Date",
         MA_EXT.CHARGE_OFF_AMT length = 8
                               format = NLNUM18.5
                               informat = NLNUM18.5
                               label = "Charge Off Amount",
         MA_EXT.LATEST_MTH_PREM_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Latest Month Premium Amount",
         MA_EXT.GUARANTEE_AMT length = 8
                              format = NLNUM18.5
                              informat = NLNUM18.5
                              label = "Guarantee Amount",
         MA_EXT.CLOSING_COST_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Closing Cost Amount",
         MA_EXT.APPROVED_ADVANCE_AMT length = 8
                                     format = NLNUM18.5
                                     informat = NLNUM18.5
                                     label = "Approved Advance Amount",
         MA_EXT.MAXIMUM_MONTHLY_PAYMENT_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Maximum Monthly Payment Amount",
         MA_EXT.PAYMENT_ADJUSTABLE_CAP_AMT length = 8
                                           format = NLNUM18.5
                                           informat = NLNUM18.5
                                           label = "Maximum Payment Adjustable  Amount",
         MA_EXT.IMPROVEMENTS_ALLOCATION_AMT length = 8
                                            format = NLNUM18.5
                                            informat = NLNUM18.5
                                            label = "Improvements Allocation Amount",
         MA_EXT.DEBT_PAYMENT_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Debt Payment Amount",
         MA_EXT.MONTHLY_PAYMENT_AMT length = 8
                                    format = NLNUM18.5
                                    informat = NLNUM18.5
                                    label = "Monthly Payment Amount",
         MA_EXT.DOWN_PAYMENT_AMT length = 8
                                 format = NLNUM18.5
                                 informat = NLNUM18.5
                                 label = "Down Payment Amount",
         MA_EXT.APR_RT length = 8
                       format = NLNUM9.4
                       informat = NLNUM9.4
                       label = "APR Rate",
         MA_EXT.BASE_APR_RT length = 8
                            format = NLNUM9.4
                            informat = NLNUM9.4
                            label = "Base APR Rate",
         MA_EXT.VRBLE_CHNG_TIME_FREQUENCY_CD length = 3
                                             label = "Variable Change Time Frequency Code",
         MA_EXT.FIXED_APR_RT length = 8
                             format = NLNUM9.4
                             informat = NLNUM9.4
                             label = "Fixed APR Rate",
         MA_EXT.FIXED_PERIOD_MONTHS length = 8
                                    label = "Fixed Period Months",
         MA_EXT.FIXED_VARIABLE_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Fixed Variable Date",
         MA_EXT.CONVERSION_TO_FIXED_END_DT length = 8
                                           format = NLDATE10.
                                           informat = NLDATE10.
                                           label = "Conversion To Fixed End Date",
         MA_EXT.HOME_STATUS_CD length = 3
                               label = "Social Aim Type Code",
         MA_EXT.MORTGAGE_STATUS_CD length = 3
                                   label = "Mortgage Status Code",
         MA_EXT.EXCHANGE_DT length = 8
                            format = NLDATE10.
                            informat = NLDATE10.
                            label = "Exchange Date",
         MA_EXT.REDEEMED_DT length = 8
                            format = NLDATE10.
                            informat = NLDATE10.
                            label = "Redeemed Date",
         MA_EXT.MATURITY_DT length = 8
                            format = NLDATE10.
                            informat = NLDATE10.
                            label = "Maturity Date",
         MA_EXT.PAYMENT_METHOD_CD length = 3
                                  label = "Payment Method Code",
         MA_EXT.COLLECTIONS_STATUS_CD length = 3
                                      label = "Collections Status Code",
         MA_EXT.CASHBACK_AMT length = 8
                             format = NLNUM18.5
                             informat = NLNUM18.5
                             label = "Cashback Amount",
         MA_EXT.CASHBACK_PCT length = 8
                             format = NLNUM9.4
                             informat = NLNUM9.4
                             label = "Cashback Percent",
         MA_EXT.LIFE_INSURANCE_FLG length = 1
                                   label = "Life Insurance Flag",
         MA_EXT.INTRODUCER_CD length = 3
                              label = "Introducer Code",
         MA_EXT.LAST_STATEMENT_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Last Statement Date",
         MA_EXT.REDEMPTION_CHARGES_CD length = 3
                                      label = "Redemption Charges Code",
         MA_EXT.OPEN_TO_BUY_AMT length = 8
                                format = NLNUM18.5
                                informat = NLNUM18.5
                                label = "Open To Buy Amount",
         MA_EXT.PROTECTION_FLG length = 1
                               label = "Protection Flag",
         MA_EXT.PROTECTION_POLICY_NO length = 20
                                     label = "Protection Policy No",
         MA_EXT.PROTECTION_START_DT length = 8
                                    format = NLDATE10.
                                    informat = NLDATE10.
                                    label = "Protection Start Date",
         MA_EXT.PROTECTION_PREM_RT length = 8
                                   format = NLNUM9.4
                                   informat = NLNUM9.4
                                   label = "Protection Premium Rate",
         MA_EXT.PROTECTION_INS_EXTERNAL_ORG_RK length = 8
                                               format = 12.
                                               informat = 12.
                                               label = "Protection Insurance External Organization Key",
         MA_EXT.PROT_TERM_CONDITION_CD length = 3
                                       label = "Protection Term Condition Code",
         MA_EXT.PROT_PREM_START_DT length = 8
                                   format = NLDATE10.
                                   informat = NLDATE10.
                                   label = "Protection Prem Start Date",
         MA_EXT.PPI_PREMIUM_FIRST_DUE_DT length = 8
                                         format = NLDATE10.
                                         informat = NLDATE10.
                                         label = "Protection insurance first premium due date",
         MA_EXT.PREPAYMENT_PENALTY_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Prepayment Penalty Date",
         MA_EXT.PREPAYMENT_PENALTY_AMT length = 8
                                       format = NLNUM18.5
                                       informat = NLNUM18.5
                                       label = "Prepayment Penalty Amount",
         MA_EXT.BUILDINGS_INS_FLG length = 1
                                  label = "Buildings Insurance Flag",
         MA_EXT.BLDG_INS_PROOF_FLG length = 1
                                   label = "Building Insurance Proof Flag",
         MA_EXT.MONTHS_SINCE_AT_BUREAU_CNT length = 8
                                           label = "Months Since At Bureau",
         MA_EXT.BUREAU_CLASS_CD length = 3
                                label = "Bureau Class Code",
         MA_EXT.INQUIRY_BUREAU_CNT length = 8
                                   label = "Inquiry Bureau Count",
         MA_EXT.INTEREST_RATE_CAP_RT length = 8
                                     format = NLNUM9.4
                                     informat = NLNUM9.4
                                     label = "Maximum Interest Rate",
         MA_EXT.NEXT_PI_ADJUSTMENT_DT length = 8
                                      format = NLDATE10.
                                      informat = NLDATE10.
                                      label = "Next PI Adjustment Date",
         MA_EXT.PERIOD_CAP_PERCENTAGE_RT length = 8
                                         format = NLNUM9.4
                                         informat = NLNUM9.4
                                         label = "Period Maximum Percentage Rate",
         MA_EXT.HOME_EQUITY_LOAN_FLG length = 1
                                     label = "Home Equity Loan Flag",
         MA_EXT.DOCUMENTATION_TYPE_CD length = 3
                                      label = "Documentation Type Code",
         MA_EXT.FIRST_TIME_BUYER_FLG length = 1
                                     label = "First Time Buyer Flag",
         MA_EXT.PRINCIPAL_REPAYMENT_FLG length = 1
                                        label = "Principal Repayment Flag",
         MA_EXT.ANNUAL_REPAYMENT_PCT length = 8
                                     format = NLNUM9.4
                                     informat = NLNUM9.4
                                     label = "Annual Repayment Percent",
         MA_EXT.PAYMENT_TIME_FREQUENCY_CD length = 3
                                          label = "Payment Time Frequency Code",
         MA_EXT.PAYMENT_AMT length = 8
                            format = NLNUM18.5
                            informat = NLNUM18.5
                            label = "Payment Amount",
         MA_EXT.FIRST_MORTGAGE_FLG length = 1
                                   label = "First Mortgage Flag",
         MA_EXT.AUTO_PAY_FLG length = 1
                             label = "Auto Pay Flag",
         MA_EXT.LIEN_INDICATOR_FLG length = 1
                                   label = "Lien Indicator Flag",
         MA_EXT.MAINTENANCE_FLG length = 1
                                label = "Maintenance Flag",
         MA_EXT.BORROWED_DOWNPAYMENT_FLG length = 1
                                         label = "Borrowed Downpayment Flag",
         MA_EXT.BORROWED_DOWNPAYMENT_PCT length = 8
                                         format = NLNUM9.4
                                         informat = NLNUM9.4
                                         label = "Borrowed Downpayment Percent",
         MA_EXT.CASH_ADVANCE_FLG length = 1
                                 label = "Cash Advance Flag",
         MA_EXT.PURPOSE_CD length = 3
                           label = "Purpose Code",
         MA_EXT.SPECIALIZED_LENDING_CD length = 3
                                       label = "Specialized Lending Code",
         MA_EXT.SENIORITY_CD length = 3
                             label = "Seniority Code",
         MA_EXT.INTEREST_TIER_NO length = 18
                                 label = "Interest Tier No",
         MA_EXT.PRE_CREDIT_CD length = 3
                              label = "Pre Credit Code",
         MA_EXT.PRE_CREDIT_END_DT length = 8
                                  format = NLDATE10.
                                  informat = NLDATE10.
                                  label = "Pre Credit End Date",
         MA_EXT.REFINANCE_AMT length = 8
                              format = NLNUM18.5
                              informat = NLNUM18.5
                              label = "Refinance Amount",
         MA_EXT.APR_TYPE_CD length = 10
                            label = "Annual Percentage Rate (APR) Type code.",
         MA_EXT.MINIMUM_PAYMENT_FLG length = 1
                                    label = "Minimum Payment Flag",
         MA_EXT.REDRAW_FLG length = 1
                           label = "Redraw Flag",
         MA_EXT.MINIMUM_REDRAW_AMT length = 8
                                   format = NLNUM18.5
                                   informat = NLNUM18.5
                                   label = "Minimum Redraw Amount",
         MA_EXT.CONVERT_TO_SPLIT_OPTION_FLG length = 1
                                            label = "Convert to Split Option Flag",
         MA_EXT.ORIGIN_CHANNEL_CD length = 3
                                  label = "Origin Channel Code",
         MA_EXT.ACCOUNT_ID length = 32
                           label = "Account Id",
         MA_EXT.SOURCE_SYSTEM_CD length = 3
                                 label = "Source System Code",
         MA_EXT.HONEYMOON_FLG length = 1
                              label = "Honeymoon Flag",
         MA_EXT.HONEYMOON_END_DT length = 8
                                 format = NLDATE10.
                                 informat = NLDATE10.
                                 label = "Honeymoon End Date",
         MA_EXT.OFFSET_ACCOUNT_FLG length = 1
                                   label = "Offset Account Flag",
         MA_EXT.PORTABILITY_FLG length = 1
                                label = "Portability Flag",
         MA_EXT.PAYMENT_PROTECTION_FLG length = 1
                                       label = "Payment Protection Flag",
         MA_EXT.PAYMENT_PROTECTION_STATUS_CD length = 3
                                             label = "Payment Protect Status Code",
         MA_EXT.PROTECTION_STATUS_CD length = 3
                                     label = "Protection Status Code",
         MA_EXT.SPLIT_LOAN_FLG length = 1
                               label = "Split Loan Flag",
         MA_EXT.FIXED_INT_END_DT length = 8
                                 format = NLDATE10.
                                 informat = NLDATE10.
                                 label = "Fixed Interest End Date",
         MA_EXT.CONVERTIBLE_CD length = 3
                               label = "Convertible Code",
         PRP_EXT.PROPERTY_RK length = 8
                             format = 12.
                             informat = 12.
                             label = "Property Key"
      from
         martscr.PRP_EXT, 
         martscr.MA_EXT
      where
         MA_EXT.PROPERTY_RK = PRP_EXT.PROPERTY_RK
         and MA_EXT.LOAD_END_DTTM = PRP_EXT.LOAD_END_DTTM
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Append data from different account tables A52B3KFO.BQ00000O * 
 * Transform:     Append                                                      * 
 * Description:   Append data from different account tables                   * 
 *                                                                            * 
 * Source Tables: CBA_EXT - martscr.CBA_EXT                 A52B3KFO.BH0000SJ * 
 *                CRA_EXT - martscr.CRA_EXT                 A52B3KFO.BH0000T0 * 
 *                LA_EXT - martscr.LA_EXT                   A52B3KFO.BH0000U3 * 
 *                SQL Target - martscr.MA_PRP               A52B3KFO.BR000336 * 
 * Target Table:  AppendWorkTableName -                     A52B3KFO.BR00000G * 
 *                 martscr.APPEND_ACCOUNTS                                    * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ00000O); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete APPEND_ACCOUNTS;
quit;

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5KMUM02;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: INITIAL_LIMIT_AMT,"
        " LIEN_INDICATOR_FLG, CLOSING_COST_AMT, REDRAW_FLG,"
        " COLLECTIONS_STATUS_CD, APR_TYPE_CD, APR_RT_CHANGE_REASON_CD,"
        " COLLATERAL_AMT, HOME_STATUS_CD, SPECIAL_INTEREST_RT, PURPOSE_CD,"
        " ADDITIONAL_CARD_CNT, COLLATERAL_CD, SECURITY_CD,"
        " MORTGAGE_INSURED_FLG, PAYMENT_INSURED_FLG, DOCUMENTATION_TYPE_CD,"
        " TENURE_CHANGE_REASON_CD, MIN_REDRAW_AMT, MIN_PAYMENT_FLG,"
        " DISBURSEMENT_TYPE_CD, CASH_BACK_FLG, CASH_BACK_PCT,"
        " FINANCE_CHARGE_FLG, SPLIT_LOAN_FLG, PORTABILITY_FLG,"
        " CURRENT_LIMIT_AMT, CURRENT_LIMIT_DT, CASH_LIMIT_AMT, APPROVED_AMT,"
        " ACTUAL_ADVANCE_AMT, DOWNPAYMENT_AMT, IMPROVEMENTS_ALLOCATION_AMT,"
        " MATURITY_DT, CARD_ISSUE_DT, CARD_EXPIRATION_DT, CARD_REISSUE_DT,"
        " OFFSET_ACCOUNT_FLG, HONEYMOON_PERIOD_FLG, HONEYMOON_START_DT,"
        " HONEYMOON_PERIOD_END_DT, REPAYMENT_HOLIDAY_FLG,"
        " REPAYMENT_HOLIDAY_START_DT, REPAYMENT_HOLIDAY_END_DT,"
        " PAYMENT_DAY_OF_MONTH, SPECIAL_RATE_TYPE_CD, SPECIAL_RATE_START_DT,"
        " SPECIAL_RATE_END_DT, SENIORITY_CD, GUARANTEE_AMT,"
        " PROVISIONAL_CREDIT_LIMIT_AMT, PROV_CREDIT_LIMIT_OPEN_DT,"
        " PROV_CREDIT_LIMIT_CLOSE_DT, OPEN_TO_BUY_AMT, CHARGE_OFF_AMT,"
        " CHARGE_OFF_DT";
run; 

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.W5KMUM02 as 
      select ACCOUNT_RK length = 8,
             LOAD_END_DTTM length = 8,
             DIRECT_DEBITS_CNT length = 8,
             CHECKING_MAIN_FLG length = 1,
             . as INITIAL_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             STANDING_ORDERS_CNT length = 8,
             OVERDRAFT_LIMIT_AMT length = 8,
             OVERDRAFT_LIMIT_DT length = 8,
             "" as LIEN_INDICATOR_FLG length = 1,
             . as CLOSING_COST_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             "" as REDRAW_FLG length = 1,
             "" as COLLECTIONS_STATUS_CD length = 3,
             "" as APR_TYPE_CD length = 10,
             APR_RT length = 8,
             ACCOUNT_RENEWAL_TYPE_CD length = 3,
             "" as APR_RT_CHANGE_REASON_CD length = 3,
             . as COLLATERAL_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             "" as HOME_STATUS_CD length = 3,
             . as SPECIAL_INTEREST_RT length = 8,
             CORE_ACCOUNT_TYPE_CD as ACCOUNT_SUB_TYPE_CD length = 3,
             "" as PURPOSE_CD length = 3,
             . as ADDITIONAL_CARD_CNT length = 8,
             "" as COLLATERAL_CD length = 3,
             "" as SECURITY_CD length = 3,
             "" as MORTGAGE_INSURED_FLG length = 1,
             "" as PAYMENT_INSURED_FLG length = 1,
             "" as DOCUMENTATION_TYPE_CD length = 3,
             CHECKING_BOOK_FLG as CHECK_BOOK_FLG length = 1,
             MIN_ACCOUNT_OPENING_AMT length = 8,
             REQUIRED_MIN_BALANCE_AMT length = 8,
             OVERDRAFT_FLG as ALLOW_OVERDRAFT_FLG length = 1,
             SAFE_DEPOSIT_FLG length = 1,
             "" as TENURE_CHANGE_REASON_CD length = 3,
             . as MIN_REDRAW_AMT length = 8,
             "" as MIN_PAYMENT_FLG length = 1,
             "" as DISBURSEMENT_TYPE_CD length = 3,
             "" as CASH_BACK_FLG length = 1,
             . as CASH_BACK_PCT length = 8,
             "" as FINANCE_CHARGE_FLG length = 1,
             "" as SPLIT_LOAN_FLG length = 1,
             "" as PORTABILITY_FLG length = 1,
             ACTUAL_ACCOUNT_OPENING_AMT length = 8,
             . as CURRENT_LIMIT_AMT length = 8,
             . as CURRENT_LIMIT_DT length = 8,
             . as CASH_LIMIT_AMT length = 8,
             . as APPROVED_AMT length = 8,
             . as ACTUAL_ADVANCE_AMT length = 8,
             . as DOWNPAYMENT_AMT length = 8,
             . as IMPROVEMENTS_ALLOCATION_AMT length = 8,
             INTEREST_PAYOUT_FLG length = 1,
             . as MATURITY_DT length = 8,
             . as CARD_ISSUE_DT length = 8,
             . as CARD_EXPIRATION_DT length = 8,
             . as CARD_REISSUE_DT length = 8,
             "" as OFFSET_ACCOUNT_FLG length = 1,
             "" as HONEYMOON_PERIOD_FLG length = 1,
             . as HONEYMOON_START_DT length = 8,
             . as HONEYMOON_PERIOD_END_DT length = 8,
             LINKED_ACCOUNT_FLG length = 1,
             LINKED_DEPOSIT_ACCOUNT_FLG length = 1,
             "" as REPAYMENT_HOLIDAY_FLG length = 1,
             . as REPAYMENT_HOLIDAY_START_DT length = 8,
             . as REPAYMENT_HOLIDAY_END_DT length = 8,
             PAYMENT_TIME_FREQUENCY_CD as PAYMENT_FREQUENCY_CD length = 3,
             PAYMENT_AMT as REGULAR_PERIODIC_PAYMENT_AMT length = 8,
             . as PAYMENT_DAY_OF_MONTH length = 8,
             PAYMENT_METHOD_CD as PAYMENT_MODE_CD length = 3,
             "" as SPECIAL_RATE_TYPE_CD length = 3,
             . as SPECIAL_RATE_START_DT length = 8,
             . as SPECIAL_RATE_END_DT length = 8,
             STEP_UP_FACILITY_USED_FLG length = 1,
             CALLABLE_FACILITY_USED_FLG length = 1,
             "" as SENIORITY_CD length = 3,
             . as GUARANTEE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as PROVISIONAL_CREDIT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as PROV_CREDIT_LIMIT_OPEN_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as PROV_CREDIT_LIMIT_CLOSE_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as OPEN_TO_BUY_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as CHARGE_OFF_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as CHARGE_OFF_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             RENEWAL_DT length = 8,
             TERM length = 8,
             TERM_TIME_UOM_CD length = 3
         from martscr.CBA_EXT; 
quit;

%let SYSLAST = work.W5KMUM02; 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5KMUM0C;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: DIRECT_DEBITS_CNT,"
        " CHECKING_MAIN_FLG, STANDING_ORDERS_CNT, OVERDRAFT_LIMIT_AMT,"
        " OVERDRAFT_LIMIT_DT, LIEN_INDICATOR_FLG, CLOSING_COST_AMT, REDRAW_FLG,"
        " APR_TYPE_CD, APR_RT_CHANGE_REASON_CD, COLLATERAL_AMT, HOME_STATUS_CD,"
        " SPECIAL_INTEREST_RT, PURPOSE_CD, COLLATERAL_CD, SECURITY_CD,"
        " MORTGAGE_INSURED_FLG, DOCUMENTATION_TYPE_CD, CHECK_BOOK_FLG,"
        " MIN_ACCOUNT_OPENING_AMT, REQUIRED_MIN_BALANCE_AMT,"
        " ALLOW_OVERDRAFT_FLG, SAFE_DEPOSIT_FLG, TENURE_CHANGE_REASON_CD,"
        " MIN_REDRAW_AMT, MIN_PAYMENT_FLG, DISBURSEMENT_TYPE_CD,"
        " SPLIT_LOAN_FLG, PORTABILITY_FLG, ACTUAL_ACCOUNT_OPENING_AMT,"
        " APPROVED_AMT, ACTUAL_ADVANCE_AMT, DOWNPAYMENT_AMT,"
        " IMPROVEMENTS_ALLOCATION_AMT, INTEREST_PAYOUT_FLG, MATURITY_DT,"
        " HONEYMOON_PERIOD_FLG, HONEYMOON_START_DT, HONEYMOON_PERIOD_END_DT,"
        " LINKED_ACCOUNT_FLG, LINKED_DEPOSIT_ACCOUNT_FLG,"
        " REPAYMENT_HOLIDAY_FLG, REPAYMENT_HOLIDAY_START_DT,"
        " REPAYMENT_HOLIDAY_END_DT, PAYMENT_FREQUENCY_CD,"
        " REGULAR_PERIODIC_PAYMENT_AMT, PAYMENT_DAY_OF_MONTH,"
        " SPECIAL_RATE_TYPE_CD, SPECIAL_RATE_START_DT, SPECIAL_RATE_END_DT,"
        " STEP_UP_FACILITY_USED_FLG, CALLABLE_FACILITY_USED_FLG, SENIORITY_CD,"
        " GUARANTEE_AMT, TERM, TERM_TIME_UOM_CD";
run; 

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.W5KMUM0C as 
      select ACCOUNT_RK length = 8,
             LOAD_END_DTTM length = 8,
             . as DIRECT_DEBITS_CNT length = 8,
             "" as CHECKING_MAIN_FLG length = 1,
             INITIAL_LIMIT_AMT length = 8,
             . as STANDING_ORDERS_CNT length = 8,
             . as OVERDRAFT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as OVERDRAFT_LIMIT_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             "" as LIEN_INDICATOR_FLG length = 1,
             . as CLOSING_COST_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             "" as REDRAW_FLG length = 1,
             COLLECTIONS_STATUS_CD length = 3,
             "" as APR_TYPE_CD length = 10,
             APR_RT length = 8,
             ACCOUNT_RENEWAL_TYPE_CD length = 3,
             "" as APR_RT_CHANGE_REASON_CD length = 3,
             . as COLLATERAL_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             "" as HOME_STATUS_CD length = 3,
             . as SPECIAL_INTEREST_RT length = 8,
             CREDIT_CARD_ACCOUNT_TYPE_CD as ACCOUNT_SUB_TYPE_CD length = 3,
             "" as PURPOSE_CD length = 3,
             ADDITIONAL_CARD_CNT length = 8,
             "" as COLLATERAL_CD length = 3,
             "" as SECURITY_CD length = 3,
             "" as MORTGAGE_INSURED_FLG length = 1,
             PAYMENT_PROTECTION_FLG as PAYMENT_INSURED_FLG length = 1,
             "" as DOCUMENTATION_TYPE_CD length = 3,
             "" as CHECK_BOOK_FLG length = 1,
             . as MIN_ACCOUNT_OPENING_AMT length = 8,
             . as REQUIRED_MIN_BALANCE_AMT length = 8,
             "" as ALLOW_OVERDRAFT_FLG length = 1,
             "" as SAFE_DEPOSIT_FLG length = 1,
             "" as TENURE_CHANGE_REASON_CD length = 3,
             . as MIN_REDRAW_AMT length = 8,
             "" as MIN_PAYMENT_FLG length = 1,
             "" as DISBURSEMENT_TYPE_CD length = 3,
             CASH_BACK_FLG length = 1,
             CASH_BACK_PCT length = 8,
             FINANCE_CHARGE_FLG length = 1,
             "" as SPLIT_LOAN_FLG length = 1,
             "" as PORTABILITY_FLG length = 1,
             . as ACTUAL_ACCOUNT_OPENING_AMT length = 8,
             CURRENT_LIMIT_AMT length = 8,
             CURRENT_LIMIT_DT length = 8,
             CASH_CREDIT_LINE_AMT as CASH_LIMIT_AMT length = 8,
             . as APPROVED_AMT length = 8,
             . as ACTUAL_ADVANCE_AMT length = 8,
             . as DOWNPAYMENT_AMT length = 8,
             . as IMPROVEMENTS_ALLOCATION_AMT length = 8,
             "" as INTEREST_PAYOUT_FLG length = 1,
             . as MATURITY_DT length = 8,
             CARD_ISSUE_DT length = 8,
             CARD_EXPIRATION_DT length = 8,
             CARD_REISSUE_DT length = 8,
             OFFSET_ACCOUNT_FLG length = 1,
             "" as HONEYMOON_PERIOD_FLG length = 1,
             . as HONEYMOON_START_DT length = 8,
             . as HONEYMOON_PERIOD_END_DT length = 8,
             "" as LINKED_ACCOUNT_FLG length = 1,
             "" as LINKED_DEPOSIT_ACCOUNT_FLG length = 1,
             "" as REPAYMENT_HOLIDAY_FLG length = 1,
             . as REPAYMENT_HOLIDAY_START_DT length = 8,
             . as REPAYMENT_HOLIDAY_END_DT length = 8,
             "" as PAYMENT_FREQUENCY_CD length = 3,
             . as REGULAR_PERIODIC_PAYMENT_AMT length = 8,
             . as PAYMENT_DAY_OF_MONTH length = 8,
             PAYMENT_METHOD_CD as PAYMENT_MODE_CD length = 3,
             "" as SPECIAL_RATE_TYPE_CD length = 3,
             . as SPECIAL_RATE_START_DT length = 8,
             . as SPECIAL_RATE_END_DT length = 8,
             "" as STEP_UP_FACILITY_USED_FLG length = 1,
             "" as CALLABLE_FACILITY_USED_FLG length = 1,
             "" as SENIORITY_CD length = 3,
             . as GUARANTEE_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             PROVISIONAL_CREDIT_LIMIT_AMT length = 8,
             PROV_CREDIT_LIMIT_OPEN_DT length = 8,
             PROV_CREDIT_LIMIT_CLOSE_DT length = 8,
             OPEN_TO_BUY_AMT length = 8,
             CHARGE_OFF_AMT length = 8,
             CHARGE_OFF_DT length = 8,
             RENEWAL_DT length = 8,
             . as TERM length = 8,
             "" as TERM_TIME_UOM_CD length = 3
         from martscr.CRA_EXT; 
quit;

%let SYSLAST = work.W5KMUM0C; 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5KMUM0M;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: DIRECT_DEBITS_CNT,"
        " CHECKING_MAIN_FLG, INITIAL_LIMIT_AMT, STANDING_ORDERS_CNT,"
        " OVERDRAFT_LIMIT_AMT, OVERDRAFT_LIMIT_DT, CLOSING_COST_AMT,"
        " REDRAW_FLG, ACCOUNT_RENEWAL_TYPE_CD, HOME_STATUS_CD,"
        " ADDITIONAL_CARD_CNT, MORTGAGE_INSURED_FLG, CHECK_BOOK_FLG,"
        " MIN_ACCOUNT_OPENING_AMT, REQUIRED_MIN_BALANCE_AMT,"
        " ALLOW_OVERDRAFT_FLG, SAFE_DEPOSIT_FLG, MIN_REDRAW_AMT,"
        " MIN_PAYMENT_FLG, CASH_BACK_FLG, CASH_BACK_PCT, FINANCE_CHARGE_FLG,"
        " ACTUAL_ACCOUNT_OPENING_AMT, CASH_LIMIT_AMT,"
        " IMPROVEMENTS_ALLOCATION_AMT, INTEREST_PAYOUT_FLG, CARD_ISSUE_DT,"
        " CARD_EXPIRATION_DT, CARD_REISSUE_DT, LINKED_ACCOUNT_FLG,"
        " LINKED_DEPOSIT_ACCOUNT_FLG, STEP_UP_FACILITY_USED_FLG,"
        " CALLABLE_FACILITY_USED_FLG, PROVISIONAL_CREDIT_LIMIT_AMT,"
        " PROV_CREDIT_LIMIT_OPEN_DT, PROV_CREDIT_LIMIT_CLOSE_DT,"
        " OPEN_TO_BUY_AMT, RENEWAL_DT, TERM, TERM_TIME_UOM_CD";
run; 

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.W5KMUM0M as 
      select ACCOUNT_RK length = 8,
             LOAD_END_DTTM length = 8,
             . as DIRECT_DEBITS_CNT length = 8,
             "" as CHECKING_MAIN_FLG length = 1,
             . as INITIAL_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as STANDING_ORDERS_CNT length = 8,
             . as OVERDRAFT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as OVERDRAFT_LIMIT_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             LIEN_INDICATOR_FLG length = 1,
             . as CLOSING_COST_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             "" as REDRAW_FLG length = 1,
             COLLECTIONS_STATUS_CD length = 3,
             APR_TYPE_CD length = 10,
             APR_RT length = 8,
             "" as ACCOUNT_RENEWAL_TYPE_CD length = 3,
             APR_RT_CHANGE_REASON_CD length = 3,
             COLLATERAL_AMT length = 8,
             "" as HOME_STATUS_CD length = 3,
             SPECIAL_INTEREST_RT length = 8,
             LOAN_TYPE_CD as ACCOUNT_SUB_TYPE_CD length = 3,
             PURPOSE_CD length = 3,
             . as ADDITIONAL_CARD_CNT length = 8,
             COLLATERAL_CD length = 3,
             SECURITY_CD length = 3,
             "" as MORTGAGE_INSURED_FLG length = 1,
             PPI_FLG as PAYMENT_INSURED_FLG length = 1,
             DOCUMENTATION_TYPE_CD length = 3,
             "" as CHECK_BOOK_FLG length = 1,
             . as MIN_ACCOUNT_OPENING_AMT length = 8,
             . as REQUIRED_MIN_BALANCE_AMT length = 8,
             "" as ALLOW_OVERDRAFT_FLG length = 1,
             "" as SAFE_DEPOSIT_FLG length = 1,
             MATURITY_CHANGE_REASON_CD as TENURE_CHANGE_REASON_CD length = 3,
             . as MIN_REDRAW_AMT length = 8,
             "" as MIN_PAYMENT_FLG length = 1,
             DISBURSEMENT_TYPE_CD length = 3,
             "" as CASH_BACK_FLG length = 1,
             . as CASH_BACK_PCT length = 8,
             "" as FINANCE_CHARGE_FLG length = 1,
             SPLIT_LOAN_FLG length = 1,
             PORTABILITY_FLG length = 1,
             . as ACTUAL_ACCOUNT_OPENING_AMT length = 8,
             CURRENT_LIMIT_AMT length = 8,
             CURRENT_LIMIT_DT length = 8,
             . as CASH_LIMIT_AMT length = 8,
             ADVANCE_APPROVED_AMT as APPROVED_AMT length = 8,
             ACTUAL_ADVANCE_AMT length = 8,
             DOWN_PAYMENT_AMT as DOWNPAYMENT_AMT length = 8,
             . as IMPROVEMENTS_ALLOCATION_AMT length = 8,
             "" as INTEREST_PAYOUT_FLG length = 1,
             MATURITY_DT length = 8,
             . as CARD_ISSUE_DT length = 8,
             . as CARD_EXPIRATION_DT length = 8,
             . as CARD_REISSUE_DT length = 8,
             OFFSET_ACCOUNT_FLG length = 1,
             HONEYMOON_FLG as HONEYMOON_PERIOD_FLG length = 1,
             HONEYMOON_START_DT length = 8,
             HONEYMOON_END_DT as HONEYMOON_PERIOD_END_DT length = 8,
             "" as LINKED_ACCOUNT_FLG length = 1,
             "" as LINKED_DEPOSIT_ACCOUNT_FLG length = 1,
             REPAYMENT_HOLIDAY_FLG length = 1,
             REPAYMENT_HOLIDAY_START_DT length = 8,
             REPAYMENT_HOLIDAY_END_DT length = 8,
             PAYMENT_TIME_FREQUENCY_CD as PAYMENT_FREQUENCY_CD length = 3,
             PAYMENT_AMT as REGULAR_PERIODIC_PAYMENT_AMT length = 8,
             LOAN_CYCLE_NO as PAYMENT_DAY_OF_MONTH length = 8,
             PAYMENT_METHOD_CD as PAYMENT_MODE_CD length = 3,
             SPECIAL_RATE_TYPE_CD length = 3,
             SPECIAL_RATE_START_DT length = 8,
             SPECIAL_RATE_END_DT length = 8,
             "" as STEP_UP_FACILITY_USED_FLG length = 1,
             "" as CALLABLE_FACILITY_USED_FLG length = 1,
             SENIORITY_CD length = 3,
             GUARANTEE_AMT length = 8,
             . as PROVISIONAL_CREDIT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as PROV_CREDIT_LIMIT_OPEN_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as PROV_CREDIT_LIMIT_CLOSE_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as OPEN_TO_BUY_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             CHARGE_OFF_AMT length = 8,
             CHARGE_OFF_DT length = 8,
             . as RENEWAL_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as TERM length = 8,
             "" as TERM_TIME_UOM_CD length = 3
         from martscr.LA_EXT; 
quit;

%let SYSLAST = work.W5KMUM0M; 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete W5KMUM0W;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: DIRECT_DEBITS_CNT,"
        " CHECKING_MAIN_FLG, INITIAL_LIMIT_AMT, STANDING_ORDERS_CNT,"
        " OVERDRAFT_LIMIT_AMT, OVERDRAFT_LIMIT_DT, ACCOUNT_RENEWAL_TYPE_CD,"
        " ADDITIONAL_CARD_CNT, SECURITY_CD, CHECK_BOOK_FLG,"
        " MIN_ACCOUNT_OPENING_AMT, REQUIRED_MIN_BALANCE_AMT,"
        " ALLOW_OVERDRAFT_FLG, SAFE_DEPOSIT_FLG, CASH_BACK_FLG, CASH_BACK_PCT,"
        " FINANCE_CHARGE_FLG, ACTUAL_ACCOUNT_OPENING_AMT, CASH_LIMIT_AMT,"
        " INTEREST_PAYOUT_FLG, CARD_ISSUE_DT, CARD_EXPIRATION_DT,"
        " CARD_REISSUE_DT, LINKED_ACCOUNT_FLG, LINKED_DEPOSIT_ACCOUNT_FLG,"
        " STEP_UP_FACILITY_USED_FLG, CALLABLE_FACILITY_USED_FLG,"
        " PROVISIONAL_CREDIT_LIMIT_AMT, PROV_CREDIT_LIMIT_OPEN_DT,"
        " PROV_CREDIT_LIMIT_CLOSE_DT, RENEWAL_DT, TERM, TERM_TIME_UOM_CD";
run; 

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.W5KMUM0W as 
      select ACCOUNT_RK length = 8,
             LOAD_END_DTTM length = 8,
             . as DIRECT_DEBITS_CNT length = 8,
             "" as CHECKING_MAIN_FLG length = 1,
             . as INITIAL_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as STANDING_ORDERS_CNT length = 8,
             . as OVERDRAFT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as OVERDRAFT_LIMIT_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             LIEN_INDICATOR_FLG length = 1,
             CLOSING_COST_AMT length = 8,
             REDRAW_FLG length = 1,
             COLLECTIONS_STATUS_CD length = 3,
             APR_TYPE_CD length = 10,
             APR_RT length = 8,
             "" as ACCOUNT_RENEWAL_TYPE_CD length = 3,
             APR_RT_CHANGE_REASON_CD length = 3,
             APPRAISED_VALUE_AMT as COLLATERAL_AMT length = 8,
             HOME_STATUS_CD length = 3,
             SPECIAL_INTEREST_RT length = 8,
             MORTGAGE_TYPE_CD as ACCOUNT_SUB_TYPE_CD length = 3,
             PURPOSE_CD length = 3,
             . as ADDITIONAL_CARD_CNT length = 8,
             COLLATERAL_CD length = 3,
             "" as SECURITY_CD length = 3,
             LIFE_INSURANCE_FLG as MORTGAGE_INSURED_FLG length = 1,
             PAYMENT_PROTECTION_FLG as PAYMENT_INSURED_FLG length = 1,
             DOCUMENTATION_TYPE_CD length = 3,
             "" as CHECK_BOOK_FLG length = 1,
             . as MIN_ACCOUNT_OPENING_AMT length = 8,
             . as REQUIRED_MIN_BALANCE_AMT length = 8,
             "" as ALLOW_OVERDRAFT_FLG length = 1,
             "" as SAFE_DEPOSIT_FLG length = 1,
             MATURITY_CHANGE_REASON_CD as TENURE_CHANGE_REASON_CD length = 3,
             MINIMUM_REDRAW_AMT as MIN_REDRAW_AMT length = 8,
             MINIMUM_PAYMENT_FLG as MIN_PAYMENT_FLG length = 1,
             DISBURSEMENT_TYPE_CD length = 3,
             "" as CASH_BACK_FLG length = 1,
             . as CASH_BACK_PCT length = 8,
             "" as FINANCE_CHARGE_FLG length = 1,
             SPLIT_LOAN_FLG length = 1,
             PORTABILITY_FLG length = 1,
             . as ACTUAL_ACCOUNT_OPENING_AMT length = 8,
             CURRENT_LIMIT_AMT length = 8,
             CURRENT_LIMIT_DT length = 8,
             . as CASH_LIMIT_AMT length = 8,
             APPROVED_ADVANCE_AMT as APPROVED_AMT length = 8,
             ACTUAL_ADVANCE_AMT length = 8,
             DOWN_PAYMENT_AMT as DOWNPAYMENT_AMT length = 8,
             IMPROVEMENTS_ALLOCATION_AMT length = 8,
             "" as INTEREST_PAYOUT_FLG length = 1,
             MATURITY_DT length = 8,
             . as CARD_ISSUE_DT length = 8,
             . as CARD_EXPIRATION_DT length = 8,
             . as CARD_REISSUE_DT length = 8,
             OFFSET_ACCOUNT_FLG length = 1,
             HONEYMOON_FLG as HONEYMOON_PERIOD_FLG length = 1,
             HONEYMOON_START_DT length = 8,
             HONEYMOON_END_DT as HONEYMOON_PERIOD_END_DT length = 8,
             "" as LINKED_ACCOUNT_FLG length = 1,
             "" as LINKED_DEPOSIT_ACCOUNT_FLG length = 1,
             REPAYMENT_HOLIDAY_FLG length = 1,
             REPAYMENT_HOLIDAY_START_DT length = 8,
             REPAYMENT_HOLIDAY_END_DT length = 8,
             PAYMENT_TIME_FREQUENCY_CD as PAYMENT_FREQUENCY_CD length = 3,
             PAYMENT_AMT as REGULAR_PERIODIC_PAYMENT_AMT length = 8,
             MORTGAGE_CYCLE_DAY_NO as PAYMENT_DAY_OF_MONTH length = 8,
             PAYMENT_METHOD_CD as PAYMENT_MODE_CD length = 3,
             SPECIAL_RATE_TYPE_CD length = 3,
             SPECIAL_RATE_START_DT length = 8,
             SPECIAL_RATE_END_DT length = 8,
             "" as STEP_UP_FACILITY_USED_FLG length = 1,
             "" as CALLABLE_FACILITY_USED_FLG length = 1,
             SENIORITY_CD length = 3,
             GUARANTEE_AMT length = 8,
             . as PROVISIONAL_CREDIT_LIMIT_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             . as PROV_CREDIT_LIMIT_OPEN_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as PROV_CREDIT_LIMIT_CLOSE_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             OPEN_TO_BUY_AMT length = 8,
             CHARGE_OFF_AMT length = 8,
             CHARGE_OFF_DT length = 8,
             . as RENEWAL_DT length = 8 format = NLDATE10. informat = NLDATE10.,
             . as TERM length = 8,
             "" as TERM_TIME_UOM_CD length = 3
         from martscr.MA_PRP; 
quit;

%let SYSLAST = work.W5KMUM0W; 

data martscr.APPEND_ACCOUNTS;
   set work.W5KMUM02
       work.W5KMUM0C
       work.W5KMUM0M
       work.W5KMUM0W;
   keep ACCOUNT_RK LOAD_END_DTTM DIRECT_DEBITS_CNT CHECKING_MAIN_FLG 
          INITIAL_LIMIT_AMT STANDING_ORDERS_CNT OVERDRAFT_LIMIT_AMT 
          OVERDRAFT_LIMIT_DT LIEN_INDICATOR_FLG CLOSING_COST_AMT REDRAW_FLG 
          COLLECTIONS_STATUS_CD APR_TYPE_CD APR_RT ACCOUNT_RENEWAL_TYPE_CD 
          APR_RT_CHANGE_REASON_CD COLLATERAL_AMT HOME_STATUS_CD 
          SPECIAL_INTEREST_RT ACCOUNT_SUB_TYPE_CD PURPOSE_CD ADDITIONAL_CARD_CNT 
          COLLATERAL_CD SECURITY_CD MORTGAGE_INSURED_FLG PAYMENT_INSURED_FLG 
          DOCUMENTATION_TYPE_CD CHECK_BOOK_FLG MIN_ACCOUNT_OPENING_AMT 
          REQUIRED_MIN_BALANCE_AMT ALLOW_OVERDRAFT_FLG SAFE_DEPOSIT_FLG 
          TENURE_CHANGE_REASON_CD MIN_REDRAW_AMT MIN_PAYMENT_FLG 
          DISBURSEMENT_TYPE_CD CASH_BACK_FLG CASH_BACK_PCT FINANCE_CHARGE_FLG 
          SPLIT_LOAN_FLG PORTABILITY_FLG ACTUAL_ACCOUNT_OPENING_AMT 
          CURRENT_LIMIT_AMT CURRENT_LIMIT_DT CASH_LIMIT_AMT APPROVED_AMT 
          ACTUAL_ADVANCE_AMT DOWNPAYMENT_AMT IMPROVEMENTS_ALLOCATION_AMT 
          INTEREST_PAYOUT_FLG MATURITY_DT CARD_ISSUE_DT CARD_EXPIRATION_DT 
          CARD_REISSUE_DT OFFSET_ACCOUNT_FLG HONEYMOON_PERIOD_FLG 
          HONEYMOON_START_DT HONEYMOON_PERIOD_END_DT LINKED_ACCOUNT_FLG 
          LINKED_DEPOSIT_ACCOUNT_FLG REPAYMENT_HOLIDAY_FLG 
          REPAYMENT_HOLIDAY_START_DT REPAYMENT_HOLIDAY_END_DT 
          PAYMENT_FREQUENCY_CD REGULAR_PERIODIC_PAYMENT_AMT PAYMENT_DAY_OF_MONTH 
          PAYMENT_MODE_CD SPECIAL_RATE_TYPE_CD SPECIAL_RATE_START_DT 
          SPECIAL_RATE_END_DT STEP_UP_FACILITY_USED_FLG 
          CALLABLE_FACILITY_USED_FLG SENIORITY_CD GUARANTEE_AMT 
          PROVISIONAL_CREDIT_LIMIT_AMT PROV_CREDIT_LIMIT_OPEN_DT 
          PROV_CREDIT_LIMIT_CLOSE_DT OPEN_TO_BUY_AMT CHARGE_OFF_AMT 
          CHARGE_OFF_DT RENEWAL_DT TERM TERM_TIME_UOM_CD; 
run;

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0005EK * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  AppendWorkTableName -                     A52B3KFO.BR00000G * 
 *                 martscr.APPEND_ACCOUNTS                                    * 
 * Target Table:  APPEND_ACCOUNTS - martscr.APPEND_ACCOUNTS A52B3KFO.BH0000S6 * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A52B3KFO.AY0001JX * 
 *                                                                            * 
 * User Written:  Index creation code on ACCOUNT_RK,        A52B3KFO.AF00083S * 
 *                 LOAD_END_DTTM                                              * 
 *                Index creation code on ACCOUNT_RK, LOAD_END_DTTM            * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on ACCOUNT_RK AND LOAD_END_DTTM column */
PROC SQL NOPRINT;
           CREATE INDEX ACCOUNT_RK_LOAD_END_DTTM
            ON martscr.APPEND_ACCOUNTS(ACCOUNT_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

