/****************************************************************************** 
 * Job:           APPL_APPT_SUMMARY_ABT                     A52B3KFO.BP0000D1 * 
 * Description:   This job picks up the data from APPL_APPT_ALL.              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Table:  APPL_APPT_ALL - abtscr.APPL_APPT_ALL      A52B3KFO.BH00017Y * 
 * Target Table:  APPL_APPT_SUMMARY_ABT -                   A52B3KFO.BH00017W * 
 *                 abtagg.APPL_APPT_SUMMARY_ABT                               * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:11:28 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP0000D1);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = APPL_APPT_SUMMARY_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Aggregating the data for the detail table A52B3KFO.BQ0000T1 * 
 * Transform:     Extract                                                     * 
 * Description:   Aggregating the data for the detail table for preparing     * 
 *                 data for the APPL_APPT_SUMMARY table.                      * 
 *                                                                            * 
 * Source Table:  APPL_APPT_ALL - abtscr.APPL_APPT_ALL      A52B3KFO.BH00017Y * 
 * Target Table:  Extract Target -                          A52B3KFO.BR0000GB * 
 *                 abtagg.APPL_APPT_SUMMARY_ABT                               * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for ABT Aggregate Tables  */ 
LIBNAME abtagg BASE "Data/bisdata/abt_agg_table" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(abtscr.APPL_APPT_ALL); 

%let transformID = %quote(A52B3KFO.BQ0000T1); 

%let trans_rc = 0; 

proc datasets lib = abtagg nolist nowarn memtype = (data view);
   delete APPL_APPT_SUMMARY_ABT;
quit;

proc sql; 
   create table abtagg.APPL_APPT_SUMMARY_ABT as 
      select (MAX(INTCK('YEAR',APPLICANT_BIRTH_DT,APPLICATION_DT ))) as APPL_APPT_MAX_AGE_NO length = 8,
             APPLICATION_RK length = 8 label = '_RKorSK',
             (MIN(INTCK('YEAR',APPLICANT_BIRTH_DT,APPLICATION_DT ))) as APPL_APPT_MIN_AGE_NO length = 8,
             (AVG(INTCK('YEAR',APPLICANT_BIRTH_DT,APPLICATION_DT ))) as APPL_APPT_AVG_AGE_NO length = 8,
             (MAX(DEPENDENTS_CNT )) as APPL_APPT_MAX_DPND_CNT length = 8,
             (MIN(DEPENDENTS_CNT )) as APPL_APPT_MIN_DPND_CNT length = 8,
             (MAX (CASE WHEN  CUSTOMER_RK ^= .
             THEN &FLAG_TRUE.
             ELSE  
             &FLAG_FALSE.
             END)) as APPL_APPT_EXI_CUS_FLG length = 1 format = $1. informat = $1.,
             (MAX(INTCK('MONTH',CURRENT_ADDRESS_START_DT,APPLICATION_DT ))) as APPL_APPT_MAX_CURR_ADD_MTH_CNT length = 8,
             (MIN(INTCK('MONTH',CURRENT_ADDRESS_START_DT,APPLICATION_DT ))) as APPL_APPT_MIN_CURR_ADD_MTH_CNT length = 8,
             (MAX(EMPLOYMENT_YEARS_CNT )) as APPL_APPT_MAX_EMP_YR_CNT length = 8,
             (MAX(MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)) as APPL_APPT_MAX_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)) as APPL_APPT_MIN_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (AVG(MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)) as APPL_APPT_AVG_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (SUM(HHOLD_INCOME_AMT )) as APPL_APPT_HHD_INC_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+ 
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+ 
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT)) as APPL_APPT_MAX_EXP_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+ 
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+ 
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT)) as APPL_APPT_MIN_EXP_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (AVG(MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+ 
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+ 
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT)) as APPL_APPT_AVG_EXP_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX((MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)-
                 (MONTHLY_BUSINESS_INCOME_AMT+MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT))) as APPL_APPT_MAX_NET_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN((MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)-
                 (MONTHLY_BUSINESS_INCOME_AMT+MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT))) as APPL_APPT_MIN_NET_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (AVG( (MONTHLY_BUSINESS_INCOME_AMT + MONTHLY_CHILD_ALLOW_AMT+MONTHLY_OTHER_INCOME_AMT+ 
                 MONTHLY_RENTAL_INCOME_AMT+MONTHLY_REPLACEMENT_INCOME_AMT+MONTHLY_SALARY_INCOME_AMT)- 
                  (MONTHLY_BUSINESS_INCOME_AMT+MONTHLY_CHILD_SUPPORT_AMT+MONTHLY_HOUSING_AMT+ 
                  MONTHLY_INVESTMENT_AMT+MONTHLY_OTHER_CHARGE_AMT+ MONTHLY_RENTAL_AMT+ 
                   MONTHLY_REPAYMENT_AMT+MONTHLY_REPAYMENT_OTHERS_AMT))) as APPL_APPT_AVG_NET_INC_MTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(ASSET_OTHER_AMT )) as APPL_APPT_AST_OTH_MAX_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(ASSET_OTHER_AMT )) as APPL_APPT_AST_OTH_MIN_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(TOTAL_ASSET_AMT )) as APPL_APPT_AST_MAX_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(LIABILITY_OTHER_AMT )) as APPL_APPT_MAX_LBL_OTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(LIABILITY_OTHER_AMT )) as APPL_APPT_MIN_LBL_OTH_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(TOTAL_LIABILITY_AMT )) as APPL_APPT_MAX_LBL_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(REAL_ESTATE_AMT )) as APPL_APPT_MAX_REST_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(REAL_ESTATE_AMT )) as APPL_APPT_MIN_REST_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(LIQUID_NET_WORTH_AMT )) as APPL_APPT_NET_WRTH_MAX_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MAX(LIABILITY_REAL_ESTATE_AMT )) as APPL_APPT_LBL_REST_MAX_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5,
             (MIN(LIABILITY_REAL_ESTATE_AMT )) as APPL_APPT_LBL_REST_MIN_AMT length = 8 format = NLNUM18.5 informat = NLNUM18.5
         from &SYSLAST
            where APPLICANT_TYPE_CD IN  (&PRI_APP_TYPE_CD,&JA1_APP_TYPE_CD , &JA2_APP_TYPE_CD)
         group by APPLICATION_RK; 
quit;

%let SYSLAST = abtagg.APPL_APPT_SUMMARY_ABT; 

%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0000T0 * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Extract Target -                          A52B3KFO.BR0000GB * 
 *                 abtagg.APPL_APPT_SUMMARY_ABT                               * 
 * Target Table:  APPL_APPT_SUMMARY_ABT -                   A52B3KFO.BH00017W * 
 *                 abtagg.APPL_APPT_SUMMARY_ABT                               * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

