/****************************************************************************** 
 * Job:           ControlCreditScoringJob                   A52B3KFO.BP0001WS * 
 * Description:                                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Generated on:  Tuesday, June 24, 2008 11:44:46 AM IST                      * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 

/* Parameter default value(s) for ControlCreditScoringJob  */ 
%let job_nm = ;
%let level_no = ;
%let master_level_no = ;
%let status_table = &status_table;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Pre-Process code for the job                             A52B3KFO.AY0005EM * 
 *                                                                            * 
 * User Written:  Predecessor process                       A52B3KFO.AF000U3H * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

data _null_;                            
var_jb=compress("&job_nm",'.sas');                            
logfile="Data/bisdata/log/schedule_credit_scoring/"||var_jb;                 
call symput('job_logname',trim(logfile));                                     
run;                                                                          
filename joblog "&job_logname..log";                                          
%put NOTE: Redirecting log to &job_logname..log;                              
proc printto log=joblog;                                                  
run;                                                                          
%put &job_logname;

/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          User Written Code                         A52B3KFO.BQ0003WU * 
 * Transform:     User Written Code                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Target Table:  User Written Code Target - work.W5AREK3F  A52B3KFO.BR00020X * 
 *                                                                            * 
 * User Written:  CreateTable                               A52B3KFO.AF000LU6 * 
 *============================================================================*/ 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.W5AREK3F); 

/*---- Start of User Written Code  ----*/ 


%put 'level_no=' &level_no;
%put 'master_level_no=' &master_level_no; 

%if &level_no EQ &master_level_no  %then 
%do;

/*%trylock(member=&status_table, timeout=100000);*/
/**/
/*proc sql;*/
/*select count(job_nm) into :job_count  */
/*from control.parameter_list_mod_abt*/
/*where  job_nm = "&job_nm" and level_no = &level_no and */
/*return_cd = .;*/
/*quit;*/
/**/
/*lock  &status_table clear;*/
/**/
/*%if &job_count = 1 %then*/
%include jobs (&job_nm);
%end;


/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Post-Process code for the job                            A52B3KFO.AY0005EL * 
 *                                                                            * 
 * User Written:  Post process                              A52B3KFO.AF000U3I * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

proc printto log=log;                                                     
run;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

