/****************************************************************************** 
 * Job:           FINANCIAL_PRODUCT_PRE_DIM                 A52B3KFO.BP00007Q * 
 * Description:   This job picks up the data from table  FP_APPND_PRD_TYPE_L  * 
 *                  and FP_ALL_LVLS                                           * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: FPT_EXT - martscr.FPT_EXT                 A52B3KFO.BH0000TP * 
 *                APPEND_PRODUCT_TYPE -                     A52B3KFO.BH0000S8 * 
 *                 martscr.APPEND_PRODUCT_TYPE                                * 
 *                FP_APPND_PRD_TYPE_L -                     A52B3KFO.BH0000ZZ * 
 *                 martscr.FP_APPND_PRD_TYPE_L                                * 
 *                FP_ALL_LVLS - martscr.FP_ALL_LVLS         A52B3KFO.BH0000ZY * 
 * Target Table:  FINANCIAL_PRODUCT_PRE_DIM -               A52B3KFO.BH000109 * 
 *                 martscr.FINANCIAL_PRODUCT_PRE_DIM                          * 
 *                                                                            * 
 * Generated on:  Tuesday, June 10, 2008 2:54:07 PM IST                       * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * FINANCIAL_PRODUCT_PRE_DIM                                                  * 
 * Job Name: FINANCIAL_PRODUCT_PRE_DIM.Job DescPre Process: Format for        * 
 * product level code descriptionPRODUCT_CATEGORY_DESC as PR_DESC a           * 
 * character format andPRODUCT_TYPE_DESC as PRT_DES a character               * 
 * format.Main: a) This job picks up the data from table                      * 
 * FP_APPND_PRD_TYPE_L and FP_ALL_LVLS.*Here PRODUCT_CAT_LEVEL_1_CD is        * 
 * mapped to PRODUCT_CATEGORY_CD so join is done on the column                * 
 * PRODUCT_CAT_LEVEL_1_CD.b)Format PR_DESC is used to get all the product     * 
 * category level description from product category level code.c)Format       * 
 * PRT_DESC is used to get the product sub type description from product      * 
 * sub type code.This information is stored in the dataset                    * 
 * FINANCIAL_PRODUCT_PRE_DIM.Post Process: NoneParameters: NoneDeveloped      * 
 *  by: sinharReviewed by: sinrsiTested by:                                   * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00007Q);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = FINANCIAL_PRODUCT_PRE_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Left join on FINANCIAL_PRODUCT for  pre   A52B3KFO.BQ0000HC * 
 *                 dimension table.                                           * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   perform Left Outer join on  FP_APPND_PRD_TYPEandProduct     * 
 *                Category  Code level 5   with  FINANCIAL_PRODUCT  as        * 
 *                 driving table                                              * 
 *                                                                            * 
 * Source Tables: FP_APPND_PRD_TYPE_L -                     A52B3KFO.BH0000ZZ * 
 *                 martscr.FP_APPND_PRD_TYPE_L                                * 
 *                FP_ALL_LVLS - martscr.FP_ALL_LVLS         A52B3KFO.BH0000ZY * 
 * Target Table:  SQL Target - martscr.FP_ALL_LVLS_APPEND   A52B3KFO.BR000090 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0000HC); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FP_ALL_LVLS_APPEND;
quit;

data _null_; 
   put "NOTE: The following column(s) do not have a column mapping, so the"
        " value(s) will be set to missing: PRODUCT_TYPE_DESC,"
        " PRODUCT_SUB_TYPE_DESC";
run; 

proc sql;
   create table martscr.FP_ALL_LVLS_APPEND as
      select
         FP_APPND_PRD_TYPE_L.PRODUCT_RK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "Product Key",
         FP_APPND_PRD_TYPE_L.LOAD_END_DTTM length = 8
                                           format = NLDATM21.
                                           informat = NLDATM21.
                                           label = "Load End Datetime",
         FP_APPND_PRD_TYPE_L.PRODUCT_NM length = 40
                                        label = "Product Name",
         FP_APPND_PRD_TYPE_L.PRODUCT_ID length = 32
                                        label = "Product ID",
         FP_APPND_PRD_TYPE_L.FINANCIAL_PRODUCT_TYPE_CD length = 3
                                                       label = "Financial Product Type Code",
         FP_APPND_PRD_TYPE_L.PRODUCT_LEVEL_NO length = 8
                                              label = "product Relative Level No",
         FP_APPND_PRD_TYPE_L.PRODUCT_CATEGORY_CD length = 3
                                                 label = "Product Category Code",
         FP_APPND_PRD_TYPE_L.EFFECTIVE_DT length = 8
                                          format = NLDATE10.
                                          informat = NLDATE10.
                                          label = "Effective Date",
         FP_APPND_PRD_TYPE_L.EXPIRATION_DT length = 8
                                           format = NLDATE10.
                                           informat = NLDATE10.
                                           label = "Expiration Date",
         "" as PRODUCT_TYPE_DESC length = 100,
         FP_APPND_PRD_TYPE_L.PRODUCT_SUB_TYPE_CD length = 3,
         "" as PRODUCT_SUB_TYPE_DESC length = 100,
         FP_ALL_LVLS.PRODUCT_CLASS_CD length = 3,
         FP_ALL_LVLS.PRODUCT_SUB_CLASS_CD length = 3,
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_1_CD length = 3
                                            label = "Parent Product Category Code",
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_1_DESC length = 100,
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_2_CD length = 3
                                            label = "Parent Product Category Code",
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_2_DESC length = 100,
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_3_CD length = 3
                                            format = $8.
                                            label = "Parent Product Category Code",
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_3_DESC length = 100,
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_4_CD length = 3
                                            label = "Parent Product Category Code",
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_4_DESC length = 100,
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_5_CD length = 3
                                            label = "Parent Product Category Code",
         FP_ALL_LVLS.PRODUCT_CAT_LEVEL_5_DESC length = 100,
         FP_APPND_PRD_TYPE_L.SOURCE_SYSTEM_CD length = 3
                                              label = "Source System Code"
      from
         martscr.FP_APPND_PRD_TYPE_L left join 
         martscr.FP_ALL_LVLS
            on
            (
               FP_APPND_PRD_TYPE_L.PRODUCT_CATEGORY_CD = FP_ALL_LVLS.PRODUCT_CAT_LEVEL_1_CD
               and FP_APPND_PRD_TYPE_L.LOAD_END_DTTM = FP_ALL_LVLS.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify FP_ALL_LVLS_APPEND;
         ic create not null (PRODUCT_CATEGORY_CD);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Lookup                                    A52B3KFO.BQ0000HE * 
 * Transform:     Lookup                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: SQL Target - martscr.FP_ALL_LVLS_APPEND   A52B3KFO.BR000090 * 
 *                FPT_EXT - martscr.FPT_EXT                 A52B3KFO.BH0000TP * 
 *                APPEND_PRODUCT_TYPE -                     A52B3KFO.BH0000S8 * 
 *                 martscr.APPEND_PRODUCT_TYPE                                * 
 * Target Table:  Lookup Target -                           A52B3KFO.BR000092 * 
 *                 martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM                   * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0000HE); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete FINANCIAL_PRODUCT_BEFORE_PRE_DIM;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM
         (keep = PRODUCT_RK LOAD_END_DTTM PRODUCT_NM PRODUCT_ID PRODUCT_LEVEL_NO 
                 FINANCIAL_PRODUCT_TYPE_CD PRODUCT_TYPE_DESC PRODUCT_SUB_TYPE_CD 
                 PRODUCT_SUB_TYPE_DESC EFFECTIVE_DT EXPIRATION_DT 
                 SOURCE_SYSTEM_CD PRODUCT_CLASS_CD PRODUCT_SUB_CLASS_CD 
                 PRODUCT_CAT_LEVEL_1_CD PRODUCT_CAT_LEVEL_1_DESC 
                 PRODUCT_CAT_LEVEL_2_CD PRODUCT_CAT_LEVEL_2_DESC 
                 PRODUCT_CAT_LEVEL_3_CD PRODUCT_CAT_LEVEL_3_DESC 
                 PRODUCT_CAT_LEVEL_4_CD PRODUCT_CAT_LEVEL_4_DESC 
                 PRODUCT_CAT_LEVEL_5_CD PRODUCT_CAT_LEVEL_5_DESC)
      ; 
   
   attrib PRODUCT_RK length=8 format=12. label="Product Key"
          LOAD_END_DTTM length=8 format=NLDATM21. label="Load End Datetime"
          PRODUCT_NM length=$40 label="Product Name"
          PRODUCT_ID length=$32 label="Product ID"
          PRODUCT_LEVEL_NO length=8 label="product Relative Level No"
          FINANCIAL_PRODUCT_TYPE_CD length=$3 label="Financial Product Type Code"
          PRODUCT_TYPE_DESC length=$100
          PRODUCT_SUB_TYPE_CD length=$3
          PRODUCT_SUB_TYPE_DESC length=$100
          EFFECTIVE_DT length=8 format=NLDATE10. label="Effective Date"
          EXPIRATION_DT length=8 format=NLDATE10. label="Expiration Date"
          SOURCE_SYSTEM_CD length=$3 label="Source System Code"
          PRODUCT_CLASS_CD length=$3
          PRODUCT_SUB_CLASS_CD length=$3
          PRODUCT_CAT_LEVEL_1_CD length=$3 label="Parent Product Category Code"
          PRODUCT_CAT_LEVEL_1_DESC length=$100 label="Product Category Description"
          PRODUCT_CAT_LEVEL_2_CD length=$3 label="Parent Product Category Code"
          PRODUCT_CAT_LEVEL_2_DESC length=$100 label="Product Category Description"
          PRODUCT_CAT_LEVEL_3_CD length=$8 label="Parent Product Category Code"
          PRODUCT_CAT_LEVEL_3_DESC length=$100 label="Product Category Description"
          PRODUCT_CAT_LEVEL_4_CD length=$3 label="Parent Product Category Code"
          PRODUCT_CAT_LEVEL_4_DESC length=$100 label="Product Category Description"
          PRODUCT_CAT_LEVEL_5_CD length=$3 label="Parent Product Category Code"
          PRODUCT_CAT_LEVEL_5_DESC length=$100 label="Product Category Description"
          ; 
   
   length FINANCIAL_PRODUCT_TYPE_DESC $100 PRODUCT_TYPE_CD $3 ; 
   
   retain missing0 0 missing1 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.FPT_EXT */ 
      nlobs = .; 
      dsid = open("martscr.FPT_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.FPT_EXT", hashexp: exponent);
            h0.defineKey( "FINANCIAL_PRODUCT_TYPE_CD",
                           "LOAD_END_DTTM");
            h0.defineData( "FINANCIAL_PRODUCT_TYPE_DESC");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.FPT_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.FPT_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.FPT_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.FPT_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: martscr.FPT_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.FPT_EXT";
         
         abort 3; 
      end; 
      
      /* Build hash h1 from lookup table martscr.APPEND_PRODUCT_TYPE */ 
      nlobs = .; 
      dsid = open("martscr.APPEND_PRODUCT_TYPE"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h1(dataset: "martscr.APPEND_PRODUCT_TYPE", hashexp: exponent);
            h1.defineKey( "PRODUCT_TYPE_CD",
                           "LOAD_END_DTTM");
            h1.defineData( "PRODUCT_TYPE_DESC");
            h1.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h1.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.APPEND_PRODUCT_TYPE";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.APPEND_PRODUCT_TYPE";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.APPEND_PRODUCT_TYPE";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.APPEND_PRODUCT_TYPE";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " martscr.APPEND_PRODUCT_TYPE";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.APPEND_PRODUCT_TYPE";
         
         abort 3; 
      end; 
      
      call missing (FINANCIAL_PRODUCT_TYPE_CD, LOAD_END_DTTM, 
                    FINANCIAL_PRODUCT_TYPE_DESC, PRODUCT_TYPE_CD, 
                    PRODUCT_TYPE_DESC); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.FP_ALL_LVLS_APPEND end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   rc0 = h0.find();
   PRODUCT_TYPE_DESC = FINANCIAL_PRODUCT_TYPE_DESC;
   
   /* Is the current key value stored in hash h1?  */ 
   PRODUCT_TYPE_CD = PRODUCT_SUB_TYPE_CD;
   rc1 = h1.find();
   PRODUCT_SUB_TYPE_DESC = PRODUCT_TYPE_DESC;
   
   /* Examine success of lookups  */ 
   if (rc0=0 and rc1=0) then 
   do; 
      /* Write row to target  */ 
      output martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (FINANCIAL_PRODUCT_TYPE_DESC); 
         request_write_target = 1; 
      end; 
      
      if (rc1 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (PRODUCT_TYPE_DESC); 
         request_write_target = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (request_write_target eq 1) then 
         /* Write row to target  */ 
         output martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete mapped;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.mapped as 
      select PRODUCT_RK length = 8,
             LOAD_END_DTTM length = 8,
             PRODUCT_NM length = 40,
             PRODUCT_ID length = 32,
             PRODUCT_LEVEL_NO length = 8,
             FINANCIAL_PRODUCT_TYPE_CD length = 3,
             PRODUCT_TYPE_DESC,
             PRODUCT_SUB_TYPE_CD length = 3,
             PRODUCT_SUB_TYPE_DESC,
             EFFECTIVE_DT length = 8,
             EXPIRATION_DT length = 8,
             SOURCE_SYSTEM_CD length = 3,
             PRODUCT_CLASS_CD length = 3,
             PRODUCT_SUB_CLASS_CD length = 3,
             PRODUCT_CAT_LEVEL_1_CD length = 3,
             PRODUCT_CAT_LEVEL_1_DESC length = 100,
             PRODUCT_CAT_LEVEL_2_CD length = 3,
             PRODUCT_CAT_LEVEL_2_DESC length = 100,
             PRODUCT_CAT_LEVEL_3_CD length = 8,
             PRODUCT_CAT_LEVEL_3_DESC length = 100,
             PRODUCT_CAT_LEVEL_4_CD length = 3,
             PRODUCT_CAT_LEVEL_4_DESC length = 100,
             PRODUCT_CAT_LEVEL_5_CD length = 3,
             PRODUCT_CAT_LEVEL_5_DESC length = 100
         from martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM; 
quit;

%let SYSLAST = work.mapped; 

data martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM; 
   set work.mapped; 
run; 

proc datasets lib=work nolist nowarn memtype = VIEW;
   delete mapped;
quit;

/*============================================================================* 
 * Step:          Code for deduplicate Financial Product    A52B3KFO.BQ0000HF * 
 * Transform:     User Written Code                                           * 
 * Description:   Code for deduplicate Financial Product                      * 
 *                                                                            * 
 * Source Tables: SQL Target - martscr.FP_ALL_LVLS_APPEND   A52B3KFO.BR000090 * 
 *                Lookup Target -                           A52B3KFO.BR000092 * 
 *                 martscr.FINANCIAL_PRODUCT_BEFORE_PRE_DIM                   * 
 * Target Table:  User Written Code Target -                A52B3KFO.BR000091 * 
 *                 martscr.FINANCIAL_PRODUCT_PRE_DIM                          * 
 *                                                                            * 
 * User Written:  Code for deduplicate Financial Product    A52B3KFO.AF000A6M * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0000HF); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.FINANCIAL_PRODUCT_PRE_DIM); 

/*---- Start of User Written Code  ----*/ 

%let sort_col=PRODUCT_RK LOAD_END_DTTM; 

%let etl_str=KTRIM(KLEFT(PRODUCT_RK))||
KTRIM(KLEFT(PRODUCT_NM))||
KTRIM(KLEFT(EFFECTIVE_DT))||
KTRIM(KLEFT(EXPIRATION_DT))||
KTRIM(KLEFT(FINANCIAL_PRODUCT_TYPE_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_1_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_1_DESC))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_2_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_2_DESC))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_3_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_3_DESC))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_4_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_5_CD))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_4_DESC))||
KTRIM(KLEFT(PRODUCT_CAT_LEVEL_5_DESC))||
KTRIM(KLEFT(PRODUCT_SUB_CLASS_CD))||
KTRIM(KLEFT(PRODUCT_CLASS_CD))||
KTRIM(KLEFT(PRODUCT_TYPE_DESC))||
KTRIM(KLEFT(PRODUCT_SUB_TYPE_CD))||
KTRIM(KLEFT(PRODUCT_SUB_TYPE_DESC))||
KTRIM(KLEFT(PRODUCT_LEVEL_NO))||
KTRIM(KLEFT(SOURCE_SYSTEM_CD));

%deduplicate(in_table=&SYSLAST,sort_col=&sort_col,out_table=&_OUTPUT,etls_str_in=&etl_str)
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0000HD * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A52B3KFO.BR000091 * 
 *                 martscr.FINANCIAL_PRODUCT_PRE_DIM                          * 
 * Target Table:  FINANCIAL_PRODUCT_PRE_DIM -               A52B3KFO.BH000109 * 
 *                 martscr.FINANCIAL_PRODUCT_PRE_DIM                          * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A52B3KFO.AY0001SH * 
 *                                                                            * 
 * User Written:  Index creation code on PRODUCT_RK column  A52B3KFO.AF000A6O * 
 *                Index creation code on PRODUCT_RK column                    * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on PRODUCT_RK  column */
PROC SQL NOPRINT;
           CREATE INDEX  PRODUCT_RK_LOAD_END_DTTM
            ON martscr.FINANCIAL_PRODUCT_PRE_DIM(PRODUCT_RK, LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

