/****************************************************************************** 
 * Job:           INQUIRY_FACT_EXT_LST_13_24M               A52B3KFO.BP00021T * 
 * Description:   This job picks up the data from INQUIRY_FACT.               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: INQUIRY_FACT - fact.INQUIRY_FACT          A52B3KFO.BH0000YM * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  INQUIRY_FACT_EXT_LST_13_24M -             A52B3KFO.BH00013C * 
 *                 abtscr.INQUIRY_FACT_EXT_LST_13_24M                         * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 4:22:45 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00021T);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = INQUIRY_FACT_EXT_LST_13_24M;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0004NO * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: INQUIRY_FACT - fact.INQUIRY_FACT          A52B3KFO.BH0000YM * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002C3 * 
 *                 abtscr.INQUIRY_FACT_EXT_LST_13_24M                         * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004NO); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete INQUIRY_FACT_EXT_LST_13_24M;
quit;

proc sql;
   create table abtscr.INQUIRY_FACT_EXT_LST_13_24M as
      select
         INQUIRY_FACT.TRANSACTION_TYPE_SK length = 8
                                          format = 12.
                                          informat = 12.
                                          label = "_RKorSK",
         INQUIRY_FACT.ACCOUNT_SK length = 8
                                 format = 12.
                                 informat = 12.
                                 label = "_RKorSK",
         INQUIRY_FACT.TIME_SK length = 8
                              format = 12.
                              informat = 12.
                              label = "_RKorSK",
         INQUIRY_FACT.CHANNEL_SK length = 8
                                 format = 12.
                                 informat = 12.
                                 label = "Surrogate key for the channel dimension.",
         INQUIRY_FACT.INQUIRY_CNT length = 8,
         INQUIRY_FACT.DISPUTE_AMT length = 8
                                  format = NLNUM18.5
                                  informat = NLNUM18.5
                                  label = "_AMT",
         INQUIRY_FACT.CUSTOMER_SK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "_RKorSK",
         INQUIRY_FACT.INQUIRY_STATUS_SK length = 8
                                        format = 12.
                                        informat = 12.
                                        label = "_RKorSK",
         INQUIRY_FACT.PRODUCT_SK length = 8
                                 format = 12.
                                 informat = 12.
                                 label = "_RKorSK",
         INQUIRY_FACT.RESOLUTION_SK length = 8
                                    format = 12.
                                    informat = 12.
                                    label = "_RKorSK",
         INQUIRY_FACT.INTERNAL_ORG_SK length = 8
                                      format = 12.
                                      informat = 12.
                                      label = "_RKorSK",
         INQUIRY_FACT.SEGMENT_SK length = 8
                                 format = 12.
                                 informat = 12.
                                 label = "_RKorSK",
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                          format = NLDATM21.
                                                          informat = NLDATM21.,
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DATE length = 8
                                                          format = NLDATE10.
                                                          informat = NLDATE10.,
         ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK length = 8
      from
         fact.INQUIRY_FACT, 
         abtscr.ACC_DEF_EVENT_X_ACC_DIM, 
         dim.account_dim
      where
         account_dim.ACCOUNT_RK = ACC_DEF_EVENT_X_ACC_DIM.ACCOUNT_RK
         and INQUIRY_FACT.ACCOUNT_SK = account_dim.ACCOUNT_SK
         and INQUIRY_FACT.TIME_SK > ACC_DEF_EVENT_X_ACC_DIM.BACK_24M_TIME_SK
         and INQUIRY_FACT.TIME_SK <= ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy  Loader                             A52B3KFO.BQ0004NN * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002C3 * 
 *                 abtscr.INQUIRY_FACT_EXT_LST_13_24M                         * 
 * Target Table:  INQUIRY_FACT_EXT_LST_13_24M -             A52B3KFO.BH00013C * 
 *                 abtscr.INQUIRY_FACT_EXT_LST_13_24M                         * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
