/****************************************************************************** 
 * Job:           INTERNAL_ORG_PRE_DIM                      A52B3KFO.BP00007S * 
 * Description:   This job picks up data from IO_ALL_LVLS and IO_EXT and      * 
 *                 builds the INTERNAL_ORG_PRE_DIM table.                     * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: OT_EXT - martscr.OT_EXT                   A52B3KFO.BH0000UJ * 
 *                IO_ALL_LVLS - martscr.IO_ALL_LVLS         A52B3KFO.BH000101 * 
 *                IO_EXT - martscr.IO_EXT                   A52B3KFO.BH0000TZ * 
 * Target Table:  INTERNAL_ORG_PRE_DIM -                    A52B3KFO.BH00010B * 
 *                 martscr.INTERNAL_ORG_PRE_DIM                               * 
 *                                                                            * 
 * Generated on:  Tuesday, June 10, 2008 2:54:08 PM IST                       * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * INTERNAL_ORG_PRE_DIM                                                       * 
 * Job Name: INTERNAL_ORG_PRE_DIMJob DescPre Process:a) User defined formats  * 
 * are needed for this job. A dataset called Work.fmtlist is created which    * 
 * has the table name, column_name and the format-name as observations.b)     * 
 * The Work.fmtlist dataset is passed to the fmtgen macro which creates       * 
 * formats called IO_ID, IO_NM, IO_OD.Main:a) The IO_EXT and IO_ALL_LVLS      * 
 * source tables are joined using left-join.b) User defined formats are       * 
 * applied on the IO_EXT.INTERNAL_ORG_RK, IO_ALL_LVLS.ORG_LEVEL_1_RK,         * 
 * IO_ALL_LVLS.ORG_LEVEL_2_RK, IO_ALL_LVLS.ORG_LEVEL_3_RK,                    * 
 * IO_ALL_LVLS.ORG_LEVEL_4_RK fields.c) The resultant data is loaded into     * 
 * the INTERNAL_ORG_PRE_DIM table.Post Process: A simple index is created     * 
 * on INTERNAL_ORG_RKin the INTERNAL_ORG_PRE_DIM table.Parameters:            * 
 *  NoneDeveloped by: sinprgReviewed by: sinrsiTested by:                     * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00007S);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = INTERNAL_ORG_PRE_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Left Join                                 A52B3KFO.BQ0000HM * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: IO_ALL_LVLS - martscr.IO_ALL_LVLS         A52B3KFO.BH000101 * 
 *                IO_EXT - martscr.IO_EXT                   A52B3KFO.BH0000TZ * 
 * Target Table:  SQL Target - martscr.IO_ALL               A52B3KFO.BR000095 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0000HM); 

%let trans_rc = 0; 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete IO_ALL;
quit;

proc sql;
   create table martscr.IO_ALL as
      select
         IO_EXT.INTERNAL_ORG_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "Internal Organization Retained Key",
         IO_EXT.LOAD_END_DTTM length = 8
                              format = NLDATM21.
                              informat = NLDATM21.
                              label = "Load End Datetime",
         IO_ALL_LVLS.INTERNAL_ORG_ASSOC_TYPE_CD length = 3
                                                label = "Internal Organization Association Type Code",
         IO_EXT.INTERNAL_ORG_ID length = 32
                                label = "Internal Organization",
         IO_EXT.ORGANIZATION_TYPE_CD as INTERNAL_ORG_TYPE_CD length = 3
                                                             label = "Organization Type Code",
         IO_EXT.ORGANIZATION_NM as INTERNAL_ORG_NM length = 40
                                                   format = $100.
                                                   label = "Organization Name",
         IO_EXT.CITY_NM as INTERNAL_ORG_CITY_NM length = 100
                                                label = "City Name",
         IO_EXT.POSTAL_CD as INTERNAL_ORG_POSTAL_CD length = 20
                                                    label = "Postal Code",
         IO_EXT.STATE_REGION_CD as INTERNAL_ORG_STATE_REGION_CD length = 4
                                                                label = "State/Region code",
         IO_EXT.COUNTRY_CD as INTERNAL_ORG_COUNTRY_CD length = 3
                                                      label = "Country Code",
         IO_ALL_LVLS.ORG_LEVEL_1_ID length = 32
                                    format = $32.,
         IO_ALL_LVLS.ORG_LEVEL_1_NM length = 40
                                    format = $40.,
         IO_ALL_LVLS.ORG_LEVEL_2_ID length = 32
                                    format = $32.,
         IO_ALL_LVLS.ORG_LEVEL_2_NM length = 40
                                    format = $40.,
         IO_ALL_LVLS.ORG_LEVEL_3_ID length = 32
                                    format = $32.,
         IO_ALL_LVLS.ORG_LEVEL_3_NM length = 40
                                    format = $40.,
         IO_ALL_LVLS.ORG_LEVEL_4_ID length = 32
                                    format = $32.,
         IO_ALL_LVLS.ORG_LEVEL_4_NM length = 40
                                    format = $40.,
         IO_ALL_LVLS.ORG_LEVEL_5_ID length = 32
                                    format = $32.,
         IO_ALL_LVLS.ORG_LEVEL_5_NM length = 40
                                    format = $40.,
         IO_EXT.SOURCE_SYSTEM_CD length = 3
                                 label = "Source System Code"
      from
         martscr.IO_EXT left join 
         martscr.IO_ALL_LVLS
            on
            (
               IO_ALL_LVLS.INTERNAL_ORG_RK = IO_EXT.INTERNAL_ORG_RK
               and IO_ALL_LVLS.LOAD_END_DTTM = IO_EXT.LOAD_END_DTTM
            )
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=martscr nolist;
      modify IO_ALL;
         ic create not null (INTERNAL_ORG_RK);
         ic create not null (LOAD_END_DTTM);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Lookup                                    A52B3KFO.BQ0000HJ * 
 * Transform:     Lookup                                                      * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: SQL Target - martscr.IO_ALL               A52B3KFO.BR000095 * 
 *                OT_EXT - martscr.OT_EXT                   A52B3KFO.BH0000UJ * 
 * Target Table:  Lookup Target - martscr.IO_BEFORE_PRE_DIM A52B3KFO.BR000096 * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0000HJ); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = martscr nolist nowarn memtype = (data view);
   delete IO_BEFORE_PRE_DIM;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  martscr.IO_BEFORE_PRE_DIM
         (keep = INTERNAL_ORG_RK LOAD_END_DTTM INTERNAL_ORG_ASSOC_TYPE_CD 
                 INTERNAL_ORG_ID INTERNAL_ORG_TYPE_CD INTERNAL_ORG_TYPE_DESC 
                 INTERNAL_ORG_NM INTERNAL_ORG_CITY_NM INTERNAL_ORG_POSTAL_CD 
                 INTERNAL_ORG_STATE_REGION_CD INTERNAL_ORG_COUNTRY_CD 
                 ORG_LEVEL_1_ID ORG_LEVEL_1_NM ORG_LEVEL_2_ID ORG_LEVEL_2_NM 
                 ORG_LEVEL_3_ID ORG_LEVEL_3_NM ORG_LEVEL_4_ID ORG_LEVEL_4_NM 
                 ORG_LEVEL_5_ID ORG_LEVEL_5_NM SOURCE_SYSTEM_CD)
      ; 
   
   attrib INTERNAL_ORG_RK length=8 format=12. label="Internal Organization Retained Key"
          LOAD_END_DTTM length=8 format=NLDATM21. label="Load End Datetime"
          INTERNAL_ORG_ASSOC_TYPE_CD length=$3 label="Internal Organization Association Type Code"
          INTERNAL_ORG_ID length=$32 label="Internal Organization"
          INTERNAL_ORG_TYPE_CD length=$3 label="Organization Type Code"
          INTERNAL_ORG_TYPE_DESC length=$100 format=$100.
          INTERNAL_ORG_NM length=$40 format=$100. label="Organization Name"
          INTERNAL_ORG_CITY_NM length=$100 label="City Name"
          INTERNAL_ORG_POSTAL_CD length=$20 label="Postal Code"
          INTERNAL_ORG_STATE_REGION_CD length=$4 label="State/Region code"
          INTERNAL_ORG_COUNTRY_CD length=$3 label="Country Code"
          ORG_LEVEL_1_ID length=$12 format=$32.
          ORG_LEVEL_1_NM length=$14 format=$100.
          ORG_LEVEL_2_ID length=$12 format=$32.
          ORG_LEVEL_2_NM length=$14 format=$100.
          ORG_LEVEL_3_ID length=$12 format=$32.
          ORG_LEVEL_3_NM length=$14 format=$100.
          ORG_LEVEL_4_ID length=$12 format=$32.
          ORG_LEVEL_4_NM length=$14 format=$100.
          ORG_LEVEL_5_ID length=$12
          ORG_LEVEL_5_NM length=$14
          SOURCE_SYSTEM_CD length=$3 label="Source System Code"
          ; 
   
   length ORGANIZATION_TYPE_DESC $100 ORGANIZATION_TYPE_CD $3 ; 
   
   retain missing0 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table martscr.OT_EXT */ 
      nlobs = .; 
      dsid = open("martscr.OT_EXT"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "martscr.OT_EXT", hashexp: exponent);
            h0.defineKey( "ORGANIZATION_TYPE_CD",
                           "LOAD_END_DTTM");
            h0.defineData( "ORGANIZATION_TYPE_DESC");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: martscr.OT_EXT";
                  put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                       " martscr.OT_EXT";
                  
                  abort 3; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: martscr.OT_EXT";
            put "NOTE: Abort action indicated, condition= Lookup table is empty:"
                 " martscr.OT_EXT";
            
            abort 3; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened: martscr.OT_EXT";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " martscr.OT_EXT";
         
         abort 3; 
      end; 
      
      call missing (ORGANIZATION_TYPE_CD, LOAD_END_DTTM, ORGANIZATION_TYPE_DESC); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set martscr.IO_ALL end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   ORGANIZATION_TYPE_CD = INTERNAL_ORG_TYPE_CD;
   rc0 = h0.find();
   INTERNAL_ORG_TYPE_DESC = ORGANIZATION_TYPE_DESC;
   
   /* Examine success of lookups  */ 
   if (rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output martscr.IO_BEFORE_PRE_DIM; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         /* Check: Lookup value not found-Set target columns to missing  */ 
         call missing (ORGANIZATION_TYPE_DESC); 
         request_write_target = 1; 
      end; 
      
      /* Set target columns to value/missing requested?  */ 
      if (request_write_target eq 1) then 
         /* Write row to target  */ 
         output martscr.IO_BEFORE_PRE_DIM; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*---- Map the columns  ----*/ 
proc datasets lib = work nolist nowarn memtype = (data view);
   delete mapped;
quit;

%put %str(NOTE: Mapping columns ...);
proc sql; 
   create view work.mapped as 
      select INTERNAL_ORG_RK length = 8,
             LOAD_END_DTTM length = 8,
             INTERNAL_ORG_ASSOC_TYPE_CD length = 3,
             INTERNAL_ORG_ID length = 32,
             INTERNAL_ORG_TYPE_CD length = 3,
             INTERNAL_ORG_TYPE_DESC,
             INTERNAL_ORG_NM length = 40,
             INTERNAL_ORG_CITY_NM length = 100,
             INTERNAL_ORG_POSTAL_CD length = 20,
             INTERNAL_ORG_STATE_REGION_CD length = 4,
             INTERNAL_ORG_COUNTRY_CD length = 3,
             ORG_LEVEL_1_ID length = 12,
             ORG_LEVEL_1_NM length = 14 format = $100.,
             ORG_LEVEL_2_ID length = 12,
             ORG_LEVEL_2_NM length = 14 format = $100.,
             ORG_LEVEL_3_ID length = 12,
             ORG_LEVEL_3_NM length = 14 format = $100.,
             ORG_LEVEL_4_ID length = 12,
             ORG_LEVEL_4_NM length = 14 format = $100.,
             ORG_LEVEL_5_ID length = 12,
             ORG_LEVEL_5_NM length = 14,
             SOURCE_SYSTEM_CD length = 3
         from martscr.IO_BEFORE_PRE_DIM; 
quit;

%let SYSLAST = work.mapped; 

data martscr.IO_BEFORE_PRE_DIM; 
   set work.mapped; 
run; 

proc datasets lib=work nolist nowarn memtype = VIEW;
   delete mapped;
quit;

/*============================================================================* 
 * Step:          User Written Code                         A52B3KFO.BQ0000HL * 
 * Transform:     User Written Code                                           * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  Lookup Target - martscr.IO_BEFORE_PRE_DIM A52B3KFO.BR000096 * 
 * Target Table:  User Written Code Target -                A52B3KFO.BR000097 * 
 *                 martscr.INTERNAL_ORG_PRE_DIM                               * 
 *                                                                            * 
 * User Written:  deduplicate internal organizations        A52B3KFO.AF000A6S * 
 *                deduplicate internal organizations before SCD2              * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(martscr.IO_BEFORE_PRE_DIM); 

%let transformID = %quote(A52B3KFO.BQ0000HL); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(martscr.INTERNAL_ORG_PRE_DIM); 

/*---- Start of User Written Code  ----*/ 

%let sort_col=INTERNAL_ORG_RK LOAD_END_DTTM; 
%let etl_str=KTRIM(KLEFT(INTERNAL_ORG_RK))||
KTRIM(KLEFT(INTERNAL_ORG_ID))||
KTRIM(KLEFT(INTERNAL_ORG_TYPE_CD))||
KTRIM(KLEFT(INTERNAL_ORG_TYPE_DESC))||
KTRIM(KLEFT(INTERNAL_ORG_NM))||
KTRIM(KLEFT(INTERNAL_ORG_CITY_NM))||
KTRIM(KLEFT(INTERNAL_ORG_POSTAL_CD))||
KTRIM(KLEFT(INTERNAL_ORG_STATE_REGION_CD))||
KTRIM(KLEFT(INTERNAL_ORG_COUNTRY_CD))||
KTRIM(KLEFT(ORG_LEVEL_1_ID))||
KTRIM(KLEFT(ORG_LEVEL_1_NM))||
KTRIM(KLEFT(ORG_LEVEL_2_ID))||
KTRIM(KLEFT(ORG_LEVEL_2_NM))||
KTRIM(KLEFT(ORG_LEVEL_3_ID))||
KTRIM(KLEFT(ORG_LEVEL_3_NM))||
KTRIM(KLEFT(ORG_LEVEL_4_ID))||
KTRIM(KLEFT(ORG_LEVEL_4_NM))||
KTRIM(KLEFT(ORG_LEVEL_5_ID))||
KTRIM(KLEFT(ORG_LEVEL_5_NM))||
KTRIM(KLEFT(SOURCE_SYSTEM_CD));

%deduplicate(in_table=&SYSLAST,sort_col=&sort_col,out_table=&_OUTPUT,etls_str_in=&etl_str)
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0000HK * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A52B3KFO.BR000097 * 
 *                 martscr.INTERNAL_ORG_PRE_DIM                               * 
 * Target Table:  INTERNAL_ORG_PRE_DIM -                    A52B3KFO.BH00010B * 
 *                 martscr.INTERNAL_ORG_PRE_DIM                               * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/*============================================================================* 
 * Post-Process code for the job                            A52B3KFO.AY0001SL * 
 *                                                                            * 
 * User Written:  Index creation code on INTERNAL_ORG_RK    A52B3KFO.AF000A70 * 
 *                 column                                                     * 
 *                Index creation code on INTERNAL_ORG_RK  column              * 
 *============================================================================*/ 

/*---- Start of User Written Code  ----*/ 

/*creating index on INTERNAL_ORG_RK column */
PROC SQL NOPRINT;
           CREATE INDEX  INT_ORG_RK_LOAD_END_DTTM
            ON martscr.INTERNAL_ORG_PRE_DIM(INTERNAL_ORG_RK,LOAD_END_DTTM);
QUIT;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

