/****************************************************************************** 
 * Job:           OTE_ACC_SNAP_6M_BCK_ABT                   A52B3KFO.BP0002C1 * 
 * Description:   This job picks up data from OTE_ACC_SNAP_EXT_6M_BCK and     * 
 *                 ACCOUNT_DIM.                                               * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: OTE_ACC_SNAP_EXT_6M_BCK -                 A52B3KFO.BH0002QY * 
 *                 abtscr.OTE_ACC_SNAP_EXT_6M_BCK                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  OTE_ACC_SNAP_6M_BCK_ABT -                 A52B3KFO.BH0002R4 * 
 *                 abtscr.OTE_ACC_SNAP_6M_BCK_ABT                             * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:35:16 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP0002C1);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = OTE_ACC_SNAP_6M_BCK_ABT;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk and the required     A52B3KFO.BQ0004SK * 
 *                 variables                                                  * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk and the required variables by joining  * 
 *                 ACCOUNT_DIM and OTE_ACC_SNAP_EXT_6M_BCK on ACCOUNT_SK.     * 
 *                                                                            * 
 * Source Tables: OTE_ACC_SNAP_EXT_6M_BCK -                 A52B3KFO.BH0002QY * 
 *                 abtscr.OTE_ACC_SNAP_EXT_6M_BCK                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002FM * 
 *                 abtscr.OTE_ACC_SNAP_6M_BCK_ABT                             * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004SK); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete OTE_ACC_SNAP_6M_BCK_ABT;
quit;

proc sql;
   create table abtscr.OTE_ACC_SNAP_6M_BCK_ABT as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         OTE_ACC_SNAP_EXT_6M_BCK.TOTAL_BALANCE_AMT as ACC_OUT_BAL_6M_BCK_AMT length = 8
                                                                             format = NLNUM18.5
                                                                             informat = NLNUM18.5,
         OTE_ACC_SNAP_EXT_6M_BCK.AVERAGE_DAILY_BALANCE_AMT as ACC_AVG_DLY_BAL_6M_BCK_AMT length = 8
                                                                                         format = NLNUM18.5
                                                                                         informat = NLNUM18.5
      from
         abtscr.OTE_ACC_SNAP_EXT_6M_BCK, 
         dim.account_dim
      where
         OTE_ACC_SNAP_EXT_6M_BCK.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004SL * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002FM * 
 *                 abtscr.OTE_ACC_SNAP_6M_BCK_ABT                             * 
 * Target Table:  OTE_ACC_SNAP_6M_BCK_ABT -                 A52B3KFO.BH0002R4 * 
 *                 abtscr.OTE_ACC_SNAP_6M_BCK_ABT                             * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

