/****************************************************************************** 
 * Job:           OTE_ACC_TRANS_EXT_LST_12M_LKP             A52B3KFO.BP0002BO * 
 * Description:   This job picks up data from                                 * 
 *                OTE_ACC_TRANS_FACT_EXT_LST_12M,  ACCOUNT_DIM and            * 
 *                 TRANSACTION_TYPE_DIM.                                      * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 *                OTE_ACC_TRANS_FACT_EXT_LST_12M -          A52B3KFO.BH0002PP * 
 *                 abtscr.OTE_ACC_TRANS_FACT_EXT_LST_12M                      * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 *                                                                            * 
 * Generated on:  Thursday, June 12, 2008 10:35:27 AM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP0002BO);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = OTE_ACC_TRANS_EXT_LST_12M_LKP;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          To obtain account_rk                      A52B3KFO.BQ0004RP * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:   To obtain account_rk by joining ACCOUNT_DIM and             * 
 *                 OTE_ACC_TRANS_FACT_EXT_LST_12M on ACCOUNT_SK.              * 
 *                                                                            * 
 * Source Tables: OTE_ACC_TRANS_FACT_EXT_LST_12M -          A52B3KFO.BH0002PP * 
 *                 abtscr.OTE_ACC_TRANS_FACT_EXT_LST_12M                      * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target - work.OTE_TRANS_L12M_TMP      A52B3KFO.BR0002F3 * 
 *============================================================================*/ 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004RP); 

%let trans_rc = 0; 

proc datasets lib = work nolist nowarn memtype = (data view);
   delete OTE_TRANS_L12M_TMP;
quit;

proc sql;
   create table work.OTE_TRANS_L12M_TMP as
      select
         account_dim.PRIMARY_CUSTOMER_RK as CUSTOMER_RK length = 8
                                                        format = 12.
                                                        informat = 12.
                                                        label = "_RKorSK",
         account_dim.ACCOUNT_RK length = 8
                                format = 12.
                                informat = 12.
                                label = "_RKorSK",
         OTE_ACC_TRANS_FACT_EXT_LST_12M.TIME_SK length = 8
                                                format = 12.
                                                informat = 12.
                                                label = "_RKorSK",
         OTE_ACC_TRANS_FACT_EXT_LST_12M.TRANSACTION_TYPE_SK length = 8
                                                            format = 12.
                                                            informat = 12.
                                                            label = "_RKorSK",
         OTE_ACC_TRANS_FACT_EXT_LST_12M.TRANSACTION_AMT length = 8
                                                        format = NLNUM18.5
                                                        informat = NLNUM18.5
                                                        label = "_AMT",
         OTE_ACC_TRANS_FACT_EXT_LST_12M.TRANSACTION_CNT length = 8,
         OTE_ACC_TRANS_FACT_EXT_LST_12M.OTE_CURR_TIME_SK length = 8
      from
         abtscr.OTE_ACC_TRANS_FACT_EXT_LST_12M, 
         dim.account_dim
      where
         OTE_ACC_TRANS_FACT_EXT_LST_12M.ACCOUNT_SK = account_dim.ACCOUNT_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Lookup on TRANSACTION_TYPE_DIM            A52B3KFO.BQ0004RQ * 
 * Transform:     Lookup                                                      * 
 * Description:   Lookup on TRANSACTION_TYPE_DIM to obtain                    * 
 *                 TRANSACTION_TYPE_CD and CREDIT_DEBIT_FLG                   * 
 *                                                                            * 
 * Source Tables: SQL Target - work.OTE_TRANS_L12M_TMP      A52B3KFO.BR0002F3 * 
 *                TRANSACTION_TYPE_DIM -                    A52B3KFO.BH0000WB * 
 *                 dim.TRANSACTION_TYPE_DIM                                   * 
 * Target Table:  Lookup Target -                           A52B3KFO.BR0002F1 * 
 *                 abtscr.OTE_ACC_TRANS_EXT_LST_12M_LKP                       * 
 *============================================================================*/ 

%let transformID = %quote(A52B3KFO.BQ0004RQ); 

%let trans_rc = 0; 

/* make the runTime macro variable to store the run time of the job  */ 
%let runTime = %sysfunc(datetime(), ); 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete OTE_ACC_TRANS_EXT_LST_12M_LKP;
quit;

/*---- Begin DATA step to perform lookups  ----*/ 
DATA  abtscr.OTE_ACC_TRANS_EXT_LST_12M_LKP
         (keep = CUSTOMER_RK ACCOUNT_RK TIME_SK TRANSACTION_TYPE_CD 
                 CREDIT_DEBIT_FLG TRANSACTION_CNT TRANSACTION_AMT 
                 OTE_CURR_TIME_SK)
      ; 
   
   attrib CUSTOMER_RK length=8 format=12. label="_RKorSK"
          ACCOUNT_RK length=8 format=12. label="_RKorSK"
          TIME_SK length=8 format=12. label="_RKorSK"
          TRANSACTION_TYPE_CD length=$3 format=$3. label="_CD"
          CREDIT_DEBIT_FLG length=$1 format=$1. label="Flags"
          TRANSACTION_CNT length=8
          TRANSACTION_AMT length=8 format=NLNUM18.5 label="_AMT"
          OTE_CURR_TIME_SK length=8
          ; 
   
   length TRANSACTION_TYPE_SK 8 ; 
   
   retain missing0 0 ; 
   
   /* Build hash objects from lookup tables before reading first source row  */ 
   if (_n_ = 1) then 
   do; 
      /* Build hash h0 from lookup table dim.TRANSACTION_TYPE_DIM */ 
      nlobs = .; 
      dsid = open("dim.TRANSACTION_TYPE_DIM"); 
      if (dsid > 0) then 
      do; 
         if ( attrc(dsid, 'MTYPE') = 'DATA' ) then 
            nlobs = attrn(dsid, 'NLOBS'); 
         else 
            nlobs = -1; 
            
         dsid = close(dsid); 
         if (nlobs ^= 0) then 
         do; 
            if (nlobs > 0) then 
               exponent = ceil(log2(nlobs)); 
            else 
               exponent = 8; 
            declare hash h0(dataset: "dim.TRANSACTION_TYPE_DIM", hashexp: exponent);
            h0.defineKey( "TRANSACTION_TYPE_SK");
            h0.defineData( "CREDIT_DEBIT_FLG",
                           "TRANSACTION_TYPE_CD");
            h0.defineDone();
            if (nlobs = -1) then 
            do; 
               if (h0.Num_Items < 1) then
               do; 
                  put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
                  missing0 = 98; 
               end; 
            end; 
         end; 
         else 
         do; 
            put "NOTE: Lookup table is empty: dim.TRANSACTION_TYPE_DIM";
            missing0 = 98; 
         end; 
      end; 
      else 
      do; 
         put "NOTE: Lookup table does not exist or cannot be opened:"
              " dim.TRANSACTION_TYPE_DIM";
         
         put "NOTE: Abort action indicated, condition= Lookup table missing:"
              " dim.TRANSACTION_TYPE_DIM";
         
         abort 3; 
      end; 
      
      call missing (TRANSACTION_TYPE_SK, CREDIT_DEBIT_FLG, TRANSACTION_TYPE_CD); 
   
   end; /* All hash objects have been defined */
   
   /* Read a row from the source table  */ 
   set work.OTE_TRANS_L12M_TMP end = eof;
   
   /* Is the current key value stored in hash h0?  */ 
   if (missing0 < 1) then 
   do; 
      rc0 = h0.find();
   end; 
   else 
      rc0 = missing0; 
      
   
   /* Examine success of lookups  */ 
   if (rc0=0 ) then 
   do; 
      /* Write row to target  */ 
      output abtscr.OTE_ACC_TRANS_EXT_LST_12M_LKP; 
      return; 
   end; 
   else 
   do; 
      error_total + 1; 
      
      if (rc0 ^= 0) then 
      do; 
         exception_total + 1; 
         if (rc0 = 98) then 
         do; 
            /* Check: Lookup table has no rows-Write exception row  */ 
            /* Check: Lookup table has no rows-Set target columns to value  */ 
         end; 
         
         else 
         do; 
            /* Check: Lookup value not found-Skip the record  */ 
            return; 
         end; 
      end; 
   
   end; /* One or more lookups failed */
   
   if (eof = 1) then 
   do; 
      put "NOTE: Source records with errors: error_total ; ";
      put "NOTE: Total lookup exceptions: exception_total ; ";
   end; 

run; 

%rcSet(&syserr); 

/*============================================================================* 
 * Step:          Macro OTE_ACC_TRANS_LST_ABT called to     A52B3KFO.BQ0004RO * 
 *                 populate data                                              * 
 * Transform:     User Written Code                                           * 
 * Description:   Macro OTE_ACC_TRANS_LST_ABT called to populate the account  * 
 *                 transaction ABTs.                                          * 
 *                                                                            * 
 * Source Table:  Lookup Target -                           A52B3KFO.BR0002F1 * 
 *                 abtscr.OTE_ACC_TRANS_EXT_LST_12M_LKP                       * 
 * Target Table:  OTE_TRANS_LST_12M - work.                 A52B3KFO.BR0002F2 * 
 *                                                                            * 
 * User Written:  Macro OTE_ACC_TRANS_LST_ABT called to     A52B3KFO.AF000P7I * 
 *                 populate data                                              * 
 *                Macro OTE_ACC_TRANS_LST_ABT called to populate the account  * 
 *                 transaction ABTs.                                          * 
 *============================================================================*/ 

%let SYSLAST = %nrquote(abtscr.OTE_ACC_TRANS_EXT_LST_12M_LKP); 

%let transformID = %quote(A52B3KFO.BQ0004RO); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(work.A52B3KFO_BR0002F2); 

/*---- Start of User Written Code  ----*/ 

/* The input to this macro is the 
1) PERIOD: (1, 3, 6, 12, 24) for which the variables have
to be aggregated.
If PERIOD=1, then aggregation for the current month will be calculated and stored in the
OTE_TRANS_PAYMENTS_CURR_MTH table.

If PERIOD=3, then aggregation for current month and last 3 months will be calculated and stored in,
OTE_TRANS_PAYMENTS_CURR_MTH
OTE_TRANS_DEP_WDR_LST_3M, OTE_TRANS_DR_CR_LST_3M, OTE_TRANS_PAYMENTS_LST_3M,
OTE_TRANS_PUR_CADV_OVL_LST_3M and OTE_TRANS_SUMMARY_LST_3M
tables.

If PERIOD=6, then aggregation for current month and last 3 & 6 months will be calculated and stored in,
OTE_TRANS_PAYMENTS_CURR_MTH
OTE_TRANS_DEP_WDR_LST_3M, OTE_TRANS_DR_CR_LST_3M, OTE_TRANS_PAYMENTS_LST_3M,
OTE_TRANS_PUR_CADV_OVL_LST_3M and OTE_TRANS_SUMMARY_LST_3M
OTE_TRANS_DEP_WDR_LST_6M, OTE_TRANS_DR_CR_LST_6M, OTE_TRANS_PAYMENTS_LST_6M,
OTE_TRANS_PUR_CADV_OVL_LST_6M and OTE_TRANS_SUMMARY_LST_6M
tables.
 
If PERIOD=12, then aggregation for current month and last 3, 6 & 12 months will be calculated and stored in,
OTE_TRANS_PAYMENTS_CURR_MTH
OTE_TRANS_DEP_WDR_LST_3M, OTE_TRANS_DR_CR_LST_3M, OTE_TRANS_PAYMENTS_LST_3M,
OTE_TRANS_PUR_CADV_OVL_LST_3M and OTE_TRANS_SUMMARY_LST_3M
OTE_TRANS_DEP_WDR_LST_6M, OTE_TRANS_DR_CR_LST_6M, OTE_TRANS_PAYMENTS_LST_6M,
OTE_TRANS_PUR_CADV_OVL_LST_6M and OTE_TRANS_SUMMARY_LST_6M,
OTE_TRANS_PAYMENTS_LST_12M
tables.
 
2) TABLE: The input table which is already filtered for the PERIOD (1, 3, 6, 12). 

Output:
 For current month: OTE_TRANS_PAYMENTS_CURR_MTH
 For last 3 month:  OTE_TRANS_DEP_WDR_LST_3M,
        OTE_TRANS_DR_CR_LST_3M,
        OTE_TRANS_PAYMENTS_LST_3M,
        OTE_TRANS_PUR_CADV_OVL_LST_3M and
        OTE_TRANS_SUMMARY_LST_3M
 For last 6 month:  OTE_TRANS_DEP_WDR_LST_6M,
        OTE_TRANS_DR_CR_LST_6M,
        OTE_TRANS_PAYMENTS_LST_6M,
        OTE_TRANS_PUR_CADV_OVL_LST_6M and
        OTE_TRANS_SUMMARY_LST_6M
 For last 12 month: OTE_TRANS_PAYMENTS_LST_12M
*/

%ote_acc_trans_lst_abt(PERIOD=12, INPUT_TABLE=OTE_ACC_TRANS_EXT_LST_12M_LKP);

proc sql;
 create index ACCOUNT_RK on abtscr.OTE_TRANS_PAYMENTS_CURR_MTH(ACCOUNT_RK);

 create index ACCOUNT_RK on abtscr.OTE_TRANS_DEP_WDR_LST_3M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_DR_CR_LST_3M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_PAYMENTS_LST_3M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_PUR_CADV_OVL_LST_3M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_SUMMARY_LST_3M(ACCOUNT_RK);

 create index ACCOUNT_RK on abtscr.OTE_TRANS_DEP_WDR_LST_6M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_DR_CR_LST_6M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_PAYMENTS_LST_6M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_PUR_CADV_OVL_LST_6M(ACCOUNT_RK);
 create index ACCOUNT_RK on abtscr.OTE_TRANS_SUMMARY_LST_6M(ACCOUNT_RK);

 create index ACCOUNT_RK on abtscr.OTE_TRANS_PAYMENTS_LST_12M(ACCOUNT_RK);

quit;
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

