/****************************************************************************** 
 * Job:           RECOVERY_FACT_EXT_LST_12M                 A52B3KFO.BP00021G * 
 * Description:   This job picks up the data from RECOVERY_FACT.              * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Tables: RECOVERY_FACT - fact.RECOVERY_FACT        A52B3KFO.BH0000YS * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  RECOVERY_FACT_EXT_LST_12M -               A52B3KFO.BH000135 * 
 *                 abtscr.RECOVERY_FACT_EXT_LST_12M                           * 
 *                                                                            * 
 * Generated on:  Wednesday, June 11, 2008 4:21:54 PM IST                     * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP00021G);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = RECOVERY_FACT_EXT_LST_12M;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          SQL Join                                  A52B3KFO.BQ0004MS * 
 * Transform:     SQL Join (Version 2)                                        * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Tables: RECOVERY_FACT - fact.RECOVERY_FACT        A52B3KFO.BH0000YS * 
 *                ACC_DEF_EVENT_X_ACC_DIM -                 A52B3KFO.BH00010U * 
 *                 abtscr.ACC_DEF_EVENT_X_ACC_DIM                             * 
 *                ACCOUNT_DIM - dim.account_dim             A52B3KFO.BH0000VE * 
 * Target Table:  SQL Target -                              A52B3KFO.BR0002BE * 
 *                 abtscr.RECOVERY_FACT_EXT_LST_12M                           * 
 *============================================================================*/ 

/* Access the data for Facts  */ 
LIBNAME fact BASE "Data/bisdata/fact" ;
%rcSet(&syslibrc); 

/* Access the data for Scratch for ABT  */ 
LIBNAME abtscr BASE "Data/bisdata/scratch/abt" ;
%rcSet(&syslibrc); 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ0004MS); 

%let trans_rc = 0; 

proc datasets lib = abtscr nolist nowarn memtype = (data view);
   delete RECOVERY_FACT_EXT_LST_12M;
quit;

proc sql;
   create table abtscr.RECOVERY_FACT_EXT_LST_12M as
      select
         RECOVERY_FACT.ACCOUNT_SK length = 8
                                  format = 12.
                                  informat = 12.
                                  label = "_RKorSK",
         RECOVERY_FACT.TIME_SK length = 8
                               format = 12.
                               informat = 12.
                               label = "_RKorSK",
         RECOVERY_FACT.RECOVERY_COST_AMT length = 8
                                         format = NLNUM18.5
                                         informat = NLNUM18.5
                                         label = "_AMT",
         RECOVERY_FACT.VALUE_REALIZED_AMT length = 8
                                          format = NLNUM18.5
                                          informat = NLNUM18.5
                                          label = "_AMT",
         RECOVERY_FACT.RECOVERY_FROM_TYPE_SK length = 8
                                             format = 12.
                                             informat = 12.
                                             label = "_RKorSK",
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DTTM length = 8
                                                          format = NLDATM21.
                                                          informat = NLDATM21.,
         ACC_DEF_EVENT_X_ACC_DIM.LOAD_ABT_USER_INPUT_DATE length = 8
                                                          format = NLDATE10.
                                                          informat = NLDATE10.,
         ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK length = 8,
         ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK length = 8
      from
         fact.RECOVERY_FACT, 
         abtscr.ACC_DEF_EVENT_X_ACC_DIM, 
         dim.account_dim
      where
         account_dim.ACCOUNT_RK = ACC_DEF_EVENT_X_ACC_DIM.ACCOUNT_RK
         and RECOVERY_FACT.ACCOUNT_SK = account_dim.ACCOUNT_SK
         and RECOVERY_FACT.TIME_SK > ACC_DEF_EVENT_X_ACC_DIM.BACK_12M_TIME_SK
         and RECOVERY_FACT.TIME_SK <= ACC_DEF_EVENT_X_ACC_DIM.CURR_TIME_SK
      ;
quit;

%rcSet(&sqlrc); 

%macro etls_completeTarget();
   /*---- Create the integrity constraints for a table  ----*/ 
   %put %str(NOTE: Creating integrity constraints ...);
   proc datasets library=abtscr nolist;
      modify RECOVERY_FACT_EXT_LST_12M;
         ic create not null (ACCOUNT_SK);
         ic create not null (TIME_SK);
   quit;
   
   %rcSet(&syserr); 
   
%mend etls_completeTarget;
%etls_completeTarget;

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ0004MR * 
 * Transform:     Table Loader (Version 2)                                    * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  SQL Target -                              A52B3KFO.BR0002BE * 
 *                 abtscr.RECOVERY_FACT_EXT_LST_12M                           * 
 * Target Table:  RECOVERY_FACT_EXT_LST_12M -               A52B3KFO.BH000135 * 
 *                 abtscr.RECOVERY_FACT_EXT_LST_12M                           * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

