/****************************************************************************** 
 * Job:           SEGMENT_DIM                               A52B3KFO.BP000048 * 
 * Description:   This job builds the SEGMENT_DIM dimension from              * 
 *                 SEGMENT_PRE_DIM                                            * 
 *                                                                            * 
 * Repository:    Foundation                                A0000001.A52B3KFO * 
 * Server:        SASMain                                   A52B3KFO.AT000001 * 
 *                                                                            * 
 * Source Table:  SEGMENT_PRE_DIM - martscr.SEGMENT_PRE_DIM A52B3KFO.BH00010F * 
 * Target Tables: SEGMENT_PRE_DIM - martscr.SEGMENT_PRE_DIM A52B3KFO.BH00010F * 
 *                SEGMENT_DIM - dim.SEGMENT_DIM             A52B3KFO.BH0000W6 * 
 *                                                                            * 
 * Generated on:  Tuesday, June 10, 2008 2:55:13 PM IST                       * 
 * Generated by:  sasadm                                                      * 
 * Version:       9.1.20060626.51875                                          * 
 ******************************************************************************
 * Notes:                                                                     * 
 * SEGMENT_DIM                                                                * 
 * Job Name:SEGMENT_DIMJob Desc Please check that the segment id is same      * 
 * across scheme id.For exampleSCHEME_ID SEGMENT_IDPROFILE Segment1PROFILE    * 
 * Segment2PROFILE Segment3BEHAVIOR Segment1BEHAVIOR Segment2BEHAVIOR         * 
 * Segment3Pre Process: NoneMain:a) This job builds theSEGMENT_DIM            * 
 * dimension from SEGMENT_PRE_DIM.b) Code to insert a dummy row in            * 
 * dimension having SK=0 and for creating index. The dummy row's SK is used   * 
 * while populating fact tables.. The CREATED_BY variable has a value         * 
 * "system generated". This row will be created only during job's initial     * 
 * run, and should not be deleted.c) The business key is Segment_Rk.d) In     * 
 * the SCD 2 LOADER , we are detecting changes in all variables except        * 
 * created_by and created_dttm.e)LOAD_END_DTTM is used to set a value for     * 
 * column VALID_START_DTTM.eg. if LOAD_END_DTTM = '31aug2006:00:00:00'dt      * 
 * then VALID_START_DTTM ='01aug2006:00:00:00'dtf) Column VALID_END_DTTM is   * 
 * set according to value in parameter VALID_HIGH_DTTM which is the           * 
 * exceptionally high datetime value. eg. if                                  * 
 * VALID_HIGH_DTTM='31dec4747:23:59:59'dt then VALID_END_DTTM=                * 
 * '31dec4747:23:59:59'dt.g) Column CREATED_DTTM is set to the value of the   * 
 * macro variable ETLS_LOADTIME. This variable has a value of "sysdate"       * 
 * appended with "systime".h) PROCESSED_DTTM is automatically set to the      * 
 * value of ETLS_LOADTIME.Post Process: NoneParameters:a)VALID_HIGH_DTTM -    * 
 * User defined parameter having date time '31dec4747:23:59:59' which is      * 
 * the exceptionally high datetime value.b)SYSUSERID - Contains the userid    * 
 * or login of the current SAS process.Developed by: singupReviewed           * 
 *  by:Tested by:                                                             * 
 ******************************************************************************/ 



%let jobID = %quote(A52B3KFO.BP000048);

/* Setup for capturing job status  */ 
data _null_; 
   call symput('etls_startTime',put(datetime(),datetime.));
run;

%let etls_jobName = SEGMENT_DIM;
%let etls_recordsBefore = 0;
%let etls_recordsAfter = 0;
%let etls_lib = 0;
%let etls_table = 0;

/* Setup to capture return codes  */ 
%global job_rc trans_rc sqlrc; 
%let job_rc = 0;
%let trans_rc = 0;
%let sqlrc = 0;
%global syserr; 

%macro rcSet(error); 
   %if (&error gt &trans_rc) %then 
      %let trans_rc = &error;
   %if (&error gt &job_rc) %then 
      %let job_rc = &error;
%mend rcSet; 

%macro rcSetDS(error); 
   if &error gt input(symget('trans_rc'),12.) then 
      call symput('trans_rc',trim(left(put(&error,12.))));
   if &error gt input(symget('job_rc'),12.) then 
      call symput('job_rc',trim(left(put(&error,12.))));
%mend rcSetDS; 

%global etls_debug; 
%macro etls_setDebug; 
   %if %str(&etls_debug) ne 0 %then 
      OPTIONS MPRINT%str(;); 
%mend; 
%etls_setDebug; 

/*============================================================================* 
 * Step:          Code to insert a required row in          A52B3KFO.BQ00009C * 
 *                 dimension having SK=0                                      * 
 * Transform:     User Written Code                                           * 
 * Description:   Code to insert a required row in dimension having SK=0 and  * 
 *                for creating index. This row's SK is used while             * 
 *                populating fact tables in case a corresponding record is    * 
 *                 not available in the dimension.                            * 
 *                                                                            * 
 * Target Table:  User Written Code Target -                A52B3KFO.BR00004M * 
 *                 dim.SEGMENT_DIM                                            * 
 *                                                                            * 
 * User Written:  Code to insert a required row in          A52B3KFO.AF0009DK * 
 *                 dimension having SK=0                                      * 
 *                Code to insert a required row in dimension having SK=0 and  * 
 *                 for creating index                                         * 
 *============================================================================*/ 

/* Access the data for Dimensions  */ 
LIBNAME dim BASE "Data/bisdata/dim" ;
%rcSet(&syslibrc); 

%let transformID = %quote(A52B3KFO.BQ00009C); 

%let trans_rc = 0; 

%let _OUTPUT = %nrquote(dim.SEGMENT_DIM); 

/*---- Start of User Written Code  ----*/ 

/* Code to generate a row with SK having value DUMMY_SK */
%let file_name = %str(segment_dim.sas);
%let dataset_name = %str(dim.segment_dim);
%insert_required_record(file_nm=&file_name, dataset_nm=&dataset_name);
/*---- End of User Written Code  ----*/ 

%rcSet(&syserr); 
%rcSet(&sqlrc); 

/*============================================================================* 
 * Step:          Dummy Loader                              A52B3KFO.BQ00009D * 
 * Transform:     Table Loader                                                * 
 * Description:                                                               * 
 *                                                                            * 
 * Source Table:  User Written Code Target -                A52B3KFO.BR00004M * 
 *                 dim.SEGMENT_DIM                                            * 
 * Target Table:  SEGMENT_PRE_DIM - martscr.SEGMENT_PRE_DIM A52B3KFO.BH00010F * 
 *============================================================================*
 *                                                                            * 
 * Nothing will be generated for this process because the "Do not generate    * 
 *  code for this process" option is selected.                                * 
 *                                                                            * 
 *============================================================================*/ 

/*============================================================================* 
 * Step:          SCD Type 2 Loader with business key as    A52B3KFO.BQ00009E * 
 *                 SEGMENT_RK                                                 * 
 * Transform:     SCD Type 2 Loader                                           * 
 * Description:   SCD Type 2 Loader with business key as SEGMENT_RK           * 
 *                ,detecting changes in all variables except created_by and   * 
 *                 created_dttm.                                              * 
 *                                                                            * 
 * Source Table:  SEGMENT_PRE_DIM - martscr.SEGMENT_PRE_DIM A52B3KFO.BH00010F * 
 * Target Table:  SEGMENT_DIM - dim.SEGMENT_DIM             A52B3KFO.BH0000W6 * 
 *============================================================================*/ 

/* Access the data for Scratch for Mart  */ 
LIBNAME martscr BASE "Data/bisdata/scratch/mart" ;
%rcSet(&syslibrc); 

%let SYSLAST = %nrquote(martscr.SEGMENT_PRE_DIM); 

%let transformID = %quote(A52B3KFO.BQ00009E); 

%let trans_rc = 0; 

%macro etls_scdloader;

   /*---- Create miscellaneous loader macros   ----*/ 
   %global etls_tableExist;
   %global etls_numIndex;
   %global etls_lastTable;
   %global etls_loadtime;
   %global etls_debug;
   %let etls_tableExist = -1;
   %let etls_numIndex = -1;
   %let etls_lastTable = &SYSLAST;
   
   /*---- If the macro etls_debug is missing, then set it to the default  ----*/ 
   /*----  value of zero.                                                 ----*/ 
   %if &etls_debug eq %str() %then
      %let etls_debug = 0;
      
   /*---- Set the Load Time column  ----*/ 
   %let etls_loadtime = &sysdate9:&systime;
   %put %str(NOTE: The load time for PROCESSED_DTTM is &etls_loadtime );
   
   /* Determine if the target table exists  */ 
   %let etls_tableExist = %eval(%sysfunc(exist(dim.SEGMENT_DIM, DATA)) or 
         %sysfunc(exist(dim.SEGMENT_DIM, VIEW))); 
   
   /*---- Create a new table  ----*/ 
   %if (&etls_tableExist eq 0) %then 
   %do;  /* if table does not exist  */ 
   
      %put %str(NOTE: Creating table ...);
      
      data dim.SEGMENT_DIM
              (label = 'SEGMENT_DIM');
         attrib SEGMENT_SK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib SEGMENT_RK length = 8 format = 12. informat = 12.
                   label = '_RKorSK'; 
         attrib SEGMENT_ID length = $32 format = $32. informat = $32.
                   label = '_Id'; 
         attrib SEGMENT_LONG_NM length = $100 format = $100. informat = $100.; 
         attrib SEGMENT_TYPE_CD length = $3 format = $3. informat = $3.
                   label = '_CD'; 
         attrib SEGMENT_TYPE_DESC length = $100 format = $100. informat = $100.; 
         attrib SEGMENT_STATUS_CD length = $3 format = $3. informat = $3.
                   label = '_CD'; 
         attrib SEGMENT_STATUS_DESC length = $100 format = $100. informat = $100.; 
         attrib SCHEME_ID length = $32 format = $32. informat = $32.
                   label = '_Id'; 
         attrib SCHEME_NM length = $100 format = $100. informat = $100.; 
         attrib CREATED_BY length = $20 format = $20. informat = $20.; 
         attrib CREATED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib VALID_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib VALID_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         attrib PROCESSED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
                   label = '_DTTM'; 
         stop;
      run;
      
      %rcSet(&syserr); 
      
   %end;  /* if table does not exist  */ 
   
   /*---- Temporary cross-reference table being used  ----*/ 
   /* Remove any existing temporary cross reference file  */ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete etls_sortedxref;
   quit;
   
   /* Sort target table  */ 
   proc sort data = dim.SEGMENT_DIM   
      out = work.etls_sortedxref;
      by SEGMENT_RK VALID_END_DTTM;
   run;
   
   %rcSet(&syserr); 
   
   /* Get the last key variable in each set of keys  */ 
   data work.etls_sortedxref; 
      set work.etls_sortedxref;
      by SEGMENT_RK;
      if last.SEGMENT_RK;
         output;
   run;
   
   %rcSet(&syserr); 
   
   /* Generate the MD5 value and append it to the dataset  */ 
   data work.etls_sortedxref(drop=etls_str etls_md5);
      set work.etls_sortedxref;
      length etls_md5 $16.;
      length DIGEST_VALUE $32.;
      etls_str = '"' ||TRIM(LEFT(SEGMENT_TYPE_CD)) 
            || TRIM(LEFT(SEGMENT_TYPE_DESC)) || TRIM(LEFT(SEGMENT_LONG_NM)) 
            || TRIM(LEFT(SEGMENT_STATUS_CD)) || TRIM(LEFT(SEGMENT_STATUS_DESC)) 
            || TRIM(LEFT(SEGMENT_ID)) || TRIM(LEFT(SCHEME_ID)) 
            || TRIM(LEFT(SCHEME_NM)) || '"';
      etls_md5 = MD5(etls_str);
      DIGEST_VALUE=put(etls_md5, hex32.);
   run;
   
   %rcSet(&syserr); 
   
   /* Sort the temporary cross reference table by primary key  */ 
   proc sort data= work.etls_sortedxref
      (KEEP = SEGMENT_SK SEGMENT_RK
       VALID_START_DTTM
      VALID_END_DTTM DIGEST_VALUE) nodupkey;
      by SEGMENT_RK VALID_START_DTTM;
   run; 
   
   %rcSet(&syserr); 
   
   /*---- Map the columns  ----*/ 
   proc datasets lib = work nolist nowarn memtype = (data view);
      delete mapped;
   quit;
   
   data _null_; 
      put "NOTE: The following column(s) do not have a column mapping, so the"
           " value(s) will be set to missing: SEGMENT_SK, VALID_END_DTTM,"
           " PROCESSED_DTTM";
   run; 
   
   %put %str(NOTE: Mapping columns ...);
   proc sql; 
      create view work.mapped as 
         select . as SEGMENT_SK length = 8 format = 12. informat = 12.,
                SEGMENT_RK length = 8,
                SEGMENT_ID length = 32 format = $32. informat = $32.,
                SEGMENT_LONG_NM length = 100 format = $100. informat = $100.,
                SEGMENT_TYPE_CD length = 3 format = $3. informat = $3.,
                SEGMENT_TYPE_DESC length = 100 format = $100. informat = $100.,
                SEGMENT_STATUS_CD length = 3 format = $3. informat = $3.,
                SEGMENT_STATUS_DESC length = 100 format = $100. informat = $100.,
                SCHEME_ID length = 32 format = $32. informat = $32.,
                SCHEME_NM length = 100 format = $100. informat = $100.,
                (STRIP("&SYSUSERID")) as CREATED_BY length = 20 format = $20. informat = $20.,
                ("&ETLS_LOADTIME"DT) as CREATED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                (INTNX('DTMONTH',LOAD_END_DTTM,0,'BEGINNING')) as VALID_START_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                . as VALID_END_DTTM length = 8 format = NLDATM21. informat = NLDATM21.,
                . as PROCESSED_DTTM length = 8 format = NLDATM21. informat = NLDATM21.
            from martscr.SEGMENT_PRE_DIM; 
   quit;
   
   %let SYSLAST = work.mapped; 
   
   %rcSet(&sqlrc); 
   
   /* Generate the MD5 value and append it to the dataset  */ 
   data work.etls_source(drop=etls_str etls_md5);
      set &syslast;
      length etls_md5 $16.;
      length DIGEST_VALUE $32.;
      etls_str = '"' ||TRIM(LEFT(SEGMENT_TYPE_CD)) 
            || TRIM(LEFT(SEGMENT_TYPE_DESC)) || TRIM(LEFT(SEGMENT_LONG_NM)) 
            || TRIM(LEFT(SEGMENT_STATUS_CD)) || TRIM(LEFT(SEGMENT_STATUS_DESC)) 
            || TRIM(LEFT(SEGMENT_ID)) || TRIM(LEFT(SCHEME_ID)) 
            || TRIM(LEFT(SCHEME_NM)) || '"';
      etls_md5 = MD5(etls_str);
      DIGEST_VALUE=put(etls_md5, hex32.);
   run;
   
   %rcSet(&syserr); 
   
   /* Generate the default from date expression  */ 
   %let etls_begdate = VALID_START_DTTM;
   /* Generate the default to date expression  */ 
   %let etls_enddate = &VALID_HIGH_DTTM;
   
   /* Sort the source table by business key and beginning/from date columns.  */ 
   proc sort data=work.etls_source;
      by SEGMENT_RK VALID_START_DTTM;
   run;
   
   %rcSet(&syserr); 
   
   /*---- Set beginning dates and close out any history records   ----*/ 
   data work.etls_source (drop = etls_sameday etls_cnt etls_closedate);
   
      set work.etls_source;
      by SEGMENT_RK;
      
      /* Set beginning dates if null  */ 
      if VALID_START_DTTM eq . then
         VALID_START_DTTM = &etls_begdate;
         
      if first.SEGMENT_RK then
         etls_cnt = 0;
      else
         etls_cnt + 1;
         
      /* Close out any history records if they exist  */ 
      if not last.SEGMENT_RK then
      do;
      
         obsnum = _n_ + 1;
         set work.etls_source(keep = VALID_START_DTTM
                  rename = (VALID_START_DTTM = etls_closedate))
                  point = obsnum;
                  
         if etls_closedate eq . then
            etls_closedate = &etls_begdate;
            
         if VALID_START_DTTM eq etls_closedate then
            etls_closedate = etls_closedate + (etls_cnt + 1);
            
         if VALID_END_DTTM eq . then
            VALID_END_DTTM = etls_closedate - 1;
            
      end;
      
      /* Fix the beginning dates if needed  */ 
      etls_sameday = lag1(VALID_START_DTTM);
      if not first.SEGMENT_RK and etls_sameday eq VALID_START_DTTM then
         VALID_START_DTTM = VALID_START_DTTM + etls_cnt;
         
   run;
   
   %rcSet(&syserr); 
   
   /*---- Generate the maximum generated key  ----*/ 
   /* Calculate the max generated key value and hold the value in the macro  */ 
   /*  variable &etls_maxkey                                                 */ 
   %let etls_maxkey = -1;
   
   proc sql noprint;
      select compress(put(max(SEGMENT_SK), best32.))
         into :etls_maxkey from dim.SEGMENT_DIM;
   quit;
   
   /* If "etls_maxkey" does not have a value, then set it to zero.  */ 
   %if (&etls_maxkey eq .)
      %then %let etls_maxkey = 0;
      
   /*---- Slowly Changing Dimension Type 2 Beginning/End Date Method  ----*/ 
   /* Data merge the cross-reference and source tables  */ 
   data work.etls_newrcds
          (drop = ETLS_STGDIGEST DIGEST_VALUE NewMaxKey ETLS_KEY ETLS_FROMDATE 
                     ETLS_CLSDATE ETLS_TODATE ETLS_LOADTIME)
      work.etls_match
          (drop = ETLS_STGDIGEST DIGEST_VALUE NewMaxKey ETLS_KEY ETLS_FROMDATE 
                     ETLS_CLSDATE ETLS_TODATE ETLS_LOADTIME)
      work.etls_close
          (keep = ETLS_KEY ETLS_CLSDATE ETLS_LOADTIME);
         
      retain NewMaxKey &etls_maxkey;
      
      merge work.etls_source(in=inSort rename=(DIGEST_VALUE = ETLS_STGDIGEST))
         work.etls_sortedxref (in=inXref rename=(
         SEGMENT_SK = ETLS_KEY
               VALID_START_DTTM = ETLS_FROMDATE
               VALID_END_DTTM = ETLS_TODATE));
      by SEGMENT_RK;
      
      attrib ETLS_CLSDATE length=8 format = NLDATM21. informat = NLDATM21.;
      attrib ETLS_LOADTIME length=8 format = NLDATM21. informat = NLDATM21.;
      
      /* Process changes made to existing records  */ 
      if inSort and inXref then
      do;
      
         if ETLS_STGDIGEST NE DIGEST_VALUE then
         do;
         
            if VALID_START_DTTM eq . then
               VALID_START_DTTM = &etls_begdate;
               
            /* Ignore history records, only accept changes where the cross reference  */ 
            /*  beginning date is less than the source beginning date                 */ 
            if ETLS_FROMDATE < VALID_START_DTTM then
            do;
            
               if VALID_END_DTTM eq . then
                  VALID_END_DTTM = &etls_enddate;
                  
               /* Save off the close date  */ 
               ETLS_CLSDATE = VALID_START_DTTM - 1;
               
               PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
               ETLS_LOADTIME = input("&etls_loadtime", NLDATM21.);
               
               output work.etls_close;
               
               NewMaxKey = sum(NewMaxKey, 1);
               SEGMENT_SK = NewMaxKey;
               
               /* Update the cross-reference varaibles to the new current values  */ 
               DIGEST_VALUE = ETLS_STGDIGEST;
               ETLS_FROMDATE = VALID_START_DTTM;
               ETLS_TODATE = VALID_END_DTTM;
               
               output work.etls_match;
               
            end;
            
         end;
         
         else do;
         
            if VALID_END_DTTM ne . then
            do;
            
               /* If the cross-reference end date is greater then the source end date then  */ 
               /*  close out the target record with the source end date                     */ 
               if last.SEGMENT_RK then
                  if ETLS_TODATE gt VALID_END_DTTM then
                  do;
                  
                     ETLS_CLSDATE = VALID_END_DTTM;
                     ETLS_LOADTIME = input("&etls_loadtime", NLDATM21.);
                     
                     output work.etls_close;
                     
                  end;
                  
            end;
            
            else do;
            
               /* if the source beginning date is greater then both the cross-reference  */ 
               /*  beginning and end date, then reactivate the closed out record         */ 
               if VALID_START_DTTM gt ETLS_FROMDATE and
                  VALID_START_DTTM gt ETLS_TODATE then
               do;
               
                  VALID_END_DTTM = &etls_enddate;
                  
                  PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
                  NewMaxKey = sum(NewMaxKey, 1);
                  SEGMENT_SK = NewMaxKey;
                  
                  /* Update the cross-reference varaibles to the new current values  */ 
                  DIGEST_VALUE = ETLS_STGDIGEST;
                  ETLS_FROMDATE = VALID_START_DTTM;
                  ETLS_TODATE = VALID_END_DTTM;
                  
                  output work.etls_match;
                  
               end;
               
            end;
            
         end;
         
      end;
      /* Process new records  */ 
      else if inSort and not inXref then 
      do;
      
         NewMaxKey = sum(NewMaxKey, 1);
         
         SEGMENT_SK = NewMaxKey;
         
         if VALID_START_DTTM eq . then
            VALID_START_DTTM = &etls_begdate;
         if VALID_END_DTTM eq . then 
            VALID_END_DTTM = &etls_enddate;
            
         PROCESSED_DTTM = input("&etls_loadtime", NLDATM21.);
         
         output work.etls_newrcds;
         
      end;
      
   run;
   
   %rcSet(&syserr); 
   
   /* Sort the output from the data merge step  */ 
   proc sort data=work.etls_close nodupkey;
      by ETLS_KEY;
   run;
   %rcSet(&syserr); 
   
   proc sort data=work.etls_match nodupkey;
      by SEGMENT_SK;
   run;
   %rcSet(&syserr); 
   
   /* Save record counts into macros  */ 
   %let etls_updatecnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_close, DATA)) or 
            %sysfunc(exist(work.etls_close, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_close out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_updatecnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   %let etls_matchcnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_match, DATA)) or 
            %sysfunc(exist(work.etls_match, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_match out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_matchcnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   %let etls_newcnt = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(work.etls_newrcds, DATA)) or 
            %sysfunc(exist(work.etls_newrcds, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = work.etls_newrcds out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_newcnt", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %rcSet(&syserr); 
   
   /* Get number of records in table  */ 
   %let etls_recordsBefore = 0; 
   %macro etls_recordCheck; 
      %let etls_recCheckExist = %eval(%sysfunc(exist(dim.SEGMENT_DIM, DATA)) or 
            %sysfunc(exist(dim.SEGMENT_DIM, VIEW))); 
      
      %if (&etls_recCheckExist) %then
      %do;
         proc contents data = dim.SEGMENT_DIM out = work.etls_contents(keep = nobs) noprint; 
         run; 
         
         data _null_; 
            set work.etls_contents (obs = 1); 
            call symput("etls_recordsBefore", left(put(nobs,32.))); 
         run;
         
         proc datasets lib = work nolist nowarn memtype = (data view);
            delete etls_contents;
         quit;
         
      %end;
   %mend etls_recordCheck;
   %etls_recordCheck;
   
   %let etls_table = %nrquote(SEGMENT_DIM);
   %let etls_lib   = %nrquote(Dimensions);
   
   /* Check to see if the update counts are greater than zero  */ 
   %if &etls_updatecnt le 0 and &etls_matchcnt le 0 and &etls_newcnt le 0
      %then %goto scdldout;
      
   /*---- Start of target table update  ----*/ 
   %if &etls_updatecnt gt 0 %then
   %do;
   
      data dim.SEGMENT_DIM;
      
         modify dim.SEGMENT_DIM
            work.etls_close
             (rename = (ETLS_KEY = SEGMENT_SK))
             updatemode=nomissingcheck;
            
         by SEGMENT_SK;
         
         VALID_END_DTTM = ETLS_CLSDATE;
         
         PROCESSED_DTTM = ETLS_LOADTIME;
         
         if %sysrc(_SOK) eq _iorc_ then 
            replace;
            
         _iorc_ = 0; 
         _error_ = 0;
         
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %else %do;
   
      %put %str(NOTE: No target table update records were found. The target table was not
            modified.);
      
   %end;
   
   /*---- Append the new records and matching datasets  ----*/ 
   %if &etls_matchcnt gt 0 %then
   %do;
   
      proc append base = dim.SEGMENT_DIM
         data = work.etls_match force;
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %if &etls_newcnt gt 0 %then
   %do;
   
      proc append base = dim.SEGMENT_DIM
         data = work.etls_newrcds force;
      run;
      
      %rcSet(&syserr); 
      
   %end;
   %else %do;
   
      %put %str(NOTE: No new dimensions were found. The target table was not modified.);
      
   %end;
   
   /* Delete the work tables  */ 
   %if &etls_debug eq 0 %then
   %do;
   
      proc datasets lib=work nolist nowarn memtype = (data view);
         delete etls_newrcds;
         delete etls_match;
         delete etls_close;
      quit;
      
   %end;
   
   %let etls_lastTable = %nrquote(dim.SEGMENT_DIM);
   
   %if &etls_debug lt 2 %then
   %do;
   
      proc datasets lib=work nolist nowarn memtype = (data view);
         delete etls_sortedxref;
         delete etls_source;
      quit;
      
   %end;
   
   %goto scdldout;
   %error:
      %let sysrc = 9999;
      %rcSet(sysrc); 
      
   %scdldout:
      /* Get number of records in table  */ 
      %let etls_recordsAfter = 0; 
      %macro etls_recordCheck; 
         %let etls_recCheckExist = %eval(%sysfunc(exist(dim.SEGMENT_DIM, DATA)) or 
               %sysfunc(exist(dim.SEGMENT_DIM, VIEW))); 
         
         %if (&etls_recCheckExist) %then
         %do;
            proc contents data = dim.SEGMENT_DIM out = work.etls_contents(keep = nobs) noprint; 
            run; 
            
            data _null_; 
               set work.etls_contents (obs = 1); 
               call symput("etls_recordsAfter", left(put(nobs,32.))); 
            run;
            
            proc datasets lib = work nolist nowarn memtype = (data view);
               delete etls_contents;
            quit;
            
         %end;
      %mend etls_recordCheck;
      %etls_recordCheck;
      
%mend etls_scdloader;

/* Execute the SCD Type 2 Loader  */ 
%etls_scdloader;

data _null_; 
   call symput('etls_endTime',put(datetime(),datetime.));
run;

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 4) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc ge 5) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/* Check return code for job  */ 
%macro etls_jobRCChk; 
   %if (&job_rc eq 0) %then
   %do; 
      %on_success(Job_nm=&etls_jobName..sas, param_table=&status_table);
   %end; 
%mend etls_jobRCChk; 
%etls_jobRCChk; 

/*---- Job status macro  ----*/ 
