/*  The input to this macro is the 
1) PERIOD:  (12 and 100(LTD ABT)) for which the variables have
			to be aggregated. 
			If PERIOD=12, then the aggregation for last 12 months will be stored in the table 
			ACC_CHNG_LST_12M_ABT
			If PERIOD=100, then aggregation for last 12 months and Life to date  will be 
			calculated and stored in, ACC_CHNG_LST_12M_ABT and ACC_CHNG_LTD_ABT.

2) INPUT_TABLE: The input table which is already filter for the 
				PERIOD (12).
				For PERIOD 100 the table account_ is used.
*/

%MACRO acc_chng_lst_macro(PERIOD= ,INPUT_TABLE= );

/*%if &PERIOD. = 12 %then %do;*/
PROC SORT DATA=ABTSCR.&INPUT_TABLE. FORCE;
	BY ACCOUNT_RK DESCENDING VALID_START_DTTM;
RUN;
/*%end;*/
/*%else %do;*/
/*PROC SORT DATA=detail.ACCOUNT_DETAIL OUT=ABTSCR.&INPUT_TABLE.;*/
/*	BY ACCOUNT_RK DESCENDING VALID_START_DTTM;*/
/*	WHERE VALID_START_DTTM <=&LOAD_ABT_USER_INPUT_DTTM.; */
/*RUN; %end;*/

data  
%if &PERIOD. = 12 %then %do; 
/*Retain the variables for last 12 months */
abtagg.ACC_CHNG_LST_12M_ABT( KEEP = ACCOUNT_RK ACC_INT_RT_CHNG_LST_12M_CNT 
ACC_MAX_INT_LST_12M_RT ACC_MIN_INT_LST_12M_RT LOAD_ABT_USER_INPUT_DTTM
LOAD_ABT_USER_INPUT_DATE); %end;
%else %do; 
/*Retain the variables for last 12 months & life to date*/
abtagg.ACC_CHNG_LST_12M_ABT ( KEEP = ACCOUNT_RK ACC_INT_RT_CHNG_LST_12M_CNT 
ACC_MAX_INT_LST_12M_RT ACC_MIN_INT_LST_12M_RT LOAD_ABT_USER_INPUT_DTTM
LOAD_ABT_USER_INPUT_DATE)

abtagg.ACC_CHNG_LTD_ABT( KEEP = ACCOUNT_RK ACC_INT_RT_CHNG_DT
ACC_MTH_SNC_FXD_TO_FLT_CNT ACC_MTH_SNC_FLT_TO_FXD_CNT ACC_MAX_INT_LTD_RT
ACC_MIN_INT_LTD_RT ACC_WRST_DLQ_LTD_CD ACC_FST_INT_RT ACC_PRV_INT_RT
ACC_SNC_LTST_INT_RT_DAY_CNT ACC_FST_MTY_DT ACC_WRST_DLQ_LTD_NUM
LOAD_ABT_USER_INPUT_DTTM LOAD_ABT_USER_INPUT_DATE); %end;
/*ACC_FST_MTY_DT ACC_WRST_DLQ_LTD_NUM were added later */

/*Set the source table */
SET  ABTSCR.&INPUT_TABLE.;
BY ACCOUNT_RK DESCENDING VALID_START_DTTM;

max_value = 99999999; /*Numeric constant */
min_value = -99999999; /*Numeric constant */

/*Set of retain statements. Retain variables will be initialized by the call of 
following macro */
/*Variables for 12 month period */
Length ACC_WRST_DLQ_LTD_CD TMP_INTEREST_RT_TYPE_CD $3.;

RETAIN ACC_MAX_INT_LST_12M_RT .
	ACC_MIN_INT_LST_12M_RT .  

/*Variables for life to date period */
ACC_INT_RT_CHNG_DT .
ACC_MTH_SNC_FXD_TO_FLT_CNT 0
ACC_MTH_SNC_FLT_TO_FXD_CNT 0
ACC_MAX_INT_LTD_RT .
ACC_MIN_INT_LTD_RT .
ACC_WRST_DLQ_LTD_CD '' 
ACC_FST_INT_RT .
ACC_PRV_INT_RT .
ACC_SNC_LTST_INT_RT_DAY_CNT 0
ACC_FST_MTY_DT .
ACC_WRST_DLQ_LTD_NUM .;

RETAIN  ACC_INT_RT_CHNG_LST_12M_CNT 0;
/*General retain variables are declared here */
/*%if &PERIOD. = 24 %then %do;*/
/*	RETAIN VALID_END_TEMP &LOAD_ABT_12M_BCK_DTTM. COUNT 12; %end;*/
/*%else %do;*/
	RETAIN VALID_END_TEMP  COUNT ;
	VALID_END_TEMP = LOAD_ABT_USER_INPUT_DTTM;
	COUNT = 0;
/*%end;*/

RETAIN PRV_INTEREST_RT .
TMP_INTEREST_RT_TYPE_CD '' 
TMP_INTEREST_RT_TYPE_CNT 0
PRV_VALID_START_DT . 
ACC_INT_RT_CHNG_LTD_CNT 0;

/*Set the value of COUNT to a temporary variable */
COUNT_TEMP=COUNT;


IF  ( COUNT <  12 ) THEN 
	DO;	
		/*Check for the first record in the group */		
		IF FIRST.ACCOUNT_RK THEN 
			DO;				
				PRV_INTEREST_RT = INTEREST_RT;
				/* Assign INTEREST_RT_TYPE to a temporary retained varaible */
				TMP_INTEREST_RT_TYPE_CD = INTEREST_RT_TYPE_CD;
				
				ACC_WRST_DLQ_LTD_CD = WORST_STATUS_LAST_12_MTH_CD;
				ACC_WRST_DLQ_LTD_NUM = INPUT(WORST_STATUS_LAST_12_MTH_CD, WRST_DLQ.);
			END;
		/*Check the change in interest rate */

		IF	PRV_INTEREST_RT NE INTEREST_RT THEN 
			DO;
			/* If the interest rate has changed then increment the counter */
			ACC_INT_RT_CHNG_LST_12M_CNT = sum(ACC_INT_RT_CHNG_LST_12M_CNT, 1); 

			/*If the interest rate has changed & this is the latest change then assing the 
			interest rate value to the previous_interest variable */
			IF ACC_INT_RT_CHNG_LST_12M_CNT = 1 THEN 
				DO;
					ACC_INT_RT_CHNG_DT = PRV_VALID_START_DT;	
					ACC_SNC_LTST_INT_RT_DAY_CNT = INTCK('DAY', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE);
					ACC_PRV_INT_RT = INTEREST_RT; 
				END;

			/*Assign the current interest rate to the previous interest rate variable for 
			further iteration */
			PRV_INTEREST_RT = INTEREST_RT;
			END;

		/*Check the change in interest rate type */
		IF TMP_INTEREST_RT_TYPE_CD NE INTEREST_RT_TYPE_CD THEN
			DO;
			  /*If the interest rate type has changed then increment the counter */ 		
			  TMP_INTEREST_RT_TYPE_CNT = sum(TMP_INTEREST_RT_TYPE_CNT, 1);

			  IF TMP_INTEREST_RT_TYPE_CNT = 1 THEN 
				DO;
					IF (TMP_INTEREST_RT_TYPE_CD = &FLT_INTEREST_TYPE) AND  
						(INTEREST_RT_TYPE_CD = &FXD_INTEREST_TYPE)THEN DO;					
							ACC_MTH_SNC_FXD_TO_FLT_CNT = SUM( INTCK ('MONTH', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE), 1); END;
					ELSE IF (TMP_INTEREST_RT_TYPE_CD = &FXD_INTEREST_TYPE) AND  
						(INTEREST_RT_TYPE_CD = &FLT_INTEREST_TYPE)THEN DO;					
							ACC_MTH_SNC_FLT_TO_FXD_CNT =  SUM( INTCK ('MONTH', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE), 1); END;				
				END;
			END;
		
		/*Assign the valid_start_dttm to a retained variable */		
		PRV_VALID_START_DT = DATEPART(VALID_START_DTTM);	
		/*For ACCOUNT_RK.LAST, 
		the value of ACC_FST_INT_RT at last will have the first INTEREST_RT*/		
		ACC_FST_INT_RT = INTEREST_RT;
		ACC_FST_MTY_DT = MATURITY_DT;
		/*Find the maximum & minimum INTEREST_RT */
		IF COALESCE(ACC_MAX_INT_LST_12M_RT, min_value) < INTEREST_RT THEN DO;
			ACC_MAX_INT_LST_12M_RT = INTEREST_RT; END;
		IF COALESCE(ACC_MIN_INT_LST_12M_RT, max_value) > INTEREST_RT THEN DO;
			ACC_MIN_INT_LST_12M_RT = INTEREST_RT; END;
		
		/*Find the worst_status_no correspodning to the worst status code */
		WORST_STATUS_LAST_12_MTH_NO = INPUT(WORST_STATUS_LAST_12_MTH_CD, WRST_DLQ.);
	
		/*Check if the worst status number is greater than previous worst status */
		IF WORST_STATUS_LAST_12_MTH_NO >  COALESCE(ACC_WRST_DLQ_LTD_NUM, min_value) THEN 
			DO;
				ACC_WRST_DLQ_LTD_NUM = WORST_STATUS_LAST_12_MTH_NO;
				ACC_WRST_DLQ_LTD_CD = WORST_STATUS_LAST_12_MTH_CD;
			END;
	END;
ELSE 
 	DO;	
		IF	PRV_INTEREST_RT NE INTEREST_RT THEN 
			DO;
			/* If the interest rate has changed then increment the counter */
			ACC_INT_RT_CHNG_LTD_CNT = sum(ACC_INT_RT_CHNG_LTD_CNT, 1); 
			
			/*If the interest rate has changed & this is the latest change then assing the 
			interest rate value to the previous_interest variable */
			IF ACC_INT_RT_CHNG_LTD_CNT = 1 THEN 
				DO;
					ACC_INT_RT_CHNG_DT = PRV_VALID_START_DT;	
					ACC_SNC_LTST_INT_RT_DAY_CNT = INTCK('DAY', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE);
					ACC_PRV_INT_RT = INTEREST_RT; 
				END;

			PRV_INTEREST_RT = INTEREST_RT;

			END;
		/*Check the change in interest rate type */
		IF TMP_INTEREST_RT_TYPE_CD NE INTEREST_RT_TYPE_CD THEN
			DO;
			  /*If the interest rate type has changed then increment the counter */ 		
			  TMP_INTEREST_RT_TYPE_CNT = sum(TMP_INTEREST_RT_TYPE_CNT, 1);

			  IF TMP_INTEREST_RT_TYPE_CNT = 1 THEN 
				DO;
					IF (TMP_INTEREST_RT_TYPE_CD = &FLT_INTEREST_TYPE) AND  
						(INTEREST_RT_TYPE_CD = &FXD_INTEREST_TYPE)THEN DO;					
							ACC_MTH_SNC_FXD_TO_FLT_CNT = sum(INTCK ('MONTH', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE), 1); END;
					ELSE IF (TMP_INTEREST_RT_TYPE_CD = &FXD_INTEREST_TYPE) AND  
						(INTEREST_RT_TYPE_CD = &FLT_INTEREST_TYPE)THEN DO;					
							ACC_MTH_SNC_FLT_TO_FXD_CNT =  sum(INTCK ('MONTH', PRV_VALID_START_DT, LOAD_ABT_USER_INPUT_DATE),1); END;
				END;
			END;

		/*Assign the valid_start_dttm to a retained variable */		
		PRV_VALID_START_DT = DATEPART(VALID_START_DTTM);	
		/*For ACCOUNT_RK.LAST, 
		the value of ACC_FST_INT_RT at last will have the first INTEREST_RT*/		
		ACC_FST_INT_RT = INTEREST_RT;
		ACC_FST_MTY_DT = MATURITY_DT;

		IF COALESCE(ACC_MAX_INT_LTD_RT, min_value) < INTEREST_RT THEN DO;
			ACC_MAX_INT_LTD_RT = INTEREST_RT; END;
		IF COALESCE(ACC_MIN_INT_LTD_RT, max_value) > INTEREST_RT THEN DO;
			ACC_MIN_INT_LTD_RT = INTEREST_RT; END;		
		/*Find the worst_status_no correspodning to the worst status code */
		WORST_STATUS_LAST_12_MTH_NO = INPUT(WORST_STATUS_LAST_12_MTH_CD, WRST_DLQ.);
 
		IF WORST_STATUS_LAST_12_MTH_NO >  ACC_WRST_DLQ_LTD_NUM THEN 
			DO;
				ACC_WRST_DLQ_LTD_NUM = WORST_STATUS_LAST_12_MTH_NO;
				ACC_WRST_DLQ_LTD_CD = WORST_STATUS_LAST_12_MTH_CD;
			END;
		
	END;



VALID_END_TEMP=INTNX('DTMONTH',VALID_END_TEMP,-1,'END');
COUNT+1;

DO WHILE ((VALID_START_DTTM<= VALID_END_TEMP<=VALID_END_DTTM)  AND COUNT < (&PERIOD.)); 

		VALID_END_TEMP=INTNX('DTMONTH',VALID_END_TEMP,-(1),'END');
		COUNT+1;
END;	

IF COUNT = 12 OR (COUNT_TEMP< 12 AND COUNT > 12) THEN 
DO;
	ACC_INT_RT_CHNG_LTD_CNT = ACC_INT_RT_CHNG_LST_12M_CNT;
	ACC_MAX_INT_LTD_RT = ACC_MAX_INT_LST_12M_RT; 
	ACC_MIN_INT_LTD_RT = ACC_MIN_INT_LST_12M_RT;
END;

PUT ACC_PRV_INT_RT=;
PUT COUNT=;

IF LAST.ACCOUNT_RK THEN
DO;
	IF COUNT <= 12 THEN 
	DO;
		ACC_INT_RT_CHNG_LTD_CNT = ACC_INT_RT_CHNG_LST_12M_CNT;
		ACC_MAX_INT_LTD_RT = ACC_MAX_INT_LST_12M_RT; 
		ACC_MIN_INT_LTD_RT = ACC_MIN_INT_LST_12M_RT;
	END;
	
	OUTPUT; 
	/*Assignments for last 12 months variables */	
	ACC_INT_RT_CHNG_LST_12M_CNT=0; ACC_MAX_INT_LST_12M_RT=.; ACC_MIN_INT_LST_12M_RT=.;

	/*Assignments for life to date variables */	
	ACC_INT_RT_CHNG_DT=.; 
	ACC_MTH_SNC_FXD_TO_FLT_CNT=0;
	ACC_MTH_SNC_FLT_TO_FXD_CNT=0;
	ACC_MAX_INT_LTD_RT=.;
	ACC_MIN_INT_LTD_RT=.;
	ACC_WRST_DLQ_LTD_CD=''; 
	ACC_FST_INT_RT=.;
	ACC_PRV_INT_RT=.;
	ACC_SNC_LTST_INT_RT_DAY_CNT=0; 
	ACC_FST_MTY_DT=.;
	ACC_WRST_DLQ_LTD_NUM=.;

	/*Assignments for other variables */


	VALID_END_TEMP = LOAD_ABT_USER_INPUT_DTTM;  COUNT= 0;


	PRV_INTEREST_RT=.; TMP_INTEREST_RT_TYPE_CD=''; 
	TMP_INTEREST_RT_TYPE_CNT=0; PRV_VALID_START_DT=.; ACC_INT_RT_CHNG_LTD_CNT=0;
END;
run;

%mend;


