%macro acc_inq_retain;
/*Common variables to retained, applicable for all datasets */
LENGTH ACCOUNT_TYPE_CD_RET ACCOUNT_SUB_TYPE_CD_RET COLLATERAL_CD_RET ACCOUNT_STATUS_CD_RET $3
ALLOW_OVERDRAFT_FLG_RET $1;

RETAIN PRIMARY_CUSTOMER_RK_RET ALLOW_OVERDRAFT_FLG_RET ACCOUNT_TYPE_CD_RET
ACCOUNT_SUB_TYPE_CD_RET COLLATERAL_CD_RET ACCOUNT_STATUS_CD_RET ;
/*List of variables to be retained */
RETAIN    
/*Account inquiry curr month abt retain */

ACC_QRY_CURR_MTH_CNT 0  
ACC_COM_CURR_MTH_CNT 0 
ACC_LMT_INR_REQ_CURR_MTH_CNT 0  
ACC_LMT_DEC_REQ_CURR_MTH_CNT 0 
ACC_DUP_STMT_REQ_CURR_MTH_CNT 0  
ACC_ODLMT_INR_REQ_CURR_MTH_CNT 0 
ACC_ODLMT_DEC_REQ_CURR_MTH_CNT 0 

ACC_RT_CHNG_REQ_CURR_MTH_CNT 0
ACC_TNR_CHNG_REQ_CURR_MTH_CNT 0
ACC_PAY_RED_INQ_CURR_MTH_CNT 0

ACC_DIS_CURR_MTH_AMT .  
ACC_MAX_DIS_CURR_MTH_AMT .  
ACC_DIS_CURR_MTH_CNT 0 
ACC_MIN_DIS_CURR_MTH_AMT . 

ACC_MAX_DIS_CURR_MTH_CNT 0
ACC_MIN_DIS_CURR_MTH_CNT 0

/*Account inquiry  last 3 month abt retain */
ACC_QRY_LST_3M_CNT 0  
ACC_COM_LST_3M_CNT 0 
ACC_LMT_INR_REQ_LST_3M_CNT 0  
ACC_LMT_DEC_REQ_LST_3M_CNT 0 
ACC_DUP_STMT_REQ_LST_3M_CNT 0  
ACC_ODLMT_INR_REQ_LST_3M_CNT 0 
ACC_ODLMT_DEC_REQ_LST_3M_CNT 0 

ACC_RT_CHNG_REQ_LST_3M_CNT 0
ACC_TNR_CHNG_REQ_LST_3M_CNT 0
ACC_PAY_RED_INQ_LST_3M_CNT 0 

ACC_DIS_LST_3M_AMT .  
ACC_MAX_DIS_LST_3M_AMT .  
ACC_DIS_LST_3M_CNT 0 
ACC_MIN_DIS_LST_3M_AMT . 

ACC_MAX_DIS_LST_3M_CNT 0
ACC_MIN_DIS_LST_3M_CNT 0

 /*Account inquiry   last 6 month abt retain */
ACC_QRY_LST_6M_CNT 0  
ACC_COM_LST_6M_CNT 0 
ACC_LMT_INR_REQ_LST_6M_CNT 0  
ACC_LMT_DEC_REQ_LST_6M_CNT 0 
ACC_DUP_STMT_REQ_LST_6M_CNT 0  
ACC_ODLMT_INR_REQ_LST_6M_CNT 0 
ACC_ODLMT_DEC_REQ_LST_6M_CNT 0 

ACC_RT_CHNG_REQ_LST_6M_CNT 0
ACC_TNR_CHNG_REQ_LST_6M_CNT 0
ACC_PAY_RED_INQ_LST_6M_CNT 0

ACC_DIS_LST_6M_AMT . 
ACC_MAX_DIS_LST_6M_AMT . 
ACC_DIS_LST_6M_CNT 0
ACC_MIN_DIS_LST_6M_AMT .

ACC_MAX_DIS_LST_6M_CNT 0
ACC_MIN_DIS_LST_6M_CNT 0
/*Account inquiry   last 12 month abt retain */
ACC_QRY_LST_12M_CNT 0 
ACC_COM_LST_12M_CNT 0
ACC_LMT_INR_REQ_LST_12M_CNT 0 
ACC_LMT_DEC_REQ_LST_12M_CNT 0
ACC_DUP_STMT_REQ_LST_12M_CNT 0 
ACC_ODLMT_INR_REQ_LST_12M_CNT 0
ACC_ODLMT_DEC_REQ_LST_12M_CNT 0

ACC_RT_CHNG_REQ_LST_12M_CNT 0
ACC_TNR_CHNG_REQ_LST_12M_CNT 0
ACC_PAY_RED_INQ_LST_12M_CNT 0

ACC_DIS_LST_12M_AMT . 
ACC_MAX_DIS_LST_12M_AMT . 
ACC_DIS_LST_12M_CNT 0
ACC_MIN_DIS_LST_12M_AMT .

ACC_MAX_DIS_LST_12M_CNT 0
ACC_MIN_DIS_LST_12M_CNT 0

/*Account inquiry   last 13_24 month abt retain */

ACC_QRY_13_24M_CNT 0 
ACC_COM_13_24M_CNT 0
ACC_LMT_INR_REQ_13_24M_CNT 0  
ACC_LMT_DEC_REQ_13_24M_CNT 0
ACC_DUP_STMT_REQ_13_24M_CNT 0 
ACC_ODLMT_INR_REQ_13_24M_CNT 0
ACC_ODLMT_DEC_REQ_13_24M_CNT 0

ACC_RT_CHNG_REQ_13_24M_CNT 0
ACC_TNR_CHNG_REQ_13_24M_CNT 0
ACC_PAY_RED_INQ_13_24M_CNT 0

ACC_DIS_13_24M_AMT .  
ACC_MAX_DIS_13_24M_AMT . 
ACC_DIS_13_24M_CNT 0
ACC_MIN_DIS_13_24M_AMT .

ACC_MAX_DIS_13_24M_CNT 0
ACC_MIN_DIS_13_24M_CNT 0;

%mend;
