/* Macro to retain the required variables. 
	This macro is called by the macro acc_snap_lst_abt */
%macro acc_snap_abt_retain;

	/*Common variables to retained, applicable for all datasets */
	LENGTH ACCOUNT_TYPE_CD_RET ACCOUNT_SUB_TYPE_CD_RET COLLATERAL_CD_RET ACCOUNT_STATUS_CD_RET $3
	ALLOW_OVERDRAFT_FLG_RET $1;

	RETAIN CUSTOMER_RK_RET ALLOW_OVERDRAFT_FLG_RET ACCOUNT_TYPE_CD_RET
	ACCOUNT_SUB_TYPE_CD_RET COLLATERAL_CD_RET ACCOUNT_STATUS_CD_RET ;

	RETAIN
		/* variable for last 3 months */
		ACC_1_30DLQ_LST_3M_CNT 0
		ACC_31_60DLQ_LST_3M_CNT 0
		ACC_61_90DLQ_LST_3M_CNT 0 
		ACC_91_120DLQ_LST_3M_CNT 0 
		ACC_120PDLQ_LST_3M_CNT 0 
		ACC_1_30DLQ_2NOR_LST_3M_CNT 0 
		ACC_31_60DLQ_2NOR_LST_3M_CNT 0 
		ACC_61_90DLQ_2NOR_LST_3M_CNT 0 
		ACC_91_120DLQ_2NOR_LST_3M_CNT 0 
		ACC_120PDLQ_2NOR_LST_3M_CNT 0 
		ACC_AVG_LMT_USE_LST_3M_PCT .
		ACC_LMT_EXH_LST_3M_CNT 0 
		ACC_AVGOTL_2AVGLMT_LST_3M_PCT . 
		ACC_MAX_OTL_LST_3M_AMT . 
		ACC_MIN_OTL_LST_3M_AMT . 
		ACC_AVG_BAL_LST_3M_AMT .
		ACC_AVG_OINT_2AVGBAL_L3M_PCT .
		ACC_MAX_OTB_LST_3M_AMT .
		ACC_MIN_OTB_LST_3M_AMT .
		ACC_MIN_BLL_PAY_LST_3M_CNT 0
		ACC_MAX_OUT_BAL_LST_3M_AMT . 
		ACC_MIN_OUT_BAL_LST_3M_AMT .
		ACC_DLD_INST_LST_3M_CNT 0
		ACC_AVG_DLY_BAL_LST_3M_AMT .
		ACC_PVE_2NIL_LST_3M_PCT .
		ACC_NIL_BAL_LST_3M_MTH_CNT 0
		ACC_BBLO_LST_3M_CNT 0
		ACC_AVOTL_2AVODLMT_L3M_PCT .
		ACC_PVE_BAL_LST_3M_MTH_CNT 0
		ACC_MAX_OUT_FEE_LST_3M_AMT .
		ACC_MIN_OUT_FEE_LST_3M_AMT .

		/* variable for last 6 months*/
		ACC_1_30DLQ_LST_6M_CNT 0
		ACC_31_60DLQ_LST_6M_CNT 0
		ACC_61_90DLQ_LST_6M_CNT 0
		ACC_91_120DLQ_LST_6M_CNT 0
		ACC_120PDLQ_LST_6M_CNT 0
		ACC_1_30DLQ_2NOR_LST_6M_CNT 0
		ACC_31_60DLQ_2NOR_LST_6M_CNT 0
		ACC_61_90DLQ_2NOR_LST_6M_CNT 0
		ACC_91_120DLQ_2NOR_LST_6M_CNT 0
		ACC_120PDLQ_2NOR_LST_6M_CNT 0
		ACC_AVG_LMT_USE_LST_6M_PCT .
		ACC_LMT_EXH_LST_6M_CNT 0
		ACC_AVGOTL_2AVGLMT_LST_6M_PCT .
		ACC_MAX_OTL_LST_6M_AMT .
		ACC_MIN_OTL_LST_6M_AMT .
		ACC_AVG_BAL_LST_6M_AMT .
		ACC_AVG_OINT_2AVGBAL_L6M_PCT .
		ACC_MAX_OTB_LST_6M_AMT .
		ACC_MIN_OTB_LST_6M_AMT .
		ACC_MIN_BLL_PAY_LST_6M_CNT 0
		ACC_MAX_OUT_BAL_LST_6M_AMT .
		ACC_MIN_OUT_BAL_LST_6M_AMT .
		ACC_DLD_INST_LST_6M_CNT 0
		ACC_AVG_DLY_BAL_LST_6M_AMT .
		ACC_PVE_2NIL_LST_6M_PCT .
		ACC_NIL_BAL_LST_6M_MTH_CNT 0
		ACC_BBLO_LST_6M_CNT 0
		ACC_AVOTL_2AVODLMT_L6M_PCT .
		ACC_PVE_BAL_LST_6M_MTH_CNT 0
		ACC_MAX_OUT_FEE_LST_6M_AMT .
		ACC_MIN_OUT_FEE_LST_6M_AMT .

		/* variable for last 12 months*/
		ACC_1_30DLQ_LST_12M_CNT 0
		ACC_31_60DLQ_LST_12M_CNT 0
		ACC_61_90DLQ_LST_12M_CNT 0
		ACC_91_120DLQ_LST_12M_CNT 0
		ACC_120PDLQ_LST_12M_CNT 0
		ACC_1_30DLQ_2NOR_LST_12M_CNT 0
		ACC_31_60DLQ_2NOR_LST_12M_CNT 0
		ACC_61_90DLQ_2NOR_LST_12M_CNT 0
		ACC_91_120DLQ_2NOR_LST_12M_CNT 0
		ACC_120PDLQ_2NOR_LST_12M_CNT 0
		ACC_AVG_LMT_USE_LST_12M_PCT .
		ACC_LMT_EXH_LST_12M_CNT 0
		ACC_AVGOTL_2AVGLMT_LST_12M_PCT .
		ACC_MAX_OTL_LST_12M_AMT .
		ACC_MIN_OTL_LST_12M_AMT .
		ACC_AVG_BAL_LST_12M_AMT .
		ACC_AVG_OINT_2AVGBAL_L12M_PCT .
		ACC_MAX_OTB_LST_12M_AMT .
		ACC_MIN_OTB_LST_12M_AMT .
		ACC_MIN_BLL_PAY_LST_12M_CNT 0
		ACC_MAX_OUT_BAL_LST_12M_AMT .
		ACC_MIN_OUT_BAL_LST_12M_AMT .
		ACC_PVE_2NIL_LST_12M_PCT .
		ACC_NIL_BAL_LST_12M_MTH_CNT 0
		ACC_DLD_INST_LST_12M_CNT 0
		ACC_AVG_DLY_BAL_LST_12M_AMT .
		ACC_BBLO_LST_12M_CNT 0
		ACC_AVOTL_2AVODLMT_L12M_PCT .
		ACC_PVE_BAL_LST_12M_MTH_CNT 0
		ACC_MAX_OUT_FEE_LST_12M_AMT .
		ACC_MIN_OUT_FEE_LST_12M_AMT .

		/* variable for last 13 to 24 months*/
		ACC_1_30DLQ_13_24M_CNT 0
		ACC_31_60DLQ_13_24M_CNT 0
		ACC_61_90DLQ_13_24M_CNT 0
		ACC_91_120DLQ_13_24M_CNT 0
		ACC_120PDLQ_13_24M_CNT 0
		ACC_1_30DLQ_2NOR_13_24M_CNT 0
		ACC_31_60DLQ_2NOR_13_24M_CNT 0 
		ACC_61_90DLQ_2NOR_13_24M_CNT 0
		ACC_91_120DLQ_2NOR_13_24M_CNT 0
		ACC_120PDLQ_2NOR_13_24M_CNT 0
		ACC_AVG_LMT_USE_13_24M_PCT .
		ACC_LMT_EXH_13_24M_CNT 0
		ACC_AVGOTL_2AVGLMT_13_24M_PCT .
		ACC_MAX_OTL_13_24M_AMT .
		ACC_MIN_OTL_13_24M_AMT .
		ACC_AVG_BAL_13_24M_AMT .
		ACC_AVG_OINT2AVGBAL_13_24M_PCT .
		ACC_MAX_OTB_13_24M_AMT .
		ACC_MIN_OTB_13_24M_AMT .
		ACC_MIN_BLL_PAY_13_24M_CNT 0
		ACC_MAX_OUT_BAL_13_24M_AMT .
		ACC_MIN_OUT_BAL_13_24M_AMT .
		ACC_PVE_2NIL_13_24M_MTH_PCT .
		ACC_NIL_BAL_13_24M_MTH_CNT 0
		ACC_DLD_INST_13_24M_CNT 0
		ACC_AVG_DLY_BAL_13_24M_AMT .
		ACC_BBLO_13_24M_CNT 0
		ACC_AVOTL_2AVODLMT_13_24M_PCT .
		ACC_PVE_BAL_13_24M_MTH_CNT 0
		ACC_MAX_OUT_FEE_13_24M_AMT .
		ACC_MIN_OUT_FEE_13_24M_AMT .

		/* Variable for life to date */
		ACC_DLQ_LTD_MTH_CNT 0
		ACC_MAX_OUT_BAL_LTD_MTH_SK .
		ACC_MIN_OUT_BAL_LTD_MTH_SK .
		ACC_DFT_2NOR_LTD_MTH_CNT 0
		ACC_PAY_DLD_2NOR_LTD_MTH_CNT 0
		ACC_DLQ_2NOR_LTD_MTH_CNT 0
		ACC_MAX_OUT_BAL_LTD_AMT .
		ACC_MIN_OUT_BAL_LTD_AMT .
		ACC_SNC_ZERO_BAL_MTH_CNT 0
		ACC_NIL_BAL_LTD_MTH_CNT 0
		ACC_OPN_TO_FST_DLD_PAY_MTH_CNT 0
		ACC_OUT_PPL2PCL_AT_DFT_PCT .
		ACC_OUT_PPL_AT_DFT_AMT .
		ACC_PCL_AT_DFT_AMT .

		/* Temporary retain variable*/
		DELINQUENCY_STATUS_CNT 
		SUM_BAL_AMT 
		SUM_CURR_LMT_AMT 
		BAL_CNT 
		CURR_LMT_CNT 
		SUM_OTL_BAL_AMT 
		SUM_OTL_CURR_LMT_AMT 
		OTL_CLMT_CNT 
		SUM_OTL_OVD_AMT 
		SUM_OTL_OVD_LMT_AMT 
		OTL_ODLMT_CNT 
		SUM_TOT_BAL_AMT 
		TOT_BAL_CNT 
		SUM_INT_EXP_AMT 
		INT_EXP_CNT 
		SUM_AVG_DLY_BAL_AMT 
		DLY_BAL_CNT 
		DEFAULT_STATUS_CNT 
		LATE_PAYMENT_STATUS_CNT 
		ZERO_BAL_MTH_STATUS_CNT 
		FST_DLD_PAY_TIME_SK 
		;

%mend acc_snap_abt_retain;
