%macro create_scr_abt(abt_key=, phy_table_nm=, error_cd=);

	/* Handle missing values */
	%if %str(&abt_key) = %str() %then %do;
		%put ERROR: ABT Key not provided. Exiting.;
		%let error_code=ERROR;
		%return;
	%end;

	/* Get level of the abt */
	proc sql noprint;
		select kupcase(level_desc) into :l_desc
		from analytic.scr_abt_master inner join analytic.abt_level
		on(scr_abt_master.scr_l_no = abt_level.l_no)
		where scr_abt_master.scr_a_no=&abt_key;
	quit;

	/* Call macro to create the abt */
	%create_abt(abt_type=SCR, abt_cat=&l_desc, abt_phy_table=&phy_table_nm, abt_key=&abt_key);


%mend create_scr_abt;
