/*  The input to this macro is the

1) INPUT_TABLE: Input parameter for this macro is CREDIT_BUREAU_DETAIL_EXT for populating 

				the data for all application and applicant for bureau serial number 1, 2 

				and 3.Four table get populated from this macro they are APPT_BUR1_ABT,

				APPT_BUR2_ABT,APPT_BUR3_ABT and APPT_BUR_ABT.

*/

%macro appl_bureau_all_sr_no_abt(INPUT_TABLE= );

/*sorting the data set on the application key,as the grouping is done for all the application*/

PROC SORT DATA=ABTSCR.&INPUT_TABLE. FORCE;

	BY APPLICANT_RK ;

RUN;



DATA %appl_bureau_all_sr_no_keep;

SET ABTSCR.&INPUT_TABLE.;

BY APPLICANT_RK;

/*Retaining all the variable*/



 %appt_bureau_lst_retain;

/*These are temporary constants for storing max & min value, which will be used

in the code as a reference for finding max, min for the variables

The value of max & min can be changed as per the need of the implementation team

*/

min_value=&min_value.;

max_value=&max_value.;

/*Finding the data for the bureau serial number one*/

		IF BUREAU_SRL_NO EQ 1 THEN

			DO;

				APPT_BUR1_BNKP_CNT=BANKRUPTCY_CNT;

				APPT_BUR1_CHRG_OFF_CNT=CHARGE_OFF_CNT;

				APPT_BUR1_CLS_ACC_CNT=CLOSED_ACCT_CNT;

				APPT_BUR1_COLL_DBT_AMT=COLLECTION_DEBT_AMT;

				APPT_BUR1_CR_ACT_DT=CREDIT_ACTIVE_DT;

				APPT_BUR1_CSS_CD=BUREAU_CLASS_CD;

				APPT_BUR1_CURR_ACC_CNT=(OPEN_ACCT_CNT-CLOSED_ACCT_CNT);

				APPT_BUR1_CURR_CR_PCT=CURRENT_CREDIT_PCT;

				APPT_BUR1_CURR_LMT_AMT=CURRENT_CREDIT_LIMIT_AMT;

				APPT_BUR1_DGTRY_ACC_CNT=DEROGATORY_ACCT_CNT;

				APPT_BUR1_DLQ_ACC_CNT=DELINQUENT_ACCT_CNT;

				APPT_BUR1_EVR_COLL_FLG=EVER_IN_COLLECTION_FLG;

				APPT_BUR1_FRD_FLG=FRAUD_FLG;

				APPT_BUR1_GD_ACC_CNT=GOOD_ACCT_CNT;

				APPT_BUR1_HST_CR_LMT_AMT=HIGHEST_CREDIT_LIMIT_AMT;

				APPT_BUR1_INST_DBT_AMT=INSTALLMENT_DEBT_AMT;

				APPT_BUR1_JUDG_CNT=JUDGEMENTS_CNT;

				APPT_BUR1_LIEN_CNT=LIENS_CNT;

				APPT_BUR1_LST_BNKP_CD=BANKRUPTCY_STATUS_CD;

				APPT_BUR1_LST_BNKP_DT=BANKRUPTCY_FILED_DT;

				APPT_BUR1_LST_JUDG_DT=LAST_JUDGEMENT_DT;

				APPT_BUR1_LST_LIEN_DT=LAST_LIEN_DT;

				APPT_BUR1_MTH_CNT=MONTHS_SINCE_AT_BUREAU;

				APPT_BUR1_OPN_ACC_CNT=OPEN_ACCT_CNT;

				APPT_BUR1_OTH_DBT_AMT=OTHER_DEBT_AMT;

				APPT_BUR1_OTH_INQ_CNT=APPT_BUR1_OTH_INQ_CNT;

				APPT_BUR1_OTH_LST_INQ_DT=OTHER_LAST_INQUIRY_DT;

				APPT_BUR1_PDUE_30D_AMT=TOT_PAST_DUE_SLOW_30_AMT;

				APPT_BUR1_PDUE_90D_AMT=TOT_PAST_DUE_SLOW_90_AMT;

				APPT_BUR1_PUB_REC_CNT=PUBLIC_RECORD_CNT;

				APPT_BUR1_REQ_DT=REQUEST_DT;

				APPT_BUR1_REST_DBT_AMT=REAL_ESTATE_DEBT_AMT;

				APPT_BUR1_REV_DBT_AMT=REVOLVING_DEBT_AMT;

				APPT_BUR1_SCR_DT=SCORE_DT;

				APPT_BUR1_SCR_NO=SCORE_NO;

				APPT_BUR1_TOT_BAL_AMT=TOTAL_BALANCE_AMT;

				APPT_BUR1_TOT_MTH_PAY_AMT=TOT_MTH_PAYMENT_AMT;

				APPT_BUR1_WRST_RTG_12M_NO=WORST_RATING_12_MTH_NO;

			END;

/*Finding the data for the bureau serial number two*/

		IF BUREAU_SRL_NO EQ 2 THEN

			DO;

				APPT_BUR2_BNKP_CNT=BANKRUPTCY_CNT;

				APPT_BUR2_CHRG_OFF_CNT=CHARGE_OFF_CNT;

				APPT_BUR2_CLS_ACC_CNT=CLOSED_ACCT_CNT;

				APPT_BUR2_COLL_DBT_AMT=COLLECTION_DEBT_AMT;

				APPT_BUR2_CR_ACT_DT=CREDIT_ACTIVE_DT;

				APPT_BUR2_CSS_CD=BUREAU_CLASS_CD;

				APPT_BUR2_CURR_ACC_CNT=(OPEN_ACCT_CNT-CLOSED_ACCT_CNT);

				APPT_BUR2_CURR_CR_PCT=CURRENT_CREDIT_PCT;

				APPT_BUR2_CURR_LMT_AMT=CURRENT_CREDIT_LIMIT_AMT;

				APPT_BUR2_DGTRY_ACC_CNT=DEROGATORY_ACCT_CNT;

				APPT_BUR2_DLQ_ACC_CNT=DELINQUENT_ACCT_CNT;

				APPT_BUR2_EVR_COLL_FLG=EVER_IN_COLLECTION_FLG;

				APPT_BUR2_FRD_FLG=FRAUD_FLG;

				APPT_BUR2_GD_ACC_CNT=GOOD_ACCT_CNT;

				APPT_BUR2_HST_CR_LMT_AMT=HIGHEST_CREDIT_LIMIT_AMT;

				APPT_BUR2_INST_DBT_AMT=INSTALLMENT_DEBT_AMT;

				APPT_BUR2_JUDG_CNT=JUDGEMENTS_CNT;

				APPT_BUR2_LIEN_CNT=LIENS_CNT;

				APPT_BUR2_LST_BNKP_CD=BANKRUPTCY_STATUS_CD;

				APPT_BUR2_LST_BNKP_DT=BANKRUPTCY_FILED_DT;

				APPT_BUR2_LST_JUDG_DT=LAST_JUDGEMENT_DT;

				APPT_BUR2_LST_LIEN_DT=LAST_LIEN_DT;

				APPT_BUR2_MTH_CNT=MONTHS_SINCE_AT_BUREAU;

				APPT_BUR2_OPN_ACC_CNT=OPEN_ACCT_CNT;

				APPT_BUR2_OTH_DBT_AMT=OTHER_DEBT_AMT;

				APPT_BUR2_OTH_INQ_CNT=APPT_BUR2_OTH_INQ_CNT;

				APPT_BUR2_OTH_LST_INQ_DT=OTHER_LAST_INQUIRY_DT;

				APPT_BUR2_PDUE_30D_AMT=TOT_PAST_DUE_SLOW_30_AMT;

				APPT_BUR2_PDUE_90D_AMT=TOT_PAST_DUE_SLOW_90_AMT;

				APPT_BUR2_PUB_REC_CNT=PUBLIC_RECORD_CNT;

				APPT_BUR2_REQ_DT=REQUEST_DT;

				APPT_BUR2_REST_DBT_AMT=REAL_ESTATE_DEBT_AMT;

				APPT_BUR2_REV_DBT_AMT=REVOLVING_DEBT_AMT;

				APPT_BUR2_SCR_DT=SCORE_DT;

				APPT_BUR2_SCR_NO=SCORE_NO;

				APPT_BUR2_TOT_BAL_AMT=TOTAL_BALANCE_AMT;

				APPT_BUR2_TOT_MTH_PAY_AMT=TOT_MTH_PAYMENT_AMT;

				APPT_BUR2_WRST_RTG_12M_NO=WORST_RATING_12_MTH_NO;

			END;

/*Finding the data for the bureau serial number three*/

		IF BUREAU_SRL_NO EQ 3 THEN

			DO;

				APPT_BUR3_BNKP_CNT=BANKRUPTCY_CNT;

				APPT_BUR3_CHRG_OFF_CNT=CHARGE_OFF_CNT;

				APPT_BUR3_CLS_ACC_CNT=CLOSED_ACCT_CNT;

				APPT_BUR3_COLL_DBT_AMT=COLLECTION_DEBT_AMT;

				APPT_BUR3_CR_ACT_DT=CREDIT_ACTIVE_DT;

				APPT_BUR3_CSS_CD=BUREAU_CLASS_CD;

				APPT_BUR3_CURR_ACC_CNT=(OPEN_ACCT_CNT-CLOSED_ACCT_CNT);

				APPT_BUR3_CURR_CR_PCT=CURRENT_CREDIT_PCT;

				APPT_BUR3_CURR_LMT_AMT=CURRENT_CREDIT_LIMIT_AMT;

				APPT_BUR3_DGTRY_ACC_CNT=DEROGATORY_ACCT_CNT;

				APPT_BUR3_DLQ_ACC_CNT=DELINQUENT_ACCT_CNT;

				APPT_BUR3_EVR_COLL_FLG=EVER_IN_COLLECTION_FLG;

				APPT_BUR3_FRD_FLG=FRAUD_FLG;

				APPT_BUR3_GD_ACC_CNT=GOOD_ACCT_CNT;

				APPT_BUR3_HST_CR_LMT_AMT=HIGHEST_CREDIT_LIMIT_AMT;

				APPT_BUR3_INST_DBT_AMT=INSTALLMENT_DEBT_AMT;

				APPT_BUR3_JUDG_CNT=JUDGEMENTS_CNT;

				APPT_BUR3_LIEN_CNT=LIENS_CNT;

				APPT_BUR3_LST_BNKP_CD=BANKRUPTCY_STATUS_CD;

				APPT_BUR3_LST_BNKP_DT=BANKRUPTCY_FILED_DT;

				APPT_BUR3_LST_JUDG_DT=LAST_JUDGEMENT_DT;

				APPT_BUR3_LST_LIEN_DT=LAST_LIEN_DT;

				APPT_BUR3_MTH_CNT=MONTHS_SINCE_AT_BUREAU;

				APPT_BUR3_OPN_ACC_CNT=OPEN_ACCT_CNT;

				APPT_BUR3_OTH_DBT_AMT=OTHER_DEBT_AMT;

				APPT_BUR3_OTH_INQ_CNT=APPT_BUR3_OTH_INQ_CNT;

				APPT_BUR3_OTH_LST_INQ_DT=OTHER_LAST_INQUIRY_DT;

				APPT_BUR3_PDUE_30D_AMT=TOT_PAST_DUE_SLOW_30_AMT;

				APPT_BUR3_PDUE_90D_AMT=TOT_PAST_DUE_SLOW_90_AMT;

				APPT_BUR3_PUB_REC_CNT=PUBLIC_RECORD_CNT;

				APPT_BUR3_REQ_DT=REQUEST_DT;

				APPT_BUR3_REST_DBT_AMT=REAL_ESTATE_DEBT_AMT;

				APPT_BUR3_REV_DBT_AMT=REVOLVING_DEBT_AMT;

				APPT_BUR3_SCR_DT=SCORE_DT;

				APPT_BUR3_SCR_NO=SCORE_NO;

				APPT_BUR3_TOT_BAL_AMT=TOTAL_BALANCE_AMT;

				APPT_BUR3_TOT_MTH_PAY_AMT=TOT_MTH_PAYMENT_AMT;

				APPT_BUR3_WRST_RTG_12M_NO=WORST_RATING_12_MTH_NO;

			END;

				APPLICATION_RK=FINANCIAL_APPLICATION_RK;

/*Calculating maximum and minimum score  */

			IF SCORE_NO> COALESCE(APPT_BUR_SCR_MAX_NO,min_value)  THEN 

				DO;

					   APPT_BUR_SCR_MAX_NO=SCORE_NO;

				END;

			ELSE IF SCORE_NO <COALESCE(APPT_BUR_SCR_MIN_NO,max_value) THEN

				DO;

						APPT_BUR_SCR_MIN_NO=SCORE_NO; 

				END;		



		IF LAST.APPLICANT_RK THEN

			DO;

				OUTPUT;

				/*Resetting all the retain variables.*/

 				%appt_bureau_lst_reset;

			END;



RUN;

%mend;

/*%appl_bureau_all_sr_no_abt(INPUT_TABLE=);*/

