%macro defdata(input_ds=,stat=,out_graph_ds = ,output_ds = ,out_stat_ds=);
%if &stat = 'AR' %then
	%do;
	data &out_graph_ds;
	set &input_ds;
		pool_SEQ = .;
		cum_totacc= .;
		caprespcum= .;
		cum_propRan_bads= .;
		cum_propIdealBads= .;
		cum_prop_guds =.;
		prop_bads= .;
		keep 	pool_SEQ
				cum_totacc
				caprespcum
				cum_propRan_bads
				cum_propIdealBads
				cum_prop_guds 
				prop_bads;

		run;
	data &out_stat_ds;
	AR = .;
	run; 

	%end;
%else %if &stat = 'ROC' %then
	%do;
/*I18N-scnhuh-20080420-1051*/

		data &out_graph_ds;
/*I18N-scnhuh-20080420-1051*/		
		set &input_ds;
			score= .;
			Sensitivity= .;
			Specificity1= .;
			keep score
			Sensitivity
			Specificity1;
		run;
	data &out_stat_ds;
	length _NAME_ $6.;
	length Col1 8.;
	Col1=.;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_roc.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_brrier.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_pietra.1, noquote))";
	output;
	run;
 

	%end;
%else %if &stat = 'KS' %then 
%do;
data &out_graph_ds;
		set &input_ds;
score_points = .;
Dist_good=.;
Dist_bad=.;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ks.1, noquote))=.;
keep score_points Dist_good Dist_bad 
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ks.1, noquote))
;
run;
%end;
%else %if &stat = 'Brier' %then 
%do;
data &output_ds;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_brrier.1, noquote))=.;
run;
%end;
%else %if &stat = 'Distance' %then 
%do;
data &out_stat_ds;
	length _NAME_ $6.;
	length Col1 8.;
	Col1=.;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ph.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_d.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_info.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_kl.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_roc.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ar.1, noquote))";
	output;
	_NAME_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ks.1, noquote))";
	output;
run;
%end;
%else %if &stat = 'HL' %then 
%do;
data &output_ds;
Chi_sq=.;
P_valueChisq =.;
run;
%end;
%else %if &stat = 'EventNonEv' %then 
%do;
data &out_graph_ds;
		set &input_ds;
Score_Points= .;
Prop_bads= .;
Prop_goods= .;
cum_prop_goods= .;
cum_prop_bads= .; 
keep Score_Points Prop_bads Prop_goods cum_prop_goods cum_prop_bads;
run;
%end;
%else %if &stat = 'KendSom' %then 
%do;
data &output_ds;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_kendal_tau_p_val.1, noquote))=.;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_somers_d_p_val.1, noquote))=.;  
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_kendal_tau_p_msr_val.1, noquote))=.; 
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_somers_d_p_msr_val.1, noquote))=.; 
run;
%end;
%else %if &stat = 'PD_Def' %then 
%do;
data &output_ds;
set &input_ds;
Pool_Name = .;
Pool_Seq= .;
No_Of_ACC_Actual= .;
No_of_Acc_Dev= .;
PD= .;
Score_Points= .;
No_Of_Actual_Bads= .;
ObsPD= .;
Ratio= .;
keep Pool_Name Pool_Seq No_Of_ACC_Actual No_of_Acc_Dev PD Score_Points No_Of_Actual_Bads ObsPD Ratio;
run;
%end;
%else %if &stat = 'Lift' %then 
%do;
data &out_graph_ds;
set &input_ds;
Pool_Seq=.;
cum_totacc=.;
Lift=.;
base=.;
ideal=.;
keep Pool_Seq cum_totacc Lift base ideal ;
run;
%end;
%else %if &stat = 'Bin' %then 
%do;
data &output_ds;
set &input_ds;
pool_seq=.;
pd=.;
No_Of_ACC_Actual=.;
No_Of_Actual_Bads=.;
BClow=.;
BChigh=.;
Traffic=.;
keep pool_seq pd No_Of_ACC_Actual No_Of_Actual_Bads BClow BChigh Traffic ;
run;
%end;
%else %if &stat = 'Norm' %then 
%do;
data &output_ds;
set &input_ds;
pool_seq=.;
NClow=.;
NChigh=.;
Zcalc=.;
Traffic=.;
keep pool_seq NClow NChigh Zcalc Traffic ;
run;
%end;
%else %if &stat = 'Traffic' %then 
%do;
data &output_ds;
set &input_ds;
pool_seq=.;
TClow=.;
TChigh=.;
Traffic=.;
pd=.;
No_Of_ACC_Actual=.;
No_Of_Actual_Bads=.;

keep pool_seq pd No_Of_ACC_Actual No_Of_Actual_Bads TClow TChigh Traffic ;
run;
%end;
%else %if &stat = 'Inter' %then 
%do;
data &output_ds;
	length Measure_nm $6.;
	length Col1 8.;
	Col1=.;
	Grade = .;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ph.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_d.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_info.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_kl.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_roc.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ar.1, noquote))";
	output;
	Measure_nm="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ks.1, noquote))";
	output;
run;
%end;
%else %if &stat = 'MAPE' %then 
%do;
data &output_ds;
MAPE=.;
run;
%end;
%else %if &stat = 'CHISQ' %then 
%do;
data &output_ds;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_chi_sq.1, noquote))=.;
%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_chi_sq_p.1, noquote)) =.;
run;
%end;
%else %if &stat = 'CORR' %then 
%do;
data &output_ds;
    length _TYPE_ $6.;
	length measure_value 8.;
	measure_value=.;
	_TYPE_="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_corr.1, noquote))";
	output;
run;
%end;
%else %if &stat = 'ERRMEA' %then 
%do;
data &output_ds;
    MSE = .;
	MAD =.;
run;
%end;
%else %if &stat = 'PDCI' %then 
%do;
data &output_ds;
set &input_ds;
Pool_name = "";
PD = .;
ActualPD=.;
No_of_Acc =.;
Pool_Seq = .;
    attrib
/*I18N-scnjih-20080418-0907*/

/*	PD  		label = "Esimated PD"*/
/*	ActualPD	label = "Default Rate"*/
/*	No_of_Acc   label = "No. of Accounts"*/
/*	Pool_name	label = "Pool Name"*/
/*	Pool_Seq	label = "Pool Sequence"*/
/*	;*/

	PD  		label ="%sysfunc(sasmsg(smd_ds.bismsg,defdata.sas.1, noquote))"
	ActualPD	label = "%sysfunc(sasmsg(smd_ds.bismsg,defdata.sas.2, noquote))"
	No_of_Acc   label =  "%sysfunc(sasmsg(smd_ds.bismsg,defdata.sas.3, noquote))"
	Pool_name	label = "%sysfunc(sasmsg(smd_ds.bismsg,defdata.sas.4, noquote))"
	Pool_Seq	label =  "%sysfunc(sasmsg(smd_ds.bismsg,defdata.sas.5, noquote))"
	;
/*I18N-scnjih-20080418-0907*/
run;
%end;
%else %if &stat = 'GINI' %then 
%do;
data &output_ds;
set &input_ds;
Gini = .;
keep Var_Name Attr_Name gini;
run;
%end;
%else %if &stat = 'Getchi' %then 
%do;
proc sql;
create table &output_ds as select distinct(put(Var_Name,$20.)) as Var_Name from &input_ds;
quit;
data &output_ds;
set &output_ds;
p_value =.;
run;
%end;
%else %if &stat = 'infowoe' %then 
%do;
data &output_ds;
set &input_ds;
WOE =.;
infoval =.;
keep Var_Name Attr_Name WOE infoval;
run;
%end;
%else %if &stat = 'report_Info_Woe' %then 
%do;
data &output_ds;
set &input_ds;
WOE =.;
infoval =.;
WOE_Diff = .;
keep Var_Name Attr_Name WOE infoval WOE_Diff;
run;
%end;
%else %if &stat = "ConfAR" %then 
%do;
data &output_ds;
    length NAME $6.;
	Mid_Pt=.;
	CI_low=.;
	CI_high =.;
	NAME="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_ar.1, noquote))";
	output;
run;
%end;
%else %if &stat = "ConfAUC" %then 
%do;
data &output_ds;
    length NAME $6.;
	Mid_Pt=.;
	CI_low=.;
	CI_high =.;
	NAME="%sysfunc(sasmsg(smd_ds.bismsg,crs.measure_nm.measure_nm_roc.1, noquote))";
	output;
run;
%end;

%mend defdata;
