%global category scat;
/* Alias for the back-end library */
%let lib=analytic;

/* Links to the various ABT variable selection screens are set through the
following macro */
%select_abt_vars_screen_links;

/* Setting output library based on the debug flag */
%let out_lib=;
%let vcnt=0;
%debug_lib_path;

proc sql;
create table &out_lib..vartable as
select v_no, var_nm, var_short_nm, var_desc from &lib..var_master 
where ktrim(kleft(var_category))=ktrim(kleft("&category"))
/*where ktrim(kleft(var_category))=ktrim(kleft("²㋔"))*/
and ktrim(kleft(var_sub_category))=ktrim(kleft("&scat"))
and is_deleted is missing
order by var_category, var_sub_category;

select count(*) into :vcnt from &out_lib..vartable;
quit;

%macro displayvars;
%if "&category" eq "" %then %do; /*If the page is loading for the first time display it as blank */
data _null_;
	file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	  /*I18N-scnjih-20080429-1543*/
	/*put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
		put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
		put "%sysfunc(sasmsg(smd_ds.bismsg,title_of_layout.1, noquote))"@;
		put '</title><!-- InstanceEndEditable -->';
	
	 /*I18N-scnjih-20080429-1543*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';
	
	put '<style type="text/css">';
	put 'body {background-color: #faf8ed}';
	put '</style>';

	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/script/action_menu.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/overlib.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/scripts.js"></script>';
	put '    <script type="text/javascript">';

	put '</script>';
	put '</head>';
	put '<body>';

	put '<table id="dashtable" width="100%" cellpadding="0" cellspacing="0"><tr><td>';
	put '<div class="section" id="Introduction">';
	put '<div class="sectionheader" id="Introduction">';
	put '<div class="sectionheadertext">';
	put '<a href="javascript:expand_collapse(''sectionbody_Introduction'',''section_expcol_img_Introduction'');">'; 
	put '<img id="section_expcol_img_Introduction" src="/SASABTFramework/images/expand_plus.gif" border="0" hspace="0" vspace="0" title="maximize" alt="maximize" /></a>'; 
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introduction.1, noquote))"@;
	put '</div>';
	put '<div class="sectionheaderbuttons">';
	put '</div>';
	put '</div>';
	put '<div class="sectionbody" align="left" id="sectionbody_Introduction" style=''display:none''">';
	/* Display the text for introduction */
	put '<H2 align="left"><table width="100%"  border="0" cellspacing="0" cellpadding="0">';
	put '<tr><td></td>';
	put '</tr></table></H2>';

	put '<p>&nbsp;</p>';
	put '<p class="LabelFont">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline1.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline2.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline3.1, noquote))"@;
	put '</p>';

	put '<p class="LabelFont">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline4.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline5.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline6.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline7.1, noquote))"@;
	put '</p>';

	put '<p class="LabelFont">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline8.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline9.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline10.1, noquote))"@;
	put " "@;
	put '<p class="LabelFont"><H3>';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline11.1, noquote))"@;
	put '</H3></p>';

	put '<p class="LabelFont">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline12.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline13.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline14.1, noquote))"@;
	put '</p>';

	put '<UL class="LabelFont">';
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline15.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline16.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline17.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline18.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline19.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline20.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline21.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline22.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline23.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline24.1, noquote))"@;
	put " "@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline25.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline26.1, noquote))"@;
	put " "@;
	put '<LI>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_introline27.1, noquote))"@;
	put '</UL>';

	put '</tr> ';
	put '</table> ';
	/* end of displaying introduction text */
	put '</div></div></td></tr></table>';

	put '<table class="tableview" border="0">';
	put '<tr>';
	put '<td class="tabletextcol">' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_mdlmonlink.1, noquote))"@;
	put '</td>';
	put "</tr><tr><td class=""tabletextcol""><a href='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?_program=SBIP://Foundation/BIS/common/reporting'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_mdlmonhd.1, noquote))"@;
	put '</a></td></tr>';
	put '</table>';
	put '</body>';
	put '</html>';
run;
%end;
%else %do;
data _null_;
	file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';
	put '<style type="text/css">';
	put 'body {background-color: #faf8ed}';
	put '</style>';
	/* External scripts */
	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/script/action_menu.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/overlib.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/scripts.js"></script>';
	put '    <script type="text/javascript">';
	put '    <!--';

	put 'function Add() {';
	put "form1._program.value=&ADD_VAR";
	put 'form1.submit();';
	put '}';

	put 'function Edit() {';
	put 'if (form1.varlist.checked==true)'; /* for exactly 1 abt */
	put '{';
	put '	form1.strvkey.value = form1.varlist.value;';
	put '}';
	put 'for(var i=0; i<form1.varlist.length; i++){';
	put 'if(form1.varlist[i].checked == true){';
	put '	form1.strvkey.value = form1.varlist[i].value;';
	put '}';
	put '}';
	put "form1._program.value=&EDIT_VAR";
	put 'form1.submit();';
	put '}';

	put 'function Delete() {';
	put 'if (form1.varlist.checked==true)'; /* for exactly 1 abt */
	put '{';
	put '	form1.strvkey.value = form1.varlist.value;';
	put '}';
	put 'else';
	put '{';
	put 'form1.strvname.value="";';
	put 'for(var i=0; i<form1.varlist.length; i++){';
	put '	if(form1.varlist[i].checked == true){';
	put "		form1.strvkey.value = form1.strvkey.value + form1.varlist[i].value + '#' ;";
	put "		form1.strvname.value = form1.strvname.value + form1.vnames[i].value + '\n' ;";
	put '	}';
	put '  }';
	put '}';
	put 'var r=confirm("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_cnfdel.1, noquote))"@;
	put '"'@;
	put '+form1.strvname.value'@;
	put ');';
	put 'if (r==false){';
	put '	return;';
	put '}';
	put "form1._program.value=&DELETE_VAR";
	put 'form1.submit();';
	put '}';	
	
	put 'function selall(obj)';
	put '{';
	put 'if (obj.checked==true)';
	put '{';
		put 'for(var i=0;i<form1.varlist.length;i++)';
		put 'form1.varlist[i].checked=true';
	put '}';
	put 'else';
	put '{';
		put 'for(var i=0;i<form1.varlist.length;i++)';
		put 'form1.varlist[i].checked=false';
	put '}';
	put '}';

	put 'function menu() {';
	put 'var menu = new TableMenu();';
	put 'var c=0;';
		put 'for(var i=0;i<form1.varlist.length;i++){';
		put 'if(form1.varlist[i].checked==true)';
		put 'c=c+1;}';
	put 'if(form1.varlist.checked==true)';
		put 'c=1;';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"/SASABTFramework/images/Add.gif", "'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_addmenu.1, noquote))"@;
	put '", "javascript:Add()"));';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));';
	put 'if (c==1)';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"/SASABTFramework/images/edit.gif", "'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_editmenu.1, noquote))"@;
	put '", "javascript:Edit()"));';
	put 'else';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.disabled, "","'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_editmenu.1, noquote))"@;
	put '", ""));';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.separator));';
	put 'if (c>0)';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.action,"/SASABTFramework/images/DeleteRed.gif", "'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_delmenu.1, noquote))"@;
	put '", "javascript:Delete()"));';
	put 'else';
	put 'menu.addMenuItem(new MenuItem(MenuItem.prototype.disabled, "","'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_delmenu.1, noquote))"@;
	put '", ""));';
	put 'menu.render();';
	put '}';

	put '    -->';
	put '    </script>';
	put '  </head>';
	put '  <body>';

	put '<form name="form1" action="/SASStoredProcess/do" method="post">';
	put '<input type="hidden" name="_program" value="">';
	
	put '<table border="0"><tr><td></td><td>';
	put '<table class="tableview" cellpadding="0">';
	put '<tr>';
	put "<th class=""tabletextcol"">"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.var_category.1, noquote))"@;
	put "</th><td class=""tabletextcol"">&category</td>";
	put '</tr><tr>';
	put "<th class=""tabletextcol"">"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.var_subcategory.1, noquote))"@;
	put "</th><td class=""tabletextcol"">&scat</td>";
	put '</tr>';
	put '</table>';
	put '</td>';
	put '<td></td></table>';

	/* Table displaying the variables */
	put '<table border="0" width="100%"><tr><td></td><td>';
	put '<table border="0" cellpadding="0" cellspacing="0" summary="" class="tableview" width="100%"><tr valign="top">';

	/* Table headings */
	put '<tr>';	
	put '	<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_variable_name.1, noquote))"@;
	put '	</th>';
	put '	<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_variable_short_name.1, noquote))"@;
	put '	</th>';
	put '	<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.disp_var_variable_desc.1, noquote))"@;
	put '	</th>';
	put '	<th class="tabletextcol" width="7%">';
	put '	<table>';
	if &vcnt > 1 then do;
		put '	<tr><td align="center"><a href="#" onclick="menu();return false;"><img src="/SASABTFramework/images/ActionMenu.gif" style="border:0"/></a></td></tr>';
		put '	<tr><td align="center"><input type="checkbox" name="selvar" onclick="selall(this);"></td></tr>';	
	end;
	if &vcnt eq 1 then do;
		put '	<tr><td align="center"><a href="#" onclick="menu();return false;"><img src="/SASABTFramework/images/ActionMenu.gif" style="border:0"/></a></td></tr>';
		put '	<tr><td align="center"><input type="checkbox" name="selvar" disabled></td></tr>';	
	end;
	put '	</table>';
	put '	</th>';
	put '   </tr>';
run;

data _NULL_;
	file _webout &webout_options;
	set &out_lib..vartable;

	/* This alternates the row color. */
	if mod(_N_,2)=0 then do;
		put '<tr class="tableevenrow" tr valign="top"> ';
	end;
	else do;
		put '<tr class="tableoddrow" tr valign="top"> ';
	end;
	
	put '<td class="tabletextcol">'@;
	put var_nm@;
	put '</td>';
	put '<td class="tabletextcol">'@;
	put var_short_nm@;
	put '</td>';
	put '<td class="tabletextcol">'@;
	put var_desc@;
	put '</td>';
	put '<td align="center">'@;
	put '<input type="checkbox" name="varlist" value='@;
	put v_no@;
	put '>';
	put '<input type="hidden" name="vnames" value="'@;
	put var_nm@;
	put '">';
	put '</td>';
	put '</tr>';
run;

/* Finish up. */
data _null_;
	file _webout &webout_options;
    put '                </table>';
	put '</td><td></td></tr></table>';
	put '<br>';
	c=symget('category');
	x1 = '<input type="hidden" name="category" value="'||c||'">';
	put x1;
	
	sc=symget('scat');
	x2 = '<input type="hidden" name="scat" value="'||sc||'">';
	put x2;

	put '<input type="hidden" name="strvkey" value="">';
	put '<input type="hidden" name="strvname" value="">';

    put '        </form>';
    put '  </body>';
	put '  <!-- InstanceEnd -->';
	put '</html>';
run;
%end;
%mend displayvars;
%displayvars;
