%global vname vshortname vdesc vgroup aggtab aggvar aggtkey level category scat
	table_cat table_key lftflg noofjobs;

%let lib=analytic;

%select_abt_vars_screen_links;

%macro globalvars;
%do c=1 %to &noofjobs;
	%global jobname&c;
	%global joblevel&c;	
	%global chjobs&c;	
	%global chjobs&c.1;
	%global chjobs&c.2;
	%global chjobs&c.3;
	%global chjobs&c.4;
	%global chjobs&c.5;
	%global jflag&c;
%end;
%do c=1 %to &noofjobs;	
	%global cj&c.1;
	%global cj&c.2;
	%global cj&c.3;
	%global cj&c.4;
	%global cj&c.5;
	%let cj&c.1=&&chjobs&c.1;
	%let cj&c.2=&&chjobs&c.2;
	%let cj&c.3=&&chjobs&c.3;
	%let cj&c.4=&&chjobs&c.4;
	%let cj&c.5=&&chjobs&c.5;
%end;
%mend globalvars;
%globalvars;

/* Alias for the back-end library */
%let lib=analytic;
%let chkvname=;
%let chkinactvname=;
%let message=;
%let prog_name=;

%select_abt_vars_screen_links;

%macro saveaddvar;
proc sql;
select count(*) into :chkvname 
from &lib..var_master 
where kupcase(var_nm) = kupcase("&vname") and is_deleted is missing;

select count(*) into :chkinactvname 
from &lib..var_master 
where kupcase(var_nm) = kupcase("&vname") and is_deleted = 'Y';
quit;

%if %str(&chkvname) eq %str(0) %then %do;
	proc sql;
	select max(v_no) into :VNUM from &lib..var_master where v_no between 80001 and 90000;
	quit;

	%if %str(&VNUM) = %str(.) %then 
		%let VNUM = 80001;
	%else
		%let VNUM = %eval(&VNUM + 1);

	proc sql UNDO_POLICY=REQUIRED;
	insert into &lib..var_master 
	(V_NO,VAR_CATEGORY,VAR_SUB_CATEGORY,VAR_GROUP,VAR_NM,VAR_SHORT_NM,VAR_DESC,AGG_TABLE_NM,
	AGG_VAR_NM,AGG_TABLE_KEY,L_NO)
	values
	(&VNUM,
	"&category",
	"&scat",
	"&vgroup",
	"&vname",
	"&vshortname",
	"&vdesc",
	"&aggtab",
	"&aggvar",
	"&aggtkey",
	&level);
	quit;

	proc sql UNDO_POLICY=REQUIRED;
	insert into &lib..var_table (VAR_TABLE_NM,TABLE_CATEGORY,TABLE_KEY,IS_LEFT_TABLE)
	values
	("&aggtab","&table_cat","&table_key","&lftflg");
	quit;

	proc sql UNDO_POLICY=REQUIRED;
	%do c=1 %to &noofjobs;
		%let jobname&c = &&jobname&c;
		%if "&&jflag&c" eq "Y" %then %do;	
				insert into &lib..table_x_job (VAR_TABLE_NM,JOB_NM)
				values
				("&aggtab","&&jobname&c...sas");
		%end;
	%end;
	quit;
	
	%do c=1 %to &noofjobs;	
		%if "&&jflag&c" eq "Y" %then 
		%do;
			%do i=1 %to 5;
				%loop1:
					%do j= %eval(&i+1) %to 5;
						%if "&&cj&c&i" eq "" and "&&cj&c&j" ne "" %then 
						%do;
							%let cj&c&i = &&cj&c&j;
							%let cj&c&j=;
							%goto loop1;
   						%end;	
 					%end;
			%end;
		%end;
	%end;
	proc sql UNDO_POLICY=REQUIRED;
      %let childjob=;
      %do c=1 %to &noofjobs;
            %if "&&jflag&c" eq "Y" %then 
                  %do;
                        %let childjob&c.1 = &&cj&c.1;
                        %let childjob&c.2 = &&cj&c.2;
                        %let childjob&c.3 = &&cj&c.3;
                        %let childjob&c.4 = &&cj&c.4;
                        %let childjob&c.5 = &&cj&c.5;

                  %if %str("&&childjob&c.1") ne %str("") and %str("&&childjob&c.2") eq %str("") 
                  and %str("&&childjob&c.3") eq %str("") and %str("&&childjob&c.4") eq %str("")
                  and %str("&&childjob&c.5") eq %str("") %then
                              %let childjob = %str(%'&&childjob&c.1..sas%');
                  %else %if %str("&&childjob&c.1") ne %str("") and %str("&&childjob&c.2") ne %str("")
                          and %str("&&childjob&c.3") eq %str("") and %str("&&childjob&c.4") eq %str("") 
                          and %str("&&childjob&c.5") eq %str("") %then
                              %let childjob = %str(%'&&childjob&c.1..sas%',%'&&childjob&c.2..sas%');
                  %else %if %str("&&childjob&c.1") ne %str("") and %str("&&childjob&c.2") ne %str("")
                          and %str("&&childjob&c.3") ne %str("") and %str("&&childjob&c.4") eq %str("") 
                          and %str("&&childjob&c.5") eq %str("") %then
                              %let childjob = %str(%'&&childjob&c.1..sas%',%'&&childjob&c.2..sas%',%'&&childjob&c.3..sas%');
                  %else %if %str("&&childjob&c.1") ne %str("") and %str("&&childjob&c.2") ne %str("")
                          and %str("&&childjob&c.3") ne %str("") and %str("&&childjob&c.4") ne %str("") 
                          and %str("&&childjob&c.5") eq %str("") %then
                              %let childjob = %str(%'&&childjob&c.1..sas%',%'&&childjob&c.2..sas%',%'&&childjob&c.3..sas%',%'&&childjob&c.4..sas%');
                  %else %if %str("&&childjob&c.1") ne %str("") and %str("&&childjob&c.2") ne %str("")
                          and %str("&&childjob&c.3") ne %str("") and %str("&&childjob&c.4") ne %str("") 
                          and %str("&&childjob&c.5") ne %str("") %then

                          %let childjob = %str(%'&&childjob&c.1..sas%',%'&&childjob&c.2..sas%',%'&&childjob&c.3..sas%',%'&&childjob&c.4..sas%',%'&&childjob&c.5..sas%');
               
                  %let jobname&c = &&jobname&c;
                  %let joblevel&c = &&joblevel&c;

                        insert into &lib..job_x_level (JOB_NM,JOB_LEVEL_NO,CHILD_JOBS)
                        values("&&jobname&c",&&joblevel&c,"&childjob");
            %end;
      %end;
quit;


		 /*I18N-scnjih-20080421-1423*/
/*	%let message = New variable added;*/
	%let message = %sysfunc(sasmsg(smd_ds.bismsg,save_add_var.sas.1, noquote));
		 /*I18N-scnjih-20080421-1423*/
	%let prog_name = &DISPLAY_VAR;
%end;
%else %if %str(&chkinactvname) ne %str(0) %then %do;
		 /*I18N-scnjih-20080421-1423*/
/*	%let message = The variable is already available and in Inactive Mode. To activate please contact system administrator;*/
	%let message = %sysfunc(sasmsg(smd_ds.bismsg,save_add_var.sas.2, noquote));
			 /*I18N-scnjih-20080421-1423*/
	%let prog_name = &ADD_VAR;
%end;
%else %do;
		 /*I18N-scnjih-20080421-1423*/
/*	%let message = Duplicate variable names not allowed;*/
	%let message = %sysfunc(sasmsg(smd_ds.bismsg,save_add_var.sas.3, noquote));
		/*I18N-scnjih-20080421-1423*/
	%let prog_name = &ADD_VAR;
%end;
%mend saveaddvar;
%saveaddvar;

data _null_;
file _webout &webout_options;
put '<HTML>';
put '<BODY>';
put '<form name="form1" action="/SASStoredProcess/do" method="post">';
put '<input type="hidden" name="_program" value="">';
put "<input type='hidden' name='category' value=""&category"">";
put "<input type='hidden' name='scat' value=""&scat"">";
put "<input type='hidden' name='vname' value=""&vname"">";
put "<input type='hidden' name='vshortname' value=""&vshortname"">";
put "<input type='hidden' name='vdesc' value=""&vdesc"">";
put "<input type='hidden' name='vgroup' value=""&vgroup"">";
put "<input type='hidden' name='aggtab' value=""&aggtab"">";
put "<input type='hidden' name='aggvar' value=""&aggvar"">";
put "<input type='hidden' name='aggtkey' value=""&aggtkey"">";
put "<input type='hidden' name='level' value=""&level"">";
put "<input type='hidden' name='table_cat' value=""&table_cat"">";
put "<input type='hidden' name='table_key' value=""&table_key"">";
put "<input type='hidden' name='lftflg' value=""&lftflg"">";
run;

%macro jobdtlcapture;
data _null_;
file _webout &webout_options;
%do i=1 %to &noofjobs;
	put '<input type="hidden" name="jobname'@;
	put "&i"@;
	put '" value="'@;
	put "&&jobname&i"@;
	put '">';
	put '<input type="hidden" name="joblevel'@;
	put "&i"@;
	put '" value="'@;
	put "&&joblevel&i"@;
	put '">';
	put '<input type="hidden" name="jflag'@;
	put "&i"@;
	put '" value="'@;
	put "&&jflag&i"@;
	put '">';
	%do j=1 %to 5;
		put '<input type="hidden" name="chjobs'@;
		put "&i.&j"@;
		put '" value="'@;
		put "&&chjobs&i&j"@;
		put '">';
	%end;	
%end;
run;
%mend jobdtlcapture;
%jobdtlcapture;

data _null_;
file _webout &webout_options;	    
put '<SCRIPT>';
put 'alert("'@;
put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_msg.1, noquote))"@;
put '")';
put "form1._program.value=&prog_name";
put 'form1.submit();';
put '</SCRIPT>';
put '</BODY>';
put '</HTML>';
run;
