%global first_load amload mid;
%let first_load=&first_load;
%let amload=&amload;
/* Getting the repository id */
libname dds 'Data/bisdata/dds';
libname SCRATCH 'Data/bisdata/scratch';
%macro chk;
%if "&first_load" ne "N" %then %do; /* page is loaded for the first time */
	filename repfile 'Data/bisdata/xmlmap/rep.xml';
	proc metadata
	IN = "<GetRepositories>
		<Repositories/>
		<Flags>0</Flags>
		<Options/>
		</GetRepositories>"
	OUT = repfile;
	run;

	/*The following 2 lines need xml map to be created */
	filename repmap 'Data/bisdata/xmlmap/repmap.map';
	libname repfile xml xmlmap=repmap access=READONLY;

	proc sql;
	select id into :reposid from repfile.repository;
	quit;

	/* creating the table metadata string */
	data _null_;
	Table_Metadata_String = "'<GetMetadataObjects><Reposid>" ||  "&reposid." || '</Reposid>
						<Type>MiningResult</Type>
						<Objects/>
						<NS>SAS</NS>
	                    <Flags>392</Flags>
						</GetMetadataObjects>''';
	call symput("Table_Metadata_String", Table_Metadata_String);
	run;

	filename minres 'Data/bisdata/xmlmap/Minres.xml';
	proc metadata
	IN=&Table_Metadata_String.
	out=minres;
	run;

	/*The following 2 lines need xml map to be created */
	filename fminres 'Data/bisdata/xmlmap/minres.map';
	libname minres xml xmlmap=fminres access=READONLY;

	data work.test;
	set minres.miningresult;
	run;	

	proc sql;
	create table SCRATCH.pre_am 
	(model_id char(32),
 	model_nm char(40),
 	model_desc char(250),
 	model_creation_dt num);
	quit;

	proc sql;
	insert into SCRATCH.pre_am
	select * from work.test;
	quit;

	proc sql;
	delete from SCRATCH.pre_am where ktrim(kleft(model_id)) in 
	(select ktrim(kleft(model_id)) from dds.analytical_model);
	quit;
%end;
%mend chk;
%chk;

%let lib=analytic;

%select_abt_vars_screen_links;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

%let mname=;
%let mdesc=;
%let mcdate=0;
proc sql;
select model_nm, model_desc, model_creation_dt into :mname, :mdesc, :mcdate
from scratch.pre_am 
where model_id = strip("&mid");
quit;

/* check if the dataset has data. If yes then this should be inserted into the ANALYTICAL_MODEL
DDS table. The other fields in this table should be populated using the front end. */

data _null_;
file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
  /*I18N-scnjih-20080429-1540*/
	/*put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
		put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
		put "%sysfunc(sasmsg(smd_ds.bismsg,title_of_layout.1, noquote))"@;
		put '</title><!-- InstanceEndEditable -->';
	
	 /*I18N-scnjih-20080429-1540*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';

	put '<style type="text/css">';
	put 'body {background-color: #faf8ed}';
	put '</style>';

	/* External scripts */
	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '	 <script language="JavaScript" src="/SASABTFramework/javascript/editable_combo.js"></script>';
	put '    <script type="text/javascript">';
	put '    <!--';

	put 'function validate_tabcol(obj,evt)';
	put '{';
	put 'var e = event || evt;';
	put 'var charCode = e.which || e.keyCode;';
	put 'if (charCode != 95 && (charCode < 48 || charCode > 57) && (charCode < 97 || charCode > 122) && (charCode < 65 || charCode > 90))';
	put '{';
		put '	return false;';
	put '}';
	put 'return true;';
	put '}';

	put 'function onlyNumbers(evt)';
	put '{';
	put 'var e = event || evt; // for trans-browser compatibility';
	put 'var charCode = e.which || e.keyCode;';
	put 'if (charCode > 31 && (charCode < 48 || charCode > 57))';
	put '	return false;';
	put 'return true;';
	put '}';

	put 'function chkchars(obj)';
	put '{';
	put 'if(obj=="")';
	put '{';
	put 'alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_prvdval.1, noquote))"@;
	put '");';
	put 'return false;';	
	put '}';
	put 'if((obj.charCodeAt(0)>=48 && obj.charCodeAt(0)<=57)&&(obj.charCodeAt(0)!=95)'@;
	put '&& (obj.charCodeAt(0)<97||obj.charCodeAt(0)>122) && (obj.charCodeAt(0)<65||obj.charCodeAt(0)>90))';
	put '{' @ ;
	put 'alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgnumbeg.1, noquote))"@;
	put '");';
	put 'return false;' @ ;
	put '}';
	put 'for(var i=1;i<obj.length;i++)';
	put '{';
	put 'if(obj.charCodeAt(i)!=95 && (obj.charCodeAt(i)<48||obj.charCodeAt(i)>57)'@;
	put '&& (obj.charCodeAt(i)<97||obj.charCodeAt(i)>122) && (obj.charCodeAt(i)<65||obj.charCodeAt(i)>90))';	
	put '{';
	put 'alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgspchrs.1, noquote))"@;
	put '");';
	put 'return false;';
	put '}';
	put '}';
	put '}';
	
	put 'function Save()';	
	put '{';
	put 'if(chkchars(form1.verno.value)==false)';
		put 'return;';
	put 'else if(chkchars(form1.mdep.value)==false)';
		put 'return;';
	put 'else if(chkchars(form1.mtype.value)==false)';
		put 'return;';
	put 'else if(chkchars(form1.mptype.value)==false)';
		put 'return;';
	put 'else';
	put '{';
	put 'form1.first_load.value="N";';
	put "form1._program.value=&SAVE_AM;";
	put "form1.amload.value='Y'";
	put 'document.getElementById("save").disabled=true;';
	put 'document.getElementById("cancel").disabled=true;';
	put 'form1.submit();';
	put 'document.getElementById("save").disabled=false;';
	put 'document.getElementById("cancel").disabled=false;';
	put '}';
	put '}';

	put 'function Cancel()';	
	put '{';
	put "form1._program.value=&TEMPLATE_LIST;";
	put 'form1.submit();';
	put '}';

	put 'function load()';
	put '{';
		put 'if(document.getElementById("mid").length==1)';
		put '{';
			put 'alert("' @ ;
			put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_nomodels.1, noquote))"@;
			put '");';
			put 'document.getElementById("save").disabled=true;';
		put '}';
	put '}';

	put 'function changemid()';
	put '{';
		put "form1._program.value=&POP_AM;";
		put 'form1.submit();';
	put '}';
		
	put '    -->';
	put '    </script>';
	put '  </head>';
	put '  <body onload="load()">';

	put '<form name="form1" action="/SASStoredProcess/do" method="post">';
	put '<input type="hidden" name="_program" value="">';
	put '<input type="hidden" name="first_load">';
	put "<input type=""hidden"" name=""amload"" value=""&amload"">";

	put '<table class="tableview" width="100%" border="0" cellpadding="0" cellspacing="0">';
	put '<tr><th class="tableheader">' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_capmodinfo.1, noquote))"@;
	put '</th></tr>';
	put '</table>';
	put '<br>';

	put '<table class="tableview" width="100%" border="0" cellpadding="1" cellspacing="0">';
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modelname.1, noquote))"@;	
	put ':'@;
	put '</b></td>'@;
	put '<td><select id="mid" name="mid" style="width:200px" onChange="changemid()">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modelname.1, noquote))"@;
	put '</option>';
run;

data _null_;
file _webout &webout_options;
set SCRATCH.pre_am;
	if model_id = "&mid" then do;
		put '<option selected="selected" value='@; put model_id@; put '>'@;
	end;
	else do;	
		put '<option value=' @ ;put model_id@; put '>'@;
	end;
		put model_nm@;
	put '</option>';
run;

data _null_;
file _webout &webout_options;
	put '</select></td></tr>';
run;

data _null_;
file _webout &webout_options;
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modeldesc.1, noquote))"@;
	put '</b></td>';
	put "<td><input type='text' name='mdesc' style='width:200px' value=""&mdesc"" readonly=true></td></tr>";
	put '<tr class="tableevenrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modelcrdt.1, noquote))"@;
	put '</b></td>';
	if &mcdate ne 0 then
		d=put(&mcdate,NLDATM.);
	put "<td><input type='text' name='mcdate' style='width:200px' value="""@;
	put d@;
	put '" readonly=true></td></tr>';

	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_verno.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="verno" style="width:200px" value="" maxlength="20" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableevenrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_moddepcd.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="mdep" style="width:200px" value="" maxlength="3" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modtypecd.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="mtype" style="width:200px" value="" maxlength="3" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableevenrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_modprodtypecd.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="mptype" style="width:200px" value="" maxlength="3" onkeypress="return validate_tabcol(this);"></td></tr>';
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_tgtpermcnt.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="tpmcnt" style="width:200px" value="" onkeypress="return onlyNumbers();"></td></tr>';
	put '<tr class="tableevenrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_cutoffscrno.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="cosn" style="width:200px" value="" onkeypress="return onlyNumbers();"></td></tr>';
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_factorrate.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="frt" style="width:200px" value="" onkeypress="return onlyNumbers();"></td></tr>';
	put '<tr class="tableevenrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_offsetrate.1, noquote))"@;
	put '</b></td>';
	put '<td><input type="text" name="ort" style="width:200px" value="" onkeypress="return onlyNumbers();"></td></tr>';
	put '<tr class="tableoddrow"><td><b>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.popam_crmaf.1, noquote))"@;
	put '</b></td>';
	put '<td><select name="craf" style="width:200px">';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.select_flag.1, noquote))"@;
	put '</option>';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.flag_yes.1, noquote))"@;
	put '</option>';
	put '<option>' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.flag_no.1, noquote))"@;
	put '</option>';
	put '</select>';
	put '</td></tr>';
	put '</table>';
	
	put '<br>';

	put '<table>';
	put '<tr>';
		put '<td><INPUT type=button id="cancel" class="mmhide_btn" onclick="javascript:Cancel();" value="' @ ;
		put "%sysfunc(sasmsg(smd_ds.bismsg,abt.cancelbttn.1, noquote))"@;
		put '"></td>';
		put '<td><INPUT type=button id="save" class="mmhide_btn" onclick="javascript:Save();" value="' @ ;
		put "%sysfunc(sasmsg(smd_ds.bismsg,abt.savebttn.1, noquote))"@;
		put '"></td>';
	put '</tr>';
	put '</table>';
	
	put '</body>';
	put '</html>';
run;
%macro call_loop;
%if "&amload" = "Y" %then %do;
	%include 'Data/bisdata/jobs/LoopABTModelJob.sas';
%end;
%mend call_loop;
%call_loop;
