libname dds 'Data/bisdata/dds';
libname SCRATCH "Data/bisdata/scratch";
%global mid verno mdep mtype mptype tpmcnt cosn frt ort craf first_load amload;
%let first_load=&first_load;
%let amload=&amload;

%select_abt_vars_screen_links;

proc sql;
select model_nm,model_desc,model_creation_dt format best20. into :mname, :mdesc, :mcdt 
from SCRATCH.pre_am
where ktrim(kleft(model_id))=ktrim(kleft("&mid"));

select max(model_rk) into :MRK from dds.analytical_model;
quit;
%macro chkmrk;
%if &MRK = . %then %let MRK=0;
%let MRK=%eval(&MRK+1);
%mend chkmrk;
%chkmrk;

proc sql;
	insert into dds.analytical_model
	set MODEL_RK = &MRK,
	VALID_FROM_DTTM = datetime(),
	VALID_TO_DTTM = '31dec4747:23:59:59'dt,
	MODEL_ID = "&mid",
	MODEL_NM = "&mname",
	VERSION_NO = "&verno",
	MODEL_CREATION_DT = datepart(&mcdt),
	MODEL_DEPLOYMENT_CD = "&mdep",
	MODEL_DESC = "&mdesc",
	MODEL_TYPE_CD = "&mtype",
	MODEL_PRODUCT_TYPE_CD = "&mptype",
	TARGET_PERIOD_MTHS_CNT = &tpmcnt,
	CUT_OFF_SCORE_NO = &cosn,
	FACTOR_RT = &frt,
	OFFSET_RT = &ort,
	EFFECTIVE_FROM_DTTM = datetime(),
	EFFECTIVE_TO_DTTM = '31dec4747:23:59:59'dt,
	CR_MITIGANT_ADJUSTED_FLG = "&craf",
	PROCESSED_DTTM = datetime();
quit;

proc sql;
delete from SCRATCH.pre_am where ktrim(kleft(model_id)) in 
(select ktrim(kleft(model_id)) from dds.analytical_model);
quit;

data _null_;
file _webout &webout_options;
put '<HTML>';
put '<BODY>';
put '<form name="form1" action="/SASStoredProcess/do" method="post">';
put '<input type="hidden" name="_program" value="">';
put "<input type=""hidden"" name=""first_load"" value=""&first_load"">";
put "<input type=""hidden"" name=""amload"" value=""&amload"">";
put '<SCRIPT>';
put "form1._program.value=&POP_AM;";
put 'form1.submit();';
put '</SCRIPT>';
put '</BODY>';
put '</HTML>';
run;
