
options nomprint;

/* Global Input Parameters */
%global scr_abt_key scr_abt_name scr_abt_desc purpose_key
purpose_desc prod_key prod_desc level_key level_desc
outcome_period out_key prev_step first_load scr_abt_table_name;

/* Start the session */
%let rc=%sysfunc(stpsrv_session(create));

/* Alias for the back-end library */
%let lib=analytic;

/* Trimming extra spaces for all input paremeters */
%let scr_abt_key=&scr_abt_key;
%let scr_abt_name=&scr_abt_name;
%let scr_abt_desc=&scr_abt_desc;
%let purpose_key=&purpose_key;
%let purpose_desc=&purpose_desc;
%let prod_key=&prod_key;
%let prod_desc=&prod_desc;
%let level_key=&level_key;
%let level_desc=&level_desc;
%let outcome_period=&outcome_period;
%let out_key=&out_key;
%let scr_abt_table_name=&scr_abt_table_name;

/* Here, copy the parameters into the session variables -- only if you are coming from the right page. */
data _null_;
	if "&prev_step" eq "0" then do;
		call symput('save_scr_abt_key', "&scr_abt_key");
		call symput('save_scr_abt_name', "&scr_abt_name");
		call symput('save_scr_abt_desc', "&scr_abt_desc");
		call symput('save_scr_purpose_key', "&purpose_key");
		call symput('save_scr_purpose_desc', "&purpose_desc");
		call symput('save_scr_prod_key', "&prod_key");
		call symput('save_scr_prod_desc', "&prod_desc");
		call symput('save_scr_level_key', "&level_key");
		call symput('save_scr_level_desc', "&level_desc");
		call symput('save_scr_abt_table_name', "&scr_abt_table_name");
	end;
run;

/* Setting default values for any required parameters */
data _null_;
	if "&purpose_key"="" then call symput('purpose_key','.');
	if "&prod_key"="" then call symput('prod_key','.');
	if "&level_key"="" then call symput('level_key','.');
run;

/* Loading macro aliases for the rest of the stored processes */
%select_abt_vars_screen_links;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

/* Start printing HTML */
data _NULL_;
	file _webout &webout_options;
	put '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"';
	put '"http://www.w3.org/TR/html4/loose.dtd">';
	put '<html>';
	put '<head>';
	put '<link href="/SASABTFramework/styles/default.css" rel="stylesheet" type="text/css"> ';
	put '<style type="text/css">';
	put '<!--';
	put 'body {';
	put '	background-color: #FAF8ED;';
	put '}';
	put '-->';
	put '</style>';

	put '<script>';
	put '<!-- ';
	/* This function is called when the Next button is clicked. */
	put 'function next()';
	put '{';	
	put 'if(chkchars(form1.scr_abt_name.value)==false)';
		put 'return;';
	put 'if(chkchars(form1.scr_abt_table_name.value)==false)';
		put 'return;';		
	put 'var x=document.getElementById("lvl");';
  	put 'form1.level_key.value=x.selectedIndex;';

	put 'if ((form1.scr_abt_name.value=='''') || (form1.scr_abt_desc.value=='''')
		 ||(form1.scr_abt_table_name.value=='''')';
	put '|| (form1.level_key.value=="0"))';	
	put '  {';
	put '    alert("'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.scr_tmplt_stp1_next.1, noquote))" @;
	put '");';
	put '  }';
	put '  else';
	put '  {';
	put "	form1._program.value=&SCR_TEMPLATE_STEP2;";
	put '   form1.submit();';
	put '  }';
	put '}';

	put 'function restrictnav()';
	put '{';
	put 'alert("'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_restrictnav.1, noquote))" @;
	put '");';
	put 'return;';
	put '}';

	/* This function is called when the cancel button is clicked */
	put 'function cancel()';
	put '{';
	put "	form1._program.value=&SCR_TEMPLATE_LIST;";
	put '	form1.submit();';
	put '}';

	put 'function chkchars(obj)';
	put '{';
	put 'if(obj.charCodeAt(0)>=48 && obj.charCodeAt(0)<=57)';
	put '{alert("'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgnumbeg.1, noquote))" @;
	put '");return false;}';
	put 'for(var i=0;i<obj.length;i++)';
	put '{';
	put 'if(obj.charCodeAt(i)!=95 && (obj.charCodeAt(i)<48||obj.charCodeAt(i)>57)'@;
	put '&& (obj.charCodeAt(i)<97||obj.charCodeAt(i)>122) && (obj.charCodeAt(i)<65||obj.charCodeAt(i)>90))';	
	put '{obj.value="";';
	put 'alert("'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.msgspchrs.1, noquote))" @;
	put '");';
	put 'return false;}';
	put '}';
	put '}';

	put 'function validate_tabcol(obj,evt)';
	put '{';
	put 'var e = event || evt;';
	put 'var charCode = e.which || e.keyCode;';
	put 'if (charCode != 95 && (charCode < 48 || charCode > 57) && (charCode < 97 || charCode > 122) && (charCode < 65 || charCode > 90))';
	put '{';
		put '	return false;';
	put '}';
	put 'return true;';
	put '}';

	put 'function validate_exchar(obj,evt)';
	put '{';
	put 'var e = event || evt;';
	put 'var charCode = e.which || e.keyCode;';
	put 'if (charCode !=32 && charCode != 95 && (charCode < 48 || charCode > 57) && (charCode < 97 || charCode > 122) && (charCode < 65 || charCode > 90))';
	put '{';
		put '	return false;';
	put '}';
	put 'return true;';
	put '}';

	put '//--> ';
	put '</script>';
	
	/* External scripts */
  	put '<script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
  	put '<script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
  	put '<script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
    
	put '</head> ';

	put '<body bgcolor="#FAF8ED">';
	put "<form name=""form1"" action=""&_THISSESSION"" method=""post"">";
	put "<input type='hidden' name='_program' value=&TEMPLATE_STEP2>";
	put '<input type="hidden" name="prev_step" value="1"/>';

	first_load=symget("first_load");
	x='<input type="hidden" name="first_load" value="'||strip(first_load)||'"/>';
	put x;


/* Hidden fields contain non-textbox form data */
	
	save_scr_purpose_key=symget("save_scr_purpose_key");
	x='<input type="hidden" name="purpose_key" value="'||strip(save_scr_purpose_key)||'">';
	put x;
	save_scr_purpose_desc=symget("save_scr_purpose_desc");
	x='<input type="hidden" name="purpose_desc" value="'||strip(save_scr_purpose_desc)||'">';
	put x;
	save_scr_prod_key=symget("save_scr_prod_key");
	x='<input type="hidden" name="prod_key" value="'||strip(save_scr_prod_key)||'">';
	put x;
	save_scr_prod_desc=symget("save_scr_prod_desc");
	x='<input type="hidden" name="prod_desc" value="'||strip(save_scr_prod_desc)||'">';
	put x;
	save_scr_level_key=symget("save_scr_level_key");
	x='<input type="hidden" name="level_key" value="'||strip(save_scr_level_key)||'">';
	put x;
	save_scr_level_desc=symget("save_scr_level_desc");
	x='<input type="hidden" name="level_desc" value="'||strip(save_scr_level_desc)||'">';
	put x;
	put '      <div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>';

	/* Banner code */
	put '      <div id="banback">';
	put '          <table id="bantabs" border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '            <tr valign="top">';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>'"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_home.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_modeling.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tabsellft"><img src="/SASABTFramework/images/tab_upper_left_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tabsellab'><a href='#'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scoring.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabselrgt"><img src="/SASABTFramework/images/tab_upper_right_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scheduling.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td width="100%">&nbsp;</td>';
	put '            </tr>';
	put '          </table>';
	put '      </div>';
	put '      <table border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '        <tr>';
	put '          <td id="butbar">';
	put '            <font color="#996600"> <b>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_create_or_edit_template.1, noquote))" @;
	put '</b>';
	put '            <span id="butfill">&nbsp;</span>';
	put '          </td>';
	put '        </tr>';
	put '      </table>';
	put '      <table border="0" cellpadding="0" cellspacing="0" summary="" width="100%" height="450">';
	put '        <tr valign="top">';
	put '          <td  id="navcel">';
	put '            <div id="navcol">';

	/* List on the left side */
	put '              <table border="0" cellspacing="0" summary="" class="mmhide_wizardsteps">';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td nowrap class="mmhide_wizardstepact"></td>';
	put '                  <td class="mmhide_wizardstepact">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.details.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td><img src="/SASABTFramework/images/blank.gif" width="16"></td>';
	put '                  <td>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.Link_scoring_to_abt_mdl.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td><img src="/SASABTFramework/images/blank.gif" width="16"></td>';
	put '                  <td>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.summary.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td>';
	put '                  </td>';
	put '                  <td><img src="/SASABTFramework/images/blank.gif" width="180" height="1"></td>';
	put '                </tr>';
	put '              </table>';
	put '            </div>';
	put '          </td>';
	put '          <td id="navwdg"><img src="/SASABTFramework/images/blank.gif" name="navwdg" border="0" width="11" height="14" hspace="0" vspace="0" alt="" /></a></td>';

	put '          <td width="100%" id="wizardmain">';

	put '            <div id="pagetitlesection">';
	put '              <div id="pagetitle">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.details.1, noquote))" @;
	put '              </div>';
	put '              <div id="pagesubtitle"><!-- InstanceBeginEditable name="pagesubtitle" -->&nbsp;<!-- InstanceEndEditable --></div>';
	put '            </div>';

	/* Start of form elements */
	put '            <div class="formfields">';
	put '              <table class="formfields" cellpadding="4" cellpadding="0" border="0" >';
	put '                <tr valign="top">';
	put '                  <td class="formfieldlabel">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_name.1, noquote))" @;
	put ':';
	put '                  </td>';
	put '                  <td class="">';
	put '                    <input type="text" style="width:200px;" name="scr_abt_name"'@;
	if "&save_scr_abt_name" eq "" then 
		put 'value=""'@;
	else	
		put "value = ""&save_scr_abt_name"""@;
	put '" maxLength="40"  class="inputtext" onkeypress="return validate_tabcol(this);"'@;
	if &save_scr_abt_key ne . then
		put ' readonly=true '@;
	put '>';
	put '                  </td>';
	put '                </tr>';
	put '                <tr valign="top">';
	put '                  <td class="formfieldlabel">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_description.1, noquote))" @;
	put ':';
	put '                  </td>';
	put '                  <td class="">';
	put '                    <input type="text" style="width:200px;" name="scr_abt_desc"'@;
	if "&save_scr_abt_desc" eq "" then 
		put 'value=""'@;
	else	
		put "value = ""&save_scr_abt_desc"""@;
	put '" maxLength="255"  class="inputtext" onkeypress="return validate_exchar(this);">';
	put '                  </td>';
	put '                </tr>';

	put '                <tr valign="top">';
	put '                  <td class="formfieldlabel">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_abt_table_nm.1, noquote))" @;
	put ':';
	put '                  </td>';
	put '                  <td class="">';
	put '                    <input type="text" style="width:200px;" name="scr_abt_table_name"'@;
	if "&save_scr_abt_table_name" eq "" then 
		put 'value=""'@;
	else	
		put "value = ""&save_scr_abt_table_name"""@;
	put '" maxLength="18"  class="inputtext" onkeypress="return validate_tabcol(this);"';
	if &save_scr_abt_key ne . then
		put ' readonly=true '@;
	put '>';
	put '                  </td>';
	put '                </tr>';

	put '                <tr valign="top">';
	put '                  <td class="formfieldlabel">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_level.1, noquote))" @;
	put ':';
	put '                  </td>';
	put '                  <td class="">';
	put '                    <select style="width:200px;" name="level" id="lvl" class="longselect"'@;
	if &save_scr_abt_key ne . then
		put ' disabled'@;
	put '>';
	put '					 <option>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.drp_dwn_default_sel_level, noquote))" @;
	put '</option>';
run;

data _null_;
file _webout &webout_options;
set &lib..abt_level;
	put '<option'@;
if "&save_scr_level_desc" eq LEVEL_DESC then
	put ' selected="selected"'@;

	put '>'@;
	put LEVEL_DESC@;
	put '</option>';
run;

data _null_;
file _webout &webout_options;	
	put '                    </select>';
	put '                  </td>';
	put '                </tr>';
run;

data _null_;
	file _webout &webout_options;
	put '              </table>';
	put '            </div>';
	put '          </td>';
	put '        </tr>';
	put '      </table>';

	/* Wizard navigation buttons */
	put '      <table border="0" cellpadding="3" cellspacing="0" summary="Action Buttons" id="dialogbuttons" width="100%">';
	put '        <tr>';
	put '          <td>';
	put '            <td width="40">';
	put '              <table border="0" cellpadding="0" cellspacing="0">';
	put '                <tr>';
	put '                  <td>';
	put '                    <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.prevbttn.1, noquote))" @;
	put '" name="< Previous" type="button" Disabled>';
	put '                  </td>';
	put '                  <td></td>';
	put '              </table>';
	put '            </td>';
	put '            <td width="40">';
	put '              <table border="0" cellpadding="0" cellspacing="0">';
	put '                <tr>';
	put '                  <td>';
	put '                    <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.nextbttn.1, noquote))" @;
	put '" name="Next >" type="button" onclick="next()">';
	put '                  </td>';
	put '                  <td></td>';
	put '              </table>';
	put '            </td>';
	put '            <td width="30"><img src="/SASABTFramework/images/blank.gif" width="30" height="1">';
	put '            </td>';
	put '            <td width="40">';
	put '              <table border="0" cellpadding="0" cellspacing="0">';
	put '                <tr>';
	put '                  <td>';
	put '                    <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg, abt.finishbttn.1, noquote))" @;
	put '" name="Finish" type="button" Disabled>';
	put '                  </td>';
	put '                  <td></td>';
	put '              </table>';
	put '            </td>';
	put '            <td width="40">';
	put '              <table border="0" cellpadding="0" cellspacing="0">';
	put '                <tr>';
	put '                  <td>';
	put '                    <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.cancelbttn.1, noquote))" @;
	put '" name="Cancel" type="button" onclick="cancel()">';
	put '                  </td>';
	put '                  <td></td>';
	put '              </table>';
	put '            </td>';
	put '          </td>';
	put '          <td width="90%">&nbsp';
	put '          </td>';
	put '        </tr>';
	put '      </table>';

	put '      <!--Big table ends here-->';
	put '      <div id="foot">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.copyright_notice.1, noquote))"@;
	put '      </div>';
	put '    </form>';
		
	put '  </body><!-- InstanceEnd -->';
	put '</html>';
run;
