options nomprint mvarsize=1000;

/* Global input variables */
%global modstr modsk abtvars;

/* Loading macro aliases for the rest of the stored processes */
%select_abt_vars_screen_links;

/* Alias for the back-end library */
%let lib=analytic;

/* Start the session */
%let rc=%sysfunc(stpsrv_session(create));

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

data _null_;
/*%let modstr = %sysfunc(kcompress(&modstr));*/
ms="&modstr";
call symput('modstr',kcompress(ms));
run;

/* Getting the repository id */
filename repfile 'Data/bisdata/xmlmap/rep.xml';
proc metadata
IN = "<GetRepositories>
	<Repositories/>
	<Flags>0</Flags>
	<Options/>
	</GetRepositories>"
OUT = repfile;
run;

/*The following 2 lines need xml map to be created */
filename repmap 'Data/bisdata/xmlmap/repmap.map';
libname repfile xml xmlmap=repmap access=READONLY;

%let reposid=;
proc sql;
select id into :reposid from repfile.repository;
quit;

/* creating the table metadata string */
data _null_;
Table_Metadata_String = "'<GetMetadataObjects><Reposid>" ||  "&reposid." || '</Reposid>
					<Type>MiningResult</Type>
					<Objects/>
					<NS>SAS</NS>
                    <Flags>392</Flags>
					</GetMetadataObjects>''';
call symput("Table_Metadata_String", Table_Metadata_String);
run;

filename minres 'Data/bisdata/xmlmap/Minres.xml';
proc metadata
IN=&Table_Metadata_String.
out=minres;
run;

/*The following 2 lines need xml map to be created */
filename fminres 'Data/bisdata/xmlmap/minres.map';
libname minres xml xmlmap=fminres access=READONLY;

/* check if the dataset has data. If yes then this should be inserted into the ANALYTICAL_MODEL
DDS table. The other fields in this table should be populated using the front end. */

data &out_lib..test;
set minres.Miningresult end=last;
length GetSV_str $ 100;
GetSV_str = cats('<MiningResult Id=""',strip(Id),'""/>'); 
run;

%let midstr=;
proc sql;
select GetSV_str into :midstr separated by '' from  &out_lib..test;
quit;
%let midstr=&midstr;

%macro chkmidstr;
%if "&midstr" eq "" %then
%do;
	data _null_;
	file _webout &webout_options;
	put '<html>';
	put '<body>';
	put '<form method="post" action="/SASStoredProcess/do" name="form1">';
	put '<input type="hidden" name="_program" VALUE="">';
	put '<script language="JavaScript" type="text/JavaScript"> ';
	put '<!-- ';
	put 'alert("' @ ;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.noregmodels.1, noquote))"@;
	put '");';
	put "	form1._program.value=&SCR_TEMPLATE_LIST";
	put '	form1.submit();';
	put '//-->';
	put	'</script>';
	put '</body>';
	put '</form>';
	put '</html>';
run;
%end;
%mend chkmidstr;
%chkmidstr;

filename f 'Data/bisdata/scratch/md.xml';

data _null_;
file f;
put '<GetMetadata><Metadata>';
put "&midstr";
put '</Metadata><NS>SAS</NS><Flags> 2052 </Flags><Options><Templates><MiningResult Name=""><TransformationSources/></MiningResult><RelationalTable><Columns/></RelationalTable><Column ColumnName=""/></Templates></Options></GetMetadata>';
run;

filename sigvar 'Data/bisdata/xmlmap/sigvar.xml';
proc metadata
IN=f
out=sigvar;
run;

/*The following 2 lines need xml map to be created */
filename fsigvar 'Data/bisdata/xmlmap/sigvar.map';
libname sigvar xml xmlmap=fsigvar access=READONLY;

data &out_lib..sample;
set sigvar.sigvartab;
run;

%let abtvars=;
proc sql;
create table &out_lib..modtabvar as
select distinct columnname from sigvar.sigvartab where model_id in (&modstr);

select v_no into :abtvars separated by ' ' from &lib..var_master, &out_lib..modtabvar
where kupcase(ktrim(kleft(var_nm))) = kupcase(ktrim(kleft(columnname)));
quit;

/* Start printing out HTML. */
data _null_;
	file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	put '    <script type="text/javascript">';
	put '      <!--';
	
	/* This function is called when the previous button is clicked */
	put 'function previous()';
	put '{';
	put "    form1._program.value=&SCR_TEMPLATE_STEP2;";
	put '	 form1.submit()';
	put '}';

	put 'function restrictnav()';
	put '{';
	put 'alert("'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.alert_restrictnav.1, noquote))" @;
	put '");';
	put 'return;';
	put '}';

	/* This function is called when the cancel button is clicked */
	put 'function cancel()';
	put '{';
	put "	form1._program.value=&SCR_TEMPLATE_LIST;";
	put '	form1.submit();';
	put '}';

	/* Takes you to the next step. */
	put 'function finish()';
	put '{';
	put "  form1._program.value=&SCR_TEMPLATE_STEP4;";
	put '  form1.submit();';
	put '}';

	put '      -->';
	put '    </script>';
		 /*I18N-scnjih-20080421-1506*/
/*	put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
	put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,scr_template_step3.sas.1, noquote))"@;
	put '</title><!-- InstanceEndEditable -->';
		/*I18N-scnjih-20080421-1506*/

	/* External scripts */
		 /*I18N-scnjih-20080421-1506*/
/*	put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
	put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,scr_template_step3.sas.1, noquote))"@;
	put '</title><!-- InstanceEndEditable -->';
		/*I18N-scnjih-20080421-1506*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';
	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '  </head>';
	put '  <body>';
	put "    <form name='form1' action='&_THISSESSION' method='post'>";
	put '      <input type="hidden" name="_program" value="" />';
	put '      <input type="hidden" name="abtvars" value="'@; put "&abtvars"@; put '" />';
	put '      <input type="hidden" name="modsk" value="'@; put "&modsk"@; put '" />';
	put '      <input type="hidden" name="modstr" value="'@; put "&modstr"@; put '" />';
	put '	<div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>';
	put '	<div id="banback">';

	/* Banner code */
	put '	  <table id="bantabs" border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '	    <tr valign="top">';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_home.1, noquote))" @;
	put'</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_modeling.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tabsellft"><img src="/SASABTFramework/images/tab_upper_left_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tabsellab'><a href='#'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scoring.1, noquote))" @;
	put'</a></td>';
	put '              <td class="mmhide_tabselrgt"><img src="/SASABTFramework/images/tab_upper_right_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "              <td class='mmhide_tablab'><a href='javascript:restrictnav();'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scheduling.1, noquote))" @;
	put '</a></td>';
	put '              <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '              <td width="100%">&nbsp;</td>';
	put '	    </tr>';
	put '	  </table>';
	put '	</div>';
	put '	<table border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '	  <tr>';
	put '	    <td id="butbar">';
	put '	      <font color="#996600"> <b>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_create_or_edit_template.1, noquote))" @;
	put '</b>';
	put '	      <span id="butfill">&nbsp;</span>';
	put '	    </td>';
	put '	  </tr>';
	put '	</table>';
	/* List on the left hand side */
	put '      <table border="0" cellpadding="0" cellspacing="0" summary="" width="100%" height="450">';
	put '        <tr valign="top">';
	put '          <td  id="navcel">';
	put '            <div id="navcol">';
	put '              <table border="0" cellspacing="0" summary="" class="mmhide_wizardsteps">';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td><img src="/SASABTFramework/images/AdjustmentComplete.gif"></td>';
	put '					<td>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.details.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td><img src="/SASABTFramework/images/AdjustmentComplete.gif"></td>';
	put '					<td>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg, abt.Link_scoring_to_abt_mdl.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td nowrap class="mmhide_wizardstepact"></td>';
	put '                  <td class="mmhide_wizardstepact">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.summary.1, noquote))" @;
	put '</td>';
	put '                </tr>';
	put '                <tr class="mmhide_wizardstep">';
	put '                  <td>';
	put '                  </td>';
	put '                  <td><img src="/SASABTFramework/images/blank.gif" width="180" height="1"></td>';
	put '                </tr>';
	put '              </table>';
	put '            </div>';
	put '          </td>';
	put '          <td id="navwdg"><img src="/SASABTFramework/images/blank.gif" name="navwdg" border="0" width="11" height="14" hspace="0" vspace="0" alt="" /></a></td>';
	put '          <td width="100%" id="wizardmain">';
	put '            <!--content comes here-->';
	put '            <div id="pagetitlesection">';
	put '            <div id="pagetitle">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.summary.1, noquote))" @;
	put '            </div>';
	put '            <div id="pagesubtitle"><!-- InstanceBeginEditable name="pagesubtitle" -->&nbsp;<!-- InstanceEndEditable --></div>';
	put '            </div>';
	put '            <div class="formfields">';

	/* Print the template detail */
	put '	        <table class="formfields" cellpadding="4" cellpadding="0" border="0" >';
	put '	          <tr valign="top">';
	put '	            <td class="formfieldlabel">';
	put '	              &nbsp;';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_name.1, noquote))" @;
	put ':';
	put '	            </td>';
	put '	            <td class="">';
	put "	              <input type='text' style=""width:200px;"" name='Name' value='&save_scr_abt_name' Disabled class='inputtext'>";
	put '	            </td>';
	put '	          </tr>';
	put '	          <tr valign="top">';
	put '	            <td class="formfieldlabel">';
	put '	              &nbsp;';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_description.1, noquote))" @;
	put ':';
	put '	            </td>';
	put '	            <td class="">';
	put "	              <input type='text' style=""width:200px;"" name='Description' value='&save_scr_abt_desc' Disabled class='inputtext'>";
	put '	            </td>';
	put '	          </tr>';
	put '	        </table>';
	put '<br>';
	put '			  <table class="tableview">';
	put '	          <tr>';
	put '			  <td>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.table_description.1, noquote))" @;
	put '</td>';
	put '			  </tr>';
	put '			  </table>';
	put '<br>';
	/* Input variable table headings */
	put '	        <table border="0" cellpadding="0" cellspacing="0" summary="" class="tableview" width="100%">';
	put '	          <tr>';
	put '	            <th class="tabletextcol">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.table_row.1, noquote))" @;
	put '</th>';
	put '	            <th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.table_catg_sub_catg.1, noquote))" @;
	put '	            </th>';
	put '	            <th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.table_scr_var.1, noquote))" @;
	put '	            </th>';
	put '	            <th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_description.1, noquote))" @;
	put '	            </th>';
	put '	          </tr>';
run;

/* This is where the input variables are printed. */
/* Create a temporary table to hold variable details. */
data &out_lib..var_details;
	set &lib..var_master(keep=v_no var_short_nm var_desc var_category var_sub_category);
	if indexw("&abtvars", v_no)>0 then output;
run;

/* Print the table rows using the temporary table */
data _null_;
	set &out_lib..var_details;
	file _webout &webout_options;
	/* This alternates the row color. */
	if mod(_N_,2)=0 then do;
		put '<tr class="tableevenrow"> ';
	end;
	else do;
		put '<tr class="tableoddrow"> ';
	end;
	put '<td class="tablenumcol" width="20">'@;
	put _N_@;
	put '</td>';
	put '<td class="tabletextcol">'@;
	put var_category@;
	put ', '@;
	put var_sub_category@;
	put '</td>';
	put '<td class="tabletextcol">'@;
	put var_short_nm@;
	put '</td>';
	put '<td class="tabletextcol">'@;
	put var_desc@;
	put '</td>';
	put '</tr>';
run;

data _null_;
	file _webout &webout_options;
	put '	        </table>';
	put '			   </tr>';
	put '			</table>';
	put '          </div>';	
	put '          </td>';
	put '        </tr>';
	put '    </table>';
	/* Wizard navigation buttons */
	put '	<table border="0" cellpadding="3" cellspacing="0" summary="Action Buttons" id="dialogbuttons" width="100%">';
	put '	  <tr>';
	put '	    <td>';
	put '	      <td width="40">';
	put '	        <table border="0" cellpadding="0" cellspacing="0">';
	put '	          <tr>';
	put '	            <td>';
	put '	              <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.prevbttn.1, noquote))" @;
	put '" name="< Previous" type="button" onclick="previous()">';
	put '	            </td>';
	put '	            <td></td>';
	put '	        </table>';
	put '	      </td>';
	put '	      <td width="40">';
	put '	        <table border="0" cellpadding="0" cellspacing="0">';
	put '	          <tr>';
	put '	            <td>';
	put '	              <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.nextbttn.1, noquote))" @;
	put '" name="Next >" type="button" Disabled>';
	put '	            </td>';
	put '	            <td></td>';
	put '	        </table>';
	put '	      </td>';
	put '	      <td width="30"><img src="/SASABTFramework/images/blank.gif" width="30" height="1">';
	put '	      </td>';
	put '	      <td width="40">';
	put '	        <table border="0" cellpadding="0" cellspacing="0">';
	put '	          <tr>';
	put '	            <td>';
	put '	              <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.finishbttn.1, noquote))" @;
	put '" name="Finish" type="button" onclick="finish()" >';
	put '	            </td>';
	put '	            <td></td>';
	put '	        </table>';
	put '	      </td>';
	put '	      <td width="40">';
	put '	        <table border="0" cellpadding="0" cellspacing="0">';
	put '	          <tr>';
	put '	            <td>';
	put '	              <input class="mmhide_btn" style="width:80px;" onmouseover="hov(this,''mmhide_btn mmhide_btnhov'')" onmouseout="hov(this,''mmhide_btn'')" value="'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.cancelbttn.1, noquote))" @;
	put '" name="Cancel" type="button" onclick="cancel()">';
	put '	            </td>';
	put '	            <td></td>';
	put '	        </table>';
	put '	      </td>';
	put '	    </td>';
	put '	    <td width="90%">&nbsp;';
	put '	    </td>';
	put '	  </tr>';
	put '	</table>';
	put '	<!--Big table ends here-->';
	put '	<div id="foot">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.copyright_notice.1, noquote))"@;
	put '	</div>';
	put '    </form>';
	put '  </body><!-- InstanceEnd -->';
	put '</html>';
run;
