/* No global input parameters. */
%global delflag strabtkey;

/* Alias for the back-end library */
%let lib=analytic;

/* Loading macro aliases for the rest of the stored processes */
%select_abt_vars_screen_links;

/* Setting output library based on the debug flag */
%let out_lib=;
%debug_lib_path;

/* Here, use a proc sql to retrieve ABT details. */
proc sql;
	/* Retrieve details for each of the templates */
	create table &out_lib..scr_abt_records as 
	select scr_a_no, scr_abt_nm, scr_abt_table_nm, scr_abt_desc,  
				scr_abt_master.scr_l_no, level_desc
	from &lib..scr_abt_master, &lib..abt_level
	where scr_abt_master.scr_l_no = abt_level.l_no;		
quit;

/* Sort the data. */
proc sort data=&out_lib..scr_abt_records out=&out_lib..scr_abt_records;
	by scr_a_no;
run;

%let scrabtcnt=0;
proc sql;
select count(*) into :scrabtcnt from &out_lib..scr_abt_records;
quit;

/* Start printing out HTML */
data _null;
	file _webout &webout_options;
	put '<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml"><!-- InstanceBegin template="/Templates/dashboard.dwt" codeOutsideHTMLIsLocked="false" -->';
	put '  <head>';
	put '    <meta http-equiv="content-type" content="text/html;charset=utf-8" />';
	  /*I18N-scnjih-20080429-1539*/
	/*put '    <!-- InstanceBeginEditable name="doctitle" --><title>Layout</title><!-- InstanceEndEditable -->';*/
		put '    <!-- InstanceBeginEditable name="doctitle" --><title>'@;
		put "%sysfunc(sasmsg(smd_ds.bismsg,title_of_layout.1, noquote))"@;
		put '</title><!-- InstanceEndEditable -->';
	
	 /*I18N-scnjih-20080429-1539*/
	put '    <link rel="stylesheet" type="text/css" href="/SASABTFramework/styles/default.css" />';

	/* External scripts */
	put '    <script src="/SASABTFramework/javascript/scripts.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/buttonMenu.js" type="text/javascript"></script>';
	put '    <script src="/SASABTFramework/javascript/overlib.js" type="text/javascript"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/table_controls.js"></script>';
	put '    <script type="text/javascript" src="/SASABTFramework/javascript/boxOver.js"></script>';
	put '    <script type="text/javascript">';
	put '    <!--';
	
	/* This function launches the wizard with the specified input data. */
	put '      function edit(scr_abt_key, scr_abt_name, scr_abt_desc, scr_abt_table_name, level_key, level_desc)';
	put '      {';
	put '        form1.scr_abt_key.value = scr_abt_key;';
	put '        form1.scr_abt_name.value = scr_abt_name;';
	put '        form1.scr_abt_desc.value = scr_abt_desc;';
	put '        form1.scr_abt_table_name.value = scr_abt_table_name;';
	put '        form1.level_key.value = level_key;';
	put '        form1.level_desc.value = level_desc;';
	put "		 form1._program.value=&SCR_TEMPLATE_STEP1;";
	put '        form1.submit();';
	put '      }';

	put 'javascript:window.history.forward(1);';
	
	put 'function seldesel(obj)';
	put '{';
		put 'if(obj.checked==true){';
			put 'for(i=0;i<form1.Sel.length;i++){';
			put 'form1.Sel[i].checked=true;';
			put '}';
			put '}';
		put 'else {';
		put 'for(i=0;i<form1.Sel.length;i++){';
			put 'form1.Sel[i].checked=false;';
			put '}';
			put '}';
	put '}';

	put '    -->';
	put '    </script>';
	put '  </head>';
	put '  <body>';
	put '    <div id="overDiv" style="position:absolute; visibility:hidden; z-index:1000;"></div>';
	put '    <div id="banback">';

	/* Banner code */
	put '      <table id="bantabs" border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '        <tr valign="top">';
	put '          <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "          <td class='mmhide_tablab'><a href='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?_program=SBIP://Foundation/BIS/analytics/explore_abt/explore_abtvars'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_home.1, noquote))" @;
	put '</a></td>';
	put '          <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '          <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "          <td class='mmhide_tablab'><a href='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?_program=SBIP://Foundation/BIS/analytics/templates/templates'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_modeling.1, noquote))" @;
	put '</a></td>';
	put '	       <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '	       <td class="mmhide_tabsellft"><img src="/SASABTFramework/images/tab_upper_left_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "          <td class='mmhide_tabsellab'><a href='#'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scoring.1, noquote))" @;
	put '</a></td>';
	put '	       <td class="mmhide_tabselrgt"><img src="/SASABTFramework/images/tab_upper_right_select.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '	       <td class="mmhide_tablft"><img src="/SASABTFramework/images/tab_upper_left.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put "          <td class='mmhide_tablab'><a href='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?_program=SBIP://Foundation/BIS/analytics/scoring/sch_scr_prc'>"@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.tabs_scheduling.1, noquote))" @;
	put '</a></td>';
	put '	       <td class="mmhide_tabrgt"><img src="/SASABTFramework/images/tab_upper_right.gif" border="0" width="5" height="5" hspace="0" vspace="0" alt="" /></td>';
	put '          <td width="100%">&nbsp;</td>';
	put '        </tr>';
	put '      </table>';
	put '    </div>';
	put '    <table border="0" cellpadding="0" cellspacing="0" width="100%">';
	put '      <tr>';
	put '        <td id="butbar">';
	put '          <span id="butfill">&nbsp;</span>';
	put '        </td>';
	put '        <td id="butbar" align="right">';
	put '          <a href="#"  onClick="javascript:window.print();" >';
	put '          <img src="/SASABTFramework/images/Print.gif" alt="Print" border="0">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.printer_icon.1, noquote))" @;
	put '</a>&nbsp;';
	put '        </td>';
	put '      </tr>';
	put '    </table>';
	put '    <table border="0" cellpadding="12" cellspacing="0" width="100%">';
	put '      <tr>';
	put '        <form method="post" action="/SASStoredProcess/do" name="form1">';

	/* Hidden fields contain the data to be passed to the wizard. */
	put "          <input type='hidden' name='_program' value=/>";
	put '          <input type="hidden" name="scr_abt_key" value="."/>';
	put '          <input type="hidden" name="scr_abt_name" value=""/>';
	put '          <input type="hidden" name="scr_abt_desc" value=""/>';
	put '          <input type="hidden" name="scr_abt_table_name" value=""/>';
	put '          <input type="hidden" name="level_key" value="."/>';
	put '          <input type="hidden" name="level_desc" value=""/>';
	put '          <input type="hidden" name="prev_step" value="0"/>';
	put '          <input type="hidden" name="first_load" value="Y"/>';
	put '          <input type="hidden" name="delflag" value=""/>';
	put '          <input type="hidden" name="strabtkey" value=""/>';
	put '          <input type="hidden" name="flag" value="1"/>';
	put '          <input type="hidden" name="action" value=""/>';
	put '          <td width="100%" id="main">';
	put '            <div id="mainentity">';

	/* This link launches the wizard for creating a new template. */
	put '	<table>';
	put '   <tr><td></td><td width="100%" align="right"><a href=''javascript:edit(".", "", "", "", ".", "")''>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.create_template.1, noquote))" @;
	put '</a></td></tr>';
	put '	</table>';
	put '              <div class="tableviewcomposite">';
	put '                <div class="tableheader">';
	put '                  <div class="tabletitle">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.templates.1, noquote))" @;
	put '                  </div>';
	put '                  <div class="tablecolcount">';
	put '                    &nbsp;';
	put '                  </div>';
	put '                </div>';

	/* Table displaying the templates*/
	put '<table border="0" cellpadding="0" cellspacing="0" summary="" class="tableview" width="100%"><tr valign="top" class="">';

	/* Table headings */
	put '<tr>';
	put '<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg, abt.heading_name.1, noquote))" @;
	put '</th>';
	put '<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_description.1, noquote))" @;
	put '</th>';
	put '<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_abt_table_nm.1, noquote))" @;
	put '</th>';
	put '<th class="tabletextcol">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.heading_level.1, noquote))" @;
	put '</th>';
	put '</tr>';
run;
/* Print the table rows */
data _NULL_;
	file _webout &webout_options;
	set &out_lib..scr_abt_records;

	/* This alternates the row color. */
	if mod(_N_,2)=0 then do;
		put '<tr class="tableevenrow" tr valign="top"> ';
	end;
	else do;
		put '<tr class="tableoddrow" tr valign="top"> ';
	end;
	
	put '<td class="tabletextcol">' @;
	/* This link launches the wizard for editing the template. */
	put '<a href="javascript:edit(' @;
	put scr_a_no @;
	put ', ''' @;
	put scr_abt_nm @;
	put ''', ''' @;
	put scr_abt_desc @;
	put ''', ''' @;
	put scr_abt_table_nm @;
	put ''', ' @;
	put scr_l_no @;
	put ', ''' @;
	put level_desc @;
	put ''')">' @;
	put scr_abt_nm @;
	put '</a></td>';
	put '<td class="tabletextcol">' @;
	put scr_abt_desc@;
	put '</td>';
	put '<td class="tabletextcol">' @;
	put scr_abt_table_nm@;
	put '</td>';
	put '<td class="tabletextcol">' @;
	put level_desc@;
	put '</td>';
	put '</tr>';
run;

/* Finish up. */
data _null_;
	file _webout &webout_options;
    put '                </table>';
    put '              </div>';
	put '            </div>';
    put '          </td>';
    put '      </tr>';
	put '    </table>';
	put '    <!--Big table ends here-->';
	
	put '  <div id="foot">';
	put "%sysfunc(sasmsg(smd_ds.bismsg,abt.copyright_notice.1, noquote))"@;
	put '  </div>';
	put '  </body>';
	put '        </form>';
	put '  <!-- InstanceEnd -->';
	put '</html>';
run;
