/*********************************************************************************************
       Module:  reporting

     Function:  This stored process creates the HTML screen which provides link to call
				the monitoring models and monitoring model inputs screen.

      Authors:  BIS Team
         Date:  05 April 2006
          SAS:  9.1
    Called-by:	NA
        Calls:  1. mon_models 		(when the link for Monitoring Models is clicked)
				2. mon_model_inputs (when the link for Monitoring Model Inputs is clicked)

Datasets used:  No input datasets required for processing of the stored process
 
        Logic:  1. Creates the HTML screen which provides link to call the monitoring models
					and monitoring model inputs screen.

   Parameters:  NA
	
**********************************************************************************************/
/*This code is Internationalized*/
data _NULL_;
	file _webout&webout_options;
	put '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN" ';
	put '"http://www.w3.org/TR/html4/loose.dtd"> ';
	put '<html> ';
	put '<head> ';
	put '<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> ';
	put '<title>'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,crs.reporting.column_reporting.1, noquote))"@;
	put '</title> ';
	put '<link href="SASTheme_default/themes/default/styles/default.css" rel="stylesheet" type="text/css"> ';
	put '<link href="/SASCSReports/styles/default.css" rel="stylesheet" type="text/css"> ';
	put '<style type="text/css"> ';
	put '<!-- ';
	put '.style2 {font-size: small} ';
	put 'body { ';
	put '	background-color: #FAF8ED; ';
	put '} ';
	put '--> ';
	put '</style> ';
	put '<script> ';
	put '<!-- ';

/*	put '	function LinkConf() { ';*/
/*	put "		form1._program.value=&CS_MSR_CONFIG";*/
/*	put '		form1.submit() ';*/
/*	put '	} ';*/
/**/
/*	put '	function Link1() { ';*/
/*	put '		form1._program.value="" ';*/
/*	put '		form1.submit() ';*/
/*	put '	} ';*/

	put '	function Link2() { ';
	put "form1._program.value=&CS_MON_MDL";
	put '		form1.submit() ';
	put '	} ';

	put '	function Link3() { ';
	put "		form1._program.value=&CS_MON_MDL_IP";
	put '		form1.submit() ';
	put '	} ';

	put '--> ';
	put '</script> ';
	put '</head> ';
	put '<body> ';
	put '<form name="form1" method="post" action="/SASStoredProcess/do"> ';
	put '<input type="hidden" name="_program" value=""> ';
	put '<table width="100%"  border="0" cellpadding="0" cellspacing="0" bgcolor="#FAF8ED"> ';
	put '<tr> ';
	put '<td align="left"> ';
	put '<table width="100%"  border="0" align="left" cellpadding="3" cellspacing="0"> ';
	put '<tr> ';
	put '<td><table width="100%"  border="0" cellspacing="0" cellpadding="0"> ';
	put '<tr> ';
	put '<td><span class="BreadCrumb">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,crs.reporting.column_reporting.1, noquote))"@;
	put '</span></td> ';
	put '<td width="215"><div align="right">';
	put '<img src="/SASCSReports/images/CrBanner.gif" width="259" height="29"></div></td> ';
	put '</tr> ';
	put '</table> ';
	put '<H2 align="left">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,crs.reporting.column_reporting.1, noquote))"@;
	put '</H2></td> ';
	put '</tr> ';
/*	put '<tr> ';*/
/*	put '<td valign="top"> ';*/
/*	put '<p class="BreadCrumb"> <a href="javascript:LinkConf()">Configuration</a></p> ';*/
/*	put '</td>';*/
/*	put '</tr> ';*/
	put '<tr> ';
	put '<td valign="top"> ';
/*	put '<p class="BreadCrumb"> <a href="#">Business Reports</a></p> ';*/
	put '<p class="BreadCrumb"> <a href="javascript:Link2()">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,crs.reporting.column_monitoring_model.1, noquote))"@;
	put '</a></p> ';
	put '<p class="BreadCrumb"> <a href="javascript:Link3()">'@;
	put "%sysfunc(sasmsg(smd_ds.bismsg,crs.reporting.column_monitoring_model_input.1, noquote))"@;
	put '</a></p></td> ';
	put '</tr> ';
	put '</table> ';
	put '</td> ';
	put '</tr> ';
	put '</table> ';
	put '</body> ';
	put '</html> ';
run;
