/******************************************************************************************************
       Module:  pool_main

     Function:  This stored process creates the frames in which the menu and links
				will be shown.

      Authors:  BIS Team
         Date:  14 May 2007
          SAS:  9.1
    Called-by:	NA
        Calls:  pool_menu (To display the menu)
				pool_introduction

Datasets used:  No input datasets required for processing of the stored process
 
        Logic:  It creates two frames and calls pool_menu in the left frame to diaplay the menu
				and pool_introduction in the right frame to display the introduction to the
				Pooling Functionality. When any other menu item is clicked on the left frame,
				the appropriate stored process is called to load the screen in the right
				frame.
				
   Parameters:  NA

******************************************************************************************************/
options nomprint;
/*This code is Internationalized*/
/* Links to the menu and introduction screens. */
/*%select_abt_vars_screen_links;*/
%let MENU=SBIP://Foundation/BIS/pool/pool_menu;
%let INTRO=SBIP://Foundation/BIS/pool/build_scheme_data;

/* Start HTML Screen*/
data _NULL_;
	file _webout&webout_options;
	put '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"';
	put '"http://www.w3.org/TR/html4/loose.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml">';
	put '<head>';
/*I18N-scnhuh-20080418-1023*/
/*from iso-8859-1 to utf-8*/
	put '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
/*I18N-scnhuh-20080418-1023*/	
	put '<title></title>';
	put '</head>';
	put '<frameset cols="200,*" framespacing="1" frameborder="yes" border="1">';
		
		/* Frame menu to display the menu items */
		put "<frame src='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?"@;
			put '&_program='@;
			put "&menu"@;
			put ''' name="menu" id="menu" title="menu" />';

		/* Frame content to load the appropriate stored process depending on the menu
		item which was selected */
		put "<frame src='http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?"@;
			put '&_program='@;
			put "&intro"@;
			put ''' name="content" id="content" title="content" />';
	put '</frameset>';
	put '<noframes><body>';
	put '</body>';
	put '</noframes></html>';
run;
