/******************************************************************************************************
       Module:  pool_menu

     Function:  To display the menu items and provide the links to each menu item 
				as available in the dataset pool_menu_items.

      Authors:  BIS Team
         Date:  14 May 2007
          SAS:  9.1
    Called-by:	pool_main
        Calls:  All stored process to load the screens in the right frame

Datasets used:  pool.pool_menu_items: Retrieves the menu items and its links from this dataset
 
        Logic:  Dataset pool.pool_menu_items contains the details and links of each menu 
				item that needs to be displayed on screen. The records in the this 
				dataset are used to display and set links for each menu item.
				
   Parameters:  NA

******************************************************************************************************/
/*This code is Internationalized*/
/* Start HTML Screen*/
data _NULL_;
	file _webout&webout_options;
	put '<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN"';
	put '"http://www.w3.org/TR/html4/loose.dtd">';
	put '<html xmlns="http://www.w3.org/1999/xhtml">';
	put '<head>';
/*I18N-scnhuh-20080418-1023*/
/*from iso-8859-1 to utf-8*/
	put '<meta http-equiv="Content-Type" content="text/html; charset=utf-8" />';
/*I18N-scnhuh-20080418-1023*/	
	put '<title></title>';
	put '<link href="/SASCSPooling/styles/default.css" rel="stylesheet" type="text/css"> ';
	put '<style type="text/css">';
	put '<!--';
	put 'body {';
	put '	background-color: #FAF8ED;';
	put '}';
	put '-->';
	put '</style>';

	put '<script>';
	put '<!--';

	/* Call the link of the selected menu item to display the appropriate screen in the 
	right frame */
	put 'function CallScreen(prg_nm){';
		put 'form1._program.value=prg_nm';
		put 'form1.submit()';
	put '}';

	put '//-->';
	put '</script>';

	put '</head> ';
	put '<body>';
	put '<form name="form1" action="/SASStoredProcess/do">';

	put '<p>&nbsp;</p>';
run;

/* Display the Menu items */
data _null_;
	file _webout&webout_options;
	set pool.pool_menu_items end=last;
	if _N_=1 then put '<UL class="BreadCrumb">';
	put '<LI><a href="'@;
	put "http://&_SRVNAME:&_SRVPORT/SASStoredProcess/do?"@;
	put '&_program='@;
	put PROGRAM_NM;
	put '" target="content">'@;
	put MENU_NM@;
	put '</a></LI>';
	if last then put '</UL>';
run;

data _null_;
	file _webout&webout_options;
	put '</body> ';
	put '</html> ';
run;
