/* The input to this macro is the 
1) PERIOD: (1, 3, 6, 12, 24) for which the variables have
to be aggregated.
If PERIOD=1, then aggregation for the current month will be calculated and stored in the
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH tables.

If PERIOD=3, then aggregation for current month and last 3 months will be calculated and stored in,
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH, 
TRANS_CASHBACK_REFUND_LST_3M, TRANS_CCD_MERCHANT_CAT_LST_3M, TRANS_CHANNEL_USAGE_LST_3M,
TRANS_CHECK_ISSUE_LST_3M, TRANS_DDR_SORD_LST_3M, TRANS_DEP_WDR_LST_3M,
TRANS_DR_CR_LST_3M, TRANS_FEES_LST_3M, TRANS_FEES_WAIVED_LST_3M,
TRANS_INST_PAYMENTS_LST_3M, TRANS_PAYMENTS_LST_3M, TRANS_PUR_CADV_OVL_LST_3M, 
TRANS_SUMMARY_LST_3M and TRANS_TRANSFER_LST_3M
tables.

If PERIOD=6, then aggregation for current month and last 3 & 6 months will be calculated and stored in,
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH,
TRANS_CASHBACK_REFUND_LST_3M, TRANS_CCD_MERCHANT_CAT_LST_3M, TRANS_CHANNEL_USAGE_LST_3M,
TRANS_CHECK_ISSUE_LST_3M, TRANS_DDR_SORD_LST_3M, TRANS_DEP_WDR_LST_3M,
TRANS_DR_CR_LST_3M, TRANS_FEES_LST_3M, TRANS_FEES_WAIVED_LST_3M,
TRANS_INST_PAYMENTS_LST_3M, TRANS_PAYMENTS_LST_3M, TRANS_PUR_CADV_OVL_LST_3M, 
TRANS_SUMMARY_LST_3M and TRANS_TRANSFER_LST_3M,
TRANS_CASHBACK_REFUND_LST_6M, TRANS_CCD_MERCHANT_CAT_LST_6M, TRANS_CHANNEL_USAGE_LST_6M,
TRANS_CHECK_ISSUE_LST_6M, TRANS_DDR_SORD_LST_6M, TRANS_DEP_WDR_LST_6M,
TRANS_DR_CR_LST_6M, TRANS_FEES_LST_6M, TRANS_FEES_WAIVED_LST_6M,
TRANS_INST_PAYMENTS_LST_6M, TRANS_PAYMENTS_LST_6M, TRANS_PUR_CADV_OVL_LST_6M, 
TRANS_SUMMARY_LST_6M and TRANS_TRANSFER_LST_6M
tables.
 
If PERIOD=12, then aggregation for current month and last 3, 6 & 12 months will be calculated and stored in,
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH,
TRANS_CASHBACK_REFUND_LST_3M, TRANS_CCD_MERCHANT_CAT_LST_3M, TRANS_CHANNEL_USAGE_LST_3M,
TRANS_CHECK_ISSUE_LST_3M, TRANS_DDR_SORD_LST_3M, TRANS_DEP_WDR_LST_3M,
TRANS_DR_CR_LST_3M, TRANS_FEES_LST_3M, TRANS_FEES_WAIVED_LST_3M,
TRANS_INST_PAYMENTS_LST_3M, TRANS_PAYMENTS_LST_3M, TRANS_PUR_CADV_OVL_LST_3M, 
TRANS_SUMMARY_LST_3M and TRANS_TRANSFER_LST_3M,
TRANS_CASHBACK_REFUND_LST_6M, TRANS_CCD_MERCHANT_CAT_LST_6M, TRANS_CHANNEL_USAGE_LST_6M,
TRANS_CHECK_ISSUE_LST_6M, TRANS_DDR_SORD_LST_6M, TRANS_DEP_WDR_LST_6M,
TRANS_DR_CR_LST_6M, TRANS_FEES_LST_6M, TRANS_FEES_WAIVED_LST_6M,
TRANS_INST_PAYMENTS_LST_6M, TRANS_PAYMENTS_LST_6M, TRANS_PUR_CADV_OVL_LST_6M, 
TRANS_SUMMARY_LST_6M and TRANS_TRANSFER_LST_6M,
TRANS_CASHBACK_REFUND_LST_12M, TRANS_CCD_MERCHANT_CAT_LST_12M, TRANS_CHANNEL_USAGE_LST_12M,
TRANS_CHECK_ISSUE_LST_12M, TRANS_DDR_SORD_LST_12M, TRANS_DEP_WDR_LST_12M,
TRANS_DR_CR_LST_12M, TRANS_FEES_LST_12M, TRANS_FEES_WAIVED_LST_12M,
TRANS_INST_PAYMENTS_LST_12M, TRANS_PAYMENTS_LST_12M, TRANS_PUR_CADV_OVL_LST_12M, 
TRANS_SUMMARY_LST_12M and TRANS_TRANSFER_LST_12M
tables.

If PERIOD=24, then aggregation for last 13-24 months will be calculated and stored in,
TRANS_CASHBACK_REFUND_13_24M, TRANS_CCD_MERCHANT_CAT_13_24M, TRANS_CHANNEL_USAGE_13_24M,
TRANS_CHECK_ISSUE_13_24M, TRANS_DDR_SORD_13_24M, TRANS_DEP_WDR_13_24M,
TRANS_DR_CR_13_24M, TRANS_FEES_13_24M, TRANS_FEES_WAIVED_13_24M,
TRANS_INST_PAYMENTS_13_24M, TRANS_PAYMENTS_13_24M, TRANS_PUR_CADV_OVL_13_24M, 
TRANS_SUMMARY_13_24M and TRANS_TRANSFER_13_24M
tables.

If PERIOD=100, then aggregation for current month and last 3, 6, 12 months & life to date data
will be calculated and stored in,
TRANS_CASHBACK_REFUND_CURR_MTH, TRANS_CCD_MERCHANT_CAT_CURR_MTH, TRANS_CHANNEL_USAGE_CURR_MTH,
TRANS_CHECK_ISSUE_CURR_MTH, TRANS_DDR_SORD_CURR_MTH, TRANS_DEP_WDR_CURR_MTH,
TRANS_DR_CR_CURR_MTH, TRANS_FEES_CURR_MTH, TRANS_FEES_WAIVED_CURR_MTH,
TRANS_INST_PAYMENTS_CURR_MTH, TRANS_PAYMENTS_CURR_MTH, TRANS_PUR_CADV_OVL_CURR_MTH, 
TRANS_SUMMARY_CURR_MTH and TRANS_TRANSFER_CURR_MTH,
TRANS_CASHBACK_REFUND_LST_3M, TRANS_CCD_MERCHANT_CAT_LST_3M, TRANS_CHANNEL_USAGE_LST_3M,
TRANS_CHECK_ISSUE_LST_3M, TRANS_DDR_SORD_LST_3M, TRANS_DEP_WDR_LST_3M,
TRANS_DR_CR_LST_3M, TRANS_FEES_LST_3M, TRANS_FEES_WAIVED_LST_3M,
TRANS_INST_PAYMENTS_LST_3M, TRANS_PAYMENTS_LST_3M, TRANS_PUR_CADV_OVL_LST_3M, 
TRANS_SUMMARY_LST_3M and TRANS_TRANSFER_LST_3M,
TRANS_CASHBACK_REFUND_LST_6M, TRANS_CCD_MERCHANT_CAT_LST_6M, TRANS_CHANNEL_USAGE_LST_6M,
TRANS_CHECK_ISSUE_LST_6M, TRANS_DDR_SORD_LST_6M, TRANS_DEP_WDR_LST_6M,
TRANS_DR_CR_LST_6M, TRANS_FEES_LST_6M, TRANS_FEES_WAIVED_LST_6M,
TRANS_INST_PAYMENTS_LST_6M, TRANS_PAYMENTS_LST_6M, TRANS_PUR_CADV_OVL_LST_6M, 
TRANS_SUMMARY_LST_6M and TRANS_TRANSFER_LST_6M,
TRANS_CASHBACK_REFUND_LST_12M, TRANS_CCD_MERCHANT_CAT_LST_12M, TRANS_CHANNEL_USAGE_LST_12M,
TRANS_CHECK_ISSUE_LST_12M, TRANS_DDR_SORD_LST_12M, TRANS_DEP_WDR_LST_12M,
TRANS_DR_CR_LST_12M, TRANS_FEES_LST_12M, TRANS_FEES_WAIVED_LST_12M,
TRANS_INST_PAYMENTS_LST_12M, TRANS_PAYMENTS_LST_12M, TRANS_PUR_CADV_OVL_LST_12M, 
TRANS_SUMMARY_LST_12M and TRANS_TRANSFER_LST_12M,
TRANS_CASHBACK_REFUND_13_24M, TRANS_CCD_MERCHANT_CAT_13_24M, TRANS_CHANNEL_USAGE_13_24M,
TRANS_CHECK_ISSUE_13_24M, TRANS_DDR_SORD_13_24M, TRANS_DEP_WDR_13_24M,
TRANS_DR_CR_13_24M, TRANS_FEES_13_24M, TRANS_FEES_WAIVED_13_24M,
TRANS_INST_PAYMENTS_13_24M, TRANS_PAYMENTS_13_24M, TRANS_PUR_CADV_OVL_13_24M, 
TRANS_SUMMARY_13_24M and TRANS_TRANSFER_13_24M
and ACC_TRANS_FACT_LTD_ABT 
tables.
 
2) TABLE: The input table which is already filtered for the PERIOD (LTD, 1, 3, 6, 12, 13-24). 
*/
%macro macro_acc_trans_lst_abt(PERIOD=, INPUT_TABLE=);
/*Sort the input data BY ACCOUNT_RK in ascending order 
and BY TIME_SK in descending order */
PROC SORT DATA=ABTSCR.&INPUT_TABLE.;
	BY ACCOUNT_RK DESCENDING TIME_SK;
RUN;

/*The data step begins here. The data step reads the sorted input data set
& outputs aggregation tables based on the PERIOD*/

data 
%if &PERIOD. = 1 %then %do; /*If PERIOD = 1*/
	%acc_trans_curr_mth_abt_keep; %end;
%else %if &PERIOD. = 3 %then /*If PERIOD = 3*/
%do;
	%acc_trans_curr_mth_abt_keep	
	%acc_trans_lst_3m_abt_keep; 
%end;
%else %if &PERIOD. = 6 %then /*If PERIOD = 6*/ 
%do;
	%acc_trans_curr_mth_abt_keep 
	%acc_trans_lst_3m_abt_keep
	%acc_trans_lst_6m_abt_keep;
%end;
%else %if &PERIOD. = 12 %then /*If PERIOD = 12*/
%do;
	%acc_trans_curr_mth_abt_keep 
	%acc_trans_lst_3m_abt_keep
	%acc_trans_lst_6m_abt_keep
	%acc_trans_lst_12m_abt_keep;
%end;
%else %if &PERIOD. = 24 %then %do; /*If PERIOD = 24*/
	%acc_trans_13_24m_abt_keep; %end;
%else %if &PERIOD. = 100 %then /*If PERIOD = 100*/
%do;
	%acc_trans_curr_mth_abt_keep 
	%acc_trans_lst_3m_abt_keep
	%acc_trans_lst_6m_abt_keep
	%acc_trans_lst_12m_abt_keep
	%acc_trans_13_24m_abt_keep
	%acc_trans_fact_ltd_abt_keep;
%end;


/* Set the input table for reading */
SET ABTSCR.&INPUT_TABLE.;
BY ACCOUNT_RK DESCENDING TIME_SK;

min_value=&min_value; /*Numeric constant */
max_value=&max_value; /*Numeric constant */

/* Defining the length of some character LTD variables. */
LENGTH ACC_FST_PREPAY_MTH_NO $6.
	   ACC_MAX_IBT_LTD_MTH_NO $6.
	   ACC_MIN_IBT_LTD_MTH_NO $6.
	   ACC_FST_PAY_MTH_NO $6.
       ACC_FST_INST_PAY_MTH_NO $6.;	

/*List of variables to be retained */
/*This macro has the unconditional retain statement for variables*/
	%abt_trans_macro_retain;

	/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_CURR_PCT 
	 and ACC_MIN_DFEE2AVG_INST_CURR_PCT*/
	RETAIN 
	MAX_DFEE2AVG_INST_CURR_PCT .
	MIN_DFEE2AVG_INST_CURR_PCT .
	CNT_DFEE2AVG_CURR 0
	SUM_RPPCURR 0
	AVG_INST_CURR_PCT 0;
	
	/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L3M_PCT 
	 and ACC_MIN_DFEE2AVG_INST_L3M_PCT*/
	RETAIN 
	MAX_DFEE2AVG_INST_L3M_PCT .
	MIN_DFEE2AVG_INST_L3M_PCT .
	CNT_DFEE2AVG_3M 0
	SUM_RPP3M 0
	AVG_INST_L3M_PCT 0;
	
	/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L6M_PCT
	and ACC_MIN_DFEE2AVG_INST_L6M_PCT*/
	RETAIN
	MAX_DFEE2AVG_INST_L6M_PCT .
	MIN_DFEE2AVG_INST_L6M_PCT .
	CNT_DFEE2AVG_6M 0 
	SUM_RPP6M 0 
	AVG_INST_L6M_PCT 0;

	/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L12M_PCT
	and ACC_MIN_DFEE2AVG_INST_L12M_PCT*/
	RETAIN
	MAX_DFEE2AVG_INST_L12M_PCT .
	MIN_DFEE2AVG_INST_L12M_PCT .
	CNT_DFEE2AVG_12M 0 
	SUM_RPP12M 0 
	AVG_INST_L12M_PCT 0;

	/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_13_24M_PCT
	and ACC_MIN_DFEE2AVG_INST_13_24M_PCT*/
	RETAIN
	MAX_DFEE2AVG_INST_13_24M_PCT .
	MIN_DFEE2AVG_INST_13_24M_PCT .
	CNT_DFEE2AVG_13_24M 0 
	SUM_RPP13_24M 0 
	AVG_INST_13_24M_PCT 0;

	/*Special variable used in calculating ACC_CCD_NOUSE_CURR_MTH_CNT */
	RETAIN NOUSE_CNTR1 0 NOUSE_TIME_SK1 0;	
	/*Special variable used in calculating ACC_CCD_NOUSE_LST_3M_MTH_CNT */
	RETAIN NOUSE_CNTR3 0 NOUSE_TIME_SK3 0;
	/*Special variable used in calculating ACC_CCD_NOUSE_LST_6M_MTH_CNT */
	RETAIN NOUSE_CNTR6 0 NOUSE_TIME_SK6 0;
	/*Special variable used in calculating ACC_CCD_NOUSE_LST_12M_MTH_CNT */
	RETAIN NOUSE_CNTR12 0 NOUSE_TIME_SK12 0;
	/*Special variable used in calculating ACC_CCD_NOUSE_13_24M_MTH_CNT */
	RETAIN NOUSE_CNTR13_24 0 NOUSE_TIME_SK13_24 0;

	/*Special variable used in calculating ACC_AVG_CADV_CURR_MTH_AMT */
	RETAIN CADV_CURR_CNTR 0;
	/*Special variable used in calculating ACC_AVG_CADV_LST_3M_AMT */
	RETAIN CADV_3M_CNTR 0;
	/*Special variable used in calculating ACC_AVG_CADV_LST_6M_AMT */
	RETAIN CADV_6M_CNTR 0;
	/*Special variable used in calculating ACC_AVG_CADV_LST_12M_AMT */
	RETAIN CADV_12M_CNTR 0;
	/*Special variable used in calculating ACC_AVG_CADV_13_24M_AMT */
	RETAIN CADV_13_24M_CNTR 0;
	
	LENGTH ACCT_STS_CD $3. 
		   ACCT_TYPE_CD $3.
		   ACCT_SUB_TYPE_CD $3.
		   COLL_CD $3.
		   AOD_FLG $1.;

	/* Special variable used for calculating some LTD variables */
	RETAIN INST_MIN_TIME_SK
		   	PPY_MIN_TIME_SK
		   	MAX_IBT_TRNS_AMT
			MIN_IBT_TRNS_AMT
			MAX_IBT_TIME_SK
			MIN_IBT_TIME_SK
			PAY_MIN_TIME_SK;

	RETAIN	PREV_TIME_SK 0;
	RETAIN	ACCT_STS_CD; 	
	RETAIN	SUM_FWV_TRANS_CNT .;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_CURR_MTH_AMT 
											  ACC_MIN_PPL_INT_CURR_MTH_AMT */
		RETAIN SUM_PPL_INT_CURR_MTH;	
		RETAIN ACC_PPL_CURR_MTH_AMT_TMP;
		RETAIN ACC_INT_CURR_MTH_AMT_TMP;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_3M_AMT 
											  ACC_MIN_PPL_INT_LST_3M_AMT */
		RETAIN SUM_PPL_INT_3M;	
		RETAIN ACC_PPL_LST_3M_AMT_TMP;
		RETAIN ACC_INT_LST_3M_AMT_TMP;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_6M_AMT 
											  ACC_MIN_PPL_INT_LST_6M_AMT */
		RETAIN SUM_PPL_INT_6M;	
		RETAIN ACC_PPL_LST_6M_AMT_TMP;
		RETAIN ACC_INT_LST_6M_AMT_TMP;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_12M_AMT 
											  ACC_MIN_PPL_INT_LST_12M_AMT */
		RETAIN SUM_PPL_INT_12M;	
		RETAIN ACC_PPL_LST_12M_AMT_TMP;
		RETAIN ACC_INT_LST_12M_AMT_TMP;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_13_24M_AMT 
											  ACC_MIN_PPL_INT_13_24M_AMT */
		RETAIN SUM_PPL_INT_13_24M;	
		RETAIN ACC_PPL_13_24M_AMT_TMP;
		RETAIN ACC_INT_13_24M_AMT_TMP;

	/*Code variables and primary customer rk that are picked up directly 
			from the source */
	RETAIN ACCT_TYPE_CD
		   ACCT_SUB_TYPE_CD
		   PRI_CUSTOMER_RK 
		   COLL_CD
		   AOD_FLG;

/*Depending on whether the PERIOD is (3, 6, 12) or 24, the retained variable will be
initialized */
%if &PERIOD. = 24 %then %do;
	RETAIN CURR_TIME . COUNT 12;  
	CURR_TIME = BACK_12M_TIME_SK;
%end;
%else %do;
	RETAIN CURR_TIME . COUNT 0 COUNT_TMP .; 
	CURR_TIME = CURR_TIME_SK;
%end;

/* Assign the value of count at the start of every iteration. 
	Later used to check in conditions where counters are between 3 and 6 */
COUNT_TMP = COUNT;

/* Check to see if data is missing for certain period in the input table. If so,
   then adjust the count accordingly */
DO WHILE (TIME_SK < CURR_TIME);
	CURR_TIME = CURR_TIME - 1;
/*	COUNT = COUNT + 1;*/
END;

/* Check to see if there is more than one entry for certain period in the input table. 
   If so,  then adjust the count accordingly */
DO WHILE (CURR_TIME < TIME_SK ) ;
	CURR_TIME = CURR_TIME + 1;
/*	COUNT = COUNT - 1;*/
END;

IF FIRST.ACCOUNT_RK THEN 
DO;
	ACCT_STS_CD = ACCOUNT_STATUS_CD; /*Retain the ACCT_STS_CD throughout the account_rk group */

	/*The variables below are assigned so, for picking up the recent record, not the last ones */
	ACCT_TYPE_CD = ACCOUNT_TYPE_CD;
	ACCT_SUB_TYPE_CD = ACCOUNT_SUB_TYPE_CD; 
	PRI_CUSTOMER_RK = PRIMARY_CUSTOMER_RK;
	COLL_CD = COLLATERAL_CD;
	AOD_FLG = ALLOW_OVERDRAFT_FLG;
END;

IF FIRST.TIME_SK THEN 
DO;
	/*Check to see if the count has reached some level (1, 3,6,12), if so then assign the
	value of previous variable to the next level variable */

	IF COUNT EQ 1 OR (COUNT_TMP  <= 1 AND COUNT > 1) THEN DO;
	/* This macro has the assignment statements for variables of current month to 3 months */
		%abt_trans_macro_assign_1_to_3; END;	
	IF COUNT EQ 3 OR (COUNT_TMP  <= 3 AND COUNT > 3) THEN DO;
	/* This macro has the assignment statements for variables of 3 months to 6 months */
		%abt_trans_macro_assign_3_to_6; END;
	IF COUNT EQ 6 OR (COUNT_TMP  <= 6 AND COUNT > 6) THEN DO;
	/* This macro has the assignment statements for variables of 6 months to 12 months */
		%abt_trans_macro_assign_6_to_12; END;	

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_CURR_MTH_AMT 
											  ACC_MIN_PPL_INT_CURR_MTH_AMT */
		SUM_PPL_INT_CURR_MTH = .;	
		ACC_PPL_CURR_MTH_AMT_TMP = .;
		ACC_INT_CURR_MTH_AMT_TMP = .;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_3M_AMT 
											  ACC_MIN_PPL_INT_LST_3M_AMT */
		SUM_PPL_INT_3M = .;	
		ACC_PPL_LST_3M_AMT_TMP = .;
		ACC_INT_LST_3M_AMT_TMP = .;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_6M_AMT 
											  ACC_MIN_PPL_INT_LST_6M_AMT */
		SUM_PPL_INT_6M = .;	
		ACC_PPL_LST_6M_AMT_TMP = .;
		ACC_INT_LST_6M_AMT_TMP = .;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_LST_12M_AMT 
											  ACC_MIN_PPL_INT_LST_12M_AMT */
		SUM_PPL_INT_12M = .;	
		ACC_PPL_LST_12M_AMT_TMP = .;
		ACC_INT_LST_12M_AMT_TMP = .;

	/*	Special variable used in calculating  ACC_MAX_PPL_INT_13_24M_AMT 
											  ACC_MIN_PPL_INT_13_24M_AMT */
		SUM_PPL_INT_13_24M = .;	
		ACC_PPL_13_24M_AMT_TMP = .;
		ACC_INT_13_24M_AMT_TMP = .;

	/*	Special variable used in calculating ACC_CCD_NOUSE_CURR_MTH_CNT */
		NOUSE_TIME_SK1 = TIME_SK;		
	/*	Special variable used in calculating ACC_CCD_NOUSE_LST_3M_MTH_CNT */
		NOUSE_TIME_SK3 = TIME_SK;
	/*	Special variable used in calculating ACC_CCD_NOUSE_LST_6M_MTH_CNT */
		NOUSE_TIME_SK6 = TIME_SK;
	/*	Special variable used in calculating ACC_CCD_NOUSE_LST_12M_MTH_CNT */
		NOUSE_TIME_SK12 = TIME_SK;
	/*	Special variable used in calculating ACC_CCD_NOUSE_13_24M_MTH_CNT */
		NOUSE_TIME_SK13_24 = TIME_SK;
END;

/*The expressions like summations, max, min, count, average are all done here */
/*Check starts for 3 month calculations */
IF (COUNT < 1) THEN
DO;
/*Variables of TRANS_CASHBACK_REFUND_CURR_MTH */
	/* Check for cash_back type of transactions */
	IF TRANSACTION_TYPE_CD IN (&CBK_TRANS_TYPE) THEN 
	DO;
			ACC_CSHBCK_CURR_MTH_AMT + TRANSACTION_AMT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CSHBCK_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_CSHBCK_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CSHBCK_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_CSHBCK_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check for refund type of transactions */
	IF TRANSACTION_TYPE_CD IN (&REF_TRANS_TYPE) THEN 
	DO;	
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_REF_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_REF_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_REF_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_REF_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;

		ACC_REF_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_REF_CURR_MTH_CNT + TRANSACTION_CNT;	
	END;

/*Variables of TRANS_CCD_MERCHANTCAT_CURR_MTH */
	/* Check if merchant category code is airline */	
	IF MERCHANT_CATEGORY_CD IN (&ARL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ARL_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_ARL_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is automative */	
	IF MERCHANT_CATEGORY_CD IN (&AUT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_AUT_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_AUT_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is clothing */	
	IF MERCHANT_CATEGORY_CD IN (&CLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CLTH_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_CLTH_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is car rentals */	
	IF MERCHANT_CATEGORY_CD IN (&CRN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CRN_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_CRN_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is entertainment and recreation */	
	IF MERCHANT_CATEGORY_CD IN (&ENT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ENT_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_ENT_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Financial Services */	
	IF MERCHANT_CATEGORY_CD IN (&FIN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FIN_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_FIN_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Food */	
	IF MERCHANT_CATEGORY_CD IN (&FUD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FUD_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_FUD_CURR_MTH_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Government */	
	IF MERCHANT_CATEGORY_CD IN (&GOV_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_GOV_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_GOV_CURR_MTH_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Household/Shelter */	
	IF MERCHANT_CATEGORY_CD IN (&HHD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HHD_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_HHD_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Health and Education */	
	IF MERCHANT_CATEGORY_CD IN (&HLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HLTH_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_HLTH_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Hotels */	
	IF MERCHANT_CATEGORY_CD IN (&HTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HTL_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_HTL_CURR_MTH_CNT + TRANSACTION_CNT;
	END;

	/* We need to get the number of months where there was no 
		credit card transaction */
	/* Check if the medium is NOT credit card, and account is NOT of credit card type */
	IF (MEDIUM_CD NOT IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD NOT IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		IF NOUSE_TIME_SK1 = TIME_SK THEN 
		DO;
			NOUSE_TIME_SK1 = NOUSE_TIME_SK1 - 1;		
			NOUSE_CNTR1 = NOUSE_CNTR1 + 1;
		END;
	END;

	/* Check if the medium is credit card, and account is of credit card type */
	IF (MEDIUM_CD IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		ACC_CCD_USE_CURR_MTH_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Personal Shopping */	
	IF MERCHANT_CATEGORY_CD IN (&PER_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_PER_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_PER_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Transportation */	
	IF MERCHANT_CATEGORY_CD IN (&TPT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_TPT_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_TPT_CURR_MTH_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Utility payments */	
	IF MERCHANT_CATEGORY_CD IN (&UTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_UTLY_CURR_MTH_AMT + TRANSACTION_AMT;
		ACC_CCD_UTLY_CURR_MTH_CNT + TRANSACTION_CNT;
	END;
	
/* Variables of TRANS_CHANNEL_USAGE_CURR_MTH */
	/* Check if transaction channel is ATM */
	IF CHANNEL_CD IN (&ATM_CHANNEL) THEN DO;
		ACC_ATM_USE_CURR_MTH_CNT + TRANSACTION_CNT; END;
	
	/* Check if transaction channel is Internet */
	IF CHANNEL_CD IN (&INN_CHANNEL) THEN DO;
		ACC_INN_USE_CURR_MTH_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Telephone */
	IF CHANNEL_CD IN (&PHN_CHANNEL) THEN DO;
		ACC_PHN_USE_CURR_MTH_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Teller/Branch */
	IF CHANNEL_CD IN (&TLR_CHANNEL) THEN DO;
		ACC_TLR_USE_CURR_MTH_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_CHECK_ISSUE_CURR_MTH */
	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		/* Check if medium is cheque */
		IF MEDIUM_CD IN (&CHQ_MEDIUM) THEN 
		DO;
			ACC_CHQ_ISU_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_CHQ_ISU_CURR_MTH_CNT + TRANSACTION_CNT;
		END;
		/* Total amount paid by the card holder in the current month */
			ACC_PAY_CURR_MTH_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PAY_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_PAY_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PAY_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_PAY_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_DDR_SORD_CURR_MTH */
	/* Check if transaction type is direct debit */
	IF TRANSACTION_TYPE_CD IN (&DDR_TRANS_TYPE) THEN 
	DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DDR_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_DDR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DDR_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_DDR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;

			ACC_DDR_CURR_MTH_AMT + TRANSACTION_AMT;		
	END;

	/* Check if transaction type is standing orders */
	IF TRANSACTION_TYPE_CD IN (&SOR_TRANS_TYPE) THEN DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_SORD_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_SORD_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_SORD_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_SORD_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;

			ACC_SORD_CURR_MTH_AMT + TRANSACTION_AMT;	
	END;
	
/* Variables of TRANS_DEP_WDR_CURR_MTH */
	/* Check if transaction type is Withdrawal */
	IF TRANSACTION_TYPE_CD IN (&WDR_TRANS_TYPE) THEN 
	DO;
			ACC_WDR_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_WDR_CURR_MTH_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_WDR_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_WDR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_WDR_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_WDR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;

		/*Check if channel is ATM*/
		IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
		DO;
				ACC_ATM_WDR_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_ATM_WDR_CURR_MTH_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ATM_WDR_CURR_MTH_AMT, min_value) THEN DO;
				ACC_MAX_ATM_WDR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ATM_WDR_CURR_MTH_AMT, max_value) THEN DO;
				ACC_MIN_ATM_WDR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END;

		/*Check if channel is Teller/branch */
		IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
		DO;
				ACC_TLR_WDR_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_TLR_WDR_CURR_MTH_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TLR_WDR_CURR_MTH_AMT, min_value) THEN DO;
				ACC_MAX_TLR_WDR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TLR_WDR_CURR_MTH_AMT, max_value) THEN DO;
				ACC_MIN_TLR_WDR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END;	
	END;

	/* Check if transaction type is Deposit Encashment */
	IF TRANSACTION_TYPE_CD IN (&DEN_TRANS_TYPE) THEN 
	DO;
		ACC_DEP_ENC_CURR_MTH_AMT + TRANSACTION_AMT;
				
		/*Check if account has been closed and closing reason is deposit early encashment */
		IF CLOSE_DT NE . AND CLOSE_REASON_CD IN (&ECH_CLOSE_REASON) THEN 
		DO;
		/* check if year and month of close date and of cal mnth date are same */
			IF ((YEAR(CLOSE_DT) EQ YEAR(CAL_MONTH_FIRST_DT))
						AND
				(MONTH(CLOSE_DT) EQ MONTH(CAL_MONTH_FIRST_DT))) THEN DO;

					ACC_DEP_ERLY_ENC_CURR_MTH_CNT = ACC_DEP_ERLY_ENC_CURR_MTH_CNT + 1; END;
				
		END;
	END;
	
	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_DEP_CURR_MTH_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_DEP_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_DEP_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/*Check if transactions are made using Credit card*/
	IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
	DO;
			ACC_CR_TRNS_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_CR_TRNS_CURR_MTH_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CR_TRNS_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_CR_TRNS_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CR_TRNS_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_CR_TRNS_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;

	/*Check if transactions are made using Debit card*/
	IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
	DO;
			ACC_DR_TRNS_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_DR_TRNS_CURR_MTH_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DR_TRNS_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_DR_TRNS_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DR_TRNS_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_DR_TRNS_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;
		
	/* Variables of TRANS_FEES_CURR_MTH */
	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for atm/debit card issuance*/
		IF FEE_REASON_TYPE_CD IN (&ATM_FEE_TYPE) THEN DO;
			ACC_ATM_ISU_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is balance below the limit fees */
		IF FEE_REASON_TYPE_CD IN (&BBL_FEE_TYPE) THEN DO;
			ACC_BBLO_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is cash advance */
		IF FEE_REASON_TYPE_CD IN (&CAD_FEE_TYPE) THEN DO;
			ACC_CADV_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Check book issuance */
		IF FEE_REASON_TYPE_CD IN (&CHQ_FEE_TYPE) THEN DO;
			ACC_CHQ_BK_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		
		/* Check if fees type is Dishonoured payment fees */ 
		IF FEE_REASON_TYPE_CD IN (&DSH_FEE_TYPE) THEN DO;
			ACC_DSHNR_PAY_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Duplicate statement issuance fees */
		IF FEE_REASON_TYPE_CD IN (&DST_FEE_TYPE) THEN DO;
			ACC_DUP_STMT_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;

		/* For all applicable fees type */
			ACC_FEE_CURR_MTH_AMT + TRANSACTION_AMT;	

		/* Check if fees type is Overdraft facility fees */
		IF FEE_REASON_TYPE_CD IN (&OVF_FEE_TYPE) THEN DO;
			ACC_OVD_FACY_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Over the limit fees */
		IF FEE_REASON_TYPE_CD IN (&OTL_FEE_TYPE) THEN DO;
			ACC_OTL_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Incoming balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&IBT_FEE_TYPE) THEN DO;
			ACC_IBT_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Increasing credit limit fees */
		IF FEE_REASON_TYPE_CD IN (&CLI_FEE_TYPE) THEN DO;
			ACC_LMT_INR_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* For all applicable fees type */
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FEE_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_FEE_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FEE_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_FEE_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		/* Check if fees type is Missed or unpaid installment fees */
		IF FEE_REASON_TYPE_CD IN (&MIS_FEE_TYPE) THEN DO;
			ACC_MIS_INST_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Account maintenance fees */
		IF FEE_REASON_TYPE_CD IN (&MNT_FEE_TYPE) THEN DO;
			ACC_MNTS_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Outgoing balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&OBT_FEE_TYPE) THEN DO;
			ACC_OBT_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Prepayment penalty fees */
		IF FEE_REASON_TYPE_CD IN (&PPP_FEE_TYPE) THEN DO;
			ACC_PPY_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is fixed to floating rate fees */
		IF FEE_REASON_TYPE_CD IN (&FXF_FEE_TYPE) THEN DO;
			ACC_RTTYP_CHG_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is visit fees */
		IF FEE_REASON_TYPE_CD IN (&VIS_FEE_TYPE) THEN DO;
			ACC_SRV_VIS_FEE_CURR_MTH_AMT + TRANSACTION_AMT;
		END;		
		/* Check if fees type is Transaction charges fees */
		IF FEE_REASON_TYPE_CD IN (&TRN_FEE_TYPE) THEN DO;
			ACC_TRNS_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
		/*Check if fees type is delayed payments only */
		IF FEE_REASON_TYPE_CD IN (&DLP_FEE_TYPE) THEN 
		DO;
				ACC_DLD_PAY_FEE_CURR_MTH_AMT + TRANSACTION_AMT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(MAX_DFEE2AVG_INST_CURR_PCT, min_value) THEN DO; 
				MAX_DFEE2AVG_INST_CURR_PCT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(MIN_DFEE2AVG_INST_CURR_PCT, max_value) THEN DO; 
				MIN_DFEE2AVG_INST_CURR_PCT = MIN_TRANSACTION_AMT; END;

				CNT_DFEE2AVG_CURR + 1;
				SUM_RPPCURR + REGULAR_PERIODIC_PAYMENT_AMT;
				AVG_INST_CURR_PCT = SUM_RPPCURR / CNT_DFEE2AVG_CURR; /* Average calculation */
				ACC_MAX_DFEE2AVG_INST_CURR_PCT = (MAX_DFEE2AVG_INST_CURR_PCT / AVG_INST_CURR_PCT)*100;
				/* final abt variable derivation */	
				ACC_MIN_DFEE2AVG_INST_CURR_PCT = (MIN_DFEE2AVG_INST_CURR_PCT / AVG_INST_CURR_PCT)*100;
				/* final abt variable derivation */ 
		END;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;

		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_CURR_MTH_AMT + TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_FEES_WAIVED_CURR_MTH */
	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
			ACC_FWV_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_FWV_CURR_MTH_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FWV_CURR_MTH_AMT, min_value) THEN DO; 
			ACC_MAX_FWV_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FWV_CURR_MTH_AMT, max_value) THEN DO; 
			ACC_MIN_FWV_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END; 
	END;

/* Variables of TRANS_INST_PAYMENTS_CURR_MTH */
	/* Check for interest payment type transactions */
	IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
	DO;
			ACC_INT_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_INT_CURR_MTH_CNT + TRANSACTION_CNT;

			/*Temporary variable used in calculating ACC_MAX_PPL_INT_CURR_MTH_AMT 
												 and ACC_MIN_PPL_INT_CURR_MTH_AMT */
			ACC_INT_CURR_MTH_AMT_TMP + TRANSACTION_AMT; 
			
			/* final abt derivation */
			ACC_PPL_INT_PYD_CURR_MTH_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_CURR_MTH_AMT, min_value) THEN DO; 
			ACC_MAX_INT_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_CURR_MTH_AMT, max_value) THEN DO; 
			ACC_MIN_INT_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RCD_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_INT_RCD_CURR_MTH_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_RCD_CURR_MTH_AMT, min_value) THEN DO; 
			ACC_MAX_INT_RCD_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_RCD_CURR_MTH_AMT, max_value) THEN DO; 
			ACC_MIN_INT_RCD_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RINV_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_INT_RINV_CURR_MTH_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INT_RINV_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MX_INT_RINV_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INT_RINV_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MN_INT_RINV_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;	
	
	/* Check if transaction type is principal payment */	
	IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
	DO;
			ACC_PPL_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_PPL_CURR_MTH_CNT + TRANSACTION_CNT; /*Note: This field is not
																		present in excel*/
			/* Temporary variable used to calculate ACC_MAX_PPL_INT_CURR_MTH_AMT 
												and ACC_MIN_PPL_INT_CURR_MTH_AMT */
			ACC_PPL_CURR_MTH_AMT_TMP + TRANSACTION_AMT; 
			
			ACC_PPL_INT_PYD_CURR_MTH_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PPL_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_PPL_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PPL_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_PPL_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;	
		
	/* Check if transaction type is Additional payment */
	IF TRANSACTION_TYPE_CD IN (&APY_TRANS_TYPE) THEN 
	DO;
		ACC_ADDL_PAY_CURR_MTH_AMT + TRANSACTION_AMT;/*NOTE: Not in excel*/ 
		ACC_ADDL_PAY_CURR_MTH_CNT + TRANSACTION_CNT; 
	END;
	
	/* Check for escrow type transaction */
		IF TRANSACTION_TYPE_CD IN (&ESC_TRANS_TYPE) THEN 
		DO;
				ACC_ESCR_CURR_MTH_AMT + TRANSACTION_AMT;
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ESCR_PYD_CURR_MTH_AMT, min_value) THEN DO;
				ACC_MAX_ESCR_PYD_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ESCR_PYD_CURR_MTH_AMT, max_value) THEN DO;
				ACC_MIN_ESCR_PYD_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END;	

	/* Variables of TRANS_PAYMENTS_CURR_MTH */

			ACC_DLD_PAY_CURR_MTH_CNT + LATE_PAYMENT_CNT;
	/*Check if transaction status reason is dishonoured payment */
	IF TRANSACTION_STATUS_REASON_CD IN (&DSH_TRANS_STATUS) THEN 
	DO;
			ACC_DSHNR_PAY_CURR_MTH_AMT + TRANSACTION_AMT;
			ACC_DSHNR_PAY_CURR_MTH_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DSHNR_PAY_CURR_MTH_AMT, min_value) THEN DO; 
			ACC_MAX_DSHNR_PAY_CURR_MTH_AMT = MAX_TRANSACTION_AMT;	END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DSHNR_PAY_CURR_MTH_AMT, max_value) THEN DO; 
			ACC_MIN_DSHNR_PAY_CURR_MTH_AMT  = MIN_TRANSACTION_AMT; END; 
	END;

/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN DO;
			ACC_PREPAY_CURR_MTH_AMT + TRANSACTION_AMT; END;	

/* Variables of TRANS_PUR_CADV_OVL_CURR_MTH */
/* Check if transaction type is purchase */
	IF TRANSACTION_TYPE_CD IN (&PUR_TRANS_TYPE) THEN 
	DO;
	/* Check if its an international purchase */
		IF INTERNAL_ORG_COUNTRY_CD NE COUNTRY_CD THEN 
		DO; 
				ACC_IPUR_CURR_MTH_AMT + TRANSACTION_AMT; 
				ACC_IPUR_CURR_MTH_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IPUR_CURR_MTH_AMT, min_value) THEN DO; 
				ACC_MAX_IPUR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IPUR_CURR_MTH_AMT, max_value) THEN DO; 
				ACC_MIN_IPUR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END;

	/* Check if its a local purchase */
		IF INTERNAL_ORG_COUNTRY_CD EQ COUNTRY_CD THEN 
		DO; 
				ACC_LPUR_CURR_MTH_AMT + TRANSACTION_AMT; 
				ACC_LPUR_CURR_MTH_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_LPUR_CURR_MTH_AMT, min_value) THEN DO; 
				ACC_MAX_LPUR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_LPUR_CURR_MTH_AMT, max_value) THEN DO; 
				ACC_MIN_LPUR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PUR_CURR_MTH_AMT, min_value) THEN DO; 
				ACC_MAX_PUR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PUR_CURR_MTH_AMT, max_value) THEN DO; 
				ACC_MIN_PUR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
			
				ACC_PUR_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_PUR_CURR_MTH_CNT + TRANSACTION_CNT;
	END;	

	/* Check if transaction type is Cash Advance */
	IF TRANSACTION_TYPE_CD IN (&CAD_TRANS_TYPE) THEN 
	DO;
				ACC_CADV_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_CADV_CURR_MTH_CNT + TRANSACTION_CNT;

				CADV_CURR_CNTR + 1;
				ACC_AVG_CADV_CURR_MTH_AMT = ACC_CADV_CURR_MTH_AMT / CADV_CURR_CNTR;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CADV_CURR_MTH_AMT, min_value) THEN DO; 
				ACC_MAX_CADV_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CADV_CURR_MTH_AMT, max_value) THEN DO; 
				ACC_MIN_CADV_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check to determine the number of times account was over the limit 
		in the current month */	
	IF OVER_LIMIT_CNT > 0 THEN DO;
		ACC_OTL_CURR_MTH_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_SUMMARY_CURR_MTH */
	/* Total number of transactions in the current month */
		ACC_TRNS_CURR_MTH_CNT + TRANSACTION_CNT;
	/* Total amount of transactions in the current month */
		ACC_TRNS_CURR_MTH_AMT + TRANSACTION_AMT;
	
/* Variables of TRANS_TRANSFER_CURR_MTH */
/* Check if transaction type is transfer */
	IF TRANSACTION_TYPE_CD IN (&TRS_TRANS_TYPE) THEN 
	DO;
	/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
		/* Check if channel is internet */	
			IF CHANNEL_CD IN (&INN_CHANNEL) THEN 
			DO;
					ACC_INN_TRS_FR_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_INN_TRS_FR_CURR_MTH_CNT + TRANSACTION_CNT;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INN_TRS_FR_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MN_INN_TRS_FR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INN_TRS_FR_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MX_INN_TRS_FR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			END;

		/* Check if channel is ATM */	
			IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_ATM_TRS_FR_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MN_ATM_TRS_FR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_ATM_TRS_FR_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MX_ATM_TRS_FR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
			END;

	   	/*Check if channel is ATM or SST*/
			IF CHANNEL_CD IN (&ATM_CHANNEL,&SST_CHANNEL) THEN 
			DO;
				ACC_ATM_SST_TRS_FR_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_ATM_SST_TRS_FR_CURR_MTH_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Telephone */	
			IF CHANNEL_CD IN (&PHN_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_PHN_TRS_FR_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MN_PHN_TRS_FR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_PHN_TRS_FR_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MX_PHN_TRS_FR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_PHN_TRS_FR_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_PHN_TRS_FR_CURR_MTH_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Teller/branch */	
			IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_TLR_TRS_FR_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MN_TLR_TRS_FR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_TLR_TRS_FR_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MX_TLR_TRS_FR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_TLR_TRS_FR_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_TLR_TRS_FR_CURR_MTH_CNT + TRANSACTION_CNT;
			END;

				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_FR_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_FR_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;	
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_FR_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_FR_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_FR_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_TRS_FR_CURR_MTH_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = debit block */

	/* Check if its a credit card transaction */
		IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
		DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_IN2_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_IN2_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_IN2_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_IN2_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_IN2_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_TRS_IN2_CURR_MTH_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = credit block */	
	END;/* end of transfer type transaction block */

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
					ACC_IBT_CURR_MTH_AMT + TRANSACTION_AMT;
					ACC_IBT_CURR_MTH_CNT + TRANSACTION_CNT;	
				
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_CURR_MTH_AMT, min_value) THEN DO; 
					ACC_MAX_IBT_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_CURR_MTH_AMT, max_value) THEN DO; 
					ACC_MIN_IBT_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */
	
	/* Check if transaction type is outgoing balance transfer */
	IF TRANSACTION_TYPE_CD IN (&OBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
				ACC_OBT_CURR_MTH_AMT + TRANSACTION_AMT;
				ACC_OBT_CURR_MTH_CNT + TRANSACTION_CNT;	
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_OBT_CURR_MTH_AMT, min_value) THEN DO; 
				ACC_MAX_OBT_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_OBT_CURR_MTH_AMT, max_value) THEN DO; 
				ACC_MIN_OBT_CURR_MTH_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */

	/*check for group of time_sk */
	IF LAST.TIME_SK THEN 
	DO;
		SUM_PPL_INT_CURR_MTH = ACC_PPL_CURR_MTH_AMT_TMP + ACC_INT_CURR_MTH_AMT_TMP;

		/*To find out the max and min of principal+interest paid */
		IF SUM_PPL_INT_CURR_MTH > COALESCE(ACC_MAX_PPL_INT_CURR_MTH_AMT, min_value) THEN DO;
			ACC_MAX_PPL_INT_CURR_MTH_AMT = SUM_PPL_INT_CURR_MTH; END;
		IF SUM_PPL_INT_CURR_MTH < COALESCE(ACC_MIN_PPL_INT_CURR_MTH_AMT, max_value) THEN DO;
			ACC_MIN_PPL_INT_CURR_MTH_AMT = SUM_PPL_INT_CURR_MTH; END;
		
		/* Count the number of times credit card transactions were not made in the 
			current month */
		ACC_CCD_NOUSE_CURR_MTH_MTH_CNT + NOUSE_CNTR1;

		/*Special variables used in calculating ACC_CCD_NOUSE_CURR_MTH_MTH_CNT is reset here */
		NOUSE_CNTR1 = 0;
	END;
END;
ELSE IF (COUNT < 3) THEN 
DO;
/*Variables of TRANS_CASHBACK_REFUND_LST_3M */
	/* Check for cash_back type of transactions */
	IF TRANSACTION_TYPE_CD IN (&CBK_TRANS_TYPE) THEN 
	DO;
			ACC_CSHBCK_LST_3M_AMT + TRANSACTION_AMT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CSHBCK_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_CSHBCK_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CSHBCK_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_CSHBCK_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for refund type of transactions */
	IF TRANSACTION_TYPE_CD IN (&REF_TRANS_TYPE) THEN 
	DO;	
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_REF_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_REF_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_REF_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_REF_LST_3M_AMT = MIN_TRANSACTION_AMT; END;

		ACC_REF_LST_3M_AMT + TRANSACTION_AMT;
		ACC_REF_LST_3M_CNT + TRANSACTION_CNT;	
	END;

/*Variables of TRANS_CCD_MERCHANTCAT_LST_3M */
	/* Check if merchant category code is airline */	
	IF MERCHANT_CATEGORY_CD IN (&ARL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ARL_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_ARL_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is automative */	
	IF MERCHANT_CATEGORY_CD IN (&AUT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_AUT_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_AUT_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is clothing */	
	IF MERCHANT_CATEGORY_CD IN (&CLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CLTH_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_CLTH_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is car rentals */	
	IF MERCHANT_CATEGORY_CD IN (&CRN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CRN_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_CRN_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is entertainment and recreation */	
	IF MERCHANT_CATEGORY_CD IN (&ENT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ENT_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_ENT_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Financial Services */	
	IF MERCHANT_CATEGORY_CD IN (&FIN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FIN_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_FIN_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Food */	
	IF MERCHANT_CATEGORY_CD IN (&FUD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FUD_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_FUD_LST_3M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Government */	
	IF MERCHANT_CATEGORY_CD IN (&GOV_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_GOV_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_GOV_LST_3M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Household/Shelter */	
	IF MERCHANT_CATEGORY_CD IN (&HHD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HHD_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_HHD_LST_3M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Health and Education */	
	IF MERCHANT_CATEGORY_CD IN (&HLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HLTH_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_HLTH_LST_3M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Hotels */	
	IF MERCHANT_CATEGORY_CD IN (&HTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HTL_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_HTL_LST_3M_CNT + TRANSACTION_CNT;
	END;

	/* We need to get the number of months where there was no 
		credit card transaction */
	/* Check if the medium is NOT credit card, and account is NOT of credit card type */
	IF (MEDIUM_CD NOT IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD NOT IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		IF NOUSE_TIME_SK3 = TIME_SK THEN 
		DO;
			NOUSE_TIME_SK3 = NOUSE_TIME_SK3 - 1;		
			NOUSE_CNTR3 = NOUSE_CNTR3 + 1;
		END;
	END;

	/* Check if the medium is credit card, and account is of credit card type */
	IF (MEDIUM_CD IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		ACC_CCD_USE_LST_3M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Personal Shopping */	
	IF MERCHANT_CATEGORY_CD IN (&PER_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_PER_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_PER_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Transportation */	
	IF MERCHANT_CATEGORY_CD IN (&TPT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_TPT_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_TPT_LST_3M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Utility payments */	
	IF MERCHANT_CATEGORY_CD IN (&UTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_UTLY_LST_3M_AMT + TRANSACTION_AMT;
		ACC_CCD_UTLY_LST_3M_CNT + TRANSACTION_CNT;
	END;
	
/* Variables of TRANS_CHANNEL_USAGE_LST_3M */
	/* Check if transaction channel is ATM */
	IF CHANNEL_CD IN (&ATM_CHANNEL) THEN DO;
		ACC_ATM_USE_LST_3M_CNT + TRANSACTION_CNT; END;
	
	/* Check if transaction channel is Internet */
	IF CHANNEL_CD IN (&INN_CHANNEL) THEN DO;
		ACC_INN_USE_LST_3M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Telephone */
	IF CHANNEL_CD IN (&PHN_CHANNEL) THEN DO;
		ACC_PHN_USE_LST_3M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Teller/Branch */
	IF CHANNEL_CD IN (&TLR_CHANNEL) THEN DO;
		ACC_TLR_USE_LST_3M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_CHECK_ISSUE_LST_3M */
	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		/* Check if medium is cheque */
		IF MEDIUM_CD IN (&CHQ_MEDIUM) THEN 
		DO;
			ACC_CHQ_ISU_LST_3M_AMT + TRANSACTION_AMT;
			ACC_CHQ_ISU_LST_3M_CNT + TRANSACTION_CNT;
		END;
		/* Total amount paid by the card holder in the last 3 months */
			ACC_PAY_LST_3M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PAY_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_PAY_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PAY_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_PAY_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_DDR_SORD_LST_3M */
	/* Check if transaction type is direct debit */
	IF TRANSACTION_TYPE_CD IN (&DDR_TRANS_TYPE) THEN 
	DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DDR_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_DDR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DDR_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_DDR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_DDR_LST_3M_AMT + TRANSACTION_AMT;		
	END;

	/* Check if transaction type is standing orders */
	IF TRANSACTION_TYPE_CD IN (&SOR_TRANS_TYPE) THEN DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_SORD_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_SORD_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_SORD_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_SORD_LST_3M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_SORD_LST_3M_AMT + TRANSACTION_AMT;	
	END;
	
/* Variables of TRANS_DEP_WDR_LST_3M */
	/* Check if transaction type is Withdrawal */
	IF TRANSACTION_TYPE_CD IN (&WDR_TRANS_TYPE) THEN 
	DO;
			ACC_WDR_LST_3M_AMT + TRANSACTION_AMT;
			ACC_WDR_LST_3M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_WDR_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_WDR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_WDR_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_WDR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;

		/*Check if channel is ATM*/
		IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
		DO;
				ACC_ATM_WDR_LST_3M_AMT + TRANSACTION_AMT;
				ACC_ATM_WDR_LST_3M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ATM_WDR_LST_3M_AMT, min_value) THEN DO;
				ACC_MAX_ATM_WDR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ATM_WDR_LST_3M_AMT, max_value) THEN DO;
				ACC_MIN_ATM_WDR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		/*Check if channel is Teller/branch */
		IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
		DO;
				ACC_TLR_WDR_LST_3M_AMT + TRANSACTION_AMT;
				ACC_TLR_WDR_LST_3M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TLR_WDR_LST_3M_AMT, min_value) THEN DO;
				ACC_MAX_TLR_WDR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TLR_WDR_LST_3M_AMT, max_value) THEN DO;
				ACC_MIN_TLR_WDR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END;	
	END;

	/* Check if transaction type is Deposit Encashment */
	IF TRANSACTION_TYPE_CD IN (&DEN_TRANS_TYPE) THEN 
	DO;
		ACC_DEP_ENC_LST_3M_AMT + TRANSACTION_AMT;
				
		/*Check if account has been closed and closing reason is deposit early encashment */
		IF CLOSE_DT NE . AND CLOSE_REASON_CD IN (&ECH_CLOSE_REASON) THEN 
		DO;
		/* check if year and month of close date and of cal mnth date are same */
			IF ((YEAR(CLOSE_DT) EQ YEAR(CAL_MONTH_FIRST_DT))
						AND
				(MONTH(CLOSE_DT) EQ MONTH(CAL_MONTH_FIRST_DT))) THEN DO;

					ACC_DEP_ERLY_ENC_LST_3M_CNT = ACC_DEP_ERLY_ENC_LST_3M_CNT + 1; END;
				
		END;
	END;
	
	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_LST_3M_AMT + TRANSACTION_AMT;
			ACC_DEP_LST_3M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_DEP_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_DEP_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/*Check if transactions are made using Credit card*/
	IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
	DO;
			ACC_CR_TRNS_LST_3M_AMT + TRANSACTION_AMT;
			ACC_CR_TRNS_LST_3M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CR_TRNS_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_CR_TRNS_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CR_TRNS_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_CR_TRNS_LST_3M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;

	/*Check if transactions are made using Debit card*/
	IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
	DO;
			ACC_DR_TRNS_LST_3M_AMT + TRANSACTION_AMT;
			ACC_DR_TRNS_LST_3M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DR_TRNS_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_DR_TRNS_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DR_TRNS_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_DR_TRNS_LST_3M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;
		
	/* Variables of TRANS_FEES_LST_3M */
	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for atm/debit card issuance*/
		IF FEE_REASON_TYPE_CD IN (&ATM_FEE_TYPE) THEN DO;
			ACC_ATM_ISU_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is balance below the limit fees */
		IF FEE_REASON_TYPE_CD IN (&BBL_FEE_TYPE) THEN DO;
			ACC_BBLO_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is cash advance */
		IF FEE_REASON_TYPE_CD IN (&CAD_FEE_TYPE) THEN DO;
			ACC_CADV_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Check book issuance */
		IF FEE_REASON_TYPE_CD IN (&CHQ_FEE_TYPE) THEN DO;
			ACC_CHQ_BK_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Dishonoured payment fees */ 
		IF FEE_REASON_TYPE_CD IN (&DSH_FEE_TYPE) THEN DO;
			ACC_DSHNR_PAY_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Duplicate statement issuance fees */
		IF FEE_REASON_TYPE_CD IN (&DST_FEE_TYPE) THEN DO;
			ACC_DUP_STMT_FEE_LST_3M_AMT + TRANSACTION_AMT; END;

		/* For all applicable fees type */
			ACC_FEE_LST_3M_AMT + TRANSACTION_AMT;	

		/* Check if fees type is Overdraft facility fees */
		IF FEE_REASON_TYPE_CD IN (&OVF_FEE_TYPE) THEN DO;
			ACC_OVD_FACY_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Over the limit fees */
		IF FEE_REASON_TYPE_CD IN (&OTL_FEE_TYPE) THEN DO;
			ACC_OTL_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Incoming balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&IBT_FEE_TYPE) THEN DO;
			ACC_IBT_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Increasing credit limit fees */
		IF FEE_REASON_TYPE_CD IN (&CLI_FEE_TYPE) THEN DO;
			ACC_LMT_INR_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* For all applicable fees type */
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FEE_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_FEE_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FEE_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_FEE_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		/* Check if fees type is Missed or unpaid installment fees */
		IF FEE_REASON_TYPE_CD IN (&MIS_FEE_TYPE) THEN DO;
			ACC_MIS_INST_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Account maintenance fees */
		IF FEE_REASON_TYPE_CD IN (&MNT_FEE_TYPE) THEN DO;
			ACC_MNTS_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Outgoing balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&OBT_FEE_TYPE) THEN DO;
			ACC_OBT_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Prepayment penalty fees */
		IF FEE_REASON_TYPE_CD IN (&PPP_FEE_TYPE) THEN DO;
			ACC_PPY_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is fixed to floating rate fees */
		IF FEE_REASON_TYPE_CD IN (&FXF_FEE_TYPE) THEN DO;
			ACC_RTTYP_CHG_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is visit fees */
		IF FEE_REASON_TYPE_CD IN (&VIS_FEE_TYPE) THEN DO;
			ACC_SRV_VIS_FEE_LST_3M_AMT + TRANSACTION_AMT;
		END;		
		/* Check if fees type is Transaction charges fees */
		IF FEE_REASON_TYPE_CD IN (&TRN_FEE_TYPE) THEN DO;
			ACC_TRNS_FEE_LST_3M_AMT + TRANSACTION_AMT; END;
		/*Check if fees type is delayed payments only */
		IF FEE_REASON_TYPE_CD IN (&DLP_FEE_TYPE) THEN 
		DO;
				ACC_DLD_PAY_FEE_LST_3M_AMT + TRANSACTION_AMT;

			IF MAX_TRANSACTION_AMT > COALESCE(MAX_DFEE2AVG_INST_L3M_PCT, min_value) THEN DO; 
				MAX_DFEE2AVG_INST_L3M_PCT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(MIN_DFEE2AVG_INST_L3M_PCT, max_value) THEN DO; 
				MIN_DFEE2AVG_INST_L3M_PCT = MIN_TRANSACTION_AMT; END;

				CNT_DFEE2AVG_3M + 1;
				SUM_RPP3M + REGULAR_PERIODIC_PAYMENT_AMT;
				AVG_INST_L3M_PCT = SUM_RPP3M / CNT_DFEE2AVG_3M; /* Average calculation */
				ACC_MAX_DFEE2AVG_INST_L3M_PCT = (MAX_DFEE2AVG_INST_L3M_PCT / AVG_INST_L3M_PCT)*100;
				/* final abt variable derivation */	
				ACC_MIN_DFEE2AVG_INST_L3M_PCT = (MIN_DFEE2AVG_INST_L3M_PCT / AVG_INST_L3M_PCT)*100;
				/* final abt variable derivation */ 
		END;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_LST_3M_AMT + TRANSACTION_AMT; END;

		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_LST_3M_AMT  + TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_FEES_WAIVED_LST_3M */
	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
			ACC_FWV_LST_3M_AMT + TRANSACTION_AMT;
			ACC_FWV_LST_3M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FWV_LST_3M_AMT, min_value) THEN DO; 
			ACC_MAX_FWV_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FWV_LST_3M_AMT, max_value) THEN DO; 
			ACC_MIN_FWV_LST_3M_AMT = MIN_TRANSACTION_AMT; END; 
	END;

/* Variables of TRANS_INST_PAYMENTS_LST_3M */
	/* Check for interest payment type transactions */
	IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
	DO;
			ACC_INT_LST_3M_AMT + TRANSACTION_AMT;
			ACC_INT_LST_3M_CNT + TRANSACTION_CNT;

			/*Temporary variable used in calculating ACC_MAX_PPL_INT_LST_3M_AMT 
												 and ACC_MIN_PPL_INT_LST_3M_AMT */
			ACC_INT_LST_3M_AMT_TMP + TRANSACTION_AMT; 
			
			/* final abt derivation */
			ACC_PPL_INT_PYD_LST_3M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_LST_3M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_LST_3M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RCD_LST_3M_AMT + TRANSACTION_AMT;
			ACC_INT_RCD_LST_3M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_RCD_LST_3M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_RCD_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_RCD_LST_3M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_RCD_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RINV_LST_3M_AMT + TRANSACTION_AMT;
			ACC_INT_RINV_LST_3M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INT_RINV_LST_3M_AMT, min_value) THEN DO;
			ACC_MX_INT_RINV_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INT_RINV_LST_3M_AMT, max_value) THEN DO;
			ACC_MN_INT_RINV_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
	
	/* Check if transaction type is principal payment */	
	IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
	DO;
			ACC_PPL_LST_3M_AMT + TRANSACTION_AMT;
			ACC_PPL_LST_3M_CNT + TRANSACTION_CNT; /*Note: This field is not
																		present in excel*/
			/* Temporary variable used to calculate ACC_MAX_PPL_INT_LST_3M_AMT 
												and ACC_MIN_PPL_INT_LST_3M_AMT */
			ACC_PPL_LST_3M_AMT_TMP + TRANSACTION_AMT; 
			
			ACC_PPL_INT_PYD_LST_3M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PPL_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PPL_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
		
	/* Check if transaction type is Additional payment */
	IF TRANSACTION_TYPE_CD IN (&APY_TRANS_TYPE) THEN 
	DO;
		ACC_ADDL_PAY_LST_3M_AMT + TRANSACTION_AMT;/*NOTE: Not in excel*/ 
		ACC_ADDL_PAY_LST_3M_CNT + TRANSACTION_CNT; 
	END;
	
	/* Check for escrow type transaction */
		IF TRANSACTION_TYPE_CD IN (&ESC_TRANS_TYPE) THEN 
		DO;
				ACC_ESCR_LST_3M_AMT + TRANSACTION_AMT; 
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ESCR_PYD_LST_3M_AMT, min_value)  THEN DO;
				ACC_MAX_ESCR_PYD_LST_3M_AMT  = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ESCR_PYD_LST_3M_AMT, max_value) THEN DO;
				ACC_MIN_ESCR_PYD_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END;	

	/* Variables of TRANS_PAYMENTS_LST_3M */

			ACC_DLD_PAY_LST_3M_CNT + LATE_PAYMENT_CNT;
	/*Check if transaction status reason is dishonoured payment */
	IF TRANSACTION_STATUS_REASON_CD IN (&DSH_TRANS_STATUS) THEN 
	DO;
			ACC_DSHNR_PAY_LST_3M_AMT + TRANSACTION_AMT;
			ACC_DSHNR_PAY_LST_3M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DSHNR_PAY_LST_3M_AMT, min_value) THEN DO; 
			ACC_MAX_DSHNR_PAY_LST_3M_AMT = MAX_TRANSACTION_AMT;	END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DSHNR_PAY_LST_3M_AMT, max_value) THEN DO; 
			ACC_MIN_DSHNR_PAY_LST_3M_AMT  = MIN_TRANSACTION_AMT; END; 
	END;

/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN DO;
			ACC_PREPAY_LST_3M_AMT + TRANSACTION_AMT; END;	

/* Variables of TRANS_PUR_CADV_OVL_LST_3M */
/* Check if transaction type is purchase */
	IF TRANSACTION_TYPE_CD IN (&PUR_TRANS_TYPE) THEN 
	DO;
	/* Check if its an international purchase */
		IF INTERNAL_ORG_COUNTRY_CD NE COUNTRY_CD THEN 
		DO; 
				ACC_IPUR_LST_3M_AMT + TRANSACTION_AMT; 
				ACC_IPUR_LST_3M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IPUR_LST_3M_AMT, min_value) THEN DO; 
				ACC_MAX_IPUR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IPUR_LST_3M_AMT, max_value) THEN DO; 
				ACC_MIN_IPUR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END;

	/* Check if its a local purchase */
		IF INTERNAL_ORG_COUNTRY_CD EQ COUNTRY_CD THEN 
		DO; 
				ACC_LPUR_LST_3M_AMT + TRANSACTION_AMT; 
				ACC_LPUR_LST_3M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_LPUR_LST_3M_AMT, min_value) THEN DO; 
				ACC_MAX_LPUR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_LPUR_LST_3M_AMT, max_value) THEN DO; 
				ACC_MIN_LPUR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PUR_LST_3M_AMT, min_value) THEN DO; 
				ACC_MAX_PUR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PUR_LST_3M_AMT, max_value) THEN DO; 
				ACC_MIN_PUR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
			
				ACC_PUR_LST_3M_AMT + TRANSACTION_AMT;
				ACC_PUR_LST_3M_CNT + TRANSACTION_CNT;
	END;	

	/* Check if transaction type is Cash Advance */
	IF TRANSACTION_TYPE_CD IN (&CAD_TRANS_TYPE) THEN 
	DO;
				ACC_CADV_LST_3M_AMT + TRANSACTION_AMT;
				ACC_CADV_LST_3M_CNT + TRANSACTION_CNT;

				CADV_3M_CNTR + 1;
				ACC_AVG_CADV_LST_3M_AMT = ACC_CADV_LST_3M_AMT / CADV_3M_CNTR;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CADV_LST_3M_AMT, min_value) THEN DO; 
				ACC_MAX_CADV_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CADV_LST_3M_AMT, max_value) THEN DO; 
				ACC_MIN_CADV_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check to determine the number of times account was over the limit 
		in the last 3 months */	
	IF OVER_LIMIT_CNT > 0 THEN DO;
		ACC_OTL_LST_3M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_SUMMARY_LST_3M */
	/* Total number of transactions in the last 3 months */
		ACC_TRNS_LST_3M_CNT + TRANSACTION_CNT;
	/* Total amount of transactions in the last 3 months */
		ACC_TRNS_LST_3M_AMT + TRANSACTION_AMT;
	
/* Variables of TRANS_TRANSFER_LST_3M */
/* Check if transaction type is transfer */
	IF TRANSACTION_TYPE_CD IN (&TRS_TRANS_TYPE) THEN 
	DO;
	/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
		/* Check if channel is internet */	
			IF CHANNEL_CD IN (&INN_CHANNEL) THEN 
			DO;
					ACC_INN_TRS_FR_LST_3M_AMT + TRANSACTION_AMT;
					ACC_INN_TRS_FR_LST_3M_CNT + TRANSACTION_CNT;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INN_TRS_FR_LST_3M_AMT, max_value) THEN DO; 
					ACC_MN_INN_TRS_FR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INN_TRS_FR_LST_3M_AMT, min_value) THEN DO; 
					ACC_MX_INN_TRS_FR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
			END;

		/* Check if channel is ATM */	
			IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_ATM_TRS_FR_LST_3M_AMT, max_value) THEN DO; 
					ACC_MN_ATM_TRS_FR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_ATM_TRS_FR_LST_3M_AMT, min_value) THEN DO; 
					ACC_MX_ATM_TRS_FR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
			END;

		/*Check if channel is ATM or SST*/
			IF CHANNEL_CD IN (&ATM_CHANNEL,&SST_CHANNEL) THEN 
			DO;
				ACC_ATM_SST_TRS_FR_LST_3M_AMT + TRANSACTION_AMT;
				ACC_ATM_SST_TRS_FR_LST_3M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Telephone */	
			IF CHANNEL_CD IN (&PHN_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_PHN_TRS_FR_LST_3M_AMT, max_value) THEN DO; 
					ACC_MN_PHN_TRS_FR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_PHN_TRS_FR_LST_3M_AMT, min_value) THEN DO; 
					ACC_MX_PHN_TRS_FR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_PHN_TRS_FR_LST_3M_AMT + TRANSACTION_AMT;
					ACC_PHN_TRS_FR_LST_3M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Teller/branch */	
			IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_TLR_TRS_FR_LST_3M_AMT, max_value) THEN DO; 
					ACC_MN_TLR_TRS_FR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_TLR_TRS_FR_LST_3M_AMT, min_value) THEN DO; 
					ACC_MX_TLR_TRS_FR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_TLR_TRS_FR_LST_3M_AMT + TRANSACTION_AMT;
					ACC_TLR_TRS_FR_LST_3M_CNT + TRANSACTION_CNT;
			END;

				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_FR_LST_3M_AMT, max_value) THEN DO; 
					ACC_MAX_TRS_FR_LST_3M_AMT = MAX_TRANSACTION_AMT; END;	
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_FR_LST_3M_AMT, min_value) THEN DO; 
					ACC_MIN_TRS_FR_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_FR_LST_3M_AMT + TRANSACTION_AMT;
					ACC_TRS_FR_LST_3M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = debit block */

	/* Check if its a credit card transaction */
		IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
		DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_IN2_LST_3M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_IN2_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_IN2_LST_3M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_IN2_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_IN2_LST_3M_AMT + TRANSACTION_AMT;
					ACC_TRS_IN2_LST_3M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = credit block */	
	END;/* end of transfer type transaction block */

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
					ACC_IBT_LST_3M_AMT + TRANSACTION_AMT;
					ACC_IBT_LST_3M_CNT + TRANSACTION_CNT;	
				
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_LST_3M_AMT, min_value) THEN DO; 
					ACC_MAX_IBT_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_LST_3M_AMT, max_value) THEN DO; 
					ACC_MIN_IBT_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */
	
	/* Check if transaction type is outgoing balance transfer */
	IF TRANSACTION_TYPE_CD IN (&OBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
				ACC_OBT_LST_3M_AMT + TRANSACTION_AMT;
				ACC_OBT_LST_3M_CNT + TRANSACTION_CNT;	
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_OBT_LST_3M_AMT, min_value) THEN DO; 
				ACC_MAX_OBT_LST_3M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_OBT_LST_3M_AMT, max_value) THEN DO; 
				ACC_MIN_OBT_LST_3M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */

	/*check for group of time_sk */
	IF LAST.TIME_SK THEN 
	DO;
		SUM_PPL_INT_3M = ACC_PPL_LST_3M_AMT_TMP + ACC_INT_LST_3M_AMT_TMP;

		/*To find out the max and min of principal+interest paid */
		IF SUM_PPL_INT_3M > COALESCE(ACC_MAX_PPL_INT_LST_3M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_INT_LST_3M_AMT = SUM_PPL_INT_3M; END;
		IF SUM_PPL_INT_3M < COALESCE(ACC_MIN_PPL_INT_LST_3M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_INT_LST_3M_AMT = SUM_PPL_INT_3M; END;
		
		/* Count the number of times credit card transactions were not made in the 
			last 3 months */
		ACC_CCD_NOUSE_LST_3M_MTH_CNT + NOUSE_CNTR3;

		/*Special variables used in calculating ACC_CCD_NOUSE_LST_3M_MTH_CNT is reset here */
		NOUSE_CNTR3 = 0;
	END;
END;

/*Check starts for 6 month calculations */	
ELSE IF (COUNT <  6) THEN 
DO;
/*Variables of TRANS_CASHBACK_REFUND_LST_6M */
	/* Check for cash_back type of transactions */
	IF TRANSACTION_TYPE_CD IN (&CBK_TRANS_TYPE) THEN 
	DO;
			ACC_CSHBCK_LST_6M_AMT + TRANSACTION_AMT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CSHBCK_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_CSHBCK_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CSHBCK_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_CSHBCK_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for refund type of transactions */
	IF TRANSACTION_TYPE_CD IN (&REF_TRANS_TYPE) THEN 
	DO;	
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_REF_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_REF_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_REF_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_REF_LST_6M_AMT = MIN_TRANSACTION_AMT; END;

		ACC_REF_LST_6M_AMT + TRANSACTION_AMT;
		ACC_REF_LST_6M_CNT + TRANSACTION_CNT;	
	END;

/*Variables of TRANS_CCD_MERCHANTCAT_LST_6M */
	/* Check if merchant category code is airline */	
	IF MERCHANT_CATEGORY_CD IN (&ARL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ARL_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_ARL_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is automative */	
	IF MERCHANT_CATEGORY_CD IN (&AUT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_AUT_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_AUT_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is clothing */	
	IF MERCHANT_CATEGORY_CD IN (&CLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CLTH_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_CLTH_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is car rentals */	
	IF MERCHANT_CATEGORY_CD IN (&CRN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CRN_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_CRN_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is entertainment and recreation */	
	IF MERCHANT_CATEGORY_CD IN (&ENT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ENT_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_ENT_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Financial Services */	
	IF MERCHANT_CATEGORY_CD IN (&FIN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FIN_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_FIN_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Food */	
	IF MERCHANT_CATEGORY_CD IN (&FUD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FUD_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_FUD_LST_6M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Government */	
	IF MERCHANT_CATEGORY_CD IN (&GOV_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_GOV_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_GOV_LST_6M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Household/Shelter */	
	IF MERCHANT_CATEGORY_CD IN (&HHD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HHD_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_HHD_LST_6M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Health and Education */	
	IF MERCHANT_CATEGORY_CD IN (&HLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HLTH_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_HLTH_LST_6M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Hotels */	
	IF MERCHANT_CATEGORY_CD IN (&HTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HTL_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_HTL_LST_6M_CNT + TRANSACTION_CNT;
	END;

	/* We need to get the number of months where there was no 
		credit card transaction */
	/* Check if the medium is NOT credit card, and account is NOT of credit card type */
	IF (MEDIUM_CD NOT IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD NOT IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		IF NOUSE_TIME_SK6 = TIME_SK THEN 
		DO;
			NOUSE_TIME_SK6 = NOUSE_TIME_SK6 - 1;		
			NOUSE_CNTR6 = NOUSE_CNTR6 + 1;
		END;
	END;

	/* Check if the medium is credit card, and account is of credit card type */
	IF (MEDIUM_CD IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		ACC_CCD_USE_LST_6M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Personal Shopping */	
	IF MERCHANT_CATEGORY_CD IN (&PER_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_PER_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_PER_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Transportation */	
	IF MERCHANT_CATEGORY_CD IN (&TPT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_TPT_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_TPT_LST_6M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Utility payments */	
	IF MERCHANT_CATEGORY_CD IN (&UTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_UTLY_LST_6M_AMT + TRANSACTION_AMT;
		ACC_CCD_UTLY_LST_6M_CNT + TRANSACTION_CNT;
	END;
	
/* Variables of TRANS_CHANNEL_USAGE_LST_6M */
	/* Check if transaction channel is ATM */
	IF CHANNEL_CD IN (&ATM_CHANNEL) THEN DO;
		ACC_ATM_USE_LST_6M_CNT + TRANSACTION_CNT; END;
	
	/* Check if transaction channel is Internet */
	IF CHANNEL_CD IN (&INN_CHANNEL) THEN DO;
		ACC_INN_USE_LST_6M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Telephone */
	IF CHANNEL_CD IN (&PHN_CHANNEL) THEN DO;
		ACC_PHN_USE_LST_6M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Teller/Branch */
	IF CHANNEL_CD IN (&TLR_CHANNEL) THEN DO;
		ACC_TLR_USE_LST_6M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_CHECK_ISSUE_LST_6M */
	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		/* Check if medium is cheque */
		IF MEDIUM_CD IN (&CHQ_MEDIUM) THEN 
		DO;
			ACC_CHQ_ISU_LST_6M_AMT + TRANSACTION_AMT;
			ACC_CHQ_ISU_LST_6M_CNT + TRANSACTION_CNT;
		END;
		/* Total amount paid by the card holder in the last 6 months */
			ACC_PAY_LST_6M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PAY_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_PAY_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PAY_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_PAY_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_DDR_SORD_LST_6M */
	/* Check if transaction type is direct debit */
	IF TRANSACTION_TYPE_CD IN (&DDR_TRANS_TYPE) THEN 
	DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DDR_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_DDR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DDR_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_DDR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_DDR_LST_6M_AMT + TRANSACTION_AMT;		
	END;

	/* Check if transaction type is standing orders */
	IF TRANSACTION_TYPE_CD IN (&SOR_TRANS_TYPE) THEN DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_SORD_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_SORD_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_SORD_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_SORD_LST_6M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_SORD_LST_6M_AMT + TRANSACTION_AMT;	
	END;
	
/* Variables of TRANS_DEP_WDR_LST_6M */
	/* Check if transaction type is Withdrawal */
	IF TRANSACTION_TYPE_CD IN (&WDR_TRANS_TYPE) THEN 
	DO;
			ACC_WDR_LST_6M_AMT + TRANSACTION_AMT;
			ACC_WDR_LST_6M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_WDR_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_WDR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_WDR_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_WDR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;

		/*Check if channel is ATM*/
		IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
		DO;
				ACC_ATM_WDR_LST_6M_AMT + TRANSACTION_AMT;
				ACC_ATM_WDR_LST_6M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ATM_WDR_LST_6M_AMT, min_value) THEN DO;
				ACC_MAX_ATM_WDR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ATM_WDR_LST_6M_AMT, max_value) THEN DO;
				ACC_MIN_ATM_WDR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		/*Check if channel is Teller/branch */
		IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
		DO;
				ACC_TLR_WDR_LST_6M_AMT + TRANSACTION_AMT;
				ACC_TLR_WDR_LST_6M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TLR_WDR_LST_6M_AMT, min_value) THEN DO;
				ACC_MAX_TLR_WDR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TLR_WDR_LST_6M_AMT, max_value) THEN DO;
				ACC_MIN_TLR_WDR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END;	
	END;

	/* Check if transaction type is Deposit Encashment */
	IF TRANSACTION_TYPE_CD IN (&DEN_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_ENC_LST_6M_AMT + TRANSACTION_AMT;
				
		/*Check if account has been closed and closing reason is deposit early encashment */
		IF CLOSE_DT NE . AND CLOSE_REASON_CD IN (&ECH_CLOSE_REASON) THEN 
		DO;
		/* check if year and month of close date and of cal mnth date are same */
			IF ((YEAR(CLOSE_DT) EQ YEAR(CAL_MONTH_FIRST_DT))
						AND
				(MONTH(CLOSE_DT) EQ MONTH(CAL_MONTH_FIRST_DT))) THEN DO;

					ACC_DEP_ERLY_ENC_LST_6M_CNT = ACC_DEP_ERLY_ENC_LST_6M_CNT + 1; END;
				
		END;
	END;
	
	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_LST_6M_AMT + TRANSACTION_AMT;
			ACC_DEP_LST_6M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_DEP_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_DEP_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/*Check if transactions are made using Credit card*/
	IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
	DO;
			ACC_CR_TRNS_LST_6M_AMT + TRANSACTION_AMT;
			ACC_CR_TRNS_LST_6M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CR_TRNS_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_CR_TRNS_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CR_TRNS_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_CR_TRNS_LST_6M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;

	/*Check if transactions are made using Debit card*/
	IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
	DO;
			ACC_DR_TRNS_LST_6M_AMT + TRANSACTION_AMT;
			ACC_DR_TRNS_LST_6M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DR_TRNS_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_DR_TRNS_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DR_TRNS_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_DR_TRNS_LST_6M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;
		
	/* Variables of TRANS_FEES_LST_6M */
	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for atm/debit card issuance*/
		IF FEE_REASON_TYPE_CD IN (&ATM_FEE_TYPE) THEN DO;
			ACC_ATM_ISU_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is balance below the limit fees */
		IF FEE_REASON_TYPE_CD IN (&BBL_FEE_TYPE) THEN DO;
			ACC_BBLO_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is cash advance */
		IF FEE_REASON_TYPE_CD IN (&CAD_FEE_TYPE) THEN DO;
			ACC_CADV_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Check book issuance */
		IF FEE_REASON_TYPE_CD IN (&CHQ_FEE_TYPE) THEN DO;
			ACC_CHQ_BK_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Dishonoured payment fees */ 
		IF FEE_REASON_TYPE_CD IN (&DSH_FEE_TYPE) THEN DO;
			ACC_DSHNR_PAY_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Duplicate statement issuance fees */
		IF FEE_REASON_TYPE_CD IN (&DST_FEE_TYPE) THEN DO;
			ACC_DUP_STMT_FEE_LST_6M_AMT + TRANSACTION_AMT; END;

		/* For all applicable fees type */
			ACC_FEE_LST_6M_AMT + TRANSACTION_AMT;	

		/* Check if fees type is Overdraft facility fees */
		IF FEE_REASON_TYPE_CD IN (&OVF_FEE_TYPE) THEN DO;
			ACC_OVD_FACY_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Over the limit fees */
		IF FEE_REASON_TYPE_CD IN (&OTL_FEE_TYPE) THEN DO;
			ACC_OTL_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Incoming balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&IBT_FEE_TYPE) THEN DO;
			ACC_IBT_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Increasing credit limit fees */
		IF FEE_REASON_TYPE_CD IN (&CLI_FEE_TYPE) THEN DO;
			ACC_LMT_INR_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* For all applicable fees type */
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FEE_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_FEE_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FEE_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_FEE_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		/* Check if fees type is Missed or unpaid installment fees */
		IF FEE_REASON_TYPE_CD IN (&MIS_FEE_TYPE) THEN DO;
			ACC_MIS_INST_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Account maintenance fees */
		IF FEE_REASON_TYPE_CD IN (&MNT_FEE_TYPE) THEN DO;
			ACC_MNTS_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Outgoing balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&OBT_FEE_TYPE) THEN DO;
			ACC_OBT_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Prepayment penalty fees */
		IF FEE_REASON_TYPE_CD IN (&PPP_FEE_TYPE) THEN DO;
			ACC_PPY_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is fixed to floating rate fees */
		IF FEE_REASON_TYPE_CD IN (&FXF_FEE_TYPE) THEN DO;
			ACC_RTTYP_CHG_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is visit fees */
		IF FEE_REASON_TYPE_CD IN (&VIS_FEE_TYPE) THEN DO;
			ACC_SRV_VIS_FEE_LST_6M_AMT + TRANSACTION_AMT;
		END;		
		/* Check if fees type is Transaction charges fees */
		IF FEE_REASON_TYPE_CD IN (&TRN_FEE_TYPE) THEN DO;
			ACC_TRNS_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		/*Check if fees type is delayed payments only */
		IF FEE_REASON_TYPE_CD IN (&DLP_FEE_TYPE) THEN 
		DO;
				ACC_DLD_PAY_FEE_LST_6M_AMT + TRANSACTION_AMT;
		
			IF MAX_TRANSACTION_AMT > COALESCE(MAX_DFEE2AVG_INST_L6M_PCT, min_value) THEN DO; 
				MAX_DFEE2AVG_INST_L6M_PCT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(MIN_DFEE2AVG_INST_L6M_PCT, max_value) THEN DO; 
				MIN_DFEE2AVG_INST_L6M_PCT = MIN_TRANSACTION_AMT; END;

				CNT_DFEE2AVG_6M + 1;
				SUM_RPP6M + REGULAR_PERIODIC_PAYMENT_AMT;
				AVG_INST_L6M_PCT = SUM_RPP6M / CNT_DFEE2AVG_6M; /* Average calculation */
				ACC_MAX_DFEE2AVG_INST_L6M_PCT = (MAX_DFEE2AVG_INST_L6M_PCT / AVG_INST_L6M_PCT)*100;
				/* final abt variable derivation */	
				ACC_MIN_DFEE2AVG_INST_L6M_PCT = (MIN_DFEE2AVG_INST_L6M_PCT / AVG_INST_L6M_PCT)*100;
				/* final abt variable derivation */ 
		END;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_LST_6M_AMT + TRANSACTION_AMT; END;
		
		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_LST_6M_AMT + TRANSACTION_AMT; END;		
	END;
	
/* Variables of TRANS_FEES_WAIVED_LST_6M */
	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
			ACC_FWV_LST_6M_AMT + TRANSACTION_AMT;
			ACC_FWV_LST_6M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FWV_LST_6M_AMT, min_value) THEN DO; 
			ACC_MAX_FWV_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FWV_LST_6M_AMT, max_value) THEN DO; 
			ACC_MIN_FWV_LST_6M_AMT = MIN_TRANSACTION_AMT; END; 
	END;

/* Variables of TRANS_INST_PAYMENTS_LST_6M */
	/* Check for interest payment type transactions */
	IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
	DO;
			ACC_INT_LST_6M_AMT + TRANSACTION_AMT;
			ACC_INT_LST_6M_CNT + TRANSACTION_CNT;

			/*Temporary variable used in calculating ACC_MAX_PPL_INT_LST_6M_AMT 
												 and ACC_MIN_PPL_INT_LST_6M_AMT */
			ACC_INT_LST_6M_AMT_TMP + TRANSACTION_AMT; 

			ACC_PPL_INT_PYD_LST_6M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_LST_6M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_LST_6M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RCD_LST_6M_AMT + TRANSACTION_AMT;
			ACC_INT_RCD_LST_6M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_RCD_LST_6M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_RCD_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_RCD_LST_6M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_RCD_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RINV_LST_6M_AMT + TRANSACTION_AMT;
			ACC_INT_RINV_LST_6M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INT_RINV_LST_6M_AMT, min_value) THEN DO;
			ACC_MX_INT_RINV_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INT_RINV_LST_6M_AMT, max_value) THEN DO;
			ACC_MN_INT_RINV_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
	
	/* Check if transaction type is principal payment */	
	IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
	DO;
			ACC_PPL_LST_6M_AMT + TRANSACTION_AMT;
			ACC_PPL_LST_6M_CNT + TRANSACTION_CNT; /*Note: This field is not
																		present in excel*/
			/* Temporary variable used to calculate ACC_MAX_PPL_INT_LST_6M_AMT 
												and ACC_MIN_PPL_INT_LST_6M_AMT */
			ACC_PPL_LST_6M_AMT_TMP + TRANSACTION_AMT; 
			
			ACC_PPL_INT_PYD_LST_6M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PPL_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PPL_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
		
	/* Check if transaction type is Additional payment */
	IF TRANSACTION_TYPE_CD IN (&APY_TRANS_TYPE) THEN 
	DO;
		ACC_ADDL_PAY_LST_6M_AMT + TRANSACTION_AMT;/*NOTE: Not in excel*/ 
		ACC_ADDL_PAY_LST_6M_CNT + TRANSACTION_CNT; 
	END;
	
	/* Check for escrow type transaction */
		IF TRANSACTION_TYPE_CD IN (&ESC_TRANS_TYPE) THEN 
		DO;
				ACC_ESCR_LST_6M_AMT + TRANSACTION_AMT; 
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ESCR_PYD_LST_6M_AMT, min_value) THEN DO;
				ACC_MAX_ESCR_PYD_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ESCR_PYD_LST_6M_AMT, max_value) THEN DO;
				ACC_MIN_ESCR_PYD_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END;	

	/* Variables of TRANS_PAYMENTS_LST_6M */

			ACC_DLD_PAY_LST_6M_CNT + LATE_PAYMENT_CNT;
	/*Check if transaction status reason is dishonoured payment */
	IF TRANSACTION_STATUS_REASON_CD IN (&DSH_TRANS_STATUS) THEN 
	DO;
			ACC_DSHNR_PAY_LST_6M_AMT + TRANSACTION_AMT;
			ACC_DSHNR_PAY_LST_6M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DSHNR_PAY_LST_6M_AMT, min_value) THEN DO; 
			ACC_MAX_DSHNR_PAY_LST_6M_AMT = MAX_TRANSACTION_AMT;	END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DSHNR_PAY_LST_6M_AMT, max_value) THEN DO; 
			ACC_MIN_DSHNR_PAY_LST_6M_AMT  = MIN_TRANSACTION_AMT; END; 
	END;

/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN DO;
			ACC_PREPAY_LST_6M_AMT + TRANSACTION_AMT; END;	

/* Variables of TRANS_PUR_CADV_OVL_LST_6M */
/* Check if transaction type is purchase */
	IF TRANSACTION_TYPE_CD IN (&PUR_TRANS_TYPE) THEN 
	DO;
	/* Check if its an international purchase */
		IF INTERNAL_ORG_COUNTRY_CD NE COUNTRY_CD THEN 
		DO; 
				ACC_IPUR_LST_6M_AMT + TRANSACTION_AMT; 
				ACC_IPUR_LST_6M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IPUR_LST_6M_AMT, min_value) THEN DO; 
				ACC_MAX_IPUR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IPUR_LST_6M_AMT, max_value) THEN DO; 
				ACC_MIN_IPUR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END;

	/* Check if its a local purchase */
		IF INTERNAL_ORG_COUNTRY_CD EQ COUNTRY_CD THEN 
		DO; 
				ACC_LPUR_LST_6M_AMT + TRANSACTION_AMT; 
				ACC_LPUR_LST_6M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_LPUR_LST_6M_AMT, min_value) THEN DO; 
				ACC_MAX_LPUR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_LPUR_LST_6M_AMT, max_value) THEN DO; 
				ACC_MIN_LPUR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PUR_LST_6M_AMT, min_value) THEN DO; 
				ACC_MAX_PUR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PUR_LST_6M_AMT, max_value) THEN DO; 
				ACC_MIN_PUR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
			
				ACC_PUR_LST_6M_AMT + TRANSACTION_AMT;
				ACC_PUR_LST_6M_CNT + TRANSACTION_CNT;
		
	END;	

	/* Check if transaction type is Cash Advance */
	IF TRANSACTION_TYPE_CD IN (&CAD_TRANS_TYPE) THEN 
	DO;
				ACC_CADV_LST_6M_AMT + TRANSACTION_AMT;
				ACC_CADV_LST_6M_CNT + TRANSACTION_CNT;

				CADV_6M_CNTR + 1;
				ACC_AVG_CADV_LST_6M_AMT = ACC_CADV_LST_6M_AMT / CADV_6M_CNTR;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CADV_LST_6M_AMT, min_value) THEN DO; 
				ACC_MAX_CADV_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CADV_LST_6M_AMT, max_value) THEN DO; 
				ACC_MIN_CADV_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check to determine the number of times account was over the limit 
		in the last 6 months */	
	IF OVER_LIMIT_CNT > 0 THEN DO;
		ACC_OTL_LST_6M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_SUMMARY_LST_6M */
	/* Total number of transactions in the last 6 months */
		ACC_TRNS_LST_6M_CNT + TRANSACTION_CNT;
	/* Total amount of transactions in the last 6 months */
		ACC_TRNS_LST_6M_AMT + TRANSACTION_AMT;
	
/* Variables of TRANS_TRANSFER_LST_6M */
/* Check if transaction type is transfer */
	IF TRANSACTION_TYPE_CD IN (&TRS_TRANS_TYPE) THEN 
	DO;
	/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
		/* Check if channel is internet */	
			IF CHANNEL_CD IN (&INN_CHANNEL) THEN 
			DO;
					ACC_INN_TRS_FR_LST_6M_AMT + TRANSACTION_AMT;
					ACC_INN_TRS_FR_LST_6M_CNT + TRANSACTION_CNT;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INN_TRS_FR_LST_6M_AMT, max_value) THEN DO; 
					ACC_MN_INN_TRS_FR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INN_TRS_FR_LST_6M_AMT, min_value) THEN DO; 
					ACC_MX_INN_TRS_FR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
			END;

		/* Check if channel is ATM */	
			IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_ATM_TRS_FR_LST_6M_AMT, max_value) THEN DO; 
					ACC_MN_ATM_TRS_FR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_ATM_TRS_FR_LST_6M_AMT, min_value) THEN DO; 
					ACC_MX_ATM_TRS_FR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
			END;

		/*Check if channel is ATM or SST*/
			IF CHANNEL_CD IN (&ATM_CHANNEL,&SST_CHANNEL) THEN 
			DO;
				ACC_ATM_SST_TRS_FR_LST_6M_AMT + TRANSACTION_AMT;
				ACC_ATM_SST_TRS_FR_LST_6M_CNT + TRANSACTION_CNT;
			END;
			
		/* Check if channel is Telephone */	
			IF CHANNEL_CD IN (&PHN_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_PHN_TRS_FR_LST_6M_AMT, max_value) THEN DO; 
					ACC_MN_PHN_TRS_FR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_PHN_TRS_FR_LST_6M_AMT, min_value) THEN DO; 
					ACC_MX_PHN_TRS_FR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_PHN_TRS_FR_LST_6M_AMT + TRANSACTION_AMT;
					ACC_PHN_TRS_FR_LST_6M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Teller/branch */	
			IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_TLR_TRS_FR_LST_6M_AMT, max_value) THEN DO; 
					ACC_MN_TLR_TRS_FR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_TLR_TRS_FR_LST_6M_AMT, min_value) THEN DO; 
					ACC_MX_TLR_TRS_FR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_TLR_TRS_FR_LST_6M_AMT + TRANSACTION_AMT;
					ACC_TLR_TRS_FR_LST_6M_CNT + TRANSACTION_CNT;
			END;

				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_FR_LST_6M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_FR_LST_6M_AMT = MAX_TRANSACTION_AMT; END;	
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_FR_LST_6M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_FR_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_FR_LST_6M_AMT + TRANSACTION_AMT;
					ACC_TRS_FR_LST_6M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = debit block */

	/* Check if its a credit card transaction */
		IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
		DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_IN2_LST_6M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_IN2_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_IN2_LST_6M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_IN2_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_IN2_LST_6M_AMT + TRANSACTION_AMT;
					ACC_TRS_IN2_LST_6M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = credit block */	
	END;/* end of transfer type transaction block */

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
					ACC_IBT_LST_6M_AMT + TRANSACTION_AMT;
					ACC_IBT_LST_6M_CNT + TRANSACTION_CNT;	
				
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_LST_6M_AMT, min_value) THEN DO; 
					ACC_MAX_IBT_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_LST_6M_AMT, max_value) THEN DO; 
					ACC_MIN_IBT_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */
	
	/* Check if transaction type is outgoing balance transfer */
	IF TRANSACTION_TYPE_CD IN (&OBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
				ACC_OBT_LST_6M_AMT + TRANSACTION_AMT;
				ACC_OBT_LST_6M_CNT + TRANSACTION_CNT;	
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_OBT_LST_6M_AMT, min_value) THEN DO; 
				ACC_MAX_OBT_LST_6M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_OBT_LST_6M_AMT, max_value) THEN DO; 
				ACC_MIN_OBT_LST_6M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */

	/*check for group of time_sk */
	IF LAST.TIME_SK THEN 
	DO;
		SUM_PPL_INT_6M = ACC_PPL_LST_6M_AMT_TMP + ACC_INT_LST_6M_AMT_TMP;

		/*To find out the max and min of principal+interest paid */
		IF SUM_PPL_INT_6M > COALESCE(ACC_MAX_PPL_INT_LST_6M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_INT_LST_6M_AMT = SUM_PPL_INT_6M; END;
		IF SUM_PPL_INT_6M < COALESCE(ACC_MIN_PPL_INT_LST_6M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_INT_LST_6M_AMT = SUM_PPL_INT_6M; END;
		
		/* Count the number of times credit card transactions were not made in the 
			last 6 months */
		ACC_CCD_NOUSE_LST_6M_MTH_CNT + NOUSE_CNTR6;

		/*Special variables used in calculating ACC_CCD_NOUSE_LST_6M_MTH_CNT is reset here */
		NOUSE_CNTR6 = 0;
	END;
END;

/*Check starts for 12 month calculations */	
ELSE IF (COUNT <  12) THEN 
DO;
/*Variables of TRANS_CASHBACK_REFUND_LST_12M */
	/* Check for cash_back type of transactions */
	IF TRANSACTION_TYPE_CD IN (&CBK_TRANS_TYPE) THEN 
	DO;
			ACC_CSHBCK_LST_12M_AMT + TRANSACTION_AMT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CSHBCK_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_CSHBCK_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CSHBCK_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_CSHBCK_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for refund type of transactions */
	IF TRANSACTION_TYPE_CD IN (&REF_TRANS_TYPE) THEN 
	DO;	
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_REF_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_REF_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_REF_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_REF_LST_12M_AMT = MIN_TRANSACTION_AMT; END;

		ACC_REF_LST_12M_AMT + TRANSACTION_AMT;
		ACC_REF_LST_12M_CNT + TRANSACTION_CNT;	
	END;

/*Variables of TRANS_CCD_MERCHANTCAT_LST_12M */
	/* Check if merchant category code is airline */	
	IF MERCHANT_CATEGORY_CD IN (&ARL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ARL_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_ARL_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is automative */	
	IF MERCHANT_CATEGORY_CD IN (&AUT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_AUT_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_AUT_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is clothing */	
	IF MERCHANT_CATEGORY_CD IN (&CLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CLTH_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_CLTH_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is car rentals */	
	IF MERCHANT_CATEGORY_CD IN (&CRN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CRN_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_CRN_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is entertainment and recreation */	
	IF MERCHANT_CATEGORY_CD IN (&ENT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ENT_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_ENT_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Financial Services */	
	IF MERCHANT_CATEGORY_CD IN (&FIN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FIN_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_FIN_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Food */	
	IF MERCHANT_CATEGORY_CD IN (&FUD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FUD_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_FUD_LST_12M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Government */	
	IF MERCHANT_CATEGORY_CD IN (&GOV_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_GOV_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_GOV_LST_12M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Household/Shelter */	
	IF MERCHANT_CATEGORY_CD IN (&HHD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HHD_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_HHD_LST_12M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Health and Education */	
	IF MERCHANT_CATEGORY_CD IN (&HLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HLTH_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_HLTH_LST_12M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Hotels */	
	IF MERCHANT_CATEGORY_CD IN (&HTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HTL_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_HTL_LST_12M_CNT + TRANSACTION_CNT;
	END;

	/* We need to get the number of months where there was no 
		credit card transaction */
	/* Check if the medium is NOT credit card, and account is NOT of credit card type */
	IF (MEDIUM_CD NOT IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD NOT IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		IF NOUSE_TIME_SK12 = TIME_SK THEN 
		DO;
			NOUSE_TIME_SK12 = NOUSE_TIME_SK12 - 1;		
			NOUSE_CNTR12 = NOUSE_CNTR12 + 1;
		END;
	END;

	/* Check if the medium is credit card, and account is of credit card type */
	IF (MEDIUM_CD IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		ACC_CCD_USE_LST_12M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Personal Shopping */	
	IF MERCHANT_CATEGORY_CD IN (&PER_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_PER_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_PER_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Transportation */	
	IF MERCHANT_CATEGORY_CD IN (&TPT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_TPT_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_TPT_LST_12M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Utility payments */	
	IF MERCHANT_CATEGORY_CD IN (&UTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_UTLY_LST_12M_AMT + TRANSACTION_AMT;
		ACC_CCD_UTLY_LST_12M_CNT + TRANSACTION_CNT;
	END;
	
/* Variables of TRANS_CHANNEL_USAGE_LST_12M */
	/* Check if transaction channel is ATM */
	IF CHANNEL_CD IN (&ATM_CHANNEL) THEN DO;
		ACC_ATM_USE_LST_12M_CNT + TRANSACTION_CNT; END;
	
	/* Check if transaction channel is Internet */
	IF CHANNEL_CD IN (&INN_CHANNEL) THEN DO;
		ACC_INN_USE_LST_12M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Telephone */
	IF CHANNEL_CD IN (&PHN_CHANNEL) THEN DO;
		ACC_PHN_USE_LST_12M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Teller/Branch */
	IF CHANNEL_CD IN (&TLR_CHANNEL) THEN DO;
		ACC_TLR_USE_LST_12M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_CHECK_ISSUE_LST_12M */
	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		/* Check if medium is cheque */
		IF MEDIUM_CD IN (&CHQ_MEDIUM) THEN 
		DO;
			ACC_CHQ_ISU_LST_12M_AMT + TRANSACTION_AMT;
			ACC_CHQ_ISU_LST_12M_CNT + TRANSACTION_CNT;
		END;
		/* Total amount paid by the card holder in the last 12 months */
			ACC_PAY_LST_12M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PAY_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_PAY_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PAY_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_PAY_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_DDR_SORD_LST_12M */
	/* Check if transaction type is direct debit */
	IF TRANSACTION_TYPE_CD IN (&DDR_TRANS_TYPE) THEN 
	DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DDR_LST_12M_AMT, min_value) THEN DO;
			ACC_MIN_DDR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DDR_LST_12M_AMT, max_value) THEN DO;
			ACC_MAX_DDR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_DDR_LST_12M_AMT + TRANSACTION_AMT;		
	END;

	/* Check if transaction type is standing orders */
	IF TRANSACTION_TYPE_CD IN (&SOR_TRANS_TYPE) THEN DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_SORD_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_SORD_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_SORD_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_SORD_LST_12M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_SORD_LST_12M_AMT + TRANSACTION_AMT;	
	END;
	
/* Variables of TRANS_DEP_WDR_LST_12M */
	/* Check if transaction type is Withdrawal */
	IF TRANSACTION_TYPE_CD IN (&WDR_TRANS_TYPE) THEN 
	DO;
			ACC_WDR_LST_12M_AMT + TRANSACTION_AMT;
			ACC_WDR_LST_12M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_WDR_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_WDR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_WDR_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_WDR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;

		/*Check if channel is ATM*/
		IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
		DO;
				ACC_ATM_WDR_LST_12M_AMT + TRANSACTION_AMT;
				ACC_ATM_WDR_LST_12M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ATM_WDR_LST_12M_AMT, min_value) THEN DO;
				ACC_MAX_ATM_WDR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ATM_WDR_LST_12M_AMT, max_value) THEN DO;
				ACC_MIN_ATM_WDR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		/*Check if channel is Teller/branch */
		IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
		DO;
				ACC_TLR_WDR_LST_12M_AMT + TRANSACTION_AMT;
				ACC_TLR_WDR_LST_12M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TLR_WDR_LST_12M_AMT, min_value) THEN DO;
				ACC_MAX_TLR_WDR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TLR_WDR_LST_12M_AMT, max_value) THEN DO;
				ACC_MIN_TLR_WDR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END;	
	END;

	/* Check if transaction type is Deposit Encashment */
	IF TRANSACTION_TYPE_CD IN (&DEN_TRANS_TYPE) THEN 
	DO;
		ACC_DEP_ENC_LST_12M_AMT + TRANSACTION_AMT;
				
		/*Check if account has been closed and closing reason is deposit early encashment */
		IF CLOSE_DT NE . AND CLOSE_REASON_CD IN (&ECH_CLOSE_REASON) THEN 
		DO;
		/* check if year and month of close date and of cal mnth date are same */
			IF ((YEAR(CLOSE_DT) EQ YEAR(CAL_MONTH_FIRST_DT))
						AND
				(MONTH(CLOSE_DT) EQ MONTH(CAL_MONTH_FIRST_DT))) THEN DO;

					ACC_DEP_ERLY_ENC_LST_12M_CNT = ACC_DEP_ERLY_ENC_LST_12M_CNT + 1; END;
				
		END;
	END;
	
	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_LST_12M_AMT + TRANSACTION_AMT;
			ACC_DEP_LST_12M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_DEP_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_DEP_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/*Check if transactions are made using Credit card*/
	IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
	DO;
			ACC_CR_TRNS_LST_12M_AMT + TRANSACTION_AMT;
			ACC_CR_TRNS_LST_12M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CR_TRNS_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_CR_TRNS_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CR_TRNS_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_CR_TRNS_LST_12M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;

	/*Check if transactions are made using Debit card*/
	IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
	DO;
			ACC_DR_TRNS_LST_12M_AMT + TRANSACTION_AMT;
			ACC_DR_TRNS_LST_12M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DR_TRNS_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_DR_TRNS_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DR_TRNS_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_DR_TRNS_LST_12M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;
		
	/* Variables of TRANS_FEES_LST_12M */
	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for atm/debit card issuance*/
		IF FEE_REASON_TYPE_CD IN (&ATM_FEE_TYPE) THEN DO;
			ACC_ATM_ISU_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is balance below the limit fees */
		IF FEE_REASON_TYPE_CD IN (&BBL_FEE_TYPE) THEN DO;
			ACC_BBLO_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is cash advance */
		IF FEE_REASON_TYPE_CD IN (&CAD_FEE_TYPE) THEN DO;
			ACC_CADV_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Check book issuance */
		IF FEE_REASON_TYPE_CD IN (&CHQ_FEE_TYPE) THEN DO;
			ACC_CHQ_BK_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Dishonoured payment fees */ 
		IF FEE_REASON_TYPE_CD IN (&DSH_FEE_TYPE) THEN DO;
			ACC_DSHNR_PAY_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Duplicate statement issuance fees */
		IF FEE_REASON_TYPE_CD IN (&DST_FEE_TYPE) THEN DO;
			ACC_DUP_STMT_FEE_LST_12M_AMT + TRANSACTION_AMT; END;

		/* For all applicable fees type */
			ACC_FEE_LST_12M_AMT + TRANSACTION_AMT;	

		/* Check if fees type is Overdraft facility fees */
		IF FEE_REASON_TYPE_CD IN (&OVF_FEE_TYPE) THEN DO;
			ACC_OVD_FACY_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Over the limit fees */
		IF FEE_REASON_TYPE_CD IN (&OTL_FEE_TYPE) THEN DO;
			ACC_OTL_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Incoming balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&IBT_FEE_TYPE) THEN DO;
			ACC_IBT_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Increasing credit limit fees */
		IF FEE_REASON_TYPE_CD IN (&CLI_FEE_TYPE) THEN DO;
			ACC_LMT_INR_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* For all applicable fees type */
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FEE_LST_12M_AMT,min_value) THEN DO;
			ACC_MAX_FEE_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FEE_LST_12M_AMT,max_value) THEN DO;
			ACC_MIN_FEE_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		/* Check if fees type is Missed or unpaid installment fees */
		IF FEE_REASON_TYPE_CD IN (&MIS_FEE_TYPE) THEN DO;
			ACC_MIS_INST_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Account maintenance fees */
		IF FEE_REASON_TYPE_CD IN (&MNT_FEE_TYPE) THEN DO;
			ACC_MNTS_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Outgoing balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&OBT_FEE_TYPE) THEN DO;
			ACC_OBT_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Prepayment penalty fees */
		IF FEE_REASON_TYPE_CD IN (&PPP_FEE_TYPE) THEN DO;
			ACC_PPY_FEE_LST_12M_AMT = ACC_PPY_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is fixed to floating rate fees */
		IF FEE_REASON_TYPE_CD IN (&FXF_FEE_TYPE) THEN DO;
			ACC_RTTYP_CHG_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is visit fees */
		IF FEE_REASON_TYPE_CD IN (&VIS_FEE_TYPE) THEN DO;
			ACC_SRV_VIS_FEE_LST_12M_AMT + TRANSACTION_AMT;
		END;		
		/* Check if fees type is Transaction charges fees */
		IF FEE_REASON_TYPE_CD IN (&TRN_FEE_TYPE) THEN DO;
			ACC_TRNS_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		/*Check if fees type is delayed payments only */
		IF FEE_REASON_TYPE_CD IN (&DLP_FEE_TYPE) THEN 
		DO;
				ACC_DLD_PAY_FEE_LST_12M_AMT + TRANSACTION_AMT;

			IF MAX_TRANSACTION_AMT > COALESCE(MAX_DFEE2AVG_INST_L12M_PCT, min_value) THEN DO; 
				MAX_DFEE2AVG_INST_L12M_PCT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(MIN_DFEE2AVG_INST_L12M_PCT, max_value) THEN DO; 
				MIN_DFEE2AVG_INST_L12M_PCT = MIN_TRANSACTION_AMT; END;

				CNT_DFEE2AVG_12M + 1;
				SUM_RPP12M + REGULAR_PERIODIC_PAYMENT_AMT;
				AVG_INST_L12M_PCT = SUM_RPP12M / CNT_DFEE2AVG_12M; /* Average calculation */
				ACC_MAX_DFEE2AVG_INST_L12M_PCT = (MAX_DFEE2AVG_INST_L12M_PCT / AVG_INST_L12M_PCT)*100;
				/* final abt variable derivation */	
				ACC_MIN_DFEE2AVG_INST_L12M_PCT = (MIN_DFEE2AVG_INST_L12M_PCT / AVG_INST_L12M_PCT)*100;
				/* final abt variable derivation */ 
		END;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
		
		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_LST_12M_AMT + TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_FEES_WAIVED_LST_12M */
	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
			ACC_FWV_LST_12M_AMT + TRANSACTION_AMT;
			ACC_FWV_LST_12M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FWV_LST_12M_AMT, min_value) THEN DO; 
			ACC_MAX_FWV_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FWV_LST_12M_AMT, max_value) THEN DO; 
			ACC_MIN_FWV_LST_12M_AMT = MIN_TRANSACTION_AMT; END; 
	END;

/* Variables of TRANS_INST_PAYMENTS_LST_12M */
	/* Check for interest payment type transactions */
	IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
	DO;
			ACC_INT_LST_12M_AMT + TRANSACTION_AMT;
			ACC_INT_LST_12M_CNT + TRANSACTION_CNT;

			/*Temporary variable used in calculating ACC_MAX_PPL_INT_LST_12M_AMT 
												 and ACC_MIN_PPL_INT_LST_12M_AMT */
			ACC_INT_LST_12M_AMT_TMP + TRANSACTION_AMT;

			ACC_PPL_INT_PYD_LST_12M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_LST_12M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_LST_12M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RCD_LST_12M_AMT + TRANSACTION_AMT;
			ACC_INT_RCD_LST_12M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_RCD_LST_12M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_RCD_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_RCD_LST_12M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_RCD_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RINV_LST_12M_AMT + TRANSACTION_AMT;
			ACC_INT_RINV_LST_12M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INT_RINV_LST_12M_AMT, min_value) THEN DO;
			ACC_MX_INT_RINV_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INT_RINV_LST_12M_AMT, max_value) THEN DO;
			ACC_MN_INT_RINV_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
	
	/* Check if transaction type is principal payment */	
	IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
	DO;
			ACC_PPL_LST_12M_AMT + TRANSACTION_AMT;
			ACC_PPL_LST_12M_CNT + TRANSACTION_CNT; /*Note: This field is not
																		present in excel*/
			/* Temporary variable used to calculate ACC_MAX_PPL_INT_LST_12M_AMT 
												and ACC_MIN_PPL_INT_LST_12M_AMT */
			ACC_PPL_LST_12M_AMT_TMP + TRANSACTION_AMT; 
			
			ACC_PPL_INT_PYD_LST_12M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PPL_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PPL_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
		
	/* Check if transaction type is Additional payment */
	IF TRANSACTION_TYPE_CD IN (&APY_TRANS_TYPE) THEN 
	DO;
		ACC_ADDL_PAY_LST_12M_AMT + TRANSACTION_AMT;/*NOTE: Not in excel*/ 
		ACC_ADDL_PAY_LST_12M_CNT + TRANSACTION_CNT; 
	END;

	/* Check for escrow type transaction */
		IF TRANSACTION_TYPE_CD IN (&ESC_TRANS_TYPE) THEN 
		DO;
				ACC_ESCR_LST_12M_AMT + TRANSACTION_AMT; 
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ESCR_PYD_LST_12M_AMT, min_value)  THEN DO;
				ACC_MAX_ESCR_PYD_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ESCR_PYD_LST_12M_AMT, max_value) THEN DO;
				ACC_MIN_ESCR_PYD_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END;	

	/* Variables of TRANS_PAYMENTS_LST_12M */

			ACC_DLD_PAY_LST_12M_CNT + LATE_PAYMENT_CNT;
	/*Check if transaction status reason is dishonoured payment */
	IF TRANSACTION_STATUS_REASON_CD IN (&DSH_TRANS_STATUS) THEN 
	DO;
			ACC_DSHNR_PAY_LST_12M_AMT + TRANSACTION_AMT;
			ACC_DSHNR_PAY_LST_12M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DSHNR_PAY_LST_12M_AMT, min_value) THEN DO; 
			ACC_MAX_DSHNR_PAY_LST_12M_AMT = MAX_TRANSACTION_AMT;	END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DSHNR_PAY_LST_12M_AMT, max_value) THEN DO; 
			ACC_MIN_DSHNR_PAY_LST_12M_AMT  = MIN_TRANSACTION_AMT; END; 
	END;

/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN DO;
			ACC_PREPAY_LST_12M_AMT + TRANSACTION_AMT; END;	

/* Variables of TRANS_PUR_CADV_OVL_LST_12M */
/* Check if transaction type is purchase */
	IF TRANSACTION_TYPE_CD IN (&PUR_TRANS_TYPE) THEN 
	DO;
	/* Check if its an international purchase */
		IF INTERNAL_ORG_COUNTRY_CD NE COUNTRY_CD THEN 
		DO; 
				ACC_IPUR_LST_12M_AMT + TRANSACTION_AMT; 
				ACC_IPUR_LST_12M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IPUR_LST_12M_AMT, max_value) THEN DO; 
				ACC_MAX_IPUR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IPUR_LST_12M_AMT, min_value) THEN DO; 
				ACC_MIN_IPUR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END;

	/* Check if its a local purchase */
		IF INTERNAL_ORG_COUNTRY_CD EQ COUNTRY_CD THEN 
		DO; 
				ACC_LPUR_LST_12M_AMT + TRANSACTION_AMT; 
				ACC_LPUR_LST_12M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_LPUR_LST_12M_AMT, min_value) THEN DO; 
				ACC_MAX_LPUR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_LPUR_LST_12M_AMT, max_value) THEN DO; 
				ACC_MIN_LPUR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PUR_LST_12M_AMT, min_value) THEN DO; 
				ACC_MAX_PUR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PUR_LST_12M_AMT, max_value) THEN DO; 
				ACC_MIN_PUR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
			
				ACC_PUR_LST_12M_AMT + TRANSACTION_AMT;
				ACC_PUR_LST_12M_CNT + TRANSACTION_CNT;
	END;	

	/* Check if transaction type is Cash Advance */
	IF TRANSACTION_TYPE_CD IN (&CAD_TRANS_TYPE) THEN 
	DO;
				ACC_CADV_LST_12M_AMT + TRANSACTION_AMT;
				ACC_CADV_LST_12M_CNT + TRANSACTION_CNT;

				CADV_12M_CNTR + 1;
				ACC_AVG_CADV_LST_12M_AMT = ACC_CADV_LST_12M_AMT / CADV_12M_CNTR;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CADV_LST_12M_AMT, min_value) THEN DO; 
				ACC_MAX_CADV_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CADV_LST_12M_AMT, max_value) THEN DO; 
				ACC_MIN_CADV_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check to determine the number of times account was over the limit 
		in the last 12 months */	
	IF OVER_LIMIT_CNT > 0 THEN DO;
		ACC_OTL_LST_12M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_SUMMARY_LST_12M */
	/* Total number of transactions in the last 12 months */
		ACC_TRNS_LST_12M_CNT + TRANSACTION_CNT;
	/* Total amount of transactions in the last 12 months */
		ACC_TRNS_LST_12M_AMT + TRANSACTION_AMT;
	
/* Variables of TRANS_TRANSFER_LST_12M */
/* Check if transaction type is transfer */
	IF TRANSACTION_TYPE_CD IN (&TRS_TRANS_TYPE) THEN 
	DO;
	/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
		/* Check if channel is internet */	
			IF CHANNEL_CD IN (&INN_CHANNEL) THEN 
			DO;
					ACC_INN_TRS_FR_LST_12M_AMT + TRANSACTION_AMT;
					ACC_INN_TRS_FR_LST_12M_CNT + TRANSACTION_CNT;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INN_TRS_FR_LST_12M_AMT, max_value) THEN DO; 
					ACC_MN_INN_TRS_FR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INN_TRS_FR_LST_12M_AMT, min_value) THEN DO; 
					ACC_MX_INN_TRS_FR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
			END;

		/* Check if channel is ATM */	
			IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_ATM_TRS_FR_LST_12M_AMT, max_value) THEN DO; 
					ACC_MN_ATM_TRS_FR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_ATM_TRS_FR_LST_12M_AMT, min_value) THEN DO; 
					ACC_MX_ATM_TRS_FR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
			END;

			/*Check if channel is ATM or SST*/
			IF CHANNEL_CD IN (&ATM_CHANNEL,&SST_CHANNEL) THEN 
			DO;
				ACC_ATM_SST_TRS_FR_LST_12M_AMT + TRANSACTION_AMT;
				ACC_ATM_SST_TRS_FR_LST_12M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Telephone */	
			IF CHANNEL_CD IN (&PHN_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_PHN_TRS_FR_LST_12M_AMT, max_value) THEN DO; 
					ACC_MN_PHN_TRS_FR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_PHN_TRS_FR_LST_12M_AMT, min_value) THEN DO; 
					ACC_MX_PHN_TRS_FR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_PHN_TRS_FR_LST_12M_AMT + TRANSACTION_AMT;
					ACC_PHN_TRS_FR_LST_12M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Teller/branch */	
			IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_TLR_TRS_FR_LST_12M_AMT, max_value) THEN DO; 
					ACC_MN_TLR_TRS_FR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_TLR_TRS_FR_LST_12M_AMT, min_value) THEN DO; 
					ACC_MX_TLR_TRS_FR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_TLR_TRS_FR_LST_12M_AMT + TRANSACTION_AMT;
					ACC_TLR_TRS_FR_LST_12M_CNT + TRANSACTION_CNT;
			END;

				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_FR_LST_12M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_FR_LST_12M_AMT = MAX_TRANSACTION_AMT; END;	
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_FR_LST_12M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_FR_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_FR_LST_12M_AMT + TRANSACTION_AMT;
					ACC_TRS_FR_LST_12M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = debit block */

	/* Check if its a credit card transaction */
		IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
		DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_IN2_LST_12M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_IN2_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_IN2_LST_12M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_IN2_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_IN2_LST_12M_AMT + TRANSACTION_AMT;
					ACC_TRS_IN2_LST_12M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = credit block */	
	END;/* end of transfer type transaction block */

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
					ACC_IBT_LST_12M_AMT + TRANSACTION_AMT;
					ACC_IBT_LST_12M_CNT + TRANSACTION_CNT;	
				
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_LST_12M_AMT, min_value) THEN DO; 
					ACC_MAX_IBT_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_LST_12M_AMT, max_value) THEN DO; 
					ACC_MIN_IBT_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */
	
	/* Check if transaction type is outgoing balance transfer */
	IF TRANSACTION_TYPE_CD IN (&OBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
				ACC_OBT_LST_12M_AMT + TRANSACTION_AMT;
				ACC_OBT_LST_12M_CNT + TRANSACTION_CNT;	
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_OBT_LST_12M_AMT, min_value) THEN DO; 
				ACC_MAX_OBT_LST_12M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_OBT_LST_12M_AMT, max_value) THEN DO; 
				ACC_MIN_OBT_LST_12M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */

	/*check for group of time_sk */
	IF LAST.TIME_SK THEN 
	DO;
		SUM_PPL_INT_12M = ACC_PPL_LST_12M_AMT_TMP + ACC_INT_LST_12M_AMT_TMP;

		/*To find out the max and min of principal+interest paid */
		IF SUM_PPL_INT_12M > COALESCE(ACC_MAX_PPL_INT_LST_12M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_INT_LST_12M_AMT = SUM_PPL_INT_12M; END;
		IF SUM_PPL_INT_12M < COALESCE(ACC_MIN_PPL_INT_LST_12M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_INT_LST_12M_AMT = SUM_PPL_INT_12M; END;
		
		/* Count the number of times credit card transactions were not made in the 
			last 12 months */
		ACC_CCD_NOUSE_LST_12M_MTH_CNT + NOUSE_CNTR12;

		/*Special variables used in calculating ACC_CCD_NOUSE_LST_12M_MTH_CNT is reset here */
		NOUSE_CNTR12 = 0;
	END;
END;	
ELSE IF (COUNT < 24) THEN 
DO;
/*Variables of TRANS_CASHBACK_REFUND_13_24M */
	/* Check for cash_back type of transactions */
	IF TRANSACTION_TYPE_CD IN (&CBK_TRANS_TYPE) THEN 
	DO;
			ACC_CSHBCK_13_24M_AMT + TRANSACTION_AMT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CSHBCK_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_CSHBCK_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CSHBCK_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_CSHBCK_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for refund type of transactions */
	IF TRANSACTION_TYPE_CD IN (&REF_TRANS_TYPE) THEN 
	DO;	
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_REF_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_REF_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_REF_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_REF_13_24M_AMT = MIN_TRANSACTION_AMT; END;

		ACC_REF_13_24M_AMT + TRANSACTION_AMT;
		ACC_REF_13_24M_CNT + TRANSACTION_CNT;	
	END;

/*Variables of TRANS_CCD_MERCHANTCAT_13_24M */
	/* Check if merchant category code is airline */	
	IF MERCHANT_CATEGORY_CD IN (&ARL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ARL_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_ARL_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is automative */	
	IF MERCHANT_CATEGORY_CD IN (&AUT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_AUT_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_AUT_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is clothing */	
	IF MERCHANT_CATEGORY_CD IN (&CLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CLTH_13_24M_AMT = ACC_CCD_CLTH_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_CLTH_13_24M_CNT = ACC_CCD_CLTH_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is car rentals */	
	IF MERCHANT_CATEGORY_CD IN (&CRN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_CRN_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_CRN_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is entertainment and recreation */	
	IF MERCHANT_CATEGORY_CD IN (&ENT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_ENT_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_ENT_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Financial Services */	
	IF MERCHANT_CATEGORY_CD IN (&FIN_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FIN_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_FIN_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Food */	
	IF MERCHANT_CATEGORY_CD IN (&FUD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_FUD_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_FUD_13_24M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Government */	
	IF MERCHANT_CATEGORY_CD IN (&GOV_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_GOV_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_GOV_13_24M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Household/Shelter */	
	IF MERCHANT_CATEGORY_CD IN (&HHD_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HHD_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_HHD_13_24M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Health and Education */	
	IF MERCHANT_CATEGORY_CD IN (&HLT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HLTH_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_HLTH_13_24M_CNT + TRANSACTION_CNT;
	END;
	 
	/* Check if merchant category code is Hotels */	
	IF MERCHANT_CATEGORY_CD IN (&HTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_HTL_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_HTL_13_24M_CNT + TRANSACTION_CNT;
	END;

	/* We need to get the number of months where there was no 
		credit card transaction */
	/* Check if the medium is NOT credit card, and account is NOT of credit card type */
	IF (MEDIUM_CD NOT IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD NOT IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		IF NOUSE_TIME_SK13_24 = TIME_SK THEN 
		DO;
			NOUSE_TIME_SK13_24 = NOUSE_TIME_SK13_24 - 1;		
			NOUSE_CNTR13_24 = NOUSE_CNTR13_24 + 1;
		END;
	END;

	/* Check if the medium is credit card, and account is of credit card type */
	IF (MEDIUM_CD IN (&CCD_MEDIUM) AND ACCOUNT_TYPE_CD IN (&CCD_ACCOUNT_TYPE)) THEN 
	DO; 
		ACC_CCD_USE_13_24M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Personal Shopping */	
	IF MERCHANT_CATEGORY_CD IN (&PER_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_PER_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_PER_13_24M_CNT + TRANSACTION_CNT;
	END;
	
	/* Check if merchant category code is Transportation */	
	IF MERCHANT_CATEGORY_CD IN (&TPT_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_TPT_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_TPT_13_24M_CNT + TRANSACTION_CNT;
	END;

	/* Check if merchant category code is Utility payments */	
	IF MERCHANT_CATEGORY_CD IN (&UTL_MERCHANT_CATEGORY) THEN 
	DO;
		ACC_CCD_UTLY_13_24M_AMT + TRANSACTION_AMT;
		ACC_CCD_UTLY_13_24M_CNT + TRANSACTION_CNT;
	END;
	
/* Variables of TRANS_CHANNEL_USAGE_13_24M */
	/* Check if transaction channel is ATM */
	IF CHANNEL_CD IN (&ATM_CHANNEL) THEN DO;
		ACC_ATM_USE_13_24M_CNT + TRANSACTION_CNT; END;
	
	/* Check if transaction channel is Internet */
	IF CHANNEL_CD IN (&INN_CHANNEL) THEN DO;
		ACC_INN_USE_13_24M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Telephone */
	IF CHANNEL_CD IN (&PHN_CHANNEL) THEN DO;
		ACC_PHN_USE_13_24M_CNT + TRANSACTION_CNT; END;

	/* Check if transaction channel is Teller/Branch */
	IF CHANNEL_CD IN (&TLR_CHANNEL) THEN DO;
		ACC_TLR_USE_13_24M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_CHECK_ISSUE_13_24M */
	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		/* Check if medium is cheque */
		IF MEDIUM_CD IN (&CHQ_MEDIUM) THEN 
		DO;
			ACC_CHQ_ISU_13_24M_AMT + TRANSACTION_AMT;
			ACC_CHQ_ISU_13_24M_CNT + TRANSACTION_CNT;
		END;
		/* Total amount paid by the card holder in the last 13_24 months */
			ACC_PAY_13_24M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PAY_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_PAY_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PAY_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_PAY_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_DDR_SORD_13_24M */
	/* Check if transaction type is direct debit */
	IF TRANSACTION_TYPE_CD IN (&DDR_TRANS_TYPE) THEN 
	DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DDR_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_DDR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DDR_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_DDR_13_24M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_DDR_13_24M_AMT + TRANSACTION_AMT;		
	END;

	/* Check if transaction type is standing orders */
	IF TRANSACTION_TYPE_CD IN (&SOR_TRANS_TYPE) THEN DO;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_SORD_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_SORD_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_SORD_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_SORD_13_24M_AMT = MAX_TRANSACTION_AMT; END;

			ACC_SORD_13_24M_AMT + TRANSACTION_AMT;	
	END;
	
/* Variables of TRANS_DEP_WDR_13_24M */
	/* Check if transaction type is Withdrawal */
	IF TRANSACTION_TYPE_CD IN (&WDR_TRANS_TYPE) THEN 
	DO;
			ACC_WDR_13_24M_AMT + TRANSACTION_AMT;
			ACC_WDR_13_24M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_WDR_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_WDR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_WDR_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_WDR_13_24M_AMT = MIN_TRANSACTION_AMT; END;

		/*Check if channel is ATM*/
		IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
		DO;
				ACC_ATM_WDR_13_24M_AMT + TRANSACTION_AMT;
				ACC_ATM_WDR_13_24M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ATM_WDR_13_24M_AMT, min_value) THEN DO;
				ACC_MAX_ATM_WDR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ATM_WDR_13_24M_AMT, max_value) THEN DO;
				ACC_MIN_ATM_WDR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		/*Check if channel is Teller/branch */
		IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
		DO;
				ACC_TLR_WDR_13_24M_AMT + TRANSACTION_AMT;
				ACC_TLR_WDR_13_24M_CNT + TRANSACTION_CNT;

			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TLR_WDR_13_24M_AMT, min_value) THEN DO;
				ACC_MAX_TLR_WDR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TLR_WDR_13_24M_AMT, max_value) THEN DO;
				ACC_MIN_TLR_WDR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END;	
	END;

	/* Check if transaction type is Deposit Encashment */
	IF TRANSACTION_TYPE_CD IN (&DEN_TRANS_TYPE) THEN 
	DO;
		ACC_DEP_ENC_13_24M_AMT + TRANSACTION_AMT;
				
		/*Check if account has been closed and closing reason is deposit early encashment */
		IF CLOSE_DT NE . AND CLOSE_REASON_CD IN (&ECH_CLOSE_REASON) THEN 
		DO;
		/* check if year and month of close date and of cal mnth date are same */
			IF ((YEAR(CLOSE_DT) EQ YEAR(CAL_MONTH_FIRST_DT))
						AND
				(MONTH(CLOSE_DT) EQ MONTH(CAL_MONTH_FIRST_DT))) THEN DO;

					ACC_DEP_ERLY_ENC_13_24M_CNT = ACC_DEP_ERLY_ENC_13_24M_CNT + 1; END;
				
		END;
	END;
	
	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
			ACC_DEP_13_24M_AMT + TRANSACTION_AMT;
			ACC_DEP_13_24M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_DEP_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_DEP_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/*Check if transactions are made using Credit card*/
	IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
	DO;
			ACC_CR_TRNS_13_24M_AMT + TRANSACTION_AMT;
			ACC_CR_TRNS_13_24M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CR_TRNS_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_CR_TRNS_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CR_TRNS_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_CR_TRNS_13_24M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;

	/*Check if transactions are made using Debit card*/
	IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
	DO;
			ACC_DR_TRNS_13_24M_AMT + TRANSACTION_AMT;
			ACC_DR_TRNS_13_24M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DR_TRNS_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_DR_TRNS_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DR_TRNS_13_24M_AMT, max_value)THEN DO;
			ACC_MIN_DR_TRNS_13_24M_AMT = MIN_TRANSACTION_AMT; END; /*NOTE: NOT IN EXCEL*/
	END;
		
	/* Variables of TRANS_FEES_13_24M */
	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for atm/debit card issuance*/
		IF FEE_REASON_TYPE_CD IN (&ATM_FEE_TYPE) THEN DO;
			ACC_ATM_ISU_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is balance below the limit fees */
		IF FEE_REASON_TYPE_CD IN (&BBL_FEE_TYPE) THEN DO;
			ACC_BBLO_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is cash advance */
		IF FEE_REASON_TYPE_CD IN (&CAD_FEE_TYPE) THEN DO;
			ACC_CADV_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Check book issuance */
		IF FEE_REASON_TYPE_CD IN (&CHQ_FEE_TYPE) THEN DO;
			ACC_CHQ_BK_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Dishonoured payment fees */ 
		IF FEE_REASON_TYPE_CD IN (&DSH_FEE_TYPE) THEN DO;
			ACC_DSHNR_PAY_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Duplicate statement issuance fees */
		IF FEE_REASON_TYPE_CD IN (&DST_FEE_TYPE) THEN DO;
			ACC_DUP_STMT_FEE_13_24M_AMT + TRANSACTION_AMT; END;

		/* For all applicable fees type */
			ACC_FEE_13_24M_AMT + TRANSACTION_AMT;	

		/* Check if fees type is Overdraft facility fees */
		IF FEE_REASON_TYPE_CD IN (&OVF_FEE_TYPE) THEN DO;
			ACC_OVD_FACY_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Over the limit fees */
		IF FEE_REASON_TYPE_CD IN (&OTL_FEE_TYPE) THEN DO;
			ACC_OTL_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Incoming balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&IBT_FEE_TYPE) THEN DO;
			ACC_IBT_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Increasing credit limit fees */
		IF FEE_REASON_TYPE_CD IN (&CLI_FEE_TYPE) THEN DO;
			ACC_LMT_INR_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* For all applicable fees type */
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FEE_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_FEE_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FEE_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_FEE_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		/* Check if fees type is Missed or unpaid installment fees */
		IF FEE_REASON_TYPE_CD IN (&MIS_FEE_TYPE) THEN DO;
			ACC_MIS_INST_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Account maintenance fees */
		IF FEE_REASON_TYPE_CD IN (&MNT_FEE_TYPE) THEN DO;
			ACC_MNTS_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Outgoing balance transfer fees */
		IF FEE_REASON_TYPE_CD IN (&OBT_FEE_TYPE) THEN DO;
			ACC_OBT_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is Prepayment penalty fees */
		IF FEE_REASON_TYPE_CD IN (&PPP_FEE_TYPE) THEN DO;
			ACC_PPY_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is fixed to floating rate fees */
		IF FEE_REASON_TYPE_CD IN (&FXF_FEE_TYPE) THEN DO;
			ACC_RTTYP_CHG_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/* Check if fees type is visit fees */
		IF FEE_REASON_TYPE_CD IN (&VIS_FEE_TYPE) THEN DO;
			ACC_SRV_VIS_FEE_13_24M_AMT + TRANSACTION_AMT;
		END;		
		/* Check if fees type is Transaction charges fees */
		IF FEE_REASON_TYPE_CD IN (&TRN_FEE_TYPE) THEN DO;
			ACC_TRNS_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		/*Check if fees type is delayed payments only */
		IF FEE_REASON_TYPE_CD IN (&DLP_FEE_TYPE) THEN 
		DO;
			ACC_DLD_PAY_FEE_13_24M_AMT + TRANSACTION_AMT;
			IF MAX_TRANSACTION_AMT > COALESCE(MAX_DFEE2AVG_INST_13_24M_PCT, min_value) THEN DO; 
				MAX_DFEE2AVG_INST_13_24M_PCT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(MIN_DFEE2AVG_INST_13_24M_PCT, max_value) THEN DO; 
				MIN_DFEE2AVG_INST_13_24M_PCT = MIN_TRANSACTION_AMT; END;

				CNT_DFEE2AVG_13_24M + 1;
				SUM_RPP13_24M + REGULAR_PERIODIC_PAYMENT_AMT;
				AVG_INST_13_24M_PCT = SUM_RPP13_24M / CNT_DFEE2AVG_13_24M; /* Average calculation */
				ACC_MAX_DFEE2AVG_INST_13_24M_PCT = (MAX_DFEE2AVG_INST_13_24M_PCT / AVG_INST_13_24M_PCT)*100;
				/* final abt variable derivation */	
				ACC_MIN_DFEE2AVG_INST_13_24M_PCT = (MIN_DFEE2AVG_INST_13_24M_PCT / AVG_INST_13_24M_PCT)*100;
				/* final abt variable derivation */ 
		END;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_13_24M_AMT + TRANSACTION_AMT; END;
		
		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_13_24M_AMT + TRANSACTION_AMT; END;
	END;
	
/* Variables of TRANS_FEES_WAIVED_13_24M */
	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
			ACC_FWV_13_24M_AMT + TRANSACTION_AMT;
			ACC_FWV_13_24M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_FWV_13_24M_AMT, min_value) THEN DO; 
			ACC_MAX_FWV_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_FWV_13_24M_AMT, max_value) THEN DO; 
			ACC_MIN_FWV_13_24M_AMT = MIN_TRANSACTION_AMT; END; 
	END;

/* Variables of TRANS_INST_PAYMENTS_13_24M */
	/* Check for interest payment type transactions */
	IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
	DO;
			ACC_INT_13_24M_AMT + TRANSACTION_AMT;
			ACC_INT_13_24M_CNT + TRANSACTION_CNT;

			/*Temporary variable used in calculating ACC_MAX_PPL_INT_13_24M_AMT 
												 and ACC_MIN_PPL_INT_13_24M_AMT */
			ACC_INT_13_24M_AMT_TMP + TRANSACTION_AMT; 

			ACC_PPL_INT_PYD_13_24M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_13_24M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_13_24M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RCD_13_24M_AMT + TRANSACTION_AMT;
			ACC_INT_RCD_13_24M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_RCD_13_24M_AMT, min_value) THEN DO; 
			ACC_MAX_INT_RCD_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_RCD_13_24M_AMT, max_value) THEN DO; 
			ACC_MIN_INT_RCD_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
			ACC_INT_RINV_13_24M_AMT + TRANSACTION_AMT;
			ACC_INT_RINV_13_24M_CNT + TRANSACTION_CNT;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INT_RINV_13_24M_AMT, min_value) THEN DO;
			ACC_MX_INT_RINV_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INT_RINV_13_24M_AMT, max_value) THEN DO;
			ACC_MN_INT_RINV_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
	
	/* Check if transaction type is principal payment */	
	IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
	DO;
			ACC_PPL_13_24M_AMT + TRANSACTION_AMT;
			ACC_PPL_13_24M_CNT + TRANSACTION_CNT; /*Note: This field is not
																		present in excel*/
			/* Temporary variable used to calculate ACC_MAX_PPL_INT_13_24M_AMT 
												and ACC_MIN_PPL_INT_13_24M_AMT */
			ACC_PPL_13_24M_AMT_TMP + TRANSACTION_AMT; 
			
			ACC_PPL_INT_PYD_13_24M_AMT + TRANSACTION_AMT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PPL_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_13_24M_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PPL_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;	
		
	/* Check if transaction type is Additional payment */
	IF TRANSACTION_TYPE_CD IN (&APY_TRANS_TYPE) THEN 
	DO;
		ACC_ADDL_PAY_13_24M_AMT + TRANSACTION_AMT;/*NOTE: Not in excel*/ 
		ACC_ADDL_PAY_13_24M_CNT + TRANSACTION_CNT; 
	END;

	/* Check for escrow type transaction */
		IF TRANSACTION_TYPE_CD IN (&ESC_TRANS_TYPE) THEN 
		DO;
				ACC_ESCR_13_24M_AMT + TRANSACTION_AMT; 
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_ESCR_PYD_13_24M_AMT, min_value) THEN DO;
				ACC_MAX_ESCR_PYD_CURR_MTH_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_ESCR_PYD_13_24M_AMT, max_value) THEN DO;
				ACC_MIN_ESCR_PYD_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END;	

	/* Variables of TRANS_PAYMENTS_13_24M */

			ACC_DLD_PAY_13_24M_CNT + LATE_PAYMENT_CNT;
	/*Check if transaction status reason is dishonoured payment */
	IF TRANSACTION_STATUS_REASON_CD IN (&DSH_TRANS_STATUS) THEN 
	DO;
			ACC_DSHNR_PAY_13_24M_AMT + TRANSACTION_AMT;
			ACC_DSHNR_PAY_13_24M_CNT + TRANSACTION_CNT;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DSHNR_PAY_13_24M_AMT, min_value) THEN DO; 
			ACC_MAX_DSHNR_PAY_13_24M_AMT = MAX_TRANSACTION_AMT;	END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DSHNR_PAY_13_24M_AMT, max_value) THEN DO; 
			ACC_MIN_DSHNR_PAY_13_24M_AMT  = MIN_TRANSACTION_AMT; END; 
	END;

/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN DO;
			ACC_PREPAY_13_24M_AMT + TRANSACTION_AMT; END;	

/* Variables of TRANS_PUR_CADV_OVL_13_24M */
/* Check if transaction type is purchase */
	IF TRANSACTION_TYPE_CD IN (&PUR_TRANS_TYPE) THEN 
	DO;
	/* Check if its an international purchase */
		IF INTERNAL_ORG_COUNTRY_CD NE COUNTRY_CD THEN 
		DO; 
				ACC_IPUR_13_24M_AMT + TRANSACTION_AMT; 
				ACC_IPUR_13_24M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IPUR_13_24M_AMT, min_value) THEN DO; 
				ACC_MAX_IPUR_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IPUR_13_24M_AMT, max_value) THEN DO; 
				ACC_MIN_IPUR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END;

	/* Check if its a local purchase */
		IF INTERNAL_ORG_COUNTRY_CD EQ COUNTRY_CD THEN 
		DO; 
				ACC_LPUR_13_24M_AMT + TRANSACTION_AMT; 
				ACC_LPUR_13_24M_CNT + TRANSACTION_CNT;
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_LPUR_13_24M_AMT, min_value) THEN DO; 
				ACC_MAX_LPUR_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_LPUR_13_24M_AMT, max_value) THEN DO; 
				ACC_MIN_LPUR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PUR_13_24M_AMT, min_value) THEN DO; 
				ACC_MAX_PUR_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PUR_13_24M_AMT, max_value) THEN DO; 
				ACC_MIN_PUR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
			
				ACC_PUR_13_24M_AMT + TRANSACTION_AMT;
				ACC_PUR_13_24M_CNT + TRANSACTION_CNT;
	END;	

	/* Check if transaction type is Cash Advance */
	IF TRANSACTION_TYPE_CD IN (&CAD_TRANS_TYPE) THEN 
	DO;
				ACC_CADV_13_24M_AMT + TRANSACTION_AMT;
				ACC_CADV_13_24M_CNT + TRANSACTION_CNT;

				CADV_13_24M_CNTR + 1;
				ACC_AVG_CADV_13_24M_AMT = ACC_CADV_13_24M_AMT / CADV_13_24M_CNTR;

		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_CADV_13_24M_AMT, max_value) THEN DO; 
				ACC_MAX_CADV_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_CADV_13_24M_AMT, min_value) THEN DO; 
				ACC_MIN_CADV_13_24M_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* Check to determine the number of times account was over the limit 
		in the 13_24 months */	
	IF OVER_LIMIT_CNT > 0 THEN DO;
		ACC_OTL_13_24M_CNT + TRANSACTION_CNT; END;

/* Variables of TRANS_SUMMARY_13_24M */
	/* Total number of transactions in the last 13_24 months */
		ACC_TRNS_13_24M_CNT + TRANSACTION_CNT;
	/* Total amount of transactions in the last 13_24 months */
		ACC_TRNS_13_24M_AMT + TRANSACTION_AMT;
	
/* Variables of TRANS_TRANSFER_13_24M */
/* Check if transaction type is transfer */
	IF TRANSACTION_TYPE_CD IN (&TRS_TRANS_TYPE) THEN 
	DO;
	/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
		/* Check if channel is internet */	
			IF CHANNEL_CD IN (&INN_CHANNEL) THEN 
			DO;
					ACC_INN_TRS_FR_13_24M_AMT + TRANSACTION_AMT;
					ACC_INN_TRS_FR_13_24M_CNT + TRANSACTION_CNT;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_INN_TRS_FR_13_24M_AMT, max_value) THEN DO; 
					ACC_MN_INN_TRS_FR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_INN_TRS_FR_13_24M_AMT, min_value) THEN DO; 
					ACC_MX_INN_TRS_FR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
			END;

		/* Check if channel is ATM */	
			IF CHANNEL_CD IN (&ATM_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_ATM_TRS_FR_13_24M_AMT, max_value) THEN DO; 
					ACC_MN_ATM_TRS_FR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_ATM_TRS_FR_13_24M_AMT, min_value) THEN DO; 
					ACC_MX_ATM_TRS_FR_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
			END;

		/*Check if channel is ATM or SST*/
			IF CHANNEL_CD IN (&ATM_CHANNEL,&SST_CHANNEL) THEN 
			DO;
				ACC_ATM_SST_TRS_FR_13_24M_AMT + TRANSACTION_AMT;
				ACC_ATM_SST_TRS_FR_13_24M_CNT + TRANSACTION_CNT;
			END;			

			/* Check if channel is Telephone */	
			IF CHANNEL_CD IN (&PHN_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_PHN_TRS_FR_13_24M_AMT, max_value) THEN DO; 
					ACC_MN_PHN_TRS_FR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_PHN_TRS_FR_13_24M_AMT, min_value) THEN DO; 
					ACC_MX_PHN_TRS_FR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_PHN_TRS_FR_13_24M_AMT + TRANSACTION_AMT;
					ACC_PHN_TRS_FR_13_24M_CNT + TRANSACTION_CNT;
			END;

		/* Check if channel is Teller/branch */	
			IF CHANNEL_CD IN (&TLR_CHANNEL) THEN 
			DO;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MN_TLR_TRS_FR_13_24M_AMT, max_value) THEN DO; 
					ACC_MN_TLR_TRS_FR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MX_TLR_TRS_FR_13_24M_AMT, min_value) THEN DO; 
					ACC_MX_TLR_TRS_FR_13_24M_AMT = MAX_TRANSACTION_AMT; END;
				
					ACC_TLR_TRS_FR_13_24M_AMT + TRANSACTION_AMT;
					ACC_TLR_TRS_FR_13_24M_CNT + TRANSACTION_CNT;
			END;

				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_FR_13_24M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_FR_13_24M_AMT = MAX_TRANSACTION_AMT; END;	
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_FR_13_24M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_FR_13_24M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_FR_13_24M_AMT + TRANSACTION_AMT;
					ACC_TRS_FR_13_24M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = debit block */

	/* Check if its a credit card transaction */
		IF CREDIT_DEBIT_FLG IN (&CREDIT_FLAG) THEN 
		DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_TRS_IN2_13_24M_AMT, min_value) THEN DO; 
					ACC_MAX_TRS_IN2_13_24M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_TRS_IN2_13_24M_AMT, max_value) THEN DO; 
					ACC_MIN_TRS_IN2_13_24M_AMT = MIN_TRANSACTION_AMT; END;
			
					ACC_TRS_IN2_13_24M_AMT + TRANSACTION_AMT;
					ACC_TRS_IN2_13_24M_CNT + TRANSACTION_CNT;
		END; /* end of credit-debit flag = credit block */	
	END;/* end of transfer type transaction block */

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
					ACC_IBT_13_24M_AMT + TRANSACTION_AMT;
					ACC_IBT_13_24M_CNT + TRANSACTION_CNT;	
				
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_13_24M_AMT, min_value) THEN DO; 
					ACC_MAX_IBT_13_24M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_13_24M_AMT, max_value) THEN DO; 
					ACC_MIN_IBT_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */
	
	/* Check if transaction type is outgoing balance transfer */
	IF TRANSACTION_TYPE_CD IN (&OBT_TRANS_TYPE) THEN 
	DO;
		/* Check if its a debit card transaction */
		IF CREDIT_DEBIT_FLG IN (&DEBIT_FLAG) THEN 
		DO;
				ACC_OBT_13_24M_AMT + TRANSACTION_AMT;
				ACC_OBT_13_24M_CNT + TRANSACTION_CNT;	
			
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_OBT_13_24M_AMT, min_value) THEN DO; 
				ACC_MAX_OBT_13_24M_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_OBT_13_24M_AMT, max_value) THEN DO; 
				ACC_MIN_OBT_13_24M_AMT = MIN_TRANSACTION_AMT; END;
		END; /*end of debit flag if block */
	END;/*end of balance transfer if block */

	/*check for group of time_sk */
	IF LAST.TIME_SK THEN 
	DO;
		SUM_PPL_INT_13_24M = ACC_PPL_13_24M_AMT_TMP + ACC_INT_13_24M_AMT_TMP;

		/*To find out the max and min of principal+interest paid */
		IF SUM_PPL_INT_13_24M > COALESCE(ACC_MAX_PPL_INT_13_24M_AMT, min_value) THEN DO;
			ACC_MAX_PPL_INT_13_24M_AMT = SUM_PPL_INT_13_24M; END;
		IF SUM_PPL_INT_13_24M < COALESCE(ACC_MIN_PPL_INT_13_24M_AMT, max_value) THEN DO;
			ACC_MIN_PPL_INT_13_24M_AMT = SUM_PPL_INT_13_24M; END;
		
		/* Count the number of times credit card transactions were not made in the 
			last 13_24 months */
		ACC_CCD_NOUSE_13_24M_MTH_CNT + NOUSE_CNTR13_24;

		/*Special variables used in calculating ACC_CCD_NOUSE_13_24M_MTH_CNT is reset here */
		NOUSE_CNTR13_24 = 0;
	END;
END;

/*************************************** Life to date computation ***************************/
	/* Check if transaction type is principal payment */
		IF TRANSACTION_TYPE_CD IN (&PPL_TRANS_TYPE) THEN 
		DO;
			IF TIME_SK < COALESCE(INST_MIN_TIME_SK, max_value) THEN DO;
				INST_MIN_TIME_SK = TIME_SK; END;
			
			IF PREV_TIME_SK NE TIME_SK THEN 
			DO;
				ACC_INST_PAY_LTD_CNT = ACC_INST_PAY_LTD_CNT + 1; 
				PREV_TIME_SK = TIME_SK; 
			END;
		END;

	/* Check if transaction type is interest payment */
		IF TRANSACTION_TYPE_CD IN (&INT_TRANS_TYPE) THEN 
		DO;
		/* The following IF block finds the maximum and minimum interest paid in the first
		12 months */	 
			IF CAL_MONTH_FIRST_DT <= INTNX('MONTH',OPEN_DT,12,'END') THEN 
			DO;
				IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_INT_FST_12M_AMT, min_value) THEN DO;
					ACC_MAX_INT_FST_12M_AMT = MAX_TRANSACTION_AMT; END;
				IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_INT_FST_12M_AMT, max_value) THEN DO;
					ACC_MIN_INT_FST_12M_AMT = MIN_TRANSACTION_AMT; END;
			END;
		END;

	/*Check if transaction type is prepayment type */
		IF TRANSACTION_TYPE_CD IN (&PPY_TRANS_TYPE) THEN 
		DO;
			IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_PREPAY_LTD_AMT, min_value) THEN DO;
				ACC_MAX_PREPAY_LTD_AMT = MAX_TRANSACTION_AMT; END;
			IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_PREPAY_LTD_AMT, max_value) THEN DO;
				ACC_MIN_PREPAY_LTD_AMT = MIN_TRANSACTION_AMT; END;

			IF TIME_SK < COALESCE(PPY_MIN_TIME_SK,max_value) THEN DO;
				PPY_MIN_TIME_SK = TIME_SK; END;
		END;	

	/* Check if transaction type is incoming balance transfer */
	IF TRANSACTION_TYPE_CD IN (&IBT_TRANS_TYPE) THEN 
	DO;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_IBT_LTD_AMT, min_value) THEN DO;
			ACC_MAX_IBT_LTD_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_IBT_LTD_AMT, max_value) THEN DO;
			ACC_MIN_IBT_LTD_AMT = MIN_TRANSACTION_AMT; END;

		IF TRANSACTION_AMT > COALESCE(MAX_IBT_TRNS_AMT, min_value) THEN 
		DO;
			MAX_IBT_TRNS_AMT = TRANSACTION_AMT;
			MAX_IBT_TIME_SK = TIME_SK;
		END;

		IF TRANSACTION_AMT < COALESCE(MIN_IBT_TRNS_AMT, max_value) THEN 
		DO;
			MIN_IBT_TRNS_AMT = TRANSACTION_AMT;
			MIN_IBT_TIME_SK = TIME_SK;
		END;
	END;

	/* Check if transaction is of fees type */
	IF TRANSACTION_TYPE_CD IN (&FEE_TRANS_TYPE) THEN 
	DO;
		/* Check if fees type is for annual fees */
		IF FEE_REASON_TYPE_CD IN (&ANL_FEE_TYPE) THEN DO;
			ACC_ANNL_FEE_LTD_AMT + TRANSACTION_AMT;	END;
		/* Check if fees type is for closing fees */
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FEE_AMT + TRANSACTION_AMT; END;
	END;

	/* Check if transaction type is Payment */
	IF TRANSACTION_TYPE_CD IN (&PAY_TRANS_TYPE) THEN 
	DO;
		IF TIME_SK < COALESCE(PAY_MIN_TIME_SK, max_value) THEN DO;
				PAY_MIN_TIME_SK = TIME_SK; END;	
	END;

	/* Check if transaction type is Fees waived */
	IF TRANSACTION_TYPE_CD IN (&FWV_TRANS_TYPE) THEN 
	DO;
		IF FEE_REASON_TYPE_CD IN (&CLS_FEE_TYPE) THEN DO;
			ACC_CLS_FWV_AMT + TRANSACTION_AMT; END;

		SUM_FWV_TRANS_CNT = SUM_FWV_TRANS_CNT + TRANSACTION_CNT;
	END;

	/*Check if account has been closed */
	IF ACCOUNT_STATUS_CD IN (&ACCT_STATUS_CLO) THEN	
	DO;
		/* Check if transaction type is Final settlement 
		(when checkings or savings account is closed) */
		IF TRANSACTION_TYPE_CD IN (&FST_TRANS_TYPE) THEN DO;
			ACC_CLS_RCD_AMT = TRANSACTION_AMT;	END;

		/* Check if transaction type is Maturity payment type transaction.
		(when Certificate of Deposit or Recurring Deposit account is closed) */
		IF TRANSACTION_TYPE_CD IN (&MPY_TRANS_TYPE) THEN DO;
			ACC_MTY_RCD_AMT = TRANSACTION_AMT;	END;
	END;

	/* Check for interest paid to the account type transactions */
	IF TRANSACTION_TYPE_CD IN (&IPD_TRANS_TYPE) THEN 
	DO;
		/*Check if account has been closed */
		IF ACCOUNT_STATUS_CD IN (&ACCT_STATUS_CLO) THEN	
		DO;
			IF CLOSE_DT < LOAD_ABT_USER_INPUT_DATE THEN DO;
				ACC_INT_RCD_TILL_WDR_AMT + TRANSACTION_AMT; END;
		END;
	END;

	/* Check for interest reinvested type transactions */	
	IF TRANSACTION_TYPE_CD IN (&INI_TRANS_TYPE) THEN 
	DO;
	/*Check if account has been closed */
		IF ACCOUNT_STATUS_CD IN (&ACCT_STATUS_CLO) THEN	
		DO;
			IF CLOSE_DT < LOAD_ABT_USER_INPUT_DATE THEN DO;
				ACC_INT_REINV_TILL_WDR_AMT + TRANSACTION_AMT; END;
		END;
	END;

	/* Check if transaction type is Deposit */
	IF TRANSACTION_TYPE_CD IN (&DEP_TRANS_TYPE) THEN 
	DO;
		IF MAX_TRANSACTION_AMT > COALESCE(ACC_MAX_DEP_LTD_AMT, min_value) THEN DO;
			ACC_MAX_DEP_LTD_AMT = MAX_TRANSACTION_AMT; END;
		IF MIN_TRANSACTION_AMT < COALESCE(ACC_MIN_DEP_LTD_AMT, max_value) THEN DO;
			ACC_MIN_DEP_LTD_AMT = MIN_TRANSACTION_AMT; END;
	END;
	
	/* For monthly calculations */
	IF LAST.TIME_SK THEN DO;
		/* Check if transaction type is Fees waived */
		    IF SUM_FWV_TRANS_CNT > COALESCE(ACC_MAX_FWV_LTD_CNT, min_value) THEN DO;
				ACC_MAX_FWV_LTD_CNT = SUM_FWV_TRANS_CNT; END;
			IF SUM_FWV_TRANS_CNT < COALESCE(ACC_MIN_FWV_LTD_CNT, max_value) THEN DO;
				ACC_MIN_FWV_LTD_CNT = SUM_FWV_TRANS_CNT; END;
		SUM_FWV_TRANS_CNT = .; /*Reset*/
	END;
/*************************************** end of Life to date computation ********************/

/*Increment the count and at the same time decrement the CURR_TIME to cater to the next
lowest time period */
COUNT = COUNT + 1;
CURR_TIME = CURR_TIME - 1;

/*If the end of the group is reached then output the data sets */
IF LAST.ACCOUNT_RK THEN
DO;	
	IF (COUNT <= 1) THEN	
	/*Is needed in case of premature exit, data is present only
	for the current month */
	DO;
		%abt_trans_macro_assign_1_to_3;
		%abt_trans_macro_assign_1_to_6;
		%abt_trans_macro_assign_1_to_12;
	END;
	ELSE IF (COUNT <= 3) THEN	
	/*Is needed in case of premature exit, data is present only
	for 3 months */
	DO;
		%abt_trans_macro_assign_3_to_6;
		%abt_trans_macro_assign_3_to_12;
	END;
	ELSE IF (COUNT <= 6) THEN
	/*Is needed in case of premature exit, data is present only
	for 6 months */
	DO;
		%abt_trans_macro_assign_6_to_12;
	END;	
	
	/* LTD variables */
	IF PPY_MIN_TIME_SK NE . THEN DO;
		/*using user defined format CALENDAR_YYYYMM to get yearmonth */
		ACC_FST_PREPAY_MTH_NO = put(PPY_MIN_TIME_SK,CALENDAR_YYYYMM.); END;
	
	IF MAX_IBT_TIME_SK NE . THEN DO;
		/*using user defined format CALENDAR_YYYYMM to get yearmonth */
		ACC_MAX_IBT_LTD_MTH_NO = put(MAX_IBT_TIME_SK,CALENDAR_YYYYMM.); END;

	IF MIN_IBT_TIME_SK NE . THEN DO;
		/*using user defined format CALENDAR_YYYYMM to get yearmonth */
		ACC_MIN_IBT_LTD_MTH_NO = put(MIN_IBT_TIME_SK,CALENDAR_YYYYMM.); END;

	IF INST_MIN_TIME_SK NE . THEN 
	DO;
		/*using user defined format CALENDAR_YYYYMM to get yearmonth */
		ACC_FST_INST_PAY_MTH_NO = put(INST_MIN_TIME_SK,CALENDAR_YYYYMM.);
		ACC_SNC_FST_INST_MTH_CNT = CURR_TIME_SK - INST_MIN_TIME_SK;
	END;

	IF PAY_MIN_TIME_SK NE . THEN 
	DO;
		/*using user defined format CALENDAR_YYYYMM to get yearmonth */
		ACC_FST_PAY_MTH_NO = put(PAY_MIN_TIME_SK,CALENDAR_YYYYMM.); 
		ACC_SNC_FST_PAY_MTH_CNT = CURR_TIME_SK - PAY_MIN_TIME_SK;
	END;

	/* Assign the first captured value to the code variables and primary_customer_rk here */
		ACCOUNT_TYPE_CD = ACCT_TYPE_CD;
		ACCOUNT_SUB_TYPE_CD = ACCT_SUB_TYPE_CD; 
		PRIMARY_CUSTOMER_RK = PRI_CUSTOMER_RK;
		ACCOUNT_STATUS_CD = ACCT_STS_CD;
		COLLATERAL_CD = COLL_CD;
		ALLOW_OVERDRAFT_FLG = AOD_FLG;
	
	/*Output the data set */
	OUTPUT; 
	
	/*Reset all the retain variables for the next account group */
	/*This macro has the statements which resets all the variables for the next account group */
		%abt_trans_macro_reset;

		/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_CURR_PCT and  
												ACC_MIN_DFEE2AVG_INST_CURR_PCT
												are reset here */
		MAX_DFEE2AVG_INST_CURR_PCT = .;
		MIN_DFEE2AVG_INST_CURR_PCT = .;
		CNT_DFEE2AVG_CURR = 0;
		SUM_RPPCURR = 0;
		AVG_INST_CURR_PCT = 0;
		
		/*Special variable used in calculating ACC_AVG_CADV_CURR_MTH_AMT is reset here */
		CADV_CURR_CNTR = 0;
		
		/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L3M_PCT and  
												ACC_MIN_DFEE2AVG_INST_L3M_PCT
												are reset here */
		MAX_DFEE2AVG_INST_L3M_PCT = .;
		MIN_DFEE2AVG_INST_L3M_PCT = .;
		CNT_DFEE2AVG_3M = 0;
		SUM_RPP3M = 0;
		AVG_INST_L3M_PCT = 0;
		
		/*Special variable used in calculating ACC_AVG_CADV_LST_3M_AMT is reset here */
		CADV_3M_CNTR = 0;
		
		/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L6M_PCT and
												ACC_MIN_DFEE2AVG_INST_L6M_PCT 
												are reset here */
		MAX_DFEE2AVG_INST_L6M_PCT = .;
		MIN_DFEE2AVG_INST_L6M_PCT = .;
		CNT_DFEE2AVG_6M = 0;
		SUM_RPP6M = 0;
		AVG_INST_L6M_PCT = 0;		

		/*Special variable used in calculating ACC_AVG_CADV_LST_6M_AMT is reset here */
		CADV_6M_CNTR = 0;

		/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_L12M_PCT and
												ACC_MIN_DFEE2AVG_INST_L12M_PCT 
												are reset here */
		MAX_DFEE2AVG_INST_L12M_PCT = .;
		MIN_DFEE2AVG_INST_L12M_PCT = .;
		CNT_DFEE2AVG_12M = 0;
		SUM_RPP12M = 0;
		AVG_INST_L12M_PCT = 0;		

		/*Special variable used in calculating ACC_AVG_CADV_LST_12M_AMT is reset here */
		CADV_12M_CNTR = 0;

		/*Special variables used in calculating ACC_MAX_DFEE2AVG_INST_13_24M_PCT and
												ACC_MIN_DFEE2AVG_INST_13_24M_PCT
												are reset here */
		MAX_DFEE2AVG_INST_13_24M_PCT = .;
		MIN_DFEE2AVG_INST_13_24M_PCT = .;
		CNT_DFEE2AVG_13_24M = 0;  
		SUM_RPP13_24M = 0; 
		AVG_INST_13_24M_PCT = 0;
		
		/*Special variable used in calculating ACC_AVG_CADV_13_24M_AMT is reset here */
		CADV_13_24M_CNTR = 0;

		/* Special variable used for calculating some LTD variables	are reset here */
		INST_MIN_TIME_SK = .;
		PPY_MIN_TIME_SK = .;
		MAX_IBT_TRNS_AMT = .;
		MIN_IBT_TRNS_AMT = .;
		MAX_IBT_TIME_SK = .;
		MIN_IBT_TIME_SK = .;
		PAY_MIN_TIME_SK = .;
		ACCT_STS_CD = '';

		/*  Special variables used in calculating ACC_INST_PAY_LTD_CNT is reset here */
		PREV_TIME_SK = 0;
		
	%if &PERIOD. = 24 %then 
	%do;
		CURR_TIME = BACK_12M_TIME_SK; 
		COUNT = 12;
	%end;
	%else 
	%do;
		CURR_TIME = CURR_TIME_SK;
		COUNT = 0;
	%end;
END;
run;
%mend macro_acc_trans_lst_abt;
